

' VB.NET declare statements for NAG C Library DLL Mark 25
' Copyright 2015, Numerical Algorithms Group Ltd, Oxford, UK.

Imports System.Runtime.InteropServices

Module nag_declarations
Public Const NAG_FILE_LEN As Short = 512
Public Const NAG_ERROR_BUF_LEN As Short = 512
Public Const MPS_NAME_LEN As Short = 8


    

' type declarations




<StructLayout(LayoutKind.Sequential)> Structure Complex
    public re as Double
    public im as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_Sparse_Comm
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public idatax() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public rdatax() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public idata() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public rdata() as Double
    public work as IntPtr ' pointer to double
    public iwork as IntPtr ' pointer to Integer
    public lwork as Integer
    public liwork as Integer
    public f11gac_lwreq as Integer
    public f11bby_iter as Integer
    public f11bby_jump as Integer
    public f11bby_j as Integer
    public f11bby_kase as Integer
    public f11gbz_ib as Integer
    public f11gbz_id as Integer
    public f11gbz_ie2 as Integer
    public f11gbz_infoch as Integer
    public f11gbz_ip as Integer
    public f11gbz_ir as Integer
    public f11gbz_iterm as Integer
    public f11gbz_itn as Integer
    public f11gbz_its as Integer
    public f11gbz_iw as Integer
    public f11gbz_iwgt as Integer
    public f11gbz_ix as Integer
    public f11gbz_maxitn as Integer
    public f11gbz_maxits as Integer
    public f11gbz_monit as Integer
    public f11gbz_n as Integer
    public f11gbz_norm as Integer
    public f11gbz_sigcmp as Integer
    public f11gbz_sigcmx as Integer
    public f11gbz_stage as Integer
    public f11gbz_anorm as Double
    public f11gbz_bnorm as Double
    public f11gbz_sigerr as Double
    public f11gbz_sigerc as Double
    public f11gbz_sigmax as Double
    public f11gbz_sigmac as Double
    public f11gbz_stplhs as Double
    public f11gbz_stprhs as Double
    public f11gbz_talpha as Double
    public f11gbz_tbeta as Double
    public f11gbz_tol as Double
    public f11gbz_xnorm as Double
    public f11gbz_floop as Nag_Boolean
    public f11gbz_next as Nag_Boolean
    public f11gbz_precon as Nag_SparseSym_PrecType
    public f11gby_alpha as Double
    public f11gby_anorm as Double
    public f11gby_beta1 as Double
    public f11gby_beta2 as Double
    public f11gby_betain as Double
    public f11gby_bnorm as Double
    public f11gby_bnorm2 as Double
    public f11gby_gammab as Double
    public f11gby_pi as Double
    public f11gby_rho1 as Double
    public f11gby_rho2 as Double
    public f11gby_rnorm2 as Double
    public f11gby_sigerr as Double
    public f11gby_sigerc as Double
    public f11gby_sigmax as Double
    public f11gby_sigmac as Double
    public f11gby_stplhs as Double
    public f11gby_stprhs as Double
    public f11gby_tol as Double
    public f11gby_xnorm as Double
    public f11gby_xnorm0 as Double
    public f11gby_zeta as Double
    public f11gby_zetab as Double
    public f11gby_ib as Integer
    public f11gby_id as Integer
    public f11gby_ie2 as Integer
    public f11gby_infoch as Integer
    public f11gby_iterm as Integer
    public f11gby_itn as Integer
    public f11gby_its as Integer
    public f11gby_iv1 as Integer
    public f11gby_iv2 as Integer
    public f11gby_iw1 as Integer
    public f11gby_iw2 as Integer
    public f11gby_iwgt as Integer
    public f11gby_ix as Integer
    public f11gby_maxitn as Integer
    public f11gby_maxits as Integer
    public f11gby_monit as Integer
    public f11gby_n as Integer
    public f11gby_norm as Integer
    public f11gby_resid as Integer
    public f11gby_sigcmp as Integer
    public f11gby_sigcmx as Integer
    public f11gby_stage as Integer
    public f11gby_floop as Nag_Boolean
    public f11gby_next as Nag_Boolean
    public f11gby_usexc as Nag_Boolean
    public f11gby_precon as Nag_SparseSym_PrecType
    public f11gbx_fpass as Nag_Boolean
    public f11gbv_rho as Double
    public f11gbv_xi as Double
    public f11gbs_dov1 as Nag_Boolean
    public f11gbr_deltab as Double
    public f11gbr_epslon as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11baz_idatax() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11baz_rdatax() as Double
    public f11gbw_eps as Double
    public f11gbw_epslon as Double
    public f11gbw_mu1 as Double
    public f11gbw_mu1l as Double
    public f11gbw_mun as Double
    public f11gbw_munh as Double
    public f11gbw_sigmx0 as Double
    public f11gbw_sigmx1 as Double
    public f11gbw_sigtol as Double
    public f11gbw_ta2 as Double
    public f11gbw_tb2 as Double
    public f11gbw_tnorm as Double
    public f11gbw_maxits as Integer
    public f11gbw_sigcmp as Nag_Boolean
    public f11gbc_ifaill as Integer
    public f11gbc_ifailm as Integer
    public f11gbc_info as Integer
    public f11gbc_irevcx as Integer
    public f11gbc_kill as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11gbc_idata() as Integer
    public f11gbc_lworkl as Integer
    public f11gbc_done as Nag_Boolean
    public f11gbc_first as Nag_Boolean
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11gbc_rdata() as Double
    public f11gbq_factol as Double
    public f11gbq_stprhx as Double
    public f11gbq_tolc as Double
    public f11gbq_toleps as Double
    public f11gbq_tolf as Double
    public f11gbq_toll as Double
    public f11gbq_xcbnrm as Double
    public f11gbq_xlbnrm as Double
    public f11gbq_xnorm as Double
    public f11gbq_loop as Integer
    public f11gbq_fterm as Nag_Boolean
    public f11gbu_epslon as Double
    public f11gbu_stprhx as Double
    public f11gbu_toleps as Double
    public f11gbu_tolf as Double
    public f11gbu_xnorm0 as Double
    public f11gbu_loop as Integer
    public f11gbu_nrestl as Integer
    public f11gbu_nrestc as Integer
    public f11gbu_fterm as Nag_Boolean
    public f11bbz_iwgt as Integer
    public f11bbz_norm as Integer
    public f11bbz_iterm as Integer
    public f11bbz_monit as Integer
    public f11bbz_m as Integer
    public f11bbz_n as Integer
    public f11bbz_stage as Integer
    public f11bbz_ib as Integer
    public f11bbz_ic as Integer
    public f11bbz_ih as Integer
    public f11bbz_iq as Integer
    public f11bbz_ir as Integer
    public f11bbz_is as Integer
    public f11bbz_it as Integer
    public f11bbz_ix as Integer
    public f11bbz_infoch as Integer
    public f11bbz_imonit as Integer
    public f11bbz_maxitn as Integer
    public f11bbz_itn as Integer
    public f11bbz_anorm as Double
    public f11bbz_bnorm as Double
    public f11bbz_rnrm20 as Double
    public f11bbz_xnorm as Double
    public f11bbz_rnorm2 as Double
    public f11bbz_xnorm2 as Double
    public f11bbz_sigmax as Double
    public f11bbz_stplhs as Double
    public f11bbz_stprhs as Double
    public f11bbz_tol as Double
    public f11bbz_anrcmp as Nag_Boolean
    public f11bbz_precon as Nag_Boolean
    public f11bbz_next as Nag_Boolean
    public f11bbz_fcall as Nag_Boolean
    public f11bbu_first as Nag_Boolean
    public f11bbu_usedot as Nag_Boolean
    public f11bbv_tolf as Double
    public f11bbr_alpha as Double
    public f11bbr_rho as Double
    public f11bbr_do1 as Nag_Boolean
    public f11bbw_stpr as Double
    public f11bbw_m1 as Integer
    public f11bbw_tnorm as Double
    public f11bbw_im as Integer
    public f11bbw_sigcmp as Nag_Boolean
    public f11bbw_im1 as Integer
    public f11bbw_tinorm as Double
    public f11bbw_restrt as Nag_Boolean
    public f11bbw_tol1 as Double
    public f11bbt_iwgt as Integer
    public f11bbt_norm as Integer
    public f11bbt_next as Nag_Boolean
    public f11bbt_n as Integer
    public f11bbt_fcall as Nag_Boolean
    public f11bbt_irbar as Integer
    public f11bbt_stage as Integer
    public f11bbt_anorm as Double
    public f11bbt_bnorm as Double
    public f11bbt_iterm as Integer
    public f11bbt_monit as Integer
    public f11bbt_xnorm as Double
    public f11bbt_ib as Integer
    public f11bbt_ip as Integer
    public f11bbt_ir as Integer
    public f11bbt_it as Integer
    public f11bbt_ix as Integer
    public f11bbt_iy as Integer
    public f11bbt_infoch as Integer
    public f11bbt_anrcmp as Nag_Boolean
    public f11bbt_precon as Nag_Boolean
    public f11bbt_sigmax as Double
    public f11bbt_maxitn as Integer
    public f11bbt_stplhs as Double
    public f11bbt_stprhs as Double
    public f11bbt_restrt as Nag_Boolean
    public f11bbt_itn as Integer
    public f11bbt_tol as Double
    public f11bbq_tolf as Double
    public f11bbq_loop as Integer
    public f11bbq_pass1 as Nag_Boolean
    public f11bbq_frest as Nag_Boolean
    public f11bbq_xnmax as Double
    public f11bbq_toleps as Double
    public f11bbq_stplhx as Double
    public f11bbq_stprhx as Double
    public f11bbq_zz1 as Double
    public f11bbq_zz2 as Double
    public f11bbp_doxn as Nag_Boolean
    public f11bbp_next as Nag_Boolean
    public f11bbp_fcall as Nag_Boolean
    public f11bbp_anrcmp as Nag_Boolean
    public f11bbp_finish as Nag_Boolean
    public f11bbp_precon as Nag_Boolean
    public f11bbp_restrt as Nag_Boolean
    public f11bbp_imonit as Integer
    public f11bbp_maxitn as Integer
    public f11bbp_igam as Integer
    public f11bbp_itau as Integer
    public f11bbp_iwgt as Integer
    public f11bbp_norm as Integer
    public f11bbp_m as Integer
    public f11bbp_n as Integer
    public f11bbp_igamp as Integer
    public f11bbp_irbar as Integer
    public f11bbp_stage as Integer
    public f11bbp_xnorm as Double
    public f11bbp_anorm as Double
    public f11bbp_bnorm as Double
    public f11bbp_iterm as Integer
    public f11bbp_monit as Integer
    public f11bbp_ib as Integer
    public f11bbp_iq as Integer
    public f11bbp_ir as Integer
    public f11bbp_ix as Integer
    public f11bbp_infoch as Integer
    public f11bbp_idx as Integer
    public f11bbp_itn as Integer
    public f11bbp_ipx as Integer
    public f11bbp_sigmax as Double
    public f11bbp_stplhs as Double
    public f11bbp_stprhs as Double
    public f11bbp_tol as Double
    public f11bbn_rhox as Double
    public f11bbn_alpha as Double
    public f11bbn_tol1 as Double
    public f11bbn_tol2 as Double
    public f11bbn_rn1 as Double
    public f11bbn_i1 as Integer
    public f11bbn_j1 as Integer
    public f11bbn_n1 as Integer
    public f11bbn_im as Integer
    public f11bbn_jn1 as Integer
    public f11bbn_imn as Integer
    public f11bbn_doq as Nag_Boolean
    public f11bbm_tolf as Double
    public f11bbm_jitn as Integer
    public f11bbm_kitn as Integer
    public f11bbm_loop as Integer
    public f11bbm_pass1 as Nag_Boolean
    public f11bbm_frest as Nag_Boolean
    public f11bbm_irest as Integer
    public f11bbm_xnmax as Double
    public f11bbm_toleps as Double
    public f11bbm_stplhx as Double
    public f11bbm_stprhx as Double
    public f11bbm_zz1 as Double
    public f11bbm_zz2 as Double
    public f11bbf_irevcx as Integer
    public f11bbf_done as Nag_Boolean
    public f11bbf_first as Nag_Boolean
    public f11bbf_info as Integer
    public f11bbf_kill as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11bbf_idata() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=20)> public f11bbf_rdata() as Double
    public f11bbf_ifaill as Integer
    public f11bbf_ifailm as Integer
    public f11bbf_lworkl as Integer
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure NagError
    public code as Integer
    public dnprint as Nag_Boolean
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=NAG_ERROR_BUF_LEN)> public message() as Byte
    public handler as NAG_ERRHAN_DELEGATE
    public errnum as Integer
    public iflag as Integer
    public ival as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_User
    public p as IntPtr
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_Comm
    public flag as Integer
    public first as Nag_Boolean
    public last as Nag_Boolean
    public nf as Integer
    public it_prt as Nag_Boolean
    public it_maj_prt as Nag_Boolean
    public sol_sqp_prt as Nag_Boolean
    public sol_prt as Nag_Boolean
    public rootnode_sol_prt as Nag_Boolean
    public node_prt as Nag_Boolean
    public rootnode_prt as Nag_Boolean
    public g_prt as Nag_Boolean
    public new_lm as Nag_Boolean
    public needf as Integer
    public p as IntPtr
    public iuser as IntPtr ' pointer to Integer
    public user as IntPtr ' pointer to double
    public nag_w as IntPtr ' pointer to double
    public nag_iw as IntPtr ' pointer to Integer
    public nag_p as IntPtr
    public nag_print_w as IntPtr ' pointer to double
    public nag_print_iw as IntPtr ' pointer to Integer
    public nrealloc as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_QuadProgress
    public num_subint as Integer
    public fun_count as Integer
    public sub_int_beg_pts as IntPtr ' pointer to double
    public sub_int_end_pts as IntPtr ' pointer to double
    public sub_int_result as IntPtr ' pointer to double
    public sub_int_error as IntPtr ' pointer to double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_QuadSubProgress
    public intervals as Integer
    public fun_count as Integer
    public subints_per_interval as Integer
    public interval_error as IntPtr ' pointer to double
    public interval_result as IntPtr ' pointer to double
    public interval_flag as IntPtr ' pointer to Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ad02
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=12)> public alpha() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=12)> public beta() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=12)> public psi() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=12)> public v() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=12)> public w() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public sig() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public g() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=11)> public gi() as Double
    public xold as Double
    public hold as Double
    public told as Double
    public xsave as Double
    public tstar as Double
    public twou as Double
    public init as Integer
    public ibegin as Integer
    public itol as Integer
    public iinteg as Integer
    public itstop as Integer
    public inflop as Integer
    public iquit as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=10)> public iv() as Integer
    public ns as Integer
    public kord as Integer
    public kold as Integer
    public ksteps as Integer
    public kle4 as Integer
    public kprev as Integer
    public ivc as Integer
    public kgi as Integer
    public start as Nag_Boolean
    public phase1 as Nag_Boolean
    public nornd as Nag_Boolean
    public stiff as Nag_Boolean
    public intout as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_bd02
    public zero as Double
    public u as Double
    public fouru as Double
    public sru as Double
    public u34 as Double
    public u78 as Double
    public srbig as Double
    public delsgn as Double
    public troots as Double
    public tleft as Double
    public svtnew as Double
    public krootp as Integer
    public inrotp as Integer
    public gstop as Nag_Boolean
    public pgstop as Nag_Boolean
    public root as Nag_Boolean
    public roots as Nag_Boolean
    public needg as Nag_Boolean
    public discop as Nag_Boolean
    public newgeq as Nag_Boolean
    public search as Nag_Boolean
    public pserch as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_dd02
    public ts as Double
    public gts as Double
    public fd as Double
    public ftd as Double
    public fm as Double
    public fmx as Double
    public prev as Double
    public min as Double
    public max as Double
    public avg as Double
    public amb as Double
    public ambs as Double
    public sbma as Double
    public sf as Double
    public dezu34 as Double
    public ic as Integer
    public kmc as Integer
    public ising as Integer
    public kount as Integer
    public ktest as Integer
    public locext as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ed02
    public aez as Double
    public agtrl as Double
    public at as Double
    public atm as Double
    public atmtr as Double
    public brd as Double
    public brds as Double
    public ddt as Double
    public deltg as Double
    public deltgm as Double
    public deltr as Double
    public dg as Double
    public dtg as Double
    public dtgk as Double
    public dtgp as Double
    public dtqr as Double
    public fac as Double
    public g21 as Double
    public g32 as Double
    public gat as Double
    public gbr as Double
    public gbrc as Double
    public gbrmin as Double
    public gbrmns as Double
    public gct as Double
    public glocmx as Double
    public gmsign as Double
    public goldsv as Double
    public got as Double
    public gres as Double
    public gright as Double
    public gt21 as Double
    public gt32 as Double
    public gtint as Double
    public gtqr as Double
    public gtrl as Double
    public gtt as Double
    public gttmr as Double
    public gvalue as Double
    public gvdif as Double
    public gvmax as Double
    public gvmin as Double
    public omu78 as Double
    public opu78 as Double
    public pu as Double
    public qc0 as Double
    public qc1 as Double
    public qc2 as Double
    public qd as Double
    public qdq as Double
    public qr1 as Double
    public qr1n as Double
    public qr1p as Double
    public quadmn as Double
    public rd as Double
    public rdg as Double
    public dnrem as Double
    public remd as Double
    public rez as Double
    public rootno as Double
    public sdg as Double
    public signg as Double
    public slope1 as Double
    public slope2 as Double
    public slopep as Double
    public sotgv as Double
    public ss as Double
    public sstu78 as Double
    public t21 as Double
    public t31 as Double
    public t32 as Double
    public taddon as Double
    public tcb as Double
    public tcf as Double
    public tclose as Double
    public tdif as Double
    public tdmn as Double
    public tdmx as Double
    public tfar as Double
    public tgbrmn as Double
    public tgvdif as Double
    public tgvmt as Double
    public tint as Double
    public tintp as Double
    public tk as Double
    public tkold as Double
    public tlbk as Double
    public tnew as Double
    public tp as Double
    public tpoint as Double
    public tprev as Double
    public tqr as Double
    public tqr1 as Double
    public tqr2 as Double
    public tqrf as Double
    public tqrmp as Double
    public tqrp as Double
    public tqs as Double
    public tqt as Double
    public trd as Double
    public trj as Double
    public trl as Double
    public trn as Double
    public trnow as Double
    public troot as Double
    public tsave as Double
    public tslop as Double
    public tsru as Double
    public tstep as Double
    public tt as Double
    public tu78 as Double
    public tut as Double
    public tz as Double
    public tzero as Double
    public tzerok as Double
    public tzj as Double
    public tzk as Double
    public grno as Double
    public gt as Double
    public sttu78 as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=2)> public tadd() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=3)> public tr() as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_fd02
    public backr as Nag_Boolean
    public mroot as Nag_Boolean
    public multr as Nag_Boolean
    public peak as Nag_Boolean
    public qrreal as Nag_Boolean
    public skpmmt as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_gd02
    public i as Integer
    public i1 as Integer
    public i2 as Integer
    public i21 as Integer
    public i3 as Integer
    public iadd as Integer
    public ic1 as Integer
    public ic2 as Integer
    public icase as Integer
    public icbr as Integer
    public icbrk as Integer
    public idtg as Integer
    public iga as Integer
    public ijk as Integer
    public ik as Integer
    public ikmr as Integer
    public iktqr as Integer
    public indx as Integer
    public isi as Integer
    public isin as Integer
    public isr as Integer
    public itgvt as Integer
    public itry as Integer
    public j as Integer
    public j1 as Integer
    public j2 as Integer
    public j23 as Integer
    public j3 as Integer
    public jp1 as Integer
    public jr as Integer
    public jsr as Integer
    public k as Integer
    public kge as Integer
    public kp1 as Integer
    public krootn as Integer
    public krooto as Integer
    public kroots as Integer
    public kskpmt as Integer
    public ktry as Integer
    public l as Integer
    public ltqbig as Integer
    public ltr as Integer
    public mmr as Integer
    public mmrin as Integer
    public mmrk as Integer
    public nsr as Integer
    public ntin as Integer
    public ntinm as Integer
    public ipath as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_jd02
    public a as Double
    public absdx as Double
    public da as Double
    public delx as Double
    public dfdub as Double
    public dfdxb as Double
    public dx as Double
    public fbnd as Double
    public power as Double
    public relper as Double
    public ynorm as Double
    public ypnorm as Double
    public icase as Integer
    public k as Integer
    public lk as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_kd02
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public two() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public gstr() as Double
    public absh as Double
    public big as Double
    public erk as Double
    public erkm1 as Double
    public p5eps as Double
    public round as Double
    public u as Double
    public ifail as Integer
    public km1 as Integer
    public km2 as Integer
    public knew as Integer
    public kp1 as Integer
    public kp2 as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ODE_Adams
    public init1 as Integer
    public init2 as Integer
    public neqf as Integer
    public neqg as Integer
    public state as Nag_Start
    public alter_g as Nag_Boolean
    public sophist as Nag_Boolean
    public vectol as Nag_Boolean
    public a_tol as IntPtr ' pointer to double
    public rtol as IntPtr ' pointer to double
    public crit as Nag_Boolean
    public tcrit as Double
    public one_step as Nag_Boolean
    public hmax as Double
    public max_step as Integer
    public root as Nag_Boolean
    public badcmp as Integer
    public hnext as Double
    public hlast as Double
    public tolfac as Double
    public tcurr as Double
    public nsuccess as Integer
    public nfail as Integer
    public ord_last as Integer
    public ord_next as Integer
    public events as IntPtr ' pointer to Integer
    public resids as IntPtr ' pointer to double
    public yp as IntPtr ' pointer to double
    public yy as IntPtr ' pointer to double
    public p as IntPtr ' pointer to double
    public phi as IntPtr ' pointer to double
    public qwc_state as Integer
    public qfc_state as Integer
    public giwork as IntPtr ' pointer to Integer
    public siwork as IntPtr ' pointer to Integer
    public w as IntPtr ' pointer to double
    public gwork as IntPtr ' pointer to double
    public swork as IntPtr ' pointer to double
    public free as IntPtr
    public index as Integer
    public type as Integer
    public ad02qf as Nag_ad02
    public bd02qf as Nag_bd02
    public crash as Nag_Boolean
    public izflag as Integer
    public dd02qf as Nag_dd02
    public ed02qf as Nag_ed02
    public fd02qf as Nag_fd02
    public gd02qf as Nag_gd02
    public kroo as Integer
    public jd02qf as Nag_jd02
    public kd02qf as Nag_kd02
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ad02pd
    public tstrt as Double
    public tnd as Double
    public dir as Double
    public hstrt as Double
    public tolr as Double
    public neqn as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_bd02pd
    public t as Double
    public h as Double
    public told as Double
    public hold as Double
    public nfcn as Integer
    public svnfcn as Integer
    public okstp as Integer
    public flstp as Integer
    public first as Nag_Boolean
    public last as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_cd02pd
    public prthrs as Integer
    public prerst as Integer
    public prwt as Integer
    public pryold as Integer
    public prscr as Integer
    public pry as Integer
    public pryp as Integer
    public prstgs as Integer
    public printp as Integer
    public lnintp as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_dd02pd
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=169)> public a() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public b() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public c() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public bhat() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=66)> public r() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=7)> public e() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=13)> public ptr() as Integer
    public nstage as Integer
    public methd as Integer
    public mintp as Integer
    public intp as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ed02pd
    public toosml as Double
    public cost as Double
    public safety as Double
    public expon as Double
    public stbrad as Double
    public tanang as Double
    public rs as Double
    public rs1 as Double
    public rs2 as Double
    public rs3 as Double
    public rs4 as Double
    public order as Integer
    public lststg as Integer
    public maxtry as Integer
    public nsec as Integer
    public fsal as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_fd02pd
    public maxerr as Double
    public locmax as Double
    public gnfcn as Integer
    public przstg as Integer
    public przy as Integer
    public przyp as Integer
    public przers as Integer
    public przerr as Integer
    public przynu as Integer
    public erason as Nag_Boolean
    public erasfl as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_gd02pd
    public mcheps as Double
    public dwarf as Double
    public rndoff as Double
    public sqrrmc as Double
    public cubrmc as Double
    public tiny as Double
    public outch as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_hd02pd
    public utask as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_jd02pd
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=800)> public rec() as Byte
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ODE_RK
    public free as IntPtr
    public work as IntPtr ' pointer to double
    public ad02pd as Nag_ad02pd
    public bd02pd as Nag_bd02pd
    public cd02pd as Nag_cd02pd
    public dd02pd as Nag_dd02pd
    public ed02pd as Nag_ed02pd
    public fd02pd as Nag_fd02pd
    public gd02pd as Nag_gd02pd
    public hd02pd as Nag_hd02pd
    public jd02pd as Nag_jd02pd
    public init1 as Integer
    public init2 as Integer
    public utend as Double
    public tlast as Double
    public chkeff as Nag_Boolean
    public ntend as Integer
    public havg as Double
    public errold as Double
    public phase2 as Nag_Boolean
    public ynew as Integer
    public ypold as Integer
    public jflstp as Integer
    public nwntsv as Integer
    public startp as Integer
    public inintp as Nag_Boolean
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=8)> public svsta() as Integer
    public totfcn as Integer
    public stpcst as Integer
    public waste as Double
    public stpsok as Integer
    public hnext as Double
    public wrkint as IntPtr ' pointer to double
    public save_nwant as Integer
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_D03_Save
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=810)> public cwsav() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=1100)> public rwsav() as Double
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=505)> public iwsav() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=100)> public lwsav() as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_Spline
    public n as Integer
    public lamda as IntPtr ' pointer to double
    public c as IntPtr ' pointer to double
    public init1 as Integer
    public init2 as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_2dSpline
    public nx as Integer
    public lamda as IntPtr ' pointer to double
    public ny as Integer
    public mu as IntPtr ' pointer to double
    public c as IntPtr ' pointer to double
    public init1 as Integer
    public init2 as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_Grad_Chk_St
    public type as Nag_GradChk
    public obj_start as Integer
    public obj_stop as Integer
    public con_start as Integer
    public con_stop as Integer
    public g_error as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_SimSt
    public n_elements as Integer
    public dir_deriv as Double
    public fd_approx as Double
    public correct as Nag_Boolean
    public max_error as Double
    public max_subfunction as Integer
    public max_constraint as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_CompSt
    public assigned as Nag_Boolean
    public hopt as Double
    public gdiff as Double
    public iter as Integer
    public correct as Nag_Boolean
    public comment as IntPtr ' pointer to const char
    public zero as Nag_Boolean
    public dnerror as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_FDIntSt
    public hfd as Double
    public hcd as Double
    public errmax as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_GPrintSt
    public g_chk as Nag_Grad_Chk_St
    public nfdiff as Integer
    public ncdiff as Integer
    public nf_const as Integer
    public nc_const as Integer
    public deriv_level as Nag_DerivSet
    public old_deriv_level as Nag_DerivSet
    public f_sim as Nag_SimSt
    public c_sim as Nag_SimSt
    public f_comp as IntPtr ' pointer to Nag_CompSt
    public c_comp as IntPtr ' pointer to Nag_CompSt
    public intervals as IntPtr ' pointer to Nag_FDIntSt
    public print_deriv as Nag_DPrintType
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_Search_State
    public m as Integer
    public n as Integer
    public numinf as Integer
    public x as IntPtr ' pointer to double
    public f as Double
    public objf as Double
    public g as IntPtr ' pointer to double
    public diagt as IntPtr ' pointer to double
    public fvec as IntPtr ' pointer to double
    public fjac as IntPtr ' pointer to double
    public conjac as IntPtr ' pointer to double
    public tdj as Integer
    public tdconjac as Integer
    public dnstep as Double
    public xk_norm as Double
    public gpj_norm as Double
    public cond as Double
    public cond_h as Double
    public cond_hz as Double
    public cond_t as Double
    public cond_r as Double
    public iter_conv as Nag_Boolean
    public norm_gz_small as Nag_Boolean
    public violtn_small as Nag_Boolean
    public update_modified as Nag_Boolean
    public c_diff as Nag_Boolean
    public qp_not_feasible as Nag_Boolean
    public step_limit_exceeded as Nag_Boolean
    public refactor as Nag_Boolean
    public mgrmsg as IntPtr ' pointer to char
    public norm_nlnviol as Double
    public grade as Integer
    public s as IntPtr ' pointer to double
    public state as IntPtr ' pointer to Integer
    public iter as Integer
    public major_iter as Integer
    public minor_iter as Integer
    public nfun as Integer
    public merit as Double
    public violtn as Double
    public penalty as Double
    public itn as Integer
    public nf as Integer
    public nctotal as Integer
    public lncons_val as IntPtr ' pointer to double
    public major_iter_soln as Nag_Boolean
    public local_search as Nag_Boolean
    public nclin as Integer
    public ncnlin as Integer
    public nactiv as Integer
    public jdel as Integer
    public jadd as Integer
    public ninf as Integer
    public sum_infeasibilities as Double
    public bnd as Integer
    public lin as Integer
    public nln as Integer
    public t as IntPtr ' pointer to double
    public tdt as Integer
    public r as IntPtr ' pointer to double
    public diagr as IntPtr ' pointer to double
    public tdr as Integer
    public nart as Integer
    public nartm as Integer
    public nrz as Integer
    public nz as Integer
    public norm_gz as Double
    public norm_gf as Double
    public nopt as Integer
    public min_lm as Double
    public condt as Double
    public condr as Double
    public rzz as Double
    public rset as Nag_Boolean
    public ax as IntPtr ' pointer to double
    public cx as IntPtr ' pointer to double
    public nrank as Integer
    public nfixed as Integer
    public kx as IntPtr ' pointer to Integer
    public kactive as IntPtr ' pointer to Integer
    public lambda as IntPtr ' pointer to double
    public bclambda as IntPtr ' pointer to double
    public gq as IntPtr ' pointer to double
    public jmax as Integer
    public errmax as Double
    public moved as Nag_Boolean
    public nmoved as Integer
    public feasible as Nag_Boolean
    public rowerr as Nag_Boolean
    public first as Nag_Boolean
    public bl as IntPtr ' pointer to double
    public bu as IntPtr ' pointer to double
    public endstate as Nag_EndState
    public gprint as IntPtr ' pointer to Nag_GPrintSt
    public fmin as Double
    public fmax as Double
    public simplex as IntPtr ' pointer to double
    public prbtyp as IntPtr ' pointer to const char
    public tdfjac as Integer
    public col as Nag_Boolean
    public index as Integer
    public dnname as IntPtr ' pointer to const char
    public key as IntPtr ' pointer to const char
    public sstate as IntPtr ' pointer to char
    public val as Double
    public blo as Double
    public bup as Double
    public lmult as Double
    public objg as Double
    public just_feas as Nag_Boolean
    public qp as Nag_Boolean
    public pprice as Integer
    public rgval as Double
    public sb_add as Integer
    public sb_leave as Integer
    public b_leave as Integer
    public bswap_leave as Integer
    public pivot as Double
    public nnz_l as Integer
    public nnz_u as Integer
    public ncp as Integer
    public norm_rg as Double
    public nsb as Integer
    public root as Nag_Boolean
    public nnodes as Integer
    public node_num as Integer
    public parent_node as Integer
    public crnames as IntPtr ' pointer to char
    public node_status as Nag_NodeStatus
    public branch_index as Integer
    public x_before as Double
    public x_after as Double
    public x_lo as Double
    public x_up as Double
    public depth as Integer
    public posdef as Nag_Boolean
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_E04_Opt
    public f_name as IntPtr ' pointer to const char
    public f_longname as IntPtr ' pointer to const char
    public init1 as Integer
    public init2 as Integer
    public minlin as Nag_LinFun
    public grade as Integer
    public nf as Integer
    public iter as Integer
    public major_iter as Integer
    public max_iter as Integer
    public minor_max_iter as Integer
    public min_infeas as Nag_Boolean
    public f_est as Double
    public step_max as Double
    public step_limit as Double
    public max_line_step as Double
    public f_prec as Double
    public linesearch_tol as Double
    public optim_tol as Double
    public conf as IntPtr ' pointer to double
    public nag_conf as Integer
    public conjac as IntPtr ' pointer to double
    public nag_conjac as Integer
    public h as IntPtr ' pointer to double
    public nag_h as Integer
    public h_unit_init as Nag_Boolean
    public h_reset_freq as Integer
    public s as IntPtr ' pointer to double
    public nag_s as Integer
    public v as IntPtr ' pointer to double
    public nag_v as Integer
    public tdv as Integer
    public delta as IntPtr ' pointer to double
    public nag_delta as Integer
    public hesl as IntPtr ' pointer to double
    public nag_hesl as Integer
    public hesd as IntPtr ' pointer to double
    public nag_hesd as Integer
    public state as IntPtr ' pointer to Integer
    public nag_state as Integer
    public init_state as Nag_InitType
    public obj_deriv as Nag_Boolean
    public con_deriv as Nag_Boolean
    public f_diff_int as Double
    public c_diff_int as Double
    public obj_check_start as Integer
    public obj_check_stop as Integer
    public con_check_start as Integer
    public con_check_stop as Integer
    public verify_grad as Nag_GradChk
    public hessian as Nag_Boolean
    public local_search as Nag_Boolean
    public deriv_check as Nag_Boolean
    public list as Nag_Boolean
    public print_gcheck as Nag_Boolean
    public print_deriv as Nag_DPrintType
    public print_level as Nag_PrintType
    public minor_print_level as Nag_PrintType
    public print_iter as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=NAG_FILE_LEN)> public outfile() as Byte
    public print_fun as NAG_E04_PRINTFUN_DELEGATE
    public ax as IntPtr ' pointer to double
    public nag_ax as Integer
    public lambda as IntPtr ' pointer to double
    public nag_lambda as Integer
    public fcheck as Integer
    public crash_tol as Double
    public reset_ftol as Integer
    public fmax_iter as Integer
    public ftol as Double
    public lin_feas_tol as Double
    public nonlin_feas_tol as Double
    public hrows as Integer
    public inf_bound as Double
    public inf_step as Double
    public max_df as Integer
    public prob as Nag_ProblemType
    public rank_tol as Double
    public form_hessian as Nag_Boolean
    public start as Nag_Start
    public debug_iter as Integer
    public minor_debug_iter as Integer
    public dbug as Nag_Boolean
    public used as Nag_Boolean
    public unitq as Nag_Boolean
    public nfree as Integer
    public nactiv as Integer
    public nprob as Integer
    public n as Integer
    public nclin as Integer
    public ncnlin as Integer
    public bndlow as Double
    public bndupp as Double
    public minimize as Nag_Boolean
    public factor_freq as Integer
    public partial_price as Integer
    public max_sb as Integer
    public lu_factor_tol as Double
    public lu_sing_tol as Double
    public lu_update_tol as Double
    public pivot_tol as Double
    public scale_tol as Double
    public crash as Nag_CrashType
    public dnscale as Nag_ScaleType
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public prob_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public obj_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public bnd_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public rhs_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public range_name() as Byte
    public crnames as IntPtr ' pointer to char
    public nag_crnames as Integer
    public nsb as Integer
    public max_restart as Integer
    public max_basis_len as Integer
    public max_compress as Integer
    public max_basis_nfactor as Integer
    public col_lo_default as Double
    public col_up_default as Double
    public infinity as Double
    public ncol_approx as Integer
    public nrow_approx as Integer
    public est_density as Double
    public output_level as Nag_OutputType
    public deriv_want as Nag_DWantType
    public use_hfwd_init as Nag_Boolean
    public f_prec_used as Double
    public print_80ch as Nag_Boolean
    public feas_exit as Nag_Boolean
    public hess_freq as Integer
    public elastic_wt as Double
    public lu_den_tol as Double
    public part_price as Integer
    public scale_opt as Integer
    public expand_freq as Integer
    public hess_update as Integer
    public iter_lim as Integer
    public major_opt_tol as Double
    public minor_opt_tol as Double
    public unbounded_obj as Double
    public major_step_lim as Double
    public major_iter_lim as Integer
    public major_feas_tol as Double
    public minor_iter_lim as Integer
    public minor_feas_tol as Double
    public violation_limit as Double
    public nz_coef as Double
    public deriv_linesearch as Nag_Boolean
    public hess_storage as Nag_HessianType
    public direction as Nag_DirectionType
    public ncon as Integer
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_E04State
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=600*8)> public cw() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=600)> public iw() as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=600)> public rw() as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_E05State
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=100)> public comm() as Double
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_UserPrintFun
    public itc as Integer
    public rss as Double
    public objf as Double
    public para as IntPtr ' pointer to double
    public sd as IntPtr ' pointer to double
    public df as Double
    public npara as Integer
    public npe as Integer
    public mtyp as IntPtr ' pointer to Integer
    public mser as IntPtr ' pointer to Integer
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_G13_Opt
    public used as Nag_Boolean
    public f_name as IntPtr ' pointer to const char
    public init1 as Integer
    public init2 as Integer
    public cfixed as Nag_Boolean
    public criteria as Nag_Likelihood
    public max_iter as Integer
    public alpha as Double
    public beta as Double
    public delta as Double
    public gamma as Double
    public iter as Integer
    public cm as IntPtr ' pointer to double
    public tdcm as Integer
    public nag_cm as Integer
    public res as IntPtr ' pointer to double
    public lenres as Integer
    public nag_res as Integer
    public zt as IntPtr ' pointer to double
    public tdzt as Integer
    public nag_zt as Integer
    public noise as IntPtr ' pointer to double
    public nag_noise as Integer
    public isttf as Integer
    public sttf as IntPtr ' pointer to double
    public nag_sttf as Integer
    public nsttf as Integer
    public print_level as Nag_PrintType
    public list as Nag_Boolean
    public print_fun as NAG_G13_PRINTFUN_DELEGATE
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=NAG_FILE_LEN)> public outfile() as Byte
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_ArimaOrder
    public p as Integer
    public d as Integer
    public q as Integer
    public bigp as Integer
    public bigd as Integer
    public bigq as Integer
    public s as Integer
End Structure



<StructLayout(LayoutKind.Sequential)> Structure Nag_TransfOrder
    public init3 as Integer
    public b as IntPtr ' pointer to Integer
    public nag_b as Integer
    public q as IntPtr ' pointer to Integer
    public nag_q as Integer
    public p as IntPtr ' pointer to Integer
    public nag_p as Integer
    public r as IntPtr ' pointer to Integer
    public nag_r as Integer
End Structure



<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi)> Structure Nag_H02_Opt
    public f_name as IntPtr ' pointer to const char
    public f_longname as IntPtr ' pointer to const char
    public prob as Nag_MIP_ProbType
    public init1 as Integer
    public init2 as Integer
    public used as Nag_Boolean
    public list as Nag_Boolean
    public print_level as Nag_PrintType
    public print_fun as NAG_H02_PRINTFUN_DELEGATE
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=NAG_FILE_LEN)> public outfile() as Byte
    public max_iter as Integer
    public inf_bound as Double
    public feas_tol as Double
    public hrows as Integer
    public max_df as Integer
    public rank_tol as Double
    public first_soln as Nag_Boolean
    public max_depth as Integer
    public max_nodes as Integer
    public int_obj_bound as Double
    public soln_tol as Double
    public int_tol as Double
    public nodsel as Nag_Node_Selection
    public varsel as Nag_Var_Selection
    public branch_dir as Nag_Branch_Direction
    public priority as IntPtr ' pointer to double
    public lower as IntPtr ' pointer to double
    public upper as IntPtr ' pointer to double
    public lambda as IntPtr ' pointer to double
    public state as IntPtr ' pointer to Integer
    public nag_lower as Integer
    public nag_upper as Integer
    public nag_state as Integer
    public nag_lambda as Integer
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public prob_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public obj_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public bnd_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public rhs_name() as Byte
    <MarshalAs(UnmanagedType.ByValArray, sizeconst:=MPS_NAME_LEN+1)> public range_name() as Byte
    public crnames as IntPtr ' pointer to char
    public nag_crnames as Integer
    public col_lo_default as Double
    public col_up_default as Double
    public infinity as Double
    public ncol_approx as Integer
    public nrow_approx as Integer
    public output_level as Nag_OutputType
    public n_ivar as Integer
    public dbg as Nag_Boolean
    public dbg_rt as Nag_Boolean
    public dbg_rqip as Nag_Boolean
    public dbg_es as Nag_EndState
End Structure



' end of type declarations


' enumeration type declations


Public Enum NagMeanOrTrend
  Nag_NoCorrection=1538
  Nag_Mean=1539
  Nag_Trend=1540
End Enum


Public Enum Nag_BalanceType
  Nag_NoBalancing=2020
  Nag_BalancePermute=2021
  Nag_BalanceScale=2022
  Nag_BalanceBoth=2023
End Enum


Public Enum Nag_Barrier
  Nag_DownandIn=2200
  Nag_DownandOut=2201
  Nag_UpandIn=2202
  Nag_UpandOut=2203
End Enum


Public Enum Nag_BaseRNG
  Nag_Basic=2150
  Nag_WichmannHill_I=2151
  Nag_MersenneTwister=2152
  Nag_WichmannHill_II=2153
  Nag_ACORN=2154
  Nag_MRG32k3a=2155
End Enum


Public Enum Nag_Blocks
  Nag_NoBlocks=1454
  Nag_SerialBlocks=1455
  Nag_ParallelBlocks=1456
End Enum


Public Enum Nag_Boolean
  Nag_FALSE=0
  Nag_TRUE=1
End Enum


Public Enum Nag_BoundInterval
  Nag_UpperSemiInfinite=1076
  Nag_LowerSemiInfinite=1077
  Nag_Infinite=1078
End Enum


Public Enum Nag_BoundType
  Nag_BoundNotSet=1181
  Nag_Bounds=1182
  Nag_BoundsZero=1183
  Nag_BoundsEqual=1184
  Nag_NoBounds=1185
  Nag_NoBounds_One_Call=1186
End Enum


Public Enum Nag_Branch_Direction
  Nag_BrDir_NotSet=1586
  Nag_Branch_Left=1587
  Nag_Branch_Right=1588
  Nag_Branch_InitX=1589
End Enum


Public Enum Nag_BridgeOrder
  Nag_LRRoundDown=1
  Nag_LRRoundUp=2
  Nag_RLRoundDown=3
  Nag_RLRoundUp=4
End Enum


Public Enum Nag_CEMethod
  Nag_CE_EM=1475
  Nag_CE_NR=1476
End Enum


Public Enum Nag_CallPut
  Nag_Call=2190
  Nag_Put=2191
End Enum


Public Enum Nag_CestMethod
  Nag_Censored=1477
  Nag_NoCensored=1478
End Enum


Public Enum Nag_ClassBoundary
  Nag_ClassBoundaryUser=1346
  Nag_ClassBoundaryComp=1347
End Enum


Public Enum Nag_ClusterMethod
  Nag_SingleLink=1440
  Nag_CompleteLink=1441
  Nag_GroupAverage=1442
  Nag_Centroid=1443
  Nag_Median=1444
  Nag_MinVariance=1445
End Enum


Public Enum Nag_ColumnPermutationType
  Nag_Sparse_Identity=2120
  Nag_Sparse_User=2121
  Nag_Sparse_Colamd=2122
End Enum


Public Enum Nag_CompProb
  Nag_CompProbExact=1467
  Nag_CompProbApprox=1468
End Enum


Public Enum Nag_ComplexFormType
  Nag_AboveForm=1609
  Nag_BracketForm=1610
  Nag_DirectForm=1611
End Enum


Public Enum Nag_ComputeEigVecsType
  Nag_NotEigVecs=2040
  Nag_TridiagEigVecs=2041
  Nag_OrigEigVecs=2042
End Enum


Public Enum Nag_ComputeQType
  Nag_InitQ=1027
  Nag_NotQ=1028
  Nag_AccumulateQ=1029
  Nag_UpdateSchur=1030
End Enum


Public Enum Nag_ComputeSingularVecsType
  Nag_NotSingularVecs=2030
  Nag_PackedSingularVecs=2031
  Nag_SingularVecs=2032
End Enum


Public Enum Nag_ComputeType
  Nag_Compute_Definite=500046
  Nag_Compute_Definite_Indefinite=1066
  Nag_Compute_Indefinite=1067
End Enum


Public Enum Nag_ComputeUType
  Nag_AllU=2060
  Nag_NotU=2061
End Enum


Public Enum Nag_ComputeVTType
  Nag_NotVT=2100
  Nag_AllVT=2101
End Enum


Public Enum Nag_ComputeVType
  Nag_ComputeV=2070
  Nag_NotV=2071
  Nag_InitV=2072
End Enum


Public Enum Nag_ComputeZType
  Nag_InitZ=1031
  Nag_NotZ=1032
  Nag_AccumulateZ=1033
  Nag_UpdateZ=1034
End Enum


Public Enum Nag_CondErrType
  Nag_NoCondBackErr=3040
  Nag_CondOnly=3041
  Nag_BackErrLeft=3042
  Nag_BackErrRight=3043
  Nag_BackErrBoth=3044
  Nag_CondBackErrLeft=3045
  Nag_CondBackErrRight=3046
  Nag_CondBackErrBoth=3047
End Enum


Public Enum Nag_ConjType
  Nag_Conj=191
  Nag_NoConj=192
End Enum


Public Enum Nag_ControllerForm
  Nag_UH_Controller=1553
  Nag_LH_Controller=1554
End Enum


Public Enum Nag_CovMatrixEst
  Nag_CovNotSet=1388
  Nag_CovMatAve=1389
  Nag_CovMatObs=1390
End Enum


Public Enum Nag_CovOrCorr
  Nag_AutoCov=1545
  Nag_AutoCorr=1546
End Enum


Public Enum Nag_CrashType
  Nag_CrashNotSet=1252
  Nag_NoCrash=1253
  Nag_CrashOnce=1254
  Nag_CrashTwice=1255
  Nag_CrashThreeTimes=1256
End Enum


Public Enum Nag_DPrintType
  Nag_D_NotSet=1146
  Nag_D_NoPrint=1147
  Nag_D_Print=1148
  Nag_D_Sum=1149
  Nag_D_Full=1150
  Nag_D_Dbg=1151
End Enum


Public Enum Nag_DWantType
  Nag_DWant_NotSet=1155
  Nag_Grad_HessDiag=1156
  Nag_HessFull=1157
  Nag_Grad_HessFull=1158
End Enum


Public Enum Nag_DataByObsOrVar
  Nag_DataByVar=3070
  Nag_DataByObs=3071
End Enum


Public Enum Nag_DendOrient
  Nag_DendNorth=1446
  Nag_DendSouth=1447
  Nag_DendEast=1448
  Nag_DendWest=1449
End Enum


Public Enum Nag_DerivInfo
  Nag_DInfo_NotSet=1159
  Nag_Deriv_OK=1160
  Nag_Fun_Constant=1161
  Nag_Fun_LinearOdd=1162
  Nag_2ndDeriv_Large=1163
  Nag_1stDeriv_Small=1164
End Enum


Public Enum Nag_DerivSet
  Nag_DerivNotSet=1165
  Nag_SomeG_SomeJ=1166
  Nag_AllG_SomeJ=1167
  Nag_SomeG_AllJ=1168
  Nag_AllG_AllJ=1169
End Enum


Public Enum Nag_DerivType
  Nag_LeftDerivs=1104
  Nag_RightDerivs=1105
End Enum


Public Enum Nag_DiagType
  Nag_NonRefDiag=130
  Nag_NonUnitDiag=131
  Nag_UnitDiag=132
End Enum


Public Enum Nag_DirectionType
  Nag_DirectionNotSet=1617
  Nag_Minimize=1618
  Nag_Maximize=1619
  Nag_FeasiblePoint=1620
End Enum


Public Enum Nag_DiscreteDistrib
  Nag_PDF=1469
  Nag_CDF=1470
End Enum


Public Enum Nag_DiscrimMethod
  Nag_DiscrimEstimate=1426
  Nag_DiscrimPredict=1427
End Enum


Public Enum Nag_DistanceType
  Nag_DistAbs=1433
  Nag_DistEuclid=1434
  Nag_DistSquared=1435
End Enum


Public Enum Nag_Distributions
  Nag_Uniform=1485
  Nag_Normal=1486
  Nag_Gamma=1487
  Nag_Beta=1488
  Nag_ChiSquare=1489
  Nag_Binomial=1490
  Nag_Exponential=1491
  Nag_Poisson=1492
  Nag_UserProb=1493
  Nag_LogNormal=1494
  Nag_StudentT=1495
  Nag_NegBinomial=500011
  Nag_GenPareto=500012
End Enum


Public Enum Nag_DummyType
  Nag_Poly=1457
  Nag_Helmert=1458
  Nag_FirstLevel=1459
  Nag_LastLevel=1460
  Nag_AllLevels=1461
End Enum


Public Enum Nag_EigValRankType
  Nag_ByBlock=1052
  Nag_Entire=1053
End Enum


Public Enum Nag_EigValsSourceType
  Nag_HSEQRSource=1035
  Nag_NotKnown=1036
End Enum


Public Enum Nag_Eigenvalues
  Nag_AllEigVals=1450
  Nag_LargeEigVals=1451
End Enum


Public Enum Nag_EmbedPad
  Nag_EmbedPadZeros=1
  Nag_EmbedPadValues=2
End Enum


Public Enum Nag_EmbedScale
  Nag_EmbedScaleTraces=1
  Nag_EmbedScaleSqrtTraces=2
  Nag_EmbedScaleOne=3
End Enum


Public Enum Nag_EndState
  Nag_EndStateNotSet=1206
  Nag_Feasible=1207
  Nag_Optimal=1208
  Nag_Deadpoint=1209
  Nag_Weakmin=1210
  Nag_Unbounded=1211
  Nag_Infeasible=1212
  Nag_Too_Many_Iter=1213
  Nag_Hess_Too_Big=1214
  Nag_Cycling=1215
  Nag_Not_Converged=1216
  Nag_Not_Kuhn_Tucker=1217
  Nag_Deriv_Error=1218
  Nag_Hess_Indefinite=1219
  Nag_Basis_Ill_Cond=1220
  Nag_Basis_Singular=1221
  Nag_Out_Of_Workspace=1222
  Nag_MIP_Best_ISol=1223
  Nag_MIP_Stop_First_ISol=1224
  Nag_MIP_No_ISol=1225
  Nag_MIP_Root_Unbounded=1226
  Nag_MIP_Root_Infeasible=1227
  Nag_MIP_Root_Max_Itn=1228
  Nag_MIP_Root_Big_Hess=1229
  Nag_MIP_Max_Itn_ISol=1230
  Nag_MIP_Max_Nodes_ISol=1231
  Nag_MIP_Big_Hess_ISol=1232
  Nag_MIP_Max_Depth_ISol=1233
  Nag_MIP_Big_Hess_No_ISol=1234
  Nag_MIP_Max_Itn_No_ISol=1235
  Nag_MIP_Max_Nodes_No_ISol=1236
  Nag_MIP_Max_Depth_No_ISol=1237
  Nag_MIP_User_Stop=1238
End Enum


Public Enum Nag_EquilibrationType
  Nag_NoEquilibration=2000
  Nag_Equilibrated=2001
  Nag_RowEquilibration=2002
  Nag_ColumnEquilibration=2003
  Nag_RowAndColumnEquilibration=2004
End Enum


Public Enum Nag_ErrorAssess
  Nag_ErrorAssess_off=1097
  Nag_ErrorAssess_on=1098
End Enum


Public Enum Nag_ErrorControl
  Nag_Relative=1087
  Nag_Absolute=1088
  Nag_Mixed=1089
  Nag_Default=1089
End Enum


Public Enum Nag_ErrorDistn
  Nag_NormalDistn=1481
  Nag_Tdistn=1482
End Enum


Public Enum Nag_EstimatesOption
  Nag_EstimatesOrig=2610
  Nag_EstimatesStand=2611
End Enum


Public Enum Nag_EvaluateJacobian
  Nag_NumericalJacobian=0
  Nag_AnalyticalJacobian=1
  Nag_DefaultJacobian=2
  Nag_AnalyticalStructJacobian=3
  Nag_NumericalStructJacobian=4
End Enum


Public Enum Nag_ExpSmoothType
  Nag_SingleExponential=2580
  Nag_BrownsExponential=2581
  Nag_LinearHolt=2582
  Nag_AdditiveHoltWinters=2583
  Nag_MultiplicativeHoltWinters=2584
End Enum


Public Enum Nag_FacMat
  Nag_DataCorr=1415
  Nag_DataCovar=1416
  Nag_MatCorr_Covar=1417
End Enum


Public Enum Nag_FacRotation
  Nag_FacRotate=1420
  Nag_FacNoRotate=1421
End Enum


Public Enum Nag_FacScoreMethod
  Nag_FacScoreRegsn=1418
  Nag_FacScoreBart=1419
End Enum


Public Enum Nag_FactoredFormType
  Nag_Factored=2010
  Nag_NotFactored=2011
  Nag_EquilibrateAndFactor=2012
End Enum


Public Enum Nag_FullStepwise
  Nag_AddVar=2140
  Nag_BeginBackward=2141
  Nag_ColinearVar=2142
  Nag_DropVar=2143
  Nag_BeginForward=2144
  Nag_NoRemoveVar=2145
  Nag_BeginStepwise=2146
  Nag_VarianceRatio=2147
  Nag_FinishStepwise=2148
End Enum


Public Enum Nag_FunType
  Nag_Deriv=1170
  Nag_NoDeriv=1171
  Nag_Function=1172
End Enum


Public Enum Nag_Garch_Est_Initial_Type
  Nag_Garch_Est_Initial_True=1561
  Nag_Garch_Est_Initial_False=1562
End Enum


Public Enum Nag_Garch_Stationary_Type
  Nag_Garch_Stationary_True=1559
  Nag_Garch_Stationary_False=1560
End Enum


Public Enum Nag_GaussFormulae
  Nag_Legendre=1081
  Nag_Rational=1082
  Nag_Laguerre=1083
  Nag_Hermite=1084
End Enum


Public Enum Nag_GradChk
  Nag_ChkNotSet=1136
  Nag_NoCheck=1137
  Nag_SimpleCheck=1138
  Nag_CheckObj=1139
  Nag_CheckCon=1140
  Nag_CheckObjCon=1141
  Nag_XSimpleCheck=1142
  Nag_XCheckObj=1143
  Nag_XCheckCon=1144
  Nag_XCheckObjCon=1145
End Enum


Public Enum Nag_GroupCovars
  Nag_EqualCovar=1422
  Nag_NotEqualCovar=1423
End Enum


Public Enum Nag_HessianType
  Nag_HessianNotSet=1614
  Nag_HessianFull=1615
  Nag_HessianLimited=1616
End Enum


Public Enum Nag_HowManyType
  Nag_ComputeAll=1037
  Nag_BackTransform=1038
  Nag_ComputeSelected=1039
End Enum


Public Enum Nag_IncSignZeros
  Nag_IncSignZerosY=1483
  Nag_IncSignZerosN=1484
End Enum


Public Enum Nag_IncludeIntercept
  Nag_Intercept=2840
  Nag_NoIntercept=2841
End Enum


Public Enum Nag_IncludeMean
  Nag_MeanInclude=1358
  Nag_MeanZero=1359
End Enum


Public Enum Nag_InitType
  Nag_InitNotSet=1176
  Nag_Init_None=1177
  Nag_Init_F_G_H=1178
  Nag_Init_All=1179
  Nag_Init_H_S=1180
End Enum


Public Enum Nag_InitVeenumtype
  Nag_NoVec=1040
  Nag_UserVec=1041
End Enum


Public Enum Nag_InitialValues
  Nag_InitialValuesSupplied=2172
  Nag_ContinueNoUpdate=2170
  Nag_ContinueAndUpdate=2171
End Enum


Public Enum Nag_InitializeA
  Nag_InitializeI=1471
  Nag_InputA=1472
End Enum


Public Enum Nag_IntervalType
  Nag_TukeyInterval=1462
  Nag_BonferroniInterval=1463
  Nag_DunnInterval=1464
  Nag_FisherInterval=1465
  Nag_ScheffeInterval=1466
End Enum


Public Enum Nag_JobType
  Nag_DoBoth=1044
  Nag_EigVals=1045
  Nag_DoNothing=1046
  Nag_Permute=1047
  Nag_Schur=1048
  Nag_Scale=1049
  Nag_Subspace=1050
  Nag_EigVecs=1051
End Enum


Public Enum Nag_KernelForm
  Nag_NoCentroSymm=2760
  Nag_CentroSymmOdd=2761
  Nag_CentroSymmEven=2762
  Nag_CentroSymmNeither=2763
End Enum


Public Enum Nag_LARSModelType
  Nag_LARS_LAR=4000
  Nag_LARS_ForwardStagewise=4001
  Nag_LARS_LASSO=4002
  Nag_LARS_PositiveLASSO=4003
End Enum


Public Enum Nag_LARSPreProcess
  Nag_LARS_None=4010
  Nag_LARS_Centered=4011
  Nag_LARS_Normalized=4012
  Nag_LARS_CenteredNormalized=4013
End Enum


Public Enum Nag_LARSTargetType
  Nag_LARS_StepNumber=4020
  Nag_LARS_ScaledNorm=4021
  Nag_LARS_ProportionScaledNorm=4022
  Nag_LARS_UnscaledNorm=4023
  Nag_LARS_ProportionUnscaledNorm=4024
End Enum


Public Enum Nag_LCCMethod
  Nag_LCCPan=1348
  Nag_LCCImhof=1349
  Nag_LCCDefault=1350
End Enum


Public Enum Nag_LabelType
  Nag_NoLabels=1603
  Nag_IntegerLabels=1604
  Nag_CharacterLabels=1605
End Enum


Public Enum Nag_LeftVecsType
  Nag_LeftVecs=2080
  Nag_NotLeftVecs=2081
  Nag_LeftSpan=2082
  Nag_NotLeftWork=2083
  Nag_LeftVecsCtol=2084
End Enum


Public Enum Nag_Likelihood
  Nag_CriteriaNotSet=1530
  Nag_LeastSquares=1531
  Nag_Exact=1532
  Nag_Marginal=1533
End Enum


Public Enum Nag_LinAlgOption
  Nag_LinAlgFull=1119
  Nag_LinAlgBand=1120
  Nag_LinAlgSparse=1121
End Enum


Public Enum Nag_LinFun
  Nag_LinFunNotSet=1173
  Nag_Lin_Deriv=1174
  Nag_Lin_NoDeriv=1175
End Enum


Public Enum Nag_Link
  Nag_Expo=1366
  Nag_Iden=1367
  Nag_Log=1368
  Nag_Sqrt=1369
  Nag_Reci=1370
  Nag_Logistic=1371
  Nag_Probit=1372
  Nag_Compl=1373
End Enum


Public Enum Nag_LoggedSpectra
  Nag_Unlogged=1541
  Nag_Logged=1542
End Enum


Public Enum Nag_MCMethod
  Nag_OneIteration=1085
  Nag_ManyIterations=1086
End Enum


Public Enum Nag_MCSInitMethod
  Nag_SimpleBdry=2670
  Nag_SimpleOffBdry=2671
  Nag_Linesearch=2672
  Nag_UserSet=2673
  Nag_Random=2674
End Enum


Public Enum Nag_MIP_ProbType
  Nag_MIP_TypeNotSet=1570
  Nag_MILP=1571
  Nag_MIQP1=1572
  Nag_MIQP2=1573
  Nag_MIQP3=1574
  Nag_MIQP4=1575
End Enum


Public Enum Nag_MahalDist
  Nag_SamplePoints=1424
  Nag_GroupMeans=1425
End Enum


Public Enum Nag_MatFunType
  Nag_Exp=2830
  Nag_Sin=2831
  Nag_Cos=2832
  Nag_Sinh=2833
  Nag_Cosh=2834
  Nag_Loga=2835
End Enum


Public Enum Nag_MatUpdate
  Nag_MatUp=1431
  Nag_NoMatUp=1432
End Enum


Public Enum Nag_MatrixType
  Nag_GeneralMatrix=1606
  Nag_LowerMatrix=1607
  Nag_UpperMatrix=1608
End Enum


Public Enum Nag_MeshSet
  Nag_DefInitMesh=1090
  Nag_UserInitMesh=1091
End Enum


Public Enum Nag_MeshType
  Nag_UniformMesh=1117
  Nag_CustomMesh=1118
End Enum


Public Enum Nag_ModeRNG
  Nag_InitializeReference=2160
  Nag_GenerateFromReference=2161
  Nag_InitializeAndGenerate=2162
  Nag_GenerateWithoutReference=2163
End Enum


Public Enum Nag_MomentType
  Nag_RatioMoments=1353
  Nag_LinearRatio=1354
  Nag_QuadRatio=1355
End Enum


Public Enum Nag_NearCorr_ProbType
  Nag_LowerBound=2810
  Nag_WeightedNorm=2811
  Nag_Both=2812
End Enum


Public Enum Nag_NodeStatus
  Nag_NS_NotSet=1590
  Nag_NS_NotSolved=1591
  Nag_NS_NotBranched=1592
  Nag_NS_Integer=1593
  Nag_NS_Bounded=1594
  Nag_NS_Infeasible=1595
  Nag_NS_Terminated=1596
End Enum


Public Enum Nag_Node_Selection
  Nag_NodSel_NotSet=1576
  Nag_Deep_Search=1577
  Nag_Broad_Search=1578
  Nag_MinObj_Search=1579
  Nag_DeepBroad_Search=1580
  Nag_DeepMinObj_Search=1581
End Enum


Public Enum Nag_NormType
  Nag_OneNorm=171
  Nag_TwoNorm=173
  Nag_FrobeniusNorm=174
  Nag_InfNorm=175
  Nag_MaxNorm=177
  Nag_RealMaxNorm=178
End Enum


Public Enum Nag_ODEMethod
  Nag_Adams=2750
  Nag_BDF=2751
End Enum


Public Enum Nag_ObserverForm
  Nag_UH_Observer=1551
  Nag_LH_Observer=1552
End Enum


Public Enum Nag_OptimOpt
  Nag_PWM=2660
  Nag_MOM=2661
  Nag_MOMMLE=2662
  Nag_PWMMLE=2663
End Enum


Public Enum Nag_OptionLOO
  Nag_WantLOO=2640
  Nag_NoLOO=2641
End Enum


Public Enum Nag_OptionType
  Nag_EuropeanCall=1113
  Nag_AmericanCall=1114
  Nag_EuropeanPut=1115
  Nag_AmericanPut=1116
End Enum


Public Enum Nag_OrderType
  Nag_RowMajor=101
  Nag_ColMajor=102
End Enum


Public Enum Nag_OsherVersion
  Nag_OsherOriginal=1122
  Nag_OsherPhysical=1123
End Enum


Public Enum Nag_OutputType
  Nag_OutputNotSet=1563
  Nag_NoOutput=1564
  Nag_MPS_Summary=1565
  Nag_MPS_List=1566
End Enum


Public Enum Nag_ParaEstimates
  Nag_ParaSupplied=1496
  Nag_ParaEstimated=1497
End Enum


Public Enum Nag_ParaOption
  Nag_NoPara=2630
  Nag_OrigPara=2631
  Nag_StandPara=2632
End Enum


Public Enum Nag_Parity
  Nag_Odd=1
  Nag_Even=2
End Enum


Public Enum Nag_Perturb
  Nag_PerturbOn=2800
  Nag_PerturbOff=2801
End Enum


Public Enum Nag_PopVar
  Nag_PopVarEqual=1473
  Nag_PopVarNotEqual=1474
End Enum


Public Enum Nag_PredictError
  Nag_BIC=2600
  Nag_FPE=2601
  Nag_LOOCV=2602
  Nag_EUV=2603
  Nag_GCV=2604
  Nag_UEV=2605
End Enum


Public Enum Nag_Preprocess
  Nag_ColpivRrank=2780
  Nag_ColpivRrankCond=2781
  Nag_FullpivRrank=2782
  Nag_FullpivRrankCond=2783
  Nag_ColpivSVrankAbs=2784
  Nag_ColpivSVrankRel=2785
End Enum


Public Enum Nag_PrinCompMat
  Nag_MatCorrelation=1393
  Nag_MatStandardised=1394
  Nag_MatSumSq=1395
  Nag_MatVarCovar=1396
End Enum


Public Enum Nag_PrinCompScores
  Nag_ScoresStand=1397
  Nag_ScoresNotStand=1398
  Nag_ScoresUnitVar=1399
  Nag_ScoresEigenval=1400
End Enum


Public Enum Nag_PrintType
  Nag_PrintNotSet=1124
  Nag_NoPrint=1125
  Nag_Soln_Root=1126
  Nag_Soln=1127
  Nag_Iter=1128
  Nag_Iter_Long=1129
  Nag_Soln_Root_Iter=1130
  Nag_Soln_Iter=1131
  Nag_Soln_Iter_Long=1132
  Nag_Soln_Iter_Const=1133
  Nag_Soln_Iter_Diag=1134
  Nag_Soln_Iter_Full=1135
End Enum


Public Enum Nag_PriorProbability
  Nag_EqualPrior=1428
  Nag_GroupSizePrior=1429
  Nag_UserPrior=1430
End Enum


Public Enum Nag_ProblemType
  Nag_ProbTypeNotSet=1187
  Nag_FP=1188
  Nag_LP=1189
  Nag_QP1=1190
  Nag_QP2=1191
  Nag_QP3=1192
  Nag_QP4=1193
  Nag_LS1=1194
  Nag_LS2=1195
  Nag_LS3=1196
  Nag_LS4=1197
  Nag_SparseFP=1198
  Nag_SparseLP=1199
  Nag_SparseQP=1200
  Nag_SparseFPE=1201
  Nag_SparseFPL=1202
  Nag_SparseFPS=1203
  Nag_SparseQPP=1204
  Nag_SparseQPS=1205
End Enum


Public Enum Nag_PsiFun
  Nag_PsiNotSet=1378
  Nag_Lsq=1379
  Nag_HuberFun=1380
  Nag_HampelFun=1381
  Nag_AndrewFun=1382
  Nag_TukeyFun=1383
End Enum


Public Enum Nag_QuadType
  Nag_Quad_Gauss_Legendre=2710
  Nag_Quad_Gauss_Jacobi=2710
  Nag_Quad_Gauss_Jacobi_Adjusted=2710
  Nag_Quad_Gauss_Exponential=2715
  Nag_Quad_Gauss_Exponential_Adjusted=2715
  Nag_Quad_Gauss_Laguerre=2713
  Nag_Quad_Gauss_Laguerre_Adjusted=2713
  Nag_Quad_Gauss_Hermite=2714
  Nag_Quad_Gauss_Hermite_Adjusted=2714
  Nag_Quad_Gauss_Rational=2715
  Nag_Quad_Gauss_Rational_Adjusted=2715
End Enum


Public Enum Nag_QuadWeight
  Nag_Alg=1072
  Nag_Alg_loga=1073
  Nag_Alg_logb=1074
  Nag_Alg_loga_logb=1075
End Enum


Public Enum Nag_QuasiRandom_Scrambling
  Nag_NoScrambling=2590
  Nag_OwenLike=2591
  Nag_FaureTezuka=2592
  Nag_OwenFaureTezuka=2593
End Enum


Public Enum Nag_QuasiRandom_Sequence
  Nag_QuasiRandom_Sobol=1624
  Nag_QuasiRandom_SobolA659=1627
  Nag_QuasiRandom_Nied=1626
End Enum


Public Enum Nag_RCIMethod
  Nag_RCI_Exact=1479
  Nag_RCI_Approx=1480
End Enum


Public Enum Nag_RCondType
  Nag_NotRCond=2050
  Nag_RCondEigVals=2051
  Nag_RCondLeft=2052
  Nag_RCondRight=2053
  Nag_RCondEigVecs=2053
  Nag_RCondBoth=2053
End Enum


Public Enum Nag_RFP_Store
  Nag_RFP_Normal=2700
  Nag_RFP_Trans=2701
  Nag_RFP_ConjTrans=2702
End Enum


Public Enum Nag_RK_method
  Nag_RK_2_3=1094
  Nag_RK_4_5=1095
  Nag_RK_7_8=1096
End Enum


Public Enum Nag_RK_task
  Nag_RK_range=1092
  Nag_RK_onestep=1093
End Enum


Public Enum Nag_RangeStat
  Nag_UseRange=1543
  Nag_UseSD=1544
End Enum


Public Enum Nag_RangeType
  Nag_AllValues=1054
  Nag_Interval=1055
  Nag_Indices=1056
End Enum


Public Enum Nag_RegType
  Nag_RegNotSet=1374
  Nag_HuberReg=1375
  Nag_MallowsReg=1376
  Nag_SchweppeReg=1377
End Enum


Public Enum Nag_RegularizedType
  Nag_Regularized=2910
  Nag_NotRegularized=2911
End Enum


Public Enum Nag_RightVecsType
  Nag_RightVecs=2090
  Nag_NotRightVecs=2091
   Nag_RightVecsJRots=2092
  Nag_NotRightWork=2093
  Nag_RightVecsMV=2094
End Enum


Public Enum Nag_RotationLoading
  Nag_RoLoadStand=1405
  Nag_RoLoadNotStand=1406
End Enum


Public Enum Nag_RotationScale
  Nag_LsqScale=1413
  Nag_NotLsqScale=1414
End Enum


Public Enum Nag_ScaleCriterion
  Nag_Stress=1452
  Nag_SStress=1453
End Enum


Public Enum Nag_ScalePredictor
  Nag_PredNoScale=2620
  Nag_PredStdScale=2621
  Nag_PredUserScale=2622
End Enum


Public Enum Nag_ScaleResType
  Nag_ScaleRes=1601
  Nag_UnscaleRes=1602
End Enum


Public Enum Nag_ScaleType
  Nag_NoScale=1258
  Nag_NoScaleProvided=1262
  Nag_ScaleProvided=1261
  Nag_ScaleNotSet=1257
  Nag_RowColScale=1259
  Nag_ExtraScale=1260
End Enum


Public Enum Nag_Scores
  Nag_RankScores=1335
  Nag_NormalScores=1336
  Nag_BlomScores=1337
  Nag_TukeyScores=1338
  Nag_WaerdenScores=1339
  Nag_SavageScores=1340
End Enum


Public Enum Nag_SearchMatch
  Nag_First=1599
  Nag_Last=1600
End Enum


Public Enum Nag_SelectMoments
  Nag_CumulantsOnly=1351
  Nag_ComputeMoments=1352
End Enum


Public Enum Nag_Select_Eigenvalues
  Nag_Select_Modulus=1265
  Nag_Select_RealPart=1266
End Enum


Public Enum Nag_Series
  Nag_SeriesGeneral=0
  Nag_SeriesEven=1
  Nag_SeriesOdd=2
End Enum


Public Enum Nag_SideType
  Nag_LeftSide=141
  Nag_RightSide=142
  Nag_BothSides=143
End Enum


Public Enum Nag_SigmaEst
  Nag_SigmaNotSet=1384
  Nag_SigmaRes=1385
  Nag_SigmaConst=1386
  Nag_SigmaChi=1387
End Enum


Public Enum Nag_SigmaSimulEst
  Nag_SigmaSimul=1391
  Nag_SigmaBypas=1392
End Enum


Public Enum Nag_SignType
  Nag_Plus=1042
  Nag_Minus=1043
End Enum


Public Enum Nag_SignsType
  Nag_LowerMinus=3050
  Nag_UpperMinus=3051
End Enum


Public Enum Nag_SmoothFitType
  Nag_SmoothFitPartial=1507
  Nag_SmoothFitQuick=1508
  Nag_SmoothFitFull=1509
End Enum


Public Enum Nag_SmoothParamMethods
  Nag_SmoothParamCV=1510
  Nag_SmoothParamGCV=1511
  Nag_SmoothParamDF=1512
End Enum


Public Enum Nag_Smooth_Type
  Nag_4253H=1505
  Nag_3RSSH=1506
End Enum


Public Enum Nag_SolDeriv
  Nag_Sol=1099
  Nag_Der=1100
  Nag_SolDer=1101
End Enum


Public Enum Nag_SolveSystem
  Nag_LDLTX=1267
  Nag_LDX=1268
  Nag_DLTX=1269
  Nag_LLTX=1270
  Nag_LX=1271
  Nag_LTX=1272
End Enum


Public Enum Nag_SortEigValsType
  Nag_NoSortEigVals=2110
  Nag_SortEigVals=2111
End Enum


Public Enum Nag_SortOrder
  Nag_Ascending=1597
  Nag_Descending=1598
  Nag_Unsorted=500013
End Enum


Public Enum Nag_SparseNsym_CheckData
  Nag_SparseNsym_NoCheck=1314
  Nag_SparseNsym_Check=1315
End Enum


Public Enum Nag_SparseNsym_Dups
  Nag_SparseNsym_RemoveDups=1289
  Nag_SparseNsym_SumDups=1290
  Nag_SparseNsym_FailDups=1291
End Enum


Public Enum Nag_SparseNsym_Fact
  Nag_SparseNsym_ModFact=1279
  Nag_SparseNsym_UnModFact=1280
End Enum


Public Enum Nag_SparseNsym_Method
  Nag_SparseNsym_RGMRES=1273
  Nag_SparseNsym_CGS=1274
  Nag_SparseNsym_BiCGSTAB=1275
  Nag_SparseNsym_CG=1276
  Nag_SparseNsym_SYMMLQ=1277
  Nag_SparseNsym_TFQMR=1278
  Nag_SparseNsym_MINRES=1279
End Enum


Public Enum Nag_SparseNsym_Piv
  Nag_SparseNsym_NoPiv=1281
  Nag_SparseNsym_UserPiv=1282
  Nag_SparseNsym_PartialPiv=1283
  Nag_SparseNsym_CompletePiv=1284
  Nag_SparseNsym_MarkowitzPiv=1285
End Enum


Public Enum Nag_SparseNsym_PrecType
  Nag_SparseNsym_NoPrec=1299
  Nag_SparseNsym_SSORPrec=1300
  Nag_SparseNsym_JacPrec=1301
  Nag_SparseNsym_Prec=1302
End Enum


Public Enum Nag_SparseNsym_Store
  Nag_SparseNsym_StoreCS=1292
  Nag_SparseNsym_StoreSCS=1293
End Enum


Public Enum Nag_SparseNsym_Weight
  Nag_SparseNsym_Weighted=1303
  Nag_SparseNsym_UnWeighted=1304
End Enum


Public Enum Nag_SparseNsym_Zeros
  Nag_SparseNsym_RemoveZeros=1286
  Nag_SparseNsym_KeepZeros=1287
  Nag_SparseNsym_FailZeros=1288
End Enum


Public Enum Nag_SparseSym_Bisection
  Nag_SparseSym_Bisect=1307
  Nag_SparseSym_NoBisect=1308
End Enum


Public Enum Nag_SparseSym_CheckData
  Nag_SparseSym_NoCheck=1316
  Nag_SparseSym_Check=1317
End Enum


Public Enum Nag_SparseSym_Dups
  Nag_SparseSym_SumDups=1325
  Nag_SparseSym_RemoveDups=1326
End Enum


Public Enum Nag_SparseSym_Fact
  Nag_SparseSym_ModFact=1297
  Nag_SparseSym_UnModFact=1298
End Enum


Public Enum Nag_SparseSym_Method
  Nag_SparseSym_CG=1294
  Nag_SparseSym_Lanczos=1295
  Nag_SparseSym_TFQMR=1296
End Enum


Public Enum Nag_SparseSym_Piv
  Nag_SparseSym_NoPiv=1318
  Nag_SparseNsym_UserPiv=1319
  Nag_SparseNsym_PartialPiv=1320
  Nag_SparseNsym_CompletePiv=1321
  Nag_SparseNsym_MarkowitzPiv=1322
End Enum


Public Enum Nag_SparseSym_PrecType
  Nag_SparseSym_Prec=1321
  Nag_SparseSym_NoPrec=1322
  Nag_SparseSym_SSORPrec=1323
  Nag_SparseSym_JacPrec=1324
End Enum


Public Enum Nag_SparseSym_Weight
  Nag_SparseSym_Weighted=1305
  Nag_SparseSym_UnWeighted=1306
End Enum


Public Enum Nag_SparseSym_Zeros
  Nag_SparseSym_KeepZeros=1327
  Nag_SparseSym_RemoveZeros=1328
End Enum


Public Enum Nag_SplineVectorSort
  Nag_SplineVectorSort_Sorted=1
  Nag_SplineVectorSort_Sorted_Indexed=2
  Nag_SplineVectorSort_Sorted_Indexed_Perm=3
  Nag_SplineVectorSort_Unsorted=4
  Nag_SplineVectorSort_Unsorted_Indexed=5
End Enum


Public Enum Nag_Start
  Nag_StartNotSet=1106
  Nag_Cold=1107
  Nag_Warm=1108
  Nag_Hot=1109
  Nag_NewStart=1110
  Nag_ReStart=1111
  Nag_Continue=1112
  Nag_BasisFile=50001
End Enum


Public Enum Nag_SumSquare
  Nag_AboutMean=1362
  Nag_AboutZero=1363
End Enum


Public Enum Nag_TS_ChangeType
  Nag_NormalMean=2990
  Nag_NormalStd=2991
  Nag_NormalMeanStd=2992
  Nag_GammaScale=2993
  Nag_ExponentialLambda=2994
  Nag_PoissonLambda=2995
End Enum


Public Enum Nag_TS_Interpolation
  Nag_PreviousPoint=2850
  Nag_Linear=2851
  Nag_NextPoint=2852
End Enum


Public Enum Nag_TS_SegSide
  Nag_FirstSegCall=3000
  Nag_SecondSegCall=3001
  Nag_LeftSubSeg=3002
  Nag_RightSubSeg=3003
End Enum


Public Enum Nag_TS_Transform
  Nag_Identity=2860
  Nag_AbsVal=2861
  Nag_AbsDiff=2862
  Nag_AbsValScaled=2863
  Nag_AbsDiffScaled=2864
End Enum


Public Enum Nag_TS_URProbMethod
  Nag_ViaLookUp=3020
  Nag_ViaLookUpOriginal=3021
  Nag_ViaSimulation=3022
End Enum


Public Enum Nag_TS_URTestType
  Nag_UnitRoot=3020
  Nag_UnitRootWithDrift=3021
  Nag_UnitRootWithDriftAndTrend=3022
End Enum


Public Enum Nag_TableStats
  Nag_TableStatsNObs=1515
  Nag_TableStatsTotal=1516
  Nag_TableStatsAv=1517
  Nag_TableStatsMedian=1518
  Nag_TableStatsVar=1519
  Nag_TableStatsLarge=1520
  Nag_TableStatsSmall=1521
End Enum


Public Enum Nag_TableUpdate
  Nag_TableUpdateU=1522
  Nag_TableUpdateI=1523
End Enum


Public Enum Nag_TabulateVar
  Nag_TabulateVarDiscr=1524
  Nag_TabulateVarCont=1525
End Enum


Public Enum Nag_TailProbability
  Nag_LowerTail=1329
  Nag_UpperTail=1330
  Nag_TwoTailSignif=1331
  Nag_TwoTailConfid=1332
  Nag_Central=1334
  Nag_TwoTail=1333
End Enum


Public Enum Nag_TestStatistics
  Nag_DavidsAndMoodsTest=500032
  Nag_DavidsTest=500033
  Nag_MoodsTest=500034
End Enum


Public Enum Nag_Ties
  Nag_AverageTies=1341
  Nag_LowestTies=1342
  Nag_HighestTies=1343
  Nag_RandomTies=1344
  Nag_IgnoreTies=1345
End Enum


Public Enum Nag_TransNorm
  Nag_NoTransNorm=1407
  Nag_Orig=1408
  Nag_OrigCentroid=1409
  Nag_Norm=1410
  Nag_OrigNorm=1411
  Nag_OrigNormCentroid=1412
End Enum


Public Enum Nag_TransType
  Nag_NoTrans=111
  Nag_Trans=112
  Nag_ConjTrans=113
End Enum


Public Enum Nag_TransformDirection
  Nag_ForwardTransform=1070
  Nag_BackwardTransform=1071
End Enum


Public Enum Nag_TrigTransform
  Nag_Cosine=1079
  Nag_Sine=1080
End Enum


Public Enum Nag_UpdateObserv
  Nag_ObservAdd=1360
  Nag_ObservDel=1361
End Enum


Public Enum Nag_UploType
  Nag_Upper=121
  Nag_Lower=122
End Enum


Public Enum Nag_VIFOption
  Nag_NoVIF=2650
  Nag_WantVIF=2651
End Enum


Public Enum Nag_VarCovar
  Nag_GroupCovar=2920
  Nag_PooledCovar=2921
  Nag_GroupVar=2922
  Nag_PooledVar=2923
  Nag_OverallVar=2924
End Enum


Public Enum Nag_VarScaleType
  Nag_VarScaleStd=1436
  Nag_VarScaleRange=1437
  Nag_VarScaleUser=1438
  Nag_NoVarScale=1439
End Enum


Public Enum Nag_Var_Selection
  Nag_VarSel_NotSet=1582
  Nag_First_Int=1583
  Nag_Nearest_Half=1584
  Nag_Use_Priority=1585
End Enum


Public Enum Nag_VariableType
  Nag_Real=2740
  Nag_Integer=2741
  Nag_Character=2742
  Nag_Integer_Additional=2743
  Nag_Real_Additional=2744
End Enum


Public Enum Nag_Variogram
  Nag_VgmSymmStab=1
  Nag_VgmCauchy=2
  Nag_VgmDifferential=3
  Nag_VgmExponential=4
  Nag_VgmGauss=5
  Nag_VgmNugget=6
  Nag_VgmSpherical=7
  Nag_VgmBessel=8
  Nag_VgmHole=9
  Nag_VgmWhittleMatern=10
  Nag_VgmContParam=11
  Nag_VgmGenHyp=12
  Nag_VgmCosine=13
  Nag_VgmBrownian=14
End Enum


Public Enum Nag_VectType
  Nag_FormBoth=1057
  Nag_DoNotForm=1058
  Nag_ApplyP=1060
  Nag_FormP=1059
  Nag_FormX=1064
  Nag_ApplyQ=1062
  Nag_FormQ=1061
  Nag_UpdateQ=1063
End Enum


Public Enum Nag_VectorOp
  Nag_Convolution=1068
  Nag_Correlation=1069
End Enum


Public Enum Nag_Wavelet
  Nag_Morlet=2240
  Nag_DGauss=2241
  Nag_MexHat=2242
  Nag_Haar=2243
  Nag_Daubechies2=2244
  Nag_Daubechies3=2245
  Nag_Daubechies4=2246
  Nag_Daubechies5=2247
  Nag_Daubechies6=2248
  Nag_Daubechies7=2249
  Nag_Daubechies8=2250
  Nag_Daubechies9=2251
  Nag_Daubechies10=2252
  Nag_Biorthogonal1_1=2253
  Nag_Biorthogonal1_3=2254
  Nag_Biorthogonal1_5=2255
  Nag_Biorthogonal2_2=2256
  Nag_Biorthogonal2_4=2257
  Nag_Biorthogonal2_6=2258
  Nag_Biorthogonal2_8=2259
  Nag_Biorthogonal3_1=2260
  Nag_Biorthogonal3_3=2261
  Nag_Biorthogonal3_5=2262
  Nag_Biorthogonal3_7=2263
End Enum


Public Enum Nag_WaveletCoefficients
  Nag_StoreFinal=2570
  Nag_StoreAll=2571
End Enum


Public Enum Nag_WaveletMode
  Nag_HalfPointSymmetric=2220
  Nag_WholePointSymmetric=2221
  Nag_Periodic=2222
  Nag_ZeroPadded=2223
End Enum


Public Enum Nag_WaveletTransform
  Nag_SingleLevel=2560
  Nag_MultiLevel=2561
  Nag_MODWTSingle=2562
  Nag_MODWTMulti=2563
End Enum


Public Enum Nag_WeightMode
  Nag_InitWeights=2770
  Nag_ReuseWeights=2771
End Enum


Public Enum Nag_Weightstype
  Nag_NoWeights=1401
  Nag_Weights=1402
  Nag_Weightsfreq=1403
  Nag_Weightsvar=1404
End Enum


Public Enum Nag_WindowType
  Nag_WindowSupplied=2900
  Nag_RuleOfThumb=2901
End Enum


Public Enum Nag_ZeroCols
  Nag_ZeroColsNormal=2790
  Nag_ZeroColsRestrict=2791
End Enum


Public Enum Nag_ab_input
  Nag_ab_prod=1549
  Nag_ab_sep=1550
End Enum



' end enumeration types


' delegate declarations



Delegate Sub NAG_E04_PRINTFUN_DELEGATE ( _
   ByRef p1 As Nag_Search_State, _
   ByRef p2 As Nag_Comm _
)

Delegate Sub NAG_ERRHAN_DELEGATE ( _
   ByRef p1 As Byte, _
   ByVal p2 As Integer, _
   ByRef p3 As Byte _
)

Delegate Sub NAG_G13_PRINTFUN_DELEGATE ( _
   ByRef p1 As Nag_UserPrintFun, _
   ByRef p2 As Nag_Comm _
)

Delegate Sub NAG_H02_PRINTFUN_DELEGATE ( _
   ByRef p1 As Nag_Search_State, _
   ByRef p2 As Nag_Comm _
)


' end of type declarations

   

' chapter a00

   Declare Sub nag_implementation_details Lib "CLW3225DA_nag.dll" Alias "a00aac" ( _
   )

   Declare Sub a00aac Lib "CLW3225DA_nag.dll" ( _
   )


   Declare Function nag_licence_query Lib "CLW3225DA_nag.dll" Alias "a00acc" ( _
   ) as Integer

   Declare Function a00acc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


   Declare Sub nag_implementation_separated_details Lib "CLW3225DA_nag.dll" Alias "a00adc" ( _
    ByVal impl As String, _
    ByVal prec As String, _
    ByVal pcode As String, _
    ByVal mkmaj As String, _
    ByVal mkmin As String, _
    ByVal hdware As String, _
    ByVal opsys As String, _
    ByVal ccomp As String, _
    ByVal fcomp As String, _
    ByVal vend As String, _
    ByRef licval As Nag_Boolean _
   )

   Declare Sub a00adc Lib "CLW3225DA_nag.dll" ( _
    ByVal impl As String, _
    ByVal prec As String, _
    ByVal pcode As String, _
    ByVal mkmaj As String, _
    ByVal mkmin As String, _
    ByVal hdware As String, _
    ByVal opsys As String, _
    ByVal ccomp As String, _
    ByVal fcomp As String, _
    ByVal vend As String, _
    ByRef licval As Nag_Boolean _
   )


' chapter a02

   Declare Function nag_complex Lib "CLW3225DA_nag.dll" Alias "a02bac" ( _
    ByVal x As Double, _
    ByVal y As Double _
   ) as Complex

   Declare Function a02bac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double _
   ) as Complex


   Declare Function nag_complex_real Lib "CLW3225DA_nag.dll" Alias "a02bbc" ( _
    ByVal z As Complex _
   ) as Double

   Declare Function a02bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Double


   Declare Function nag_complex_imag Lib "CLW3225DA_nag.dll" Alias "a02bcc" ( _
    ByVal z As Complex _
   ) as Double

   Declare Function a02bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Double


   Declare Function nag_complex_add Lib "CLW3225DA_nag.dll" Alias "a02cac" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex

   Declare Function a02cac Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex


   Declare Function nag_complex_subtract Lib "CLW3225DA_nag.dll" Alias "a02cbc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex

   Declare Function a02cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex


   Declare Function nag_complex_multiply Lib "CLW3225DA_nag.dll" Alias "a02ccc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex

   Declare Function a02ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex


   Declare Function nag_complex_divide Lib "CLW3225DA_nag.dll" Alias "a02cdc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex

   Declare Function a02cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex


   Declare Function nag_complex_negate Lib "CLW3225DA_nag.dll" Alias "a02cec" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02cec Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_conjg Lib "CLW3225DA_nag.dll" Alias "a02cfc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02cfc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_equal Lib "CLW3225DA_nag.dll" Alias "a02cgc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Integer

   Declare Function a02cgc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Integer


   Declare Function nag_complex_not_equal Lib "CLW3225DA_nag.dll" Alias "a02chc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Integer

   Declare Function a02chc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Integer


   Declare Function nag_complex_arg Lib "CLW3225DA_nag.dll" Alias "a02dac" ( _
    ByVal z As Complex _
   ) as Double

   Declare Function a02dac Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Double


   Declare Function nag_complex_abs Lib "CLW3225DA_nag.dll" Alias "a02dbc" ( _
    ByVal z As Complex _
   ) as Double

   Declare Function a02dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Double


   Declare Function nag_complex_sqrt Lib "CLW3225DA_nag.dll" Alias "a02dcc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_i_power Lib "CLW3225DA_nag.dll" Alias "a02ddc" ( _
    ByVal z As Complex, _
    ByVal i As Integer _
   ) as Complex

   Declare Function a02ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal i As Integer _
   ) as Complex


   Declare Function nag_complex_r_power Lib "CLW3225DA_nag.dll" Alias "a02dec" ( _
    ByVal z As Complex, _
    ByVal x As Double _
   ) as Complex

   Declare Function a02dec Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal x As Double _
   ) as Complex


   Declare Function nag_complex_c_power Lib "CLW3225DA_nag.dll" Alias "a02dfc" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex

   Declare Function a02dfc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex, _
    ByVal w As Complex _
   ) as Complex


   Declare Function nag_complex_log Lib "CLW3225DA_nag.dll" Alias "a02dgc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02dgc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_exp Lib "CLW3225DA_nag.dll" Alias "a02dhc" ( _
    ByVal v As Complex _
   ) as Complex

   Declare Function a02dhc Lib "CLW3225DA_nag.dll" ( _
    ByVal v As Complex _
   ) as Complex


   Declare Function nag_complex_sin Lib "CLW3225DA_nag.dll" Alias "a02djc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02djc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_cos Lib "CLW3225DA_nag.dll" Alias "a02dkc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02dkc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


   Declare Function nag_complex_tan Lib "CLW3225DA_nag.dll" Alias "a02dlc" ( _
    ByVal z As Complex _
   ) as Complex

   Declare Function a02dlc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex _
   ) as Complex


' chapter c02

   Declare Sub nag_zeros_complex_poly Lib "CLW3225DA_nag.dll" Alias "c02afc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal dnscale As Nag_Boolean, _
    <Out()> ByVal z As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c02afc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal dnscale As Nag_Boolean, _
    <Out()> ByVal z As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_zeros_real_poly Lib "CLW3225DA_nag.dll" Alias "c02agc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal dnscale As Nag_Boolean, _
    <Out()> ByVal z As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c02agc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal dnscale As Nag_Boolean, _
    <Out()> ByVal z As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_cubic_roots Lib "CLW3225DA_nag.dll" Alias "c02akc" ( _
    ByVal u As Double, _
    ByVal r As Double, _
    ByVal s As Double, _
    ByVal t As Double, _
    <Out()> ByVal zeror As Double(), _
    <Out()> ByVal zeroi As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c02akc Lib "CLW3225DA_nag.dll" ( _
    ByVal u As Double, _
    ByVal r As Double, _
    ByVal s As Double, _
    ByVal t As Double, _
    <Out()> ByVal zeror As Double(), _
    <Out()> ByVal zeroi As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quartic_roots Lib "CLW3225DA_nag.dll" Alias "c02alc" ( _
    ByVal e As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal d As Double, _
    <Out()> ByVal zeror As Double(), _
    <Out()> ByVal zeroi As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c02alc Lib "CLW3225DA_nag.dll" ( _
    ByVal e As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal d As Double, _
    <Out()> ByVal zeror As Double(), _
    <Out()> ByVal zeroi As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef fail As NagError _
   )


' chapter c05

Delegate Function nag_zero_cont_func_brent_binsrch_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_zero_cont_func_brent_binsrch Lib "CLW3225DA_nag.dll" Alias "c05auc" ( _
    ByRef x As Double, _
    ByVal h As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As nag_zero_cont_func_brent_binsrch_f_DELEGATE, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function c05auc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub c05auc Lib "CLW3225DA_nag.dll" ( _
    ByRef x As Double, _
    ByVal h As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As c05auc_f_DELEGATE, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_interval_zero_cont_func Lib "CLW3225DA_nag.dll" Alias "c05avc" ( _
    ByRef x As Double, _
    ByVal fx As Double, _
    ByRef h As Double, _
    ByVal boundl As Double, _
    ByVal boundu As Double, _
    ByRef y As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c05avc Lib "CLW3225DA_nag.dll" ( _
    ByRef x As Double, _
    ByVal fx As Double, _
    ByRef h As Double, _
    ByVal boundl As Double, _
    ByVal boundu As Double, _
    ByRef y As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )


Delegate Function nag_zero_cont_func_cntin_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_zero_cont_func_cntin Lib "CLW3225DA_nag.dll" Alias "c05awc" ( _
    ByRef x As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As nag_zero_cont_func_cntin_f_DELEGATE, _
    ByVal nfmax As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function c05awc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub c05awc Lib "CLW3225DA_nag.dll" ( _
    ByRef x As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As c05awc_f_DELEGATE, _
    ByVal nfmax As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zero_cont_func_cntin_rcomm Lib "CLW3225DA_nag.dll" Alias "c05axc" ( _
    ByRef x As Double, _
    ByVal fx As Double, _
    ByVal tol As Double, _
    ByVal ir As Nag_ErrorControl, _
    ByVal scal As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c05axc Lib "CLW3225DA_nag.dll" ( _
    ByRef x As Double, _
    ByVal fx As Double, _
    ByVal tol As Double, _
    ByVal ir As Nag_ErrorControl, _
    ByVal scal As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )


Delegate Function nag_zero_cont_func_brent_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_zero_cont_func_brent Lib "CLW3225DA_nag.dll" Alias "c05ayc" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As nag_zero_cont_func_brent_f_DELEGATE, _
    ByRef x As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function c05ayc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub c05ayc Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal eps As Double, _
    ByVal eta As Double, _
    ByVal f As c05ayc_f_DELEGATE, _
    ByRef x As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zero_cont_func_brent_rcomm Lib "CLW3225DA_nag.dll" Alias "c05azc" ( _
    ByRef x As Double, _
    ByRef y As Double, _
    ByVal fx As Double, _
    ByVal tolx As Double, _
    ByVal ir As Nag_ErrorControl, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c05azc Lib "CLW3225DA_nag.dll" ( _
    ByRef x As Double, _
    ByRef y As Double, _
    ByVal fx As Double, _
    ByVal tolx As Double, _
    ByVal ir As Nag_ErrorControl, _
    <[In](),Out()> ByVal c As Double(), _
    ByRef ind As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_lambertW Lib "CLW3225DA_nag.dll" Alias "c05bac" ( _
    ByVal x As Double, _
    ByVal branch As Integer, _
    ByVal offset As Nag_Boolean, _
    ByRef fail As NagError _
   ) as Double

   Declare Function c05bac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal branch As Integer, _
    ByVal offset As Nag_Boolean, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_lambertW_complex Lib "CLW3225DA_nag.dll" Alias "c05bbc" ( _
    ByVal branch As Integer, _
    ByVal offset As Nag_Boolean, _
    ByVal z As Complex, _
    ByRef w As Complex, _
    ByRef resid As Double, _
    ByRef fail As NagError _
   )

   Declare Sub c05bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal branch As Integer, _
    ByVal offset As Nag_Boolean, _
    ByVal z As Complex, _
    ByRef w As Complex, _
    ByRef resid As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_zero_nonlin_eqns_easy_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub nag_zero_nonlin_eqns_easy Lib "CLW3225DA_nag.dll" Alias "c05qbc" ( _
    ByVal fcn As nag_zero_nonlin_eqns_easy_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub c05qbc_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub c05qbc Lib "CLW3225DA_nag.dll" ( _
    ByVal fcn As c05qbc_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_zero_nonlin_eqns_expert_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub nag_zero_nonlin_eqns_expert Lib "CLW3225DA_nag.dll" Alias "c05qcc" ( _
    ByVal fcn As nag_zero_nonlin_eqns_expert_fcn_DELEGATE, ByVal n As Integer, <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), ByVal xtol As Double, ByVal maxfev As Integer, _
    ByVal ml As Integer, ByVal mu As Integer, ByVal epsfcn As Double, _
    ByVal scale_mode As Nag_ScaleType, <[In](),Out()> ByVal diag As Double(), ByVal factor As Double, _
    ByVal nprint As Integer, ByRef nfev As Integer, <Out()> ByVal fjac As Double(), _
    <Out()> ByVal r As Double(), <Out()> ByVal qtf As Double(), _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub c05qcc_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub c05qcc Lib "CLW3225DA_nag.dll" ( _
    ByVal fcn As c05qcc_fcn_DELEGATE, ByVal n As Integer, <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), ByVal xtol As Double, ByVal maxfev As Integer, _
    ByVal ml As Integer, ByVal mu As Integer, ByVal epsfcn As Double, _
    ByVal scale_mode As Nag_ScaleType, <[In](),Out()> ByVal diag As Double(), ByVal factor As Double, _
    ByVal nprint As Integer, ByRef nfev As Integer, <Out()> ByVal fjac As Double(), _
    <Out()> ByVal r As Double(), <Out()> ByVal qtf As Double(), _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_zero_nonlin_eqns_rcomm Lib "CLW3225DA_nag.dll" Alias "c05qdc" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByVal ml As Integer, _
    ByVal mu As Integer, _
    ByVal epsfcn As Double, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    <[In](),Out()> ByVal fjac As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal qtf As Double(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c05qdc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByVal ml As Integer, _
    ByVal mu As Integer, _
    ByVal epsfcn As Double, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    <[In](),Out()> ByVal fjac As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal qtf As Double(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_zero_sparse_nonlin_eqns_easy_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal lindf As Integer, _
    ByVal indf_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub nag_zero_sparse_nonlin_eqns_easy Lib "CLW3225DA_nag.dll" Alias "c05qsc" ( _
    ByVal fcn As nag_zero_sparse_nonlin_eqns_easy_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByVal init As Nag_Boolean, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub c05qsc_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal lindf As Integer, _
    ByVal indf_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub c05qsc Lib "CLW3225DA_nag.dll" ( _
    ByVal fcn As c05qsc_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    ByVal xtol As Double, _
    ByVal init As Nag_Boolean, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_zero_nonlin_eqns_deriv_easy_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub nag_zero_nonlin_eqns_deriv_easy Lib "CLW3225DA_nag.dll" Alias "c05rbc" ( _
    ByVal fcn As nag_zero_nonlin_eqns_deriv_easy_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub c05rbc_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub c05rbc Lib "CLW3225DA_nag.dll" ( _
    ByVal fcn As c05rbc_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_zero_nonlin_eqns_deriv_expert_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub nag_zero_nonlin_eqns_deriv_expert Lib "CLW3225DA_nag.dll" Alias "c05rcc" ( _
    ByVal fcn As nag_zero_nonlin_eqns_deriv_expert_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByVal maxfev As Integer, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    ByVal nprint As Integer, _
    ByRef nfev As Integer, _
    ByRef njev As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal qtf As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub c05rcc_fcn_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer _
  )

   Declare Sub c05rcc Lib "CLW3225DA_nag.dll" ( _
    ByVal fcn As c05rcc_fcn_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByVal maxfev As Integer, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    ByVal nprint As Integer, _
    ByRef nfev As Integer, _
    ByRef njev As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal qtf As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zero_nonlin_eqns_deriv_rcomm Lib "CLW3225DA_nag.dll" Alias "c05rdc" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal fvec As Double(), _
    <[In](),Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal qtf As Double(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c05rdc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal fvec As Double(), _
    <[In](),Out()> ByVal fjac As Double(), _
    ByVal xtol As Double, _
    ByVal scale_mode As Nag_ScaleType, _
    <[In](),Out()> ByVal diag As Double(), _
    ByVal factor As Double, _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal qtf As Double(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_check_derivs Lib "CLW3225DA_nag.dll" Alias "c05zdc" ( _
    ByVal mode As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal fvec As Double(), _
    <[In]()> ByVal fjac As Double(), _
    <Out()> ByVal xp As Double(), _
    <[In]()> ByVal fvecp As Double(), _
    <Out()> ByVal err As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c05zdc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal fvec As Double(), _
    <[In]()> ByVal fjac As Double(), _
    <Out()> ByVal xp As Double(), _
    <[In]()> ByVal fvecp As Double(), _
    <Out()> ByVal err As Double(), _
    ByRef fail As NagError _
   )


' chapter c06

   Declare Sub nag_sum_cheby_series Lib "CLW3225DA_nag.dll" Alias "c06dcc" ( _
    <[In]()> ByVal x As Double(), _
    ByVal lx As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    ByVal s As Nag_Series, _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06dcc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal x As Double(), _
    ByVal lx As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    ByVal s As Nag_Series, _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_real Lib "CLW3225DA_nag.dll" Alias "c06eac" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06eac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_hermitian Lib "CLW3225DA_nag.dll" Alias "c06ebc" ( _
    <[In](),Out()> ByVal x As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c06ebc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal x As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_complex Lib "CLW3225DA_nag.dll" Alias "c06ecc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_convolution_real Lib "CLW3225DA_nag.dll" Alias "c06ekc" ( _
    ByVal operation As Nag_VectorOp, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06ekc Lib "CLW3225DA_nag.dll" ( _
    ByVal operation As Nag_VectorOp, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_convcorr_real Lib "CLW3225DA_nag.dll" Alias "c06fkc" ( _
    ByVal job As Nag_VectorOp, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c06fkc Lib "CLW3225DA_nag.dll" ( _
    ByVal job As Nag_VectorOp, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_real Lib "CLW3225DA_nag.dll" Alias "c06fpc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06fpc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_hermitian Lib "CLW3225DA_nag.dll" Alias "c06fqc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06fqc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_complex Lib "CLW3225DA_nag.dll" Alias "c06frc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06frc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_2d_complex Lib "CLW3225DA_nag.dll" Alias "c06fuc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    <[In]()> ByVal trigm As Double(), _
    <[In]()> ByVal trign As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06fuc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    <[In]()> ByVal trigm As Double(), _
    <[In]()> ByVal trign As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_conjugate_hermitian Lib "CLW3225DA_nag.dll" Alias "c06gbc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_conjugate_complex Lib "CLW3225DA_nag.dll" Alias "c06gcc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_multiple_conjugate_hermitian Lib "CLW3225DA_nag.dll" Alias "c06gqc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06gqc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_multiple_hermitian_to_complex Lib "CLW3225DA_nag.dll" Alias "c06gsc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal u As Double(), _
    <Out()> ByVal v As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06gsc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal u As Double(), _
    <Out()> ByVal v As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_init_trig Lib "CLW3225DA_nag.dll" Alias "c06gzc" ( _
    ByVal n As Integer, _
    <Out()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06gzc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <Out()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_sine Lib "CLW3225DA_nag.dll" Alias "c06hac" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06hac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_cosine Lib "CLW3225DA_nag.dll" Alias "c06hbc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_qtr_sine Lib "CLW3225DA_nag.dll" Alias "c06hcc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06hcc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multiple_qtr_cosine Lib "CLW3225DA_nag.dll" Alias "c06hdc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06hdc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal trig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_realherm_1d Lib "CLW3225DA_nag.dll" Alias "c06pac" ( _
    ByVal direct As Nag_TransformDirection, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c06pac Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_complex_1d Lib "CLW3225DA_nag.dll" Alias "c06pcc" ( _
    ByVal direct As Nag_TransformDirection, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub c06pcc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multid_single Lib "CLW3225DA_nag.dll" Alias "c06pfc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal nd As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pfc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal nd As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_multid_full Lib "CLW3225DA_nag.dll" Alias "c06pjc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As Integer, _
    <[In]()> ByVal nd As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pjc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As Integer, _
    <[In]()> ByVal nd As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_complex_1d_multi Lib "CLW3225DA_nag.dll" Alias "c06psc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06psc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_complex_2d Lib "CLW3225DA_nag.dll" Alias "c06puc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06puc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_real_2d Lib "CLW3225DA_nag.dll" Alias "c06pvc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pvc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_hermitian_2d Lib "CLW3225DA_nag.dll" Alias "c06pwc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pwc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fft_3d Lib "CLW3225DA_nag.dll" Alias "c06pxc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pxc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_real_3d Lib "CLW3225DA_nag.dll" Alias "c06pyc" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pyc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_hermitian_3d Lib "CLW3225DA_nag.dll" Alias "c06pzc" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06pzc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal n3 As Integer, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_sine Lib "CLW3225DA_nag.dll" Alias "c06rec" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06rec Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_cosine Lib "CLW3225DA_nag.dll" Alias "c06rfc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06rfc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_qtrsine Lib "CLW3225DA_nag.dll" Alias "c06rgc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06rgc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_fft_qtrcosine Lib "CLW3225DA_nag.dll" Alias "c06rhc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c06rhc Lib "CLW3225DA_nag.dll" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


' chapter c09

   Declare Sub nag_wfilt Lib "CLW3225DA_nag.dll" Alias "c09aac" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal n As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwc As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09aac Lib "CLW3225DA_nag.dll" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal n As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwc As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wfilt_2d Lib "CLW3225DA_nag.dll" Alias "c09abc" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwct As Integer, _
    ByRef nwcn As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09abc Lib "CLW3225DA_nag.dll" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwct As Integer, _
    ByRef nwcn As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wfilt_3d Lib "CLW3225DA_nag.dll" Alias "c09acc" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwct As Integer, _
    ByRef nwcn As Integer, _
    ByRef nwcfr As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09acc Lib "CLW3225DA_nag.dll" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    ByRef nwlmax As Integer, _
    ByRef nf As Integer, _
    ByRef nwct As Integer, _
    ByRef nwcn As Integer, _
    ByRef nwcfr As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_cwt_1d_real Lib "CLW3225DA_nag.dll" Alias "c09bac" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wparam As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal nscal As Integer, _
    <[In]()> ByVal scales As Integer(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub c09bac Lib "CLW3225DA_nag.dll" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wparam As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal nscal As Integer, _
    <[In]()> ByVal scales As Integer(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dwt Lib "CLW3225DA_nag.dll" Alias "c09cac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal cd As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09cac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal cd As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_idwt Lib "CLW3225DA_nag.dll" Alias "c09cbc" ( _
    ByVal lenc As Integer, _
    <[In]()> ByVal ca As Double(), _
    <[In]()> ByVal cd As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal lenc As Integer, _
    <[In]()> ByVal ca As Double(), _
    <[In]()> ByVal cd As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mldwt Lib "CLW3225DA_nag.dll" Alias "c09ccc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlev As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlev As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_imldwt Lib "CLW3225DA_nag.dll" Alias "c09cdc" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_modwt Lib "CLW3225DA_nag.dll" Alias "c09dac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal cd As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lenc As Integer, _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal cd As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_imodwt Lib "CLW3225DA_nag.dll" Alias "c09dbc" ( _
    ByVal lenc As Integer, _
    <[In]()> ByVal ca As Double(), _
    <[In]()> ByVal cd As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal lenc As Integer, _
    <[In]()> ByVal ca As Double(), _
    <[In]()> ByVal cd As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mlmodwt Lib "CLW3225DA_nag.dll" Alias "c09dcc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    ByRef na As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    ByRef na As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_imlmodwt Lib "CLW3225DA_nag.dll" Alias "c09ddc" ( _
    ByVal nwlinv As Integer, _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal nwlinv As Integer, _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal y As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dwt_2d Lib "CLW3225DA_nag.dll" Alias "c09eac" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    <Out()> ByVal ca As Double(), _
    ByVal ldca As Integer, _
    <Out()> ByVal ch As Double(), _
    ByVal ldch As Integer, _
    <Out()> ByVal cv As Double(), _
    ByVal ldcv As Integer, _
    <Out()> ByVal cd As Double(), _
    ByVal ldcd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09eac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    <Out()> ByVal ca As Double(), _
    ByVal ldca As Integer, _
    <Out()> ByVal ch As Double(), _
    ByVal ldch As Integer, _
    <Out()> ByVal cv As Double(), _
    ByVal ldcv As Integer, _
    <Out()> ByVal cd As Double(), _
    ByVal ldcd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_idwt_2d Lib "CLW3225DA_nag.dll" Alias "c09ebc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal ca As Double(), _
    ByVal ldca As Integer, _
    <[In]()> ByVal ch As Double(), _
    ByVal ldch As Integer, _
    <[In]()> ByVal cv As Double(), _
    ByVal ldcv As Integer, _
    <[In]()> ByVal cd As Double(), _
    ByVal ldcd As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal ca As Double(), _
    ByVal ldca As Integer, _
    <[In]()> ByVal ch As Double(), _
    ByVal ldch As Integer, _
    <[In]()> ByVal cv As Double(), _
    ByVal ldcv As Integer, _
    <[In]()> ByVal cd As Double(), _
    ByVal ldcd As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mldwt_2d Lib "CLW3225DA_nag.dll" Alias "c09ecc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlvm As Integer(), _
    <Out()> ByVal dwtlvn As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlvm As Integer(), _
    <Out()> ByVal dwtlvn As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_imldwt_2d Lib "CLW3225DA_nag.dll" Alias "c09edc" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09edc Lib "CLW3225DA_nag.dll" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wav_2d_coeff_ext Lib "CLW3225DA_nag.dll" Alias "c09eyc" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09eyc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wav_2d_coeff_ins Lib "CLW3225DA_nag.dll" Alias "c09ezc" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09ezc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dwt_3d Lib "CLW3225DA_nag.dll" Alias "c09fac" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal sda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal sda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_idwt_3d Lib "CLW3225DA_nag.dll" Alias "c09fbc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    ByVal sdb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    ByVal sdb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mldwt_3d Lib "CLW3225DA_nag.dll" Alias "c09fcc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal sda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlvm As Integer(), _
    <Out()> ByVal dwtlvn As Integer(), _
    <Out()> ByVal dwtlvfr As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lda As Integer, _
    ByVal sda As Integer, _
    ByVal lenc As Integer, _
    <Out()> ByVal c As Double(), _
    ByVal nwl As Integer, _
    <Out()> ByVal dwtlvm As Integer(), _
    <Out()> ByVal dwtlvn As Integer(), _
    <Out()> ByVal dwtlvfr As Integer(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_imldwt_3d Lib "CLW3225DA_nag.dll" Alias "c09fdc" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    ByVal sdb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal nwlinv As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fr As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal ldb As Integer, _
    ByVal sdb As Integer, _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wav_3d_coeff_ext Lib "CLW3225DA_nag.dll" Alias "c09fyc" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal d As Double(), _
    ByVal ldd As Integer, _
    ByVal sdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fyc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal d As Double(), _
    ByVal ldd As Integer, _
    ByVal sdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_wav_3d_coeff_ins Lib "CLW3225DA_nag.dll" Alias "c09fzc" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal ldd As Integer, _
    ByVal sdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub c09fzc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilev As Integer, _
    ByVal cindex As Integer, _
    ByVal lenc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal ldd As Integer, _
    ByVal sdd As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


' chapter d01

Delegate Function nag_quad_1d_fin_smooth_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_quad_1d_fin_smooth Lib "CLW3225DA_nag.dll" Alias "d01bdc" ( _
    ByVal f As nag_quad_1d_fin_smooth_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef COMM As Nag_Comm _
   )

Delegate Function d01bdc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d01bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d01bdc_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef COMM As Nag_Comm _
   )


Delegate Function nag_quad_2d_fin_phi1_DELEGATE( _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_quad_2d_fin_phi2_DELEGATE( _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_quad_2d_fin_f_DELEGATE( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_quad_2d_fin Lib "CLW3225DA_nag.dll" Alias "d01dac" ( _
    ByVal ya As Double, _
    ByVal yb As Double, _
    ByVal phi1 As nag_quad_2d_fin_phi1_DELEGATE, _
    ByVal phi2 As nag_quad_2d_fin_phi2_DELEGATE, _
    ByVal f As nag_quad_2d_fin_f_DELEGATE, _
    ByVal absacc As Double, _
    ByRef ans As Double, _
    ByRef npts As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d01dac_phi1_DELEGATE( _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d01dac_phi2_DELEGATE( _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d01dac_f_DELEGATE( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d01dac Lib "CLW3225DA_nag.dll" ( _
    ByVal ya As Double, _
    ByVal yb As Double, _
    ByVal phi1 As d01dac_phi1_DELEGATE, _
    ByVal phi2 As d01dac_phi2_DELEGATE, _
    ByVal f As d01dac_f_DELEGATE, _
    ByVal absacc As Double, _
    ByRef ans As Double, _
    ByRef npts As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_quad_md_sgq_multi_vec_f_DELEGATE( _
    ByVal ni As Integer, _
    ByVal ndim As Integer, _
    ByVal nx As Integer, _
    ByVal xtr As Double, _
    ByVal nntr As Integer, _
    ByVal icolzp_iptr As IntPtr, _
    ByVal irowix_iptr As IntPtr, _
    ByVal xs_rptr As IntPtr, _
    ByVal qs_iptr As IntPtr, _
    ByVal fm_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_quad_md_sgq_multi_vec Lib "CLW3225DA_nag.dll" Alias "d01esc" ( _
    ByVal ni As Integer, _
    ByVal ndim As Integer, _
    ByVal f As nag_quad_md_sgq_multi_vec_f_DELEGATE, _
    <[In]()> ByVal maxdlv As Integer(), _
    <Out()> ByVal dinest As Double(), _
    <Out()> ByVal errest As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d01esc_f_DELEGATE( _
    ByVal ni As Integer, _
    ByVal ndim As Integer, _
    ByVal nx As Integer, _
    ByVal xtr As Double, _
    ByVal nntr As Integer, _
    ByVal icolzp_iptr As IntPtr, _
    ByVal irowix_iptr As IntPtr, _
    ByVal xs_rptr As IntPtr, _
    ByVal qs_iptr As IntPtr, _
    ByVal fm_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d01esc Lib "CLW3225DA_nag.dll" ( _
    ByVal ni As Integer, _
    ByVal ndim As Integer, _
    ByVal f As d01esc_f_DELEGATE, _
    <[In]()> ByVal maxdlv As Integer(), _
    <Out()> ByVal dinest As Double(), _
    <Out()> ByVal errest As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_quad_md_gauss_fun_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Function nag_quad_md_gauss Lib "CLW3225DA_nag.dll" Alias "d01fbc" ( _
    ByVal ndim As Integer, _
    <[In]()> ByVal nptvec As Integer(), _
    ByVal lwa As Integer, _
    <[In]()> ByVal weight As Double(), _
    <[In]()> ByVal abscis As Double(), _
    ByVal fun As nag_quad_md_gauss_fun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   ) as Double

Delegate Function d01fbc_fun_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Function d01fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    <[In]()> ByVal nptvec As Integer(), _
    ByVal lwa As Integer, _
    <[In]()> ByVal weight As Double(), _
    <[In]()> ByVal abscis As Double(), _
    ByVal fun As d01fbc_fun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   ) as Double


Delegate Function nag_quad_md_sphere_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Sub nag_quad_md_sphere_region_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal j As Integer, _
    ByRef c As Double, _
    ByRef d As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D01FDV Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal j As Integer, _
    ByRef c As Double, _
    ByRef d As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_quad_md_sphere Lib "CLW3225DA_nag.dll" Alias "d01fdc" ( _
    ByVal ndim As Integer, _
    ByVal f As nag_quad_md_sphere_f_DELEGATE, _
    ByVal sigma As Double, _
    ByVal region As nag_quad_md_sphere_region_DELEGATE, _
    ByVal limit As Integer, _
    ByVal r0 As Double, _
    ByVal u As Double, _
    ByRef result As Double, _
    ByRef ncalls As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d01fdc_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Sub d01fdc_region_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal j As Integer, _
    ByRef c As Double, _
    ByRef d As Double, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d01fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal f As d01fdc_f_DELEGATE, _
    ByVal sigma As Double, _
    ByVal region As d01fdc_region_DELEGATE, _
    ByVal limit As Integer, _
    ByVal r0 As Double, _
    ByVal u As Double, _
    ByRef result As Double, _
    ByRef ncalls As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_quad_vals Lib "CLW3225DA_nag.dll" Alias "d01gac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef ans As Double, _
    ByRef er As Double, _
    ByRef fail As NagError _
   )

   Declare Sub d01gac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef ans As Double, _
    ByRef er As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_quad_md_numth_vec_vecfun_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fv_rptr As IntPtr, _
    ByVal m As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_quad_md_numth_vec_vecreg_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal j As Integer, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal m As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_quad_md_numth_vec Lib "CLW3225DA_nag.dll" Alias "d01gdc" ( _
    ByVal ndim As Integer, _
    ByVal vecfun As nag_quad_md_numth_vec_vecfun_DELEGATE, _
    ByVal vecreg As nag_quad_md_numth_vec_vecreg_DELEGATE, _
    ByVal npts As Integer, _
    <[In](),Out()> ByVal vk As Double(), _
    ByVal nrand As Integer, _
    ByVal transform As Nag_Boolean, _
    ByRef res As Double, _
    ByRef err As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d01gdc_vecfun_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fv_rptr As IntPtr, _
    ByVal m As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d01gdc_vecreg_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal j As Integer, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal m As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d01gdc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal vecfun As d01gdc_vecfun_DELEGATE, _
    ByVal vecreg As d01gdc_vecreg_DELEGATE, _
    ByVal npts As Integer, _
    <[In](),Out()> ByVal vk As Double(), _
    ByVal nrand As Integer, _
    ByVal transform As Nag_Boolean, _
    ByRef res As Double, _
    ByRef err As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_md_numth_coeff_prime Lib "CLW3225DA_nag.dll" Alias "d01gyc" ( _
    ByVal ndim As Integer, _
    ByVal npts As Integer, _
    <Out()> ByVal vk As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01gyc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal npts As Integer, _
    <Out()> ByVal vk As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_md_numth_coeff_2prime Lib "CLW3225DA_nag.dll" Alias "d01gzc" ( _
    ByVal ndim As Integer, _
    ByVal np1 As Integer, _
    ByVal np2 As Integer, _
    <Out()> ByVal vk As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01gzc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal np1 As Integer, _
    ByVal np2 As Integer, _
    <Out()> ByVal vk As Double(), _
    ByRef fail As NagError _
   )


Delegate Function nag_quad_md_simplex_functn_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_quad_md_simplex Lib "CLW3225DA_nag.dll" Alias "d01pac" ( _
    ByVal ndim As Integer, _
    <[In](),Out()> ByVal vert As Double(), _
    ByVal functn As nag_quad_md_simplex_functn_DELEGATE, _
    ByRef minord As Integer, _
    ByVal maxord As Integer, _
    <[In](),Out()> ByVal finvls As Double(), _
    ByRef esterr As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d01pac_functn_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d01pac Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    <[In](),Out()> ByVal vert As Double(), _
    ByVal functn As d01pac_functn_DELEGATE, _
    ByRef minord As Integer, _
    ByVal maxord As Integer, _
    <[In](),Out()> ByVal finvls As Double(), _
    ByRef esterr As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_1d_gen_vec_multi_rcomm Lib "CLW3225DA_nag.dll" Alias "d01rac" ( _
    ByRef irevcm As Integer, ByVal ni As Integer, ByVal a As Double, _
    ByVal b As Double, ByRef sid As Integer, <[In](),Out()> ByVal needi As Integer(), _
    <[In](),Out()> ByVal x As Double(), ByVal lenx As Integer, ByRef nx As Integer, _
    <[In]()> ByVal fm As Double(), ByVal ldfm As Integer, <[In](),Out()> ByVal dinest As Double(), _
    <[In](),Out()> ByVal errest As Double(), <[In]()> ByVal iopts As Integer(), <[In]()> ByVal opts As Double(), _
    <[In](),Out()> ByVal icom As Integer(), ByVal licom As Integer, <[In](),Out()> ByVal com As Double(), _
    ByVal lcom As Integer, ByRef fail As NagError _
   )

   Declare Sub d01rac Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, ByVal ni As Integer, ByVal a As Double, _
    ByVal b As Double, ByRef sid As Integer, <[In](),Out()> ByVal needi As Integer(), _
    <[In](),Out()> ByVal x As Double(), ByVal lenx As Integer, ByRef nx As Integer, _
    <[In]()> ByVal fm As Double(), ByVal ldfm As Integer, <[In](),Out()> ByVal dinest As Double(), _
    <[In](),Out()> ByVal errest As Double(), <[In]()> ByVal iopts As Integer(), <[In]()> ByVal opts As Double(), _
    <[In](),Out()> ByVal icom As Integer(), ByVal licom As Integer, <[In](),Out()> ByVal com As Double(), _
    ByVal lcom As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_quad_1d_gen_vec_multi_dimreq Lib "CLW3225DA_nag.dll" Alias "d01rcc" ( _
    ByVal ni As Integer, _
    ByRef lenxrq As Integer, _
    ByRef ldfmrq As Integer, _
    ByRef sdfmrq As Integer, _
    ByRef licmin As Integer, _
    ByRef licmax As Integer, _
    ByRef lcmin As Integer, _
    ByRef lcmax As Integer, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01rcc Lib "CLW3225DA_nag.dll" ( _
    ByVal ni As Integer, _
    ByRef lenxrq As Integer, _
    ByRef ldfmrq As Integer, _
    ByRef sdfmrq As Integer, _
    ByRef licmin As Integer, _
    ByRef licmax As Integer, _
    ByRef lcmin As Integer, _
    ByRef lcmax As Integer, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_quad_1d_fin_gonnet_vec_f_DELEGATE( _
    ByVal x_rptr As IntPtr, _
    ByVal nx As Integer, _
    ByVal fv_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_quad_1d_fin_gonnet_vec Lib "CLW3225DA_nag.dll" Alias "d01rgc" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal f As nag_quad_1d_fin_gonnet_vec_f_DELEGATE, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByRef dinest As Double, _
    ByRef errest As Double, _
    ByRef nevals As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d01rgc_f_DELEGATE( _
    ByVal x_rptr As IntPtr, _
    ByVal nx As Integer, _
    ByVal fv_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d01rgc Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal f As d01rgc_f_DELEGATE, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByRef dinest As Double, _
    ByRef errest As Double, _
    ByRef nevals As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_gen_1_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_gen_1 Lib "CLW3225DA_nag.dll" Alias "d01sjc" ( _
    ByVal f As nag_1d_quad_gen_1_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01sjc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01sjc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d01sjc_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_osc_1_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_osc_1 Lib "CLW3225DA_nag.dll" Alias "d01skc" ( _
    ByVal f As nag_1d_quad_osc_1_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01skc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01skc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d01skc_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_brkpts_1_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_brkpts_1 Lib "CLW3225DA_nag.dll" Alias "d01slc" ( _
    ByVal f As nag_1d_quad_brkpts_1_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal nbrkpts As Integer, _
    <[In]()> ByVal brkpts As Double(), _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01slc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01slc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d01slc_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal nbrkpts As Integer, _
    <[In]()> ByVal brkpts As Double(), _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_inf_1_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_inf_1 Lib "CLW3225DA_nag.dll" Alias "d01smc" ( _
    ByVal f As nag_1d_quad_inf_1_f_DELEGATE, _
    ByVal boundinf As Nag_BoundInterval, _
    ByVal bound As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01smc_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01smc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d01smc_f_DELEGATE, _
    ByVal boundinf As Nag_BoundInterval, _
    ByVal bound As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_wt_trig_1_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_wt_trig_1 Lib "CLW3225DA_nag.dll" Alias "d01snc" ( _
    ByVal g As nag_1d_quad_wt_trig_1_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal omega As Double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01snc_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01snc Lib "CLW3225DA_nag.dll" ( _
    ByVal g As d01snc_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal omega As Double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_wt_alglog_1_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_wt_alglog_1 Lib "CLW3225DA_nag.dll" Alias "d01spc" ( _
    ByVal g As nag_1d_quad_wt_alglog_1_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal alfa As Double, _
    ByVal beta As Double, _
    ByVal wt_func As Nag_QuadWeight, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01spc_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01spc Lib "CLW3225DA_nag.dll" ( _
    ByVal g As d01spc_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal alfa As Double, _
    ByVal beta As Double, _
    ByVal wt_func As Nag_QuadWeight, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_wt_cauchy_1_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_wt_cauchy_1 Lib "CLW3225DA_nag.dll" Alias "d01sqc" ( _
    ByVal g As nag_1d_quad_wt_cauchy_1_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01sqc_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01sqc Lib "CLW3225DA_nag.dll" ( _
    ByVal g As d01sqc_g_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal max_num_subint As Integer, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_inf_wt_trig_1_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_1d_quad_inf_wt_trig_1 Lib "CLW3225DA_nag.dll" Alias "d01ssc" ( _
    ByVal g As nag_1d_quad_inf_wt_trig_1_g_DELEGATE, _
    ByVal a As Double, _
    ByVal omega As Double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal maxintervals As Integer, _
    ByVal max_num_subint As Integer, _
    ByVal epsabs As Double, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qpsub As Nag_QuadSubProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01ssc_g_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01ssc Lib "CLW3225DA_nag.dll" ( _
    ByVal g As d01ssc_g_DELEGATE, _
    ByVal a As Double, _
    ByVal omega As Double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal maxintervals As Integer, _
    ByVal max_num_subint As Integer, _
    ByVal epsabs As Double, _
    ByRef result As Double, _
    ByRef abserr As Double, _
    ByRef qpsub As Nag_QuadSubProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_1d_quad_gauss_1_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Function nag_1d_quad_gauss_1 Lib "CLW3225DA_nag.dll" Alias "d01tac" ( _
    ByVal quadrule As Nag_GaussFormulae, _
    ByVal f As nag_1d_quad_gauss_1_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal npts As Integer, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   ) as Double

Delegate Function d01tac_f_DELEGATE( _
    ByVal x As Double, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Function d01tac Lib "CLW3225DA_nag.dll" ( _
    ByVal quadrule As Nag_GaussFormulae, _
    ByVal f As d01tac_f_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal npts As Integer, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_quad_1d_gauss_wset Lib "CLW3225DA_nag.dll" Alias "d01tbc" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    <Out()> ByVal weight As Double(), _
    <Out()> ByVal abscis As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01tbc Lib "CLW3225DA_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    <Out()> ByVal weight As Double(), _
    <Out()> ByVal abscis As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_1d_gauss_wgen Lib "CLW3225DA_nag.dll" Alias "d01tcc" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal d As Double, _
    ByVal n As Integer, _
    <Out()> ByVal weight As Double(), _
    <Out()> ByVal abscis As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01tcc Lib "CLW3225DA_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal d As Double, _
    ByVal n As Integer, _
    <Out()> ByVal weight As Double(), _
    <Out()> ByVal abscis As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_quad_1d_gauss_vec_f_DELEGATE( _
    ByVal x_rptr As IntPtr, _
    ByVal nx As Integer, _
    ByVal fv_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_quad_1d_gauss_vec Lib "CLW3225DA_nag.dll" Alias "d01uac" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal f As nag_quad_1d_gauss_vec_f_DELEGATE, _
    ByRef dinest As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d01uac_f_DELEGATE( _
    ByVal x_rptr As IntPtr, _
    ByVal nx As Integer, _
    ByVal fv_rptr As IntPtr, _
    ByRef iflag As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d01uac Lib "CLW3225DA_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal f As d01uac_f_DELEGATE, _
    ByRef dinest As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_multid_quad_adapt_1_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_multid_quad_adapt_1 Lib "CLW3225DA_nag.dll" Alias "d01wcc" ( _
    ByVal ndim As Integer, _
    ByVal f As nag_multid_quad_adapt_1_f_DELEGATE, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByRef minpts As Integer, _
    ByVal maxpts As Integer, _
    ByVal eps As Double, _
    ByRef finval As Double, _
    ByRef acc As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01wcc_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01wcc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal f As d01wcc_f_DELEGATE, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByRef minpts As Integer, _
    ByVal maxpts As Integer, _
    ByVal eps As Double, _
    ByRef finval As Double, _
    ByRef acc As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Function nag_multid_quad_monte_carlo_1_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_multid_quad_monte_carlo_1 Lib "CLW3225DA_nag.dll" Alias "d01xbc" ( _
    ByVal ndim As Integer, _
    ByVal f As nag_multid_quad_monte_carlo_1_f_DELEGATE, _
    ByVal method As Nag_MCMethod, _
    ByVal cont As Nag_Start, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByRef mincls As Integer, _
    ByVal maxcls As Integer, _
    ByVal eps As Double, _
    ByRef finest As Double, _
    ByRef acc As Double, _
    ByRef comm_arrPTR As IntPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Function d01xbc_f_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d01xbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal f As d01xbc_f_DELEGATE, _
    ByVal method As Nag_MCMethod, _
    ByVal cont As Nag_Start, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByRef mincls As Integer, _
    ByVal maxcls As Integer, _
    ByVal eps As Double, _
    ByRef finest As Double, _
    ByRef acc As Double, _
    ByRef comm_arrPTR As IntPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_opt_set Lib "CLW3225DA_nag.dll" Alias "d01zkc" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d01zkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_quad_opt_get Lib "CLW3225DA_nag.dll" Alias "d01zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d01zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


' chapter d02

Delegate Sub nag_ode_ivp_adams_gen_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_ivp_adams_gen_output_DELEGATE( _
    ByVal neq As Integer, _
    ByRef xsol As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function nag_ode_ivp_adams_gen_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_ode_ivp_adams_gen Lib "CLW3225DA_nag.dll" Alias "d02cjc" ( _
    ByVal neq As Integer, _
    ByVal fcn As nag_ode_ivp_adams_gen_fcn_DELEGATE, _
    ByRef x As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal xend As Double, _
    ByVal tol As Double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As nag_ode_ivp_adams_gen_output_DELEGATE, _
    ByVal g As nag_ode_ivp_adams_gen_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02cjc_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02cjc_output_DELEGATE( _
    ByVal neq As Integer, _
    ByRef xsol As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function d02cjc_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d02cjc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal fcn As d02cjc_fcn_DELEGATE, _
    ByRef x As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal xend As Double, _
    ByVal tol As Double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As d02cjc_output_DELEGATE, _
    ByVal g As d02cjc_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_bdf_gen_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_ivp_bdf_gen_pederv_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal pw_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_ivp_bdf_gen_output_DELEGATE( _
    ByVal neq As Integer, _
    ByRef xsol As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function nag_ode_ivp_bdf_gen_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_ode_ivp_bdf_gen Lib "CLW3225DA_nag.dll" Alias "d02ejc" ( _
    ByVal neq As Integer, _
    ByVal fcn As nag_ode_ivp_bdf_gen_fcn_DELEGATE, _
    ByVal pederv As nag_ode_ivp_bdf_gen_pederv_DELEGATE, _
    ByRef x As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal xend As Double, _
    ByVal tol As Double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As nag_ode_ivp_bdf_gen_output_DELEGATE, _
    ByVal g As nag_ode_ivp_bdf_gen_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02ejc_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02ejc_pederv_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal pw_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02ejc_output_DELEGATE( _
    ByVal neq As Integer, _
    ByRef xsol As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function d02ejc_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d02ejc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal fcn As d02ejc_fcn_DELEGATE, _
    ByVal pederv As d02ejc_pederv_DELEGATE, _
    ByRef x As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal xend As Double, _
    ByVal tol As Double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As d02ejc_output_DELEGATE, _
    ByVal g As d02ejc_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_bvp_fd_nonlin_fixedbc_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_bvp_fd_nonlin_fixedbc Lib "CLW3225DA_nag.dll" Alias "d02gac" ( _
    ByVal neq As Integer, _
    ByVal fcn As nag_ode_bvp_fd_nonlin_fixedbc_fcn_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Integer(), _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02gac_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub d02gac Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal fcn As d02gac_fcn_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Integer(), _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_bvp_fd_lin_gen_fcnf_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_lin_gen_fcng_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_bvp_fd_lin_gen Lib "CLW3225DA_nag.dll" Alias "d02gbc" ( _
    ByVal neq As Integer, _
    ByVal fcnf As nag_ode_bvp_fd_lin_gen_fcnf_DELEGATE, _
    ByVal fcng As nag_ode_bvp_fd_lin_gen_fcng_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal gam As Double(), _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02gbc_fcnf_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02gbc_fcng_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub d02gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal fcnf As d02gbc_fcnf_DELEGATE, _
    ByVal fcng As d02gbc_fcng_DELEGATE, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal gam As Double(), _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dae_ivp_dassl_cont Lib "CLW3225DA_nag.dll" Alias "d02mcc" ( _
    <[In](),Out()> ByVal icom As Integer() _
   )

   Declare Sub d02mcc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal icom As Integer() _
   )


   Declare Sub nag_dae_ivp_dassl_setup Lib "CLW3225DA_nag.dll" Alias "d02mwc" ( _
    ByVal neq As Integer, _
    ByVal maxord As Integer, _
    ByVal jceval As Nag_EvaluateJacobian, _
    ByVal hmax As Double, _
    ByVal h0 As Double, _
    ByVal vector_tol As Nag_Boolean, _
    <Out()> ByVal icom As Integer(), _
    ByVal licom As Integer, _
    <Out()> ByVal com As Double(), _
    ByVal lcom As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d02mwc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal maxord As Integer, _
    ByVal jceval As Nag_EvaluateJacobian, _
    ByVal hmax As Double, _
    ByVal h0 As Double, _
    ByVal vector_tol As Nag_Boolean, _
    <Out()> ByVal icom As Integer(), _
    ByVal licom As Integer, _
    <Out()> ByVal com As Double(), _
    ByVal lcom As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_dae_ivp_dassl_gen_res_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal ydot_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_dae_ivp_dassl_gen_jac_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal ydot_rptr As IntPtr, _
    ByVal pd_rptr As IntPtr, _
    ByVal cj As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D02NEZ Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal ydot_rptr As IntPtr, _
    ByVal pd_rptr As IntPtr, _
    ByVal cj As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_dae_ivp_dassl_gen Lib "CLW3225DA_nag.dll" Alias "d02nec" ( _
    ByVal neq As Integer, _
    ByRef t As Double, _
    ByVal tout As Double, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal ydot As Double(), _
    <[In](),Out()> ByVal rtol As Double(), _
    <[In](),Out()> ByVal atol As Double(), _
    ByRef itask As Integer, _
    ByVal res As nag_dae_ivp_dassl_gen_res_DELEGATE, _
    ByVal jac As nag_dae_ivp_dassl_gen_jac_DELEGATE, _
    <[In](),Out()> ByVal icom As Integer(), _
    <[In](),Out()> ByVal com As Double(), _
    ByVal lcom As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d02nec_res_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal ydot_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02nec_jac_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal ydot_rptr As IntPtr, _
    ByVal pd_rptr As IntPtr, _
    ByVal cj As Double, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d02nec Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByRef t As Double, _
    ByVal tout As Double, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal ydot As Double(), _
    <[In](),Out()> ByVal rtol As Double(), _
    <[In](),Out()> ByVal atol As Double(), _
    ByRef itask As Integer, _
    ByVal res As d02nec_res_DELEGATE, _
    ByVal jac As d02nec_jac_DELEGATE, _
    <[In](),Out()> ByVal icom As Integer(), _
    <[In](),Out()> ByVal com As Double(), _
    ByVal lcom As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dae_ivp_dassl_linalg Lib "CLW3225DA_nag.dll" Alias "d02npc" ( _
    ByVal neq As Integer, _
    ByVal ml As Integer, _
    ByVal mu As Integer, _
    <[In](),Out()> ByVal icom As Integer(), _
    ByVal licom As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d02npc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal ml As Integer, _
    ByVal mu As Integer, _
    <[In](),Out()> ByVal icom As Integer(), _
    ByVal licom As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rk_range_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_ivp_rk_range Lib "CLW3225DA_nag.dll" Alias "d02pcc" ( _
    ByVal neq As Integer, _
    ByVal f As nag_ode_ivp_rk_range_f_DELEGATE, _
    ByVal twant As Double, _
    ByRef tgot As Double, _
    <[In](),Out()> ByVal ygot As Double(), _
    <Out()> ByVal ypgot As Double(), _
    <[In](),Out()> ByVal ymax As Double(), _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02pcc_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub d02pcc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal f As d02pcc_f_DELEGATE, _
    ByVal twant As Double, _
    ByRef tgot As Double, _
    <[In](),Out()> ByVal ygot As Double(), _
    <Out()> ByVal ypgot As Double(), _
    <[In](),Out()> ByVal ymax As Double(), _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rk_onestep_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_ivp_rk_onestep Lib "CLW3225DA_nag.dll" Alias "d02pdc" ( _
    ByVal neq As Integer, _
    ByVal f As nag_ode_ivp_rk_onestep_f_DELEGATE, _
    ByRef tnow As Double, _
    <Out()> ByVal ynow As Double(), _
    <Out()> ByVal ypnow As Double(), _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02pdc_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub d02pdc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal f As d02pdc_f_DELEGATE, _
    ByRef tnow As Double, _
    <Out()> ByVal ynow As Double(), _
    <Out()> ByVal ypnow As Double(), _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rkts_range_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_ode_ivp_rkts_range Lib "CLW3225DA_nag.dll" Alias "d02pec" ( _
    ByVal f As nag_ode_ivp_rkts_range_f_DELEGATE, _
    ByVal n As Integer, _
    ByVal twant As Double, _
    ByRef tgot As Double, _
    <[In](),Out()> ByVal ygot As Double(), _
    <Out()> ByVal ypgot As Double(), _
    <[In](),Out()> ByVal ymax As Double(), _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

Delegate Sub d02pec_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d02pec Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d02pec_f_DELEGATE, _
    ByVal n As Integer, _
    ByVal twant As Double, _
    ByRef tgot As Double, _
    <[In](),Out()> ByVal ygot As Double(), _
    <Out()> ByVal ypgot As Double(), _
    <[In](),Out()> ByVal ymax As Double(), _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rkts_onestep_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_ode_ivp_rkts_onestep Lib "CLW3225DA_nag.dll" Alias "d02pfc" ( _
    ByVal f As nag_ode_ivp_rkts_onestep_f_DELEGATE, _
    ByVal n As Integer, _
    ByRef tnow As Double, _
    <Out()> ByVal ynow As Double(), _
    <Out()> ByVal ypnow As Double(), _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

Delegate Sub d02pfc_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d02pfc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As d02pfc_f_DELEGATE, _
    ByVal n As Integer, _
    ByRef tnow As Double, _
    <Out()> ByVal ynow As Double(), _
    <Out()> ByVal ypnow As Double(), _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rk_free Lib "CLW3225DA_nag.dll" Alias "d02ppc" ( _
    ByRef opt As Nag_ODE_RK _
   )

   Declare Sub d02ppc Lib "CLW3225DA_nag.dll" ( _
    ByRef opt As Nag_ODE_RK _
   )


   Declare Sub nag_ode_ivp_rkts_setup Lib "CLW3225DA_nag.dll" Alias "d02pqc" ( _
    ByVal n As Integer, _
    ByVal tstart As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal yinit As Double(), _
    ByVal tol As Double, _
    <[In]()> ByVal thresh As Double(), _
    ByVal method As Nag_RK_method, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As Double, _
    <Out()> ByVal iwsav As Integer(), _
    <Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02pqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal tstart As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal yinit As Double(), _
    ByVal tol As Double, _
    <[In]()> ByVal thresh As Double(), _
    ByVal method As Nag_RK_method, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As Double, _
    <Out()> ByVal iwsav As Integer(), _
    <Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rkts_reset_tend Lib "CLW3225DA_nag.dll" Alias "d02prc" ( _
    ByVal tendnu As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02prc Lib "CLW3225DA_nag.dll" ( _
    ByVal tendnu As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rkts_interp_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_ode_ivp_rkts_interp Lib "CLW3225DA_nag.dll" Alias "d02psc" ( _
    ByVal n As Integer, _
    ByVal twant As Double, _
    ByVal reqest As Nag_SolDeriv, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByVal f As nag_ode_ivp_rkts_interp_f_DELEGATE, _
    <[In](),Out()> ByVal wcomm As Double(), _
    ByVal lwcomm As Integer, _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

Delegate Sub d02psc_f_DELEGATE( _
    ByVal t As Double, _
    ByVal n As Integer, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d02psc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal twant As Double, _
    ByVal reqest As Nag_SolDeriv, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByVal f As d02psc_f_DELEGATE, _
    <[In](),Out()> ByVal wcomm As Double(), _
    ByVal lwcomm As Integer, _
    ByRef COMM As Nag_Comm, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rkts_diag Lib "CLW3225DA_nag.dll" Alias "d02ptc" ( _
    ByRef fevals As Integer, _
    ByRef stepcost As Integer, _
    ByRef waste As Double, _
    ByRef stepsok As Integer, _
    ByRef hnext As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In]()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02ptc Lib "CLW3225DA_nag.dll" ( _
    ByRef fevals As Integer, _
    ByRef stepcost As Integer, _
    ByRef waste As Double, _
    ByRef stepsok As Integer, _
    ByRef hnext As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In]()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rkts_errass Lib "CLW3225DA_nag.dll" Alias "d02puc" ( _
    ByVal n As Integer, _
    <Out()> ByVal rmserr As Double(), _
    ByRef errmax As Double, _
    ByRef terrmx As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02puc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <Out()> ByVal rmserr As Double(), _
    ByRef errmax As Double, _
    ByRef terrmx As Double, _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rk_setup Lib "CLW3225DA_nag.dll" Alias "d02pvc" ( _
    ByVal neq As Integer, _
    ByVal tstart As Double, _
    <[In]()> ByVal ystart As Double(), _
    ByVal tend As Double, _
    ByVal tol As Double, _
    <[In]()> ByVal thres As Double(), _
    ByVal method As Nag_RK_method, _
    ByVal task As Nag_RK_task, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )

   Declare Sub d02pvc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal tstart As Double, _
    <[In]()> ByVal ystart As Double(), _
    ByVal tend As Double, _
    ByVal tol As Double, _
    <[In]()> ByVal thres As Double(), _
    ByVal method As Nag_RK_method, _
    ByVal task As Nag_RK_task, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rk_reset_tend Lib "CLW3225DA_nag.dll" Alias "d02pwc" ( _
    ByVal tend_new As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )

   Declare Sub d02pwc Lib "CLW3225DA_nag.dll" ( _
    ByVal tend_new As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_rk_interp_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_ivp_rk_interp Lib "CLW3225DA_nag.dll" Alias "d02pxc" ( _
    ByVal neq As Integer, _
    ByVal twant As Double, _
    ByVal request As Nag_SolDeriv, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByVal f As nag_ode_ivp_rk_interp_f_DELEGATE, _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02pxc_f_DELEGATE( _
    ByVal neq As Integer, _
    ByVal t As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub d02pxc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal twant As Double, _
    ByVal request As Nag_SolDeriv, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByVal f As d02pxc_f_DELEGATE, _
    ByRef opt As Nag_ODE_RK, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_rk_errass Lib "CLW3225DA_nag.dll" Alias "d02pzc" ( _
    ByVal neq As Integer, _
    <Out()> ByVal rmserr As Double(), _
    ByRef errmax As Double, _
    ByRef terrmx As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )

   Declare Sub d02pzc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    <Out()> ByVal rmserr As Double(), _
    ByRef errmax As Double, _
    ByRef terrmx As Double, _
    ByRef opt As Nag_ODE_RK, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_ivp_adams_roots_fcn_DELEGATE( _
    ByVal neqf As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function nag_ode_ivp_adams_roots_g_DELEGATE( _
    ByVal neqf As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByVal k As Integer, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub nag_ode_ivp_adams_roots Lib "CLW3225DA_nag.dll" Alias "d02qfc" ( _
    ByVal neqf As Integer, _
    ByVal fcn As nag_ode_ivp_adams_roots_fcn_DELEGATE, _
    ByRef t As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tout As Double, _
    ByVal g As nag_ode_ivp_adams_roots_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

Delegate Sub d02qfc_fcn_DELEGATE( _
    ByVal neqf As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Function d02qfc_g_DELEGATE( _
    ByVal neqf As Integer, _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal yp_rptr As IntPtr, _
    ByVal k As Integer, _
    ByRef comm As Nag_User _
  ) as Double

   Declare Sub d02qfc Lib "CLW3225DA_nag.dll" ( _
    ByVal neqf As Integer, _
    ByVal fcn As d02qfc_fcn_DELEGATE, _
    ByRef t As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tout As Double, _
    ByVal g As d02qfc_g_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_adams_setup Lib "CLW3225DA_nag.dll" Alias "d02qwc" ( _
    ByRef state As Nag_Start, _
    ByVal neqf As Integer, _
    ByVal vectol As Nag_Boolean, _
    <[In]()> ByVal atol As Double(), _
    <[In]()> ByVal rtol As Double(), _
    ByVal one_step As Nag_Boolean, _
    ByVal crit As Nag_Boolean, _
    ByVal tcrit As Double, _
    ByVal hmax As Double, _
    ByVal max_step As Integer, _
    ByVal neqg As Integer, _
    ByRef alter_g As Nag_Boolean, _
    ByVal sophist As Nag_Boolean, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

   Declare Sub d02qwc Lib "CLW3225DA_nag.dll" ( _
    ByRef state As Nag_Start, _
    ByVal neqf As Integer, _
    ByVal vectol As Nag_Boolean, _
    <[In]()> ByVal atol As Double(), _
    <[In]()> ByVal rtol As Double(), _
    ByVal one_step As Nag_Boolean, _
    ByVal crit As Nag_Boolean, _
    ByVal tcrit As Double, _
    ByVal hmax As Double, _
    ByVal max_step As Integer, _
    ByVal neqg As Integer, _
    ByRef alter_g As Nag_Boolean, _
    ByVal sophist As Nag_Boolean, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_ivp_adams_free Lib "CLW3225DA_nag.dll" Alias "d02qyc" ( _
    ByRef opt As Nag_ODE_Adams _
   )

   Declare Sub d02qyc Lib "CLW3225DA_nag.dll" ( _
    ByRef opt As Nag_ODE_Adams _
   )


   Declare Sub nag_ode_ivp_adams_interp Lib "CLW3225DA_nag.dll" Alias "d02qzc" ( _
    ByVal neqf As Integer, _
    ByVal twant As Double, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )

   Declare Sub d02qzc Lib "CLW3225DA_nag.dll" ( _
    ByVal neqf As Integer, _
    ByVal twant As Double, _
    ByVal nwant As Integer, _
    <Out()> ByVal ywant As Double(), _
    <Out()> ByVal ypwant As Double(), _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_bvp_fd_nonlin_gen_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_nonlin_gen_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal bc_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_nonlin_gen_jacobf_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub D02GAZ Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_nonlin_gen_jacobg_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal aj_rptr As IntPtr, _
    ByVal bj_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub D02GAY Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal aj_rptr As IntPtr, _
    ByVal bj_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_nonlin_gen_jaceps_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub D02GAW Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub nag_ode_bvp_fd_nonlin_gen_jacgep_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal bcep_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub D02GAX Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal bcep_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

   Declare Sub nag_ode_bvp_fd_nonlin_gen Lib "CLW3225DA_nag.dll" Alias "d02rac" ( _
    ByVal neq As Integer, _
    ByRef deleps As Double, _
    ByVal fcn As nag_ode_bvp_fd_nonlin_gen_fcn_DELEGATE, _
    ByVal numbeg As Integer, _
    ByVal nummix As Integer, _
    ByVal g As nag_ode_bvp_fd_nonlin_gen_g_DELEGATE, _
    ByVal init As Nag_MeshSet, _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal abt As Double(), _
    ByVal jacobf As nag_ode_bvp_fd_nonlin_gen_jacobf_DELEGATE, _
    ByVal jacobg As nag_ode_bvp_fd_nonlin_gen_jacobg_DELEGATE, _
    ByVal jaceps As nag_ode_bvp_fd_nonlin_gen_jaceps_DELEGATE, _
    ByVal jacgep As nag_ode_bvp_fd_nonlin_gen_jacgep_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )

Delegate Sub d02rac_fcn_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02rac_g_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal bc_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )

Delegate Sub d02rac_jacobf_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )


Delegate Sub d02rac_jacobg_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal aj_rptr As IntPtr, _
    ByVal bj_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )


Delegate Sub d02rac_jaceps_DELEGATE( _
    ByVal neq As Integer, _
    ByVal x As Double, _
    ByVal eps As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )


Delegate Sub d02rac_jacgep_DELEGATE( _
    ByVal neq As Integer, _
    ByVal eps As Double, _
    ByVal ya_rptr As IntPtr, _
    ByVal yb_rptr As IntPtr, _
    ByVal bcep_rptr As IntPtr, _
    ByRef comm As Nag_User _
  )


   Declare Sub d02rac Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    ByRef deleps As Double, _
    ByVal fcn As d02rac_fcn_DELEGATE, _
    ByVal numbeg As Integer, _
    ByVal nummix As Integer, _
    ByVal g As d02rac_g_DELEGATE, _
    ByVal init As Nag_MeshSet, _
    ByVal mnp As Integer, _
    ByRef np As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal abt As Double(), _
    ByVal jacobf As d02rac_jacobf_DELEGATE, _
    ByVal jacobg As d02rac_jacobg_DELEGATE, _
    ByVal jaceps As d02rac_jaceps_DELEGATE, _
    ByVal jacgep As d02rac_jacgep_DELEGATE, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


Delegate Sub nag_ode_bvp_coll_nlin_solve_ffun_DELEGATE( _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_fjac_DELEGATE( _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal dfdy_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_gafun_DELEGATE( _
    ByVal ya_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nlbc As Integer, _
    ByVal ga_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_gbfun_DELEGATE( _
    ByVal yb_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nrbc As Integer, _
    ByVal gb_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_gajac_DELEGATE( _
    ByVal ya_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nlbc As Integer, _
    ByVal dgady_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_gbjac_DELEGATE( _
    ByVal yb_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nrbc As Integer, _
    ByVal dgbdy_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_ode_bvp_coll_nlin_solve_guess_DELEGATE( _
    ByVal x As Double, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal y_rptr As IntPtr, _
    ByVal dym_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_ode_bvp_coll_nlin_solve Lib "CLW3225DA_nag.dll" Alias "d02tlc" ( _
    ByVal ffun As nag_ode_bvp_coll_nlin_solve_ffun_DELEGATE, _
    ByVal fjac As nag_ode_bvp_coll_nlin_solve_fjac_DELEGATE, _
    ByVal gafun As nag_ode_bvp_coll_nlin_solve_gafun_DELEGATE, _
    ByVal gbfun As nag_ode_bvp_coll_nlin_solve_gbfun_DELEGATE, _
    ByVal gajac As nag_ode_bvp_coll_nlin_solve_gajac_DELEGATE, _
    ByVal gbjac As nag_ode_bvp_coll_nlin_solve_gbjac_DELEGATE, _
    ByVal guess As nag_ode_bvp_coll_nlin_solve_guess_DELEGATE, _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub d02tlc_ffun_DELEGATE( _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_fjac_DELEGATE( _
    ByVal x As Double, _
    ByVal y_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal dfdy_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_gafun_DELEGATE( _
    ByVal ya_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nlbc As Integer, _
    ByVal ga_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_gbfun_DELEGATE( _
    ByVal yb_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nrbc As Integer, _
    ByVal gb_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_gajac_DELEGATE( _
    ByVal ya_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nlbc As Integer, _
    ByVal dgady_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_gbjac_DELEGATE( _
    ByVal yb_rptr As IntPtr, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal nrbc As Integer, _
    ByVal dgbdy_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d02tlc_guess_DELEGATE( _
    ByVal x As Double, _
    ByVal neq As Integer, _
    ByVal m_iptr As IntPtr, _
    ByVal y_rptr As IntPtr, _
    ByVal dym_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d02tlc Lib "CLW3225DA_nag.dll" ( _
    ByVal ffun As d02tlc_ffun_DELEGATE, _
    ByVal fjac As d02tlc_fjac_DELEGATE, _
    ByVal gafun As d02tlc_gafun_DELEGATE, _
    ByVal gbfun As d02tlc_gbfun_DELEGATE, _
    ByVal gajac As d02tlc_gajac_DELEGATE, _
    ByVal gbjac As d02tlc_gbjac_DELEGATE, _
    ByVal guess As d02tlc_guess_DELEGATE, _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_coll_nlin_setup Lib "CLW3225DA_nag.dll" Alias "d02tvc" ( _
    ByVal neq As Integer, _
    <[In]()> ByVal m As Integer(), _
    ByVal nlbc As Integer, _
    ByVal nrbc As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal tols As Double(), _
    ByVal mxmesh As Integer, _
    ByVal nmesh As Integer, _
    <[In]()> ByVal mesh As Double(), _
    <[In]()> ByVal ipmesh As Integer(), _
    <Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d02tvc Lib "CLW3225DA_nag.dll" ( _
    ByVal neq As Integer, _
    <[In]()> ByVal m As Integer(), _
    ByVal nlbc As Integer, _
    ByVal nrbc As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal tols As Double(), _
    ByVal mxmesh As Integer, _
    ByVal nmesh As Integer, _
    <[In]()> ByVal mesh As Double(), _
    <[In]()> ByVal ipmesh As Integer(), _
    <Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_coll_nlin_contin Lib "CLW3225DA_nag.dll" Alias "d02txc" ( _
    ByVal mxmesh As Integer, _
    ByVal nmesh As Integer, _
    <[In]()> ByVal mesh As Double(), _
    <[In]()> ByVal ipmesh As Integer(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub d02txc Lib "CLW3225DA_nag.dll" ( _
    ByVal mxmesh As Integer, _
    ByVal nmesh As Integer, _
    <[In]()> ByVal mesh As Double(), _
    <[In]()> ByVal ipmesh As Integer(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_coll_nlin_interp Lib "CLW3225DA_nag.dll" Alias "d02tyc" ( _
    ByVal x As Double, _
    <Out()> ByVal y As Double(), _
    ByVal neq As Integer, _
    ByVal mmax As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub d02tyc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    <Out()> ByVal y As Double(), _
    ByVal neq As Integer, _
    ByVal mmax As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_coll_nlin_diag Lib "CLW3225DA_nag.dll" Alias "d02tzc" ( _
    ByVal mxmesh As Integer, _
    ByRef nmesh As Integer, _
    <Out()> ByVal mesh As Double(), _
    <Out()> ByVal ipmesh As Integer(), _
    ByRef ermx As Double, _
    ByRef iermx As Integer, _
    ByRef ijermx As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub d02tzc Lib "CLW3225DA_nag.dll" ( _
    ByVal mxmesh As Integer, _
    ByRef nmesh As Integer, _
    <Out()> ByVal mesh As Double(), _
    <Out()> ByVal ipmesh As Integer(), _
    ByRef ermx As Double, _
    ByRef iermx As Integer, _
    ByRef ijermx As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_coeffs Lib "CLW3225DA_nag.dll" Alias "d02uac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02uac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_cgl_vals Lib "CLW3225DA_nag.dll" Alias "d02ubc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal q As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02ubc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal q As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_cgl_grid Lib "CLW3225DA_nag.dll" Alias "d02ucc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02ucc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_cgl_deriv Lib "CLW3225DA_nag.dll" Alias "d02udc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal fd As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02udc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal fd As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_solve Lib "CLW3225DA_nag.dll" Alias "d02uec" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    <[In](),Out()> ByVal bmat As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal bvec As Double(), _
    <[In](),Out()> ByVal f As Double(), _
    <Out()> ByVal uc As Double(), _
    ByRef resid As Double, _
    ByRef fail As NagError _
   )

   Declare Sub d02uec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    <[In](),Out()> ByVal bmat As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal bvec As Double(), _
    <[In](),Out()> ByVal f As Double(), _
    <Out()> ByVal uc As Double(), _
    ByRef resid As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_grid_vals Lib "CLW3225DA_nag.dll" Alias "d02uwc" ( _
    ByVal n As Integer, _
    ByVal nip As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal xip As Double(), _
    <Out()> ByVal fip As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02uwc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nip As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal xip As Double(), _
    <Out()> ByVal fip As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_quad_weights Lib "CLW3225DA_nag.dll" Alias "d02uyc" ( _
    ByVal n As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d02uyc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_ode_bvp_ps_lin_cheb_eval Lib "CLW3225DA_nag.dll" Alias "d02uzc" ( _
    ByVal k As Integer, _
    ByVal x As Double, _
    ByRef t As Double, _
    ByRef fail As NagError _
   )

   Declare Sub d02uzc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal x As Double, _
    ByRef t As Double, _
    ByRef fail As NagError _
   )


' chapter d03

   Declare Sub nag_pde_bs_1d Lib "CLW3225DA_nag.dll" Alias "d03ncc" ( _
    ByVal kopt As Nag_OptionType, ByVal x As Double, ByVal mesh As Nag_MeshType, _
    ByVal ns As Integer, <[In](),Out()> ByVal s As Double(), ByVal nt As Integer, _
    <[In](),Out()> ByVal t As Double(), <[In]()> ByVal tdpar As Nag_Boolean(), <[In]()> ByVal r As Double(), _
    <[In]()> ByVal q As Double(), <[In]()> ByVal sigma As Double(), ByVal alpha As Double, _
    ByVal ntkeep As Integer, <Out()> ByVal f As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), <Out()> ByVal lambda As Double(), _
    <Out()> ByVal rho As Double(), ByRef fail As NagError _
   )

   Declare Sub d03ncc Lib "CLW3225DA_nag.dll" ( _
    ByVal kopt As Nag_OptionType, ByVal x As Double, ByVal mesh As Nag_MeshType, _
    ByVal ns As Integer, <[In](),Out()> ByVal s As Double(), ByVal nt As Integer, _
    <[In](),Out()> ByVal t As Double(), <[In]()> ByVal tdpar As Nag_Boolean(), <[In]()> ByVal r As Double(), _
    <[In]()> ByVal q As Double(), <[In]()> ByVal sigma As Double(), ByVal alpha As Double, _
    ByVal ntkeep As Integer, <Out()> ByVal f As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), <Out()> ByVal lambda As Double(), _
    <Out()> ByVal rho As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_pde_bs_1d_analytic Lib "CLW3225DA_nag.dll" Alias "d03ndc" ( _
    ByVal kopt As Nag_OptionType, _
    ByVal x As Double, _
    ByVal s As Double, _
    ByVal t As Double, _
    ByVal tmat As Double, _
    <[In]()> ByVal tdpar As Nag_Boolean(), _
    <[In]()> ByVal r As Double(), _
    <[In]()> ByVal q As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByRef f As Double, _
    ByRef theta As Double, _
    ByRef delta As Double, _
    ByRef gamma As Double, _
    ByRef lambda As Double, _
    ByRef rho As Double, _
    ByRef fail As NagError _
   )

   Declare Sub d03ndc Lib "CLW3225DA_nag.dll" ( _
    ByVal kopt As Nag_OptionType, _
    ByVal x As Double, _
    ByVal s As Double, _
    ByVal t As Double, _
    ByVal tmat As Double, _
    <[In]()> ByVal tdpar As Nag_Boolean(), _
    <[In]()> ByVal r As Double(), _
    <[In]()> ByVal q As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByRef f As Double, _
    ByRef theta As Double, _
    ByRef delta As Double, _
    ByRef gamma As Double, _
    ByRef lambda As Double, _
    ByRef rho As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_bs_1d_means Lib "CLW3225DA_nag.dll" Alias "d03nec" ( _
    ByVal t0 As Double, _
    ByVal tmat As Double, _
    ByVal ntd As Integer, _
    <[In]()> ByVal td As Double(), _
    <[In]()> ByVal phid As Double(), _
    <Out()> ByVal phiav As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d03nec Lib "CLW3225DA_nag.dll" ( _
    ByVal t0 As Double, _
    ByVal tmat As Double, _
    ByVal ntd As Integer, _
    <[In]()> ByVal td As Double(), _
    <[In]()> ByVal phid As Double(), _
    <Out()> ByVal phiav As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_fd_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_fd Lib "CLW3225DA_nag.dll" Alias "d03pcc" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As nag_pde_parab_1d_fd_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_fd_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

Delegate Sub d03pcc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pcc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d03pcc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As d03pcc_pdedef_DELEGATE, ByVal bndary As d03pcc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_coll_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal nptl As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_coll_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_coll_uinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_coll Lib "CLW3225DA_nag.dll" Alias "d03pdc" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As nag_pde_parab_1d_coll_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_coll_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal nbkpts As Integer, <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, ByVal npts As Integer, <Out()> ByVal x As Double(), _
    ByVal uinit As nag_pde_parab_1d_coll_uinit_DELEGATE, ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03pdc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal nptl As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pdc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pdc_uinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d03pdc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As d03pdc_pdedef_DELEGATE, ByVal bndary As d03pdc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal nbkpts As Integer, <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, ByVal npts As Integer, <Out()> ByVal x As Double(), _
    ByVal uinit As d03pdc_uinit_DELEGATE, ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_keller_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_keller Lib "CLW3225DA_nag.dll" Alias "d03pec" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_keller_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_keller_bndary_DELEGATE, <[In](),Out()> ByVal u As Double(), _
    ByVal npts As Integer, <[In]()> ByVal x As Double(), ByVal nleft As Integer, _
    ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

Delegate Sub d03pec_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pec_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d03pec Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03pec_pdedef_DELEGATE, ByVal bndary As d03pec_bndary_DELEGATE, <[In](),Out()> ByVal u As Double(), _
    ByVal npts As Integer, <[In]()> ByVal x As Double(), ByVal nleft As Integer, _
    ByVal acc As Double, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_cd_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PFP Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_cd_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub nag_pde_parab_1d_cd_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_cd Lib "CLW3225DA_nag.dll" Alias "d03pfc" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_cd_pdedef_DELEGATE, ByVal numflx As nag_pde_parab_1d_cd_numflx_DELEGATE, ByVal bndary As nag_pde_parab_1d_cd_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    <[In]()> ByVal acc As Double(), ByVal tsmax As Double, <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03pfc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03pfc_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub d03pfc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d03pfc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03pfc_pdedef_DELEGATE, ByVal numflx As d03pfc_numflx_DELEGATE, ByVal bndary As d03pfc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    <[In]()> ByVal acc As Double(), ByVal tsmax As Double, <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_fd_ode_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_ode_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_ode_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PCK Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_fd_ode Lib "CLW3225DA_nag.dll" Alias "d03phc" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As nag_pde_parab_1d_fd_ode_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_fd_ode_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_fd_ode_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03phc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03phc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03phc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03phc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As d03phc_pdedef_DELEGATE, ByVal bndary As d03phc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As d03phc_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_coll_ode_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal nptl As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_coll_ode_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_coll_ode_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_pde_parab_1d_coll_ode_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_coll_ode Lib "CLW3225DA_nag.dll" Alias "d03pjc" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As nag_pde_parab_1d_coll_ode_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_coll_ode_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal nbkpts As Integer, <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, ByVal npts As Integer, <Out()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_coll_ode_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, ByVal uvinit As nag_pde_parab_1d_coll_ode_uvinit_DELEGATE, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), _
    ByVal lisave As Integer, ByVal itask As Integer, ByVal itrace As Integer, _
    ByVal outfile As String, ByRef ind As Integer, _
    ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03pjc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal nptl As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pjc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pjc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03pjc_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub d03pjc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As d03pjc_pdedef_DELEGATE, ByVal bndary As d03pjc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal nbkpts As Integer, <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, ByVal npts As Integer, <Out()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As d03pjc_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, ByVal uvinit As d03pjc_uvinit_DELEGATE, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), _
    ByVal lisave As Integer, ByVal itask As Integer, ByVal itrace As Integer, _
    ByVal outfile As String, ByRef ind As Integer, _
    ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_keller_ode_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_ode_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_ode_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PEK Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_keller_ode Lib "CLW3225DA_nag.dll" Alias "d03pkc" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_keller_ode_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_keller_ode_bndary_DELEGATE, <[In](),Out()> ByVal u As Double(), _
    ByVal npts As Integer, <[In]()> ByVal x As Double(), ByVal nleft As Integer, _
    ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_keller_ode_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03pkc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pkc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal ut_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03pkc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03pkc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03pkc_pdedef_DELEGATE, ByVal bndary As d03pkc_bndary_DELEGATE, <[In](),Out()> ByVal u As Double(), _
    ByVal npts As Integer, <[In]()> ByVal x As Double(), ByVal nleft As Integer, _
    ByVal ncode As Integer, ByVal odedef As d03pkc_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_cd_ode_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PLP Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub nag_pde_parab_1d_cd_ode Lib "CLW3225DA_nag.dll" Alias "d03plc" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_cd_ode_pdedef_DELEGATE, ByVal numflx As nag_pde_parab_1d_cd_ode_numflx_DELEGATE, ByVal bndary As nag_pde_parab_1d_cd_ode_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_cd_ode_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )

Delegate Sub d03plc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03plc_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub d03plc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03plc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03plc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03plc_pdedef_DELEGATE, ByVal numflx As d03plc_numflx_DELEGATE, ByVal bndary As d03plc_bndary_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In]()> ByVal x As Double(), _
    ByVal ncode As Integer, ByVal odedef As d03plc_odedef_DELEGATE, ByVal nxi As Integer, _
    <[In]()> ByVal xi As Double(), ByVal neqn As Integer, <[In]()> ByVal rtol As Double(), _
    <[In]()> ByVal atol As Double(), ByVal itol As Integer, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, _
    ByVal itask As Integer, ByVal itrace As Integer, ByVal outfile As String, _
    ByRef ind As Integer, ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_fd_ode_remesh_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_ode_remesh_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_ode_remesh_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_fd_ode_remesh_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_pde_parab_1d_fd_ode_remesh_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PCL Lib "CLW3225DA_nag.dll" ( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_fd_ode_remesh Lib "CLW3225DA_nag.dll" Alias "d03ppc" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As nag_pde_parab_1d_fd_ode_remesh_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_fd_ode_remesh_bndary_DELEGATE, _
    ByVal uvinit As nag_pde_parab_1d_fd_ode_remesh_uvinit_DELEGATE, <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_fd_ode_remesh_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As nag_pde_parab_1d_fd_ode_remesh_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

Delegate Sub d03ppc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal q_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03ppc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal beta_rptr As IntPtr, _
    ByVal gamma_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03ppc_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03ppc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal rcp_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal ucptx_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03ppc_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03ppc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByVal m As Integer, ByRef ts As Double, _
    ByVal tout As Double, ByVal pdedef As d03ppc_pdedef_DELEGATE, ByVal bndary As d03ppc_bndary_DELEGATE, _
    ByVal uvinit As d03ppc_uvinit_DELEGATE, <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal ncode As Integer, ByVal odedef As d03ppc_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As d03ppc_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_keller_ode_remesh_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal udot_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_ode_remesh_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal udot_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_ode_remesh_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_keller_ode_remesh_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_pde_parab_1d_keller_ode_remesh_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub D03PEL Lib "CLW3225DA_nag.dll" ( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_pde_parab_1d_keller_ode_remesh Lib "CLW3225DA_nag.dll" Alias "d03prc" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_keller_ode_remesh_pdedef_DELEGATE, ByVal bndary As nag_pde_parab_1d_keller_ode_remesh_bndary_DELEGATE, ByVal uvinit As nag_pde_parab_1d_keller_ode_remesh_uvinit_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In](),Out()> ByVal x As Double(), _
    ByVal nleft As Integer, ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_keller_ode_remesh_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As nag_pde_parab_1d_keller_ode_remesh_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

Delegate Sub d03prc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal udot_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03prc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ibnd As Integer, _
    ByVal nobc As Integer, _
    ByVal u_rptr As IntPtr, _
    ByVal udot_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal res_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03prc_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03prc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03prc_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03prc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03prc_pdedef_DELEGATE, ByVal bndary As d03prc_bndary_DELEGATE, ByVal uvinit As d03prc_uvinit_DELEGATE, _
    <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, <[In](),Out()> ByVal x As Double(), _
    ByVal nleft As Integer, ByVal ncode As Integer, ByVal odedef As d03prc_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As d03prc_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


Delegate Sub nag_pde_parab_1d_cd_ode_remesh_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_pde_parab_1d_cd_ode_remesh_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_remesh_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_remesh_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_pde_parab_1d_cd_ode_remesh_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_pde_parab_1d_cd_ode_remesh_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub nag_pde_parab_1d_cd_ode_remesh Lib "CLW3225DA_nag.dll" Alias "d03psc" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As nag_pde_parab_1d_cd_ode_remesh_pdedef_DELEGATE, ByVal numflx As nag_pde_parab_1d_cd_ode_remesh_numflx_DELEGATE, ByVal bndary As nag_pde_parab_1d_cd_ode_remesh_bndary_DELEGATE, _
    ByVal uvinit As nag_pde_parab_1d_cd_ode_remesh_uvinit_DELEGATE, <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal ncode As Integer, ByVal odedef As nag_pde_parab_1d_cd_ode_remesh_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As nag_pde_parab_1d_cd_ode_remesh_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

Delegate Sub d03psc_pdedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal u_rptr As IntPtr, _
    ByVal ux_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal p_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal d_rptr As IntPtr, _
    ByVal s_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03psc_numflx_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal x As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal uleft_rptr As IntPtr, _
    ByVal uright_rptr As IntPtr, _
    ByVal flux_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef saved As Nag_D03_Save _
  )

Delegate Sub d03psc_bndary_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal t As Double, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal ibnd As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03psc_uvinit_DELEGATE( _
    ByVal npde As Integer, _
    ByVal npts As Integer, _
    ByVal nxi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xi_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub d03psc_odedef_DELEGATE( _
    ByVal npde As Integer, _
    ByVal t As Double, _
    ByVal ncode As Integer, _
    ByVal v_rptr As IntPtr, _
    ByVal vdot_rptr As IntPtr, _
    ByVal nxi As Integer, _
    ByVal xi_rptr As IntPtr, _
    ByVal ucp_rptr As IntPtr, _
    ByVal ucpx_rptr As IntPtr, _
    ByVal ucpt_rptr As IntPtr, _
    ByVal r_rptr As IntPtr, _
    ByRef ires As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub d03psc_monitf_DELEGATE( _
    ByVal t As Double, _
    ByVal npts As Integer, _
    ByVal npde As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal u_rptr As IntPtr, _
    ByVal fmon_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub d03psc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, ByRef ts As Double, ByVal tout As Double, _
    ByVal pdedef As d03psc_pdedef_DELEGATE, ByVal numflx As d03psc_numflx_DELEGATE, ByVal bndary As d03psc_bndary_DELEGATE, _
    ByVal uvinit As d03psc_uvinit_DELEGATE, <[In](),Out()> ByVal u As Double(), ByVal npts As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal ncode As Integer, ByVal odedef As d03psc_odedef_DELEGATE, _
    ByVal nxi As Integer, <[In]()> ByVal xi As Double(), ByVal neqn As Integer, _
    <[In]()> ByVal rtol As Double(), <[In]()> ByVal atol As Double(), ByVal itol As Integer, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, <[In]()> ByVal algopt As Double(), _
    ByVal remesh As Nag_Boolean, ByVal nxfix As Integer, <[In]()> ByVal xfix As Double(), _
    ByVal nrmesh As Integer, ByVal dxmesh As Double, ByVal trmesh As Double, _
    ByVal ipminf As Integer, ByVal xratio As Double, ByVal con As Double, _
    ByVal monitf As d03psc_monitf_DELEGATE, <[In](),Out()> ByVal rsave As Double(), ByVal lrsave As Integer, _
    <[In](),Out()> ByVal isave As Integer(), ByVal lisave As Integer, ByVal itask As Integer, _
    ByVal itrace As Integer, ByVal outfile As String, ByRef ind As Integer, ByRef COMM As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_parab_1d_euler_roe Lib "CLW3225DA_nag.dll" Alias "d03puc" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub d03puc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_parab_1d_euler_osher Lib "CLW3225DA_nag.dll" Alias "d03pvc" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    ByVal path As Nag_OsherVersion, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub d03pvc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    ByVal path As Nag_OsherVersion, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_parab_1d_euler_hll Lib "CLW3225DA_nag.dll" Alias "d03pwc" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub d03pwc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_parab_1d_euler_exact Lib "CLW3225DA_nag.dll" Alias "d03pxc" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    ByVal tol As Double, _
    ByVal niter As Integer, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )

   Declare Sub d03pxc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal uleft As Double(), _
    <[In]()> ByVal uright As Double(), _
    ByVal gamma As Double, _
    ByVal tol As Double, _
    ByVal niter As Integer, _
    <Out()> ByVal flux As Double(), _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_interp_1d_coll Lib "CLW3225DA_nag.dll" Alias "d03pyc" ( _
    ByVal npde As Integer, _
    <[In]()> ByVal u As Double(), _
    ByVal nbkpts As Integer, _
    <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, _
    ByVal npts As Integer, _
    <[In]()> ByVal xp As Double(), _
    ByVal intpts As Integer, _
    ByVal itype As Integer, _
    <Out()> ByVal up As Double(), _
    <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d03pyc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    <[In]()> ByVal u As Double(), _
    ByVal nbkpts As Integer, _
    <[In]()> ByVal xbkpts As Double(), _
    ByVal npoly As Integer, _
    ByVal npts As Integer, _
    <[In]()> ByVal xp As Double(), _
    ByVal intpts As Integer, _
    ByVal itype As Integer, _
    <Out()> ByVal up As Double(), _
    <[In](),Out()> ByVal rsave As Double(), _
    ByVal lrsave As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pde_interp_1d_fd Lib "CLW3225DA_nag.dll" Alias "d03pzc" ( _
    ByVal npde As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal u As Double(), _
    ByVal npts As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal xp As Double(), _
    ByVal intpts As Integer, _
    ByVal itype As Integer, _
    <Out()> ByVal up As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d03pzc Lib "CLW3225DA_nag.dll" ( _
    ByVal npde As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal u As Double(), _
    ByVal npts As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal xp As Double(), _
    ByVal intpts As Integer, _
    ByVal itype As Integer, _
    <Out()> ByVal up As Double(), _
    ByRef fail As NagError _
   )


' chapter d04

Delegate Function nag_numdiff_1d_real_fun_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_numdiff_1d_real Lib "CLW3225DA_nag.dll" Alias "d04aac" ( _
    ByVal xval As Double, _
    ByVal nder As Integer, _
    ByVal hbase As Double, _
    <Out()> ByVal der As Double(), _
    <Out()> ByVal erest As Double(), _
    ByVal fun As nag_numdiff_1d_real_fun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d04aac_fun_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d04aac Lib "CLW3225DA_nag.dll" ( _
    ByVal xval As Double, _
    ByVal nder As Integer, _
    ByVal hbase As Double, _
    <Out()> ByVal der As Double(), _
    <Out()> ByVal erest As Double(), _
    ByVal fun As d04aac_fun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_numdiff_1d_real_eval Lib "CLW3225DA_nag.dll" Alias "d04bac" ( _
    <[In]()> ByVal xval As Double(), _
    <[In]()> ByVal fval As Double(), _
    <Out()> ByVal der As Double(), _
    <Out()> ByVal erest As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d04bac Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal xval As Double(), _
    <[In]()> ByVal fval As Double(), _
    <Out()> ByVal der As Double(), _
    <Out()> ByVal erest As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_numdiff_1d_real_absci Lib "CLW3225DA_nag.dll" Alias "d04bbc" ( _
    ByVal x_0 As Double, _
    ByVal hbase As Double, _
    <Out()> ByVal xval As Double() _
   )

   Declare Sub d04bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal x_0 As Double, _
    ByVal hbase As Double, _
    <Out()> ByVal xval As Double() _
   )


' chapter d05

Delegate Function nag_inteq_fredholm2_split_k1_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_fredholm2_split_k2_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_fredholm2_split_g_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_inteq_fredholm2_split Lib "CLW3225DA_nag.dll" Alias "d05aac" ( _
    ByVal lambda As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal k1 As nag_inteq_fredholm2_split_k1_DELEGATE, _
    ByVal k2 As nag_inteq_fredholm2_split_k2_DELEGATE, _
    ByVal g As nag_inteq_fredholm2_split_g_DELEGATE, _
    ByVal kform As Nag_KernelForm, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d05aac_k1_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05aac_k2_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05aac_g_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d05aac Lib "CLW3225DA_nag.dll" ( _
    ByVal lambda As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal k1 As d05aac_k1_DELEGATE, _
    ByVal k2 As d05aac_k2_DELEGATE, _
    ByVal g As d05aac_g_DELEGATE, _
    ByVal kform As Nag_KernelForm, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_inteq_fredholm2_smooth_k_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_fredholm2_smooth_g_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_inteq_fredholm2_smooth Lib "CLW3225DA_nag.dll" Alias "d05abc" ( _
    ByVal lambda As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal k As nag_inteq_fredholm2_smooth_k_DELEGATE, _
    ByVal g As nag_inteq_fredholm2_smooth_g_DELEGATE, _
    ByVal odorev As Nag_Boolean, _
    ByVal ev As Nag_Boolean, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d05abc_k_DELEGATE( _
    ByVal x As Double, _
    ByVal s As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05abc_g_DELEGATE( _
    ByVal x As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d05abc Lib "CLW3225DA_nag.dll" ( _
    ByVal lambda As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal n As Integer, _
    ByVal k As d05abc_k_DELEGATE, _
    ByVal g As d05abc_g_DELEGATE, _
    ByVal odorev As Nag_Boolean, _
    ByVal ev As Nag_Boolean, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_inteq_volterra2_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_volterra2_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_volterra2_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_inteq_volterra2 Lib "CLW3225DA_nag.dll" Alias "d05bac" ( _
    ByVal ck As nag_inteq_volterra2_ck_DELEGATE, _
    ByVal cg As nag_inteq_volterra2_cg_DELEGATE, _
    ByVal cf As nag_inteq_volterra2_cf_DELEGATE, _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As Integer, _
    ByVal alim As Double, _
    ByVal tlim As Double, _
    ByVal tol As Double, _
    ByVal nmesh As Integer, _
    ByVal thresh As Double, _
    <Out()> ByVal work As Double(), _
    ByVal lwk As Integer, _
    <Out()> ByVal yn As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d05bac_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bac_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bac_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d05bac Lib "CLW3225DA_nag.dll" ( _
    ByVal ck As d05bac_ck_DELEGATE, _
    ByVal cg As d05bac_cg_DELEGATE, _
    ByVal cf As d05bac_cf_DELEGATE, _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As Integer, _
    ByVal alim As Double, _
    ByVal tlim As Double, _
    ByVal tol As Double, _
    ByVal nmesh As Integer, _
    ByVal thresh As Double, _
    <Out()> ByVal work As Double(), _
    ByVal lwk As Integer, _
    <Out()> ByVal yn As Double(), _
    <Out()> ByVal errest As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_inteq_abel2_weak_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_abel2_weak_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_abel2_weak_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_inteq_abel2_weak Lib "CLW3225DA_nag.dll" Alias "d05bdc" ( _
    ByVal ck As nag_inteq_abel2_weak_ck_DELEGATE, _
    ByVal cf As nag_inteq_abel2_weak_cf_DELEGATE, _
    ByVal cg As nag_inteq_abel2_weak_cg_DELEGATE, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As Integer, _
    ByVal tlim As Double, _
    ByVal tolnl As Double, _
    ByVal nmesh As Integer, _
    <Out()> ByVal yn As Double(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d05bdc_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bdc_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bdc_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d05bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal ck As d05bdc_ck_DELEGATE, _
    ByVal cf As d05bdc_cf_DELEGATE, _
    ByVal cg As d05bdc_cg_DELEGATE, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As Integer, _
    ByVal tlim As Double, _
    ByVal tolnl As Double, _
    ByVal nmesh As Integer, _
    <Out()> ByVal yn As Double(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_inteq_abel1_weak_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_abel1_weak_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_inteq_abel1_weak_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_inteq_abel1_weak Lib "CLW3225DA_nag.dll" Alias "d05bec" ( _
    ByVal ck As nag_inteq_abel1_weak_ck_DELEGATE, _
    ByVal cf As nag_inteq_abel1_weak_cf_DELEGATE, _
    ByVal cg As nag_inteq_abel1_weak_cg_DELEGATE, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As Integer, _
    ByVal tlim As Double, _
    ByVal tolnl As Double, _
    ByVal nmesh As Integer, _
    <[In](),Out()> ByVal yn As Double(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function d05bec_ck_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bec_cf_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function d05bec_cg_DELEGATE( _
    ByVal s As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub d05bec Lib "CLW3225DA_nag.dll" ( _
    ByVal ck As d05bec_ck_DELEGATE, _
    ByVal cf As d05bec_cf_DELEGATE, _
    ByVal cg As d05bec_cg_DELEGATE, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As Integer, _
    ByVal tlim As Double, _
    ByVal tolnl As Double, _
    ByVal nmesh As Integer, _
    <[In](),Out()> ByVal yn As Double(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_inteq_volterra_weights Lib "CLW3225DA_nag.dll" Alias "d05bwc" ( _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As Integer, _
    ByVal nomg As Integer, _
    <Out()> ByVal omega As Double(), _
    <Out()> ByVal sw As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d05bwc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As Integer, _
    ByVal nomg As Integer, _
    <Out()> ByVal omega As Double(), _
    <Out()> ByVal sw As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_inteq_abel_weak_weights Lib "CLW3225DA_nag.dll" Alias "d05byc" ( _
    ByVal iorder As Integer, _
    ByVal iq As Integer, _
    <Out()> ByVal omega As Double(), _
    <Out()> ByVal sw As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub d05byc Lib "CLW3225DA_nag.dll" ( _
    ByVal iorder As Integer, _
    ByVal iq As Integer, _
    <Out()> ByVal omega As Double(), _
    <Out()> ByVal sw As Double(), _
    ByRef fail As NagError _
   )


' chapter d06

   Declare Sub nag_mesh2d_inc Lib "CLW3225DA_nag.dll" Alias "d06aac" ( _
    ByVal nvb As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal bspace As Double(), _
    ByVal smooth As Nag_Boolean, _
    ByVal coef As Double, _
    ByVal power As Double, _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06aac Lib "CLW3225DA_nag.dll" ( _
    ByVal nvb As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal bspace As Double(), _
    ByVal smooth As Nag_Boolean, _
    ByVal coef As Double, _
    ByVal power As Double, _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_delaunay Lib "CLW3225DA_nag.dll" Alias "d06abc" ( _
    ByVal nvb As Integer, _
    ByVal nvint As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal weight As Double(), _
    ByVal npropa As Integer, _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06abc Lib "CLW3225DA_nag.dll" ( _
    ByVal nvb As Integer, _
    ByVal nvint As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal weight As Double(), _
    ByVal npropa As Integer, _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_front Lib "CLW3225DA_nag.dll" Alias "d06acc" ( _
    ByVal nvb As Integer, _
    ByVal nvint As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal weight As Double(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06acc Lib "CLW3225DA_nag.dll" ( _
    ByVal nvb As Integer, _
    ByVal nvint As Integer, _
    ByVal nvmax As Integer, _
    ByVal nedge As Integer, _
    <[In]()> ByVal edge As Integer(), _
    ByRef nv As Integer, _
    ByRef nelt As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <Out()> ByVal conn As Integer(), _
    <[In]()> ByVal weight As Double(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


Delegate Function nag_mesh2d_bound_fbnd_DELEGATE( _
    ByVal i As Integer, _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Function D06BAD Lib "CLW3225DA_nag.dll" ( _
    ByVal i As Integer, _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_mesh2d_bound Lib "CLW3225DA_nag.dll" Alias "d06bac" ( _
    ByVal nlines As Integer, <[In]()> ByVal coorch As Double(), <[In]()> ByVal lined As Integer(), _
    ByVal fbnd As nag_mesh2d_bound_fbnd_DELEGATE, <[In]()> ByVal crus As Double(), ByVal sdcrus As Integer, _
    <[In]()> ByVal rate As Double(), ByVal ncomp As Integer, <[In]()> ByVal nlcomp As Integer(), _
    <[In]()> ByVal lcomp As Integer(), ByVal nvmax As Integer, ByVal nedmx As Integer, _
    ByRef nvb As Integer, <Out()> ByVal coor As Double(), ByRef nedge As Integer, _
    <Out()> ByVal edge As Integer(), ByVal itrace As Integer, ByVal outfile As String, ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Function d06bac_fbnd_DELEGATE( _
    ByVal i As Integer, _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double


   Declare Sub d06bac Lib "CLW3225DA_nag.dll" ( _
    ByVal nlines As Integer, <[In]()> ByVal coorch As Double(), <[In]()> ByVal lined As Integer(), _
    ByVal fbnd As d06bac_fbnd_DELEGATE, <[In]()> ByVal crus As Double(), ByVal sdcrus As Integer, _
    <[In]()> ByVal rate As Double(), ByVal ncomp As Integer, <[In]()> ByVal nlcomp As Integer(), _
    <[In]()> ByVal lcomp As Integer(), ByVal nvmax As Integer, ByVal nedmx As Integer, _
    ByRef nvb As Integer, <Out()> ByVal coor As Double(), ByRef nedge As Integer, _
    <Out()> ByVal edge As Integer(), ByVal itrace As Integer, ByVal outfile As String, ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_smooth Lib "CLW3225DA_nag.dll" Alias "d06cac" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nedge As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <[In]()> ByVal edge As Integer(), _
    <[In]()> ByVal conn As Integer(), _
    ByVal nvfix As Integer, _
    <[In]()> ByVal numfix As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByVal nqint As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub d06cac Lib "CLW3225DA_nag.dll" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nedge As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <[In]()> ByVal edge As Integer(), _
    <[In]()> ByVal conn As Integer(), _
    ByVal nvfix As Integer, _
    <[In]()> ByVal numfix As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByVal nqint As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_sparse Lib "CLW3225DA_nag.dll" Alias "d06cbc" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nnzmax As Integer, _
    <[In]()> ByVal conn As Integer(), _
    ByRef nnz As Integer, _
    <Out()> ByVal irow As Integer(), _
    <Out()> ByVal icol As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub d06cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nnzmax As Integer, _
    <[In]()> ByVal conn As Integer(), _
    ByRef nnz As Integer, _
    <Out()> ByVal irow As Integer(), _
    <Out()> ByVal icol As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_renum Lib "CLW3225DA_nag.dll" Alias "d06ccc" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nedge As Integer, _
    ByVal nnzmax As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <[In](),Out()> ByVal edge As Integer(), _
    <[In](),Out()> ByVal conn As Integer(), _
    <Out()> ByVal irow As Integer(), _
    <Out()> ByVal icol As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal nv As Integer, _
    ByVal nelt As Integer, _
    ByVal nedge As Integer, _
    ByVal nnzmax As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal coor As Double(), _
    <[In](),Out()> ByVal edge As Integer(), _
    <[In](),Out()> ByVal conn As Integer(), _
    <Out()> ByVal irow As Integer(), _
    <Out()> ByVal icol As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_trans Lib "CLW3225DA_nag.dll" Alias "d06dac" ( _
    ByVal mode As Integer, _
    ByVal nv As Integer, _
    ByVal nedge As Integer, _
    ByVal nelt As Integer, _
    ByVal ntrans As Integer, _
    <[In]()> ByVal itype As Integer(), _
    <[In]()> ByVal trans As Double(), _
    <[In](),Out()> ByVal coori As Double(), _
    <[In](),Out()> ByVal edgei As Integer(), _
    <[In](),Out()> ByVal conni As Integer(), _
    <Out()> ByVal cooro As Double(), _
    <Out()> ByVal edgeo As Integer(), _
    <Out()> ByVal conno As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06dac Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Integer, _
    ByVal nv As Integer, _
    ByVal nedge As Integer, _
    ByVal nelt As Integer, _
    ByVal ntrans As Integer, _
    <[In]()> ByVal itype As Integer(), _
    <[In]()> ByVal trans As Double(), _
    <[In](),Out()> ByVal coori As Double(), _
    <[In](),Out()> ByVal edgei As Integer(), _
    <[In](),Out()> ByVal conni As Integer(), _
    <Out()> ByVal cooro As Double(), _
    <Out()> ByVal edgeo As Integer(), _
    <Out()> ByVal conno As Integer(), _
    ByVal itrace As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mesh2d_join Lib "CLW3225DA_nag.dll" Alias "d06dbc" ( _
    ByVal eps As Double, ByVal nv1 As Integer, ByVal nelt1 As Integer, _
    ByVal nedge1 As Integer, <[In]()> ByVal coor1 As Double(), <[In]()> ByVal edge1 As Integer(), _
    <[In]()> ByVal conn1 As Integer(), <[In]()> ByVal reft1 As Integer(), ByVal nv2 As Integer, _
    ByVal nelt2 As Integer, ByVal nedge2 As Integer, <[In]()> ByVal coor2 As Double(), _
    <[In]()> ByVal edge2 As Integer(), <[In]()> ByVal conn2 As Integer(), <[In]()> ByVal reft2 As Integer(), _
    ByRef nv3 As Integer, ByRef nelt3 As Integer, ByRef nedge3 As Integer, _
    <Out()> ByVal coor3 As Double(), <Out()> ByVal edge3 As Integer(), <Out()> ByVal conn3 As Integer(), _
    <Out()> ByVal reft3 As Integer(), ByVal itrace As Integer, ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub d06dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal eps As Double, ByVal nv1 As Integer, ByVal nelt1 As Integer, _
    ByVal nedge1 As Integer, <[In]()> ByVal coor1 As Double(), <[In]()> ByVal edge1 As Integer(), _
    <[In]()> ByVal conn1 As Integer(), <[In]()> ByVal reft1 As Integer(), ByVal nv2 As Integer, _
    ByVal nelt2 As Integer, ByVal nedge2 As Integer, <[In]()> ByVal coor2 As Double(), _
    <[In]()> ByVal edge2 As Integer(), <[In]()> ByVal conn2 As Integer(), <[In]()> ByVal reft2 As Integer(), _
    ByRef nv3 As Integer, ByRef nelt3 As Integer, ByRef nedge3 As Integer, _
    <Out()> ByVal coor3 As Double(), <Out()> ByVal edge3 As Integer(), <Out()> ByVal conn3 As Integer(), _
    <Out()> ByVal reft3 As Integer(), ByVal itrace As Integer, ByVal outfile As String, _
    ByRef fail As NagError _
   )


' chapter e01

   Declare Sub nag_1d_aitken_interp Lib "CLW3225DA_nag.dll" Alias "e01aac" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    <Out()> ByVal c As Double(), _
    ByVal x As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e01aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    <Out()> ByVal c As Double(), _
    ByVal x As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_everett_interp Lib "CLW3225DA_nag.dll" Alias "e01abc" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal a As Double(), _
    <Out()> ByVal g As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01abc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal a As Double(), _
    <Out()> ByVal g As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_interp Lib "CLW3225DA_nag.dll" Alias "e01aec" ( _
    ByVal m As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal p As Integer(), _
    ByVal itmin As Integer, _
    ByVal itmax As Integer, _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal perf As Double(), _
    ByRef num_iter As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e01aec Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal p As Integer(), _
    ByVal itmin As Integer, _
    ByVal itmax As Integer, _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal perf As Double(), _
    ByRef num_iter As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_interpolant Lib "CLW3225DA_nag.dll" Alias "e01bac" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Sub e01bac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_monotonic_interpolant Lib "CLW3225DA_nag.dll" Alias "e01bec" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01bec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_monotonic_evaluate Lib "CLW3225DA_nag.dll" Alias "e01bfc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal px As Double(), _
    <Out()> ByVal pf As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal px As Double(), _
    <Out()> ByVal pf As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_monotonic_deriv Lib "CLW3225DA_nag.dll" Alias "e01bgc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal px As Double(), _
    <Out()> ByVal pf As Double(), _
    <Out()> ByVal pd As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01bgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal px As Double(), _
    <Out()> ByVal pf As Double(), _
    <Out()> ByVal pd As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_monotonic_intg Lib "CLW3225DA_nag.dll" Alias "e01bhc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef integral As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e01bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal d As Double(), _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef integral As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_interpolant Lib "CLW3225DA_nag.dll" Alias "e01dac" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e01dac Lib "CLW3225DA_nag.dll" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_triangulate Lib "CLW3225DA_nag.dll" Alias "e01eac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal triang As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub e01eac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal triang As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_triang_bary_eval Lib "CLW3225DA_nag.dll" Alias "e01ebc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal triang As Integer(), _
    <[In]()> ByVal px As Double(), _
    <[In]()> ByVal py As Double(), _
    <Out()> ByVal pf As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal triang As Integer(), _
    <[In]()> ByVal px As Double(), _
    <[In]()> ByVal py As Double(), _
    <Out()> ByVal pf As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_ratnl_interp Lib "CLW3225DA_nag.dll" Alias "e01rac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef m As Integer, _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal u As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01rac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef m As Integer, _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal u As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_ratnl_eval Lib "CLW3225DA_nag.dll" Alias "e01rbc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal u As Double(), _
    ByVal x As Double, _
    ByRef f As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e01rbc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal u As Double(), _
    ByVal x As Double, _
    ByRef f As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_shep_interp Lib "CLW3225DA_nag.dll" Alias "e01sgc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01sgc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_shep_eval Lib "CLW3225DA_nag.dll" Alias "e01shc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    <Out()> ByVal qy As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01shc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    <Out()> ByVal qy As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_triang_interp Lib "CLW3225DA_nag.dll" Alias "e01sjc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal triang As Integer(), _
    <Out()> ByVal grads As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01sjc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal triang As Integer(), _
    <Out()> ByVal grads As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_triang_eval Lib "CLW3225DA_nag.dll" Alias "e01skc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal triang As Integer(), _
    <[In]()> ByVal grads As Double(), _
    ByVal px As Double, _
    ByVal py As Double, _
    ByRef pf As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e01skc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal triang As Integer(), _
    <[In]()> ByVal grads As Double(), _
    ByVal px As Double, _
    ByVal py As Double, _
    ByRef pf As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_3d_shep_interp Lib "CLW3225DA_nag.dll" Alias "e01tgc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01tgc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_3d_shep_eval Lib "CLW3225DA_nag.dll" Alias "e01thc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    <Out()> ByVal qy As Double(), _
    <Out()> ByVal qz As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01thc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal u As Double(), _
    <[In]()> ByVal v As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    <Out()> ByVal qy As Double(), _
    <Out()> ByVal qz As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_4d_shep_interp Lib "CLW3225DA_nag.dll" Alias "e01tkc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01tkc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_4d_shep_eval Lib "CLW3225DA_nag.dll" Alias "e01tlc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01tlc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_5d_shep_interp Lib "CLW3225DA_nag.dll" Alias "e01tmc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01tmc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_5d_shep_eval Lib "CLW3225DA_nag.dll" Alias "e01tnc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01tnc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_nd_shep_interp Lib "CLW3225DA_nag.dll" Alias "e01zmc" ( _
    ByVal d As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01zmc Lib "CLW3225DA_nag.dll" ( _
    ByVal d As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal nw As Integer, _
    ByVal nq As Integer, _
    <Out()> ByVal iq As Integer(), _
    <Out()> ByVal rq As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_nd_shep_eval Lib "CLW3225DA_nag.dll" Alias "e01znc" ( _
    ByVal d As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e01znc Lib "CLW3225DA_nag.dll" ( _
    ByVal d As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal iq As Integer(), _
    <[In]()> ByVal rq As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal xe As Double(), _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal qx As Double(), _
    ByRef fail As NagError _
   )


' chapter e02

   Declare Sub nag_1d_cheb_fit Lib "CLW3225DA_nag.dll" Alias "e02adc" ( _
    ByVal m As Integer, _
    ByVal kplus1 As Integer, _
    ByVal tda As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02adc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal kplus1 As Integer, _
    ByVal tda As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_eval Lib "CLW3225DA_nag.dll" Alias "e02aec" ( _
    ByVal nplus1 As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal xcap As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e02aec Lib "CLW3225DA_nag.dll" ( _
    ByVal nplus1 As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal xcap As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_interp_fit Lib "CLW3225DA_nag.dll" Alias "e02afc" ( _
    ByVal nplus1 As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal a As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02afc Lib "CLW3225DA_nag.dll" ( _
    ByVal nplus1 As Integer, _
    <[In]()> ByVal f As Double(), _
    <Out()> ByVal a As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_fit_constr Lib "CLW3225DA_nag.dll" Alias "e02agc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal w As Double(), _
    ByVal mf As Integer, _
    <[In]()> ByVal xf As Double(), _
    <[In]()> ByVal yf As Double(), _
    <[In]()> ByVal p As Integer(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef n As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02agc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal w As Double(), _
    ByVal mf As Integer, _
    <[In]()> ByVal xf As Double(), _
    <[In]()> ByVal yf As Double(), _
    <[In]()> ByVal p As Integer(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef n As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_deriv Lib "CLW3225DA_nag.dll" Alias "e02ahc" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByRef patm1 As Double, _
    <Out()> ByVal adif As Double(), _
    ByVal iadif1 As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02ahc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByRef patm1 As Double, _
    <Out()> ByVal adif As Double(), _
    ByVal iadif1 As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_intg Lib "CLW3225DA_nag.dll" Alias "e02ajc" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByVal qatm1 As Double, _
    <Out()> ByVal aintc As Double(), _
    ByVal iaint1 As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02ajc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByVal qatm1 As Double, _
    <Out()> ByVal aintc As Double(), _
    ByVal iaint1 As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_cheb_eval2 Lib "CLW3225DA_nag.dll" Alias "e02akc" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByVal x As Double, _
    ByRef result As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e02akc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal ia1 As Integer, _
    ByVal x As Double, _
    ByRef result As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_minimax_polynomial Lib "CLW3225DA_nag.dll" Alias "e02alc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal m As Integer, _
    <Out()> ByVal a As Double(), _
    ByRef dnref As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e02alc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal m As Integer, _
    <Out()> ByVal a As Double(), _
    ByRef dnref As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_fit_knots Lib "CLW3225DA_nag.dll" Alias "e02bac" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByRef ss As Double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Sub e02bac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByRef ss As Double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_evaluate Lib "CLW3225DA_nag.dll" Alias "e02bbc" ( _
    ByVal x As Double, _
    ByRef s As Double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Sub e02bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef s As Double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_deriv Lib "CLW3225DA_nag.dll" Alias "e02bcc" ( _
    ByVal derivs As Nag_DerivType, _
    ByVal x As Double, _
    <Out()> ByVal s As Double(), _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Sub e02bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal derivs As Nag_DerivType, _
    ByVal x As Double, _
    <Out()> ByVal s As Double(), _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_intg Lib "CLW3225DA_nag.dll" Alias "e02bdc" ( _
    ByRef spline As Nag_Spline, _
    ByRef integral As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e02bdc Lib "CLW3225DA_nag.dll" ( _
    ByRef spline As Nag_Spline, _
    ByRef integral As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_spline_fit Lib "CLW3225DA_nag.dll" Alias "e02bec" ( _
    ByVal start As Nag_Start, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByVal s As Double, _
    ByVal nest As Integer, _
    ByRef fp As Double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Sub e02bec Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByVal s As Double, _
    ByVal nest As Integer, _
    ByRef fp As Double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_fit_1dspline_deriv_vector Lib "CLW3225DA_nag.dll" Alias "e02bfc" ( _
    ByVal start As Nag_SplineVectorSort, _
    ByRef spline As Nag_Spline, _
    ByVal deriv As Nag_DerivType, _
    ByVal xord As Nag_Boolean, _
    <[In]()> ByVal x As Double(), _
    <[In](),Out()> ByVal ixloc As Integer(), _
    ByVal nx As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal pds As Integer, _
    <[In](),Out()> ByVal iwrk As Integer(), _
    ByVal liwrk As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_SplineVectorSort, _
    ByRef spline As Nag_Spline, _
    ByVal deriv As Nag_DerivType, _
    ByVal xord As Nag_Boolean, _
    <[In]()> ByVal x As Double(), _
    <[In](),Out()> ByVal ixloc As Integer(), _
    ByVal nx As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal pds As Integer, _
    <[In](),Out()> ByVal iwrk As Integer(), _
    ByVal liwrk As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_cheb_fit_lines Lib "CLW3225DA_nag.dll" Alias "e02cac" ( _
    <[In]()> ByVal m As Integer(), _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal a As Double(), _
    <[In]()> ByVal xmin As Double(), _
    <[In]()> ByVal xmax As Double(), _
    <[In]()> ByVal nux As Double(), _
    ByVal inuxp1 As Integer, _
    <[In]()> ByVal nuy As Double(), _
    ByVal inuyp1 As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02cac Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal m As Integer(), _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal a As Double(), _
    <[In]()> ByVal xmin As Double(), _
    <[In]()> ByVal xmax As Double(), _
    <[In]()> ByVal nux As Double(), _
    ByVal inuxp1 As Integer, _
    <[In]()> ByVal nuy As Double(), _
    ByVal inuyp1 As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_cheb_eval Lib "CLW3225DA_nag.dll" Alias "e02cbc" ( _
    ByVal mfirst As Integer, _
    ByVal mlast As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal y As Double, _
    ByVal ymin As Double, _
    ByVal ymax As Double, _
    <Out()> ByVal ff As Double(), _
    <[In]()> ByVal a As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal mfirst As Integer, _
    ByVal mlast As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal y As Double, _
    ByVal ymin As Double, _
    ByVal ymax As Double, _
    <Out()> ByVal ff As Double(), _
    <[In]()> ByVal a As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_fit_panel Lib "CLW3225DA_nag.dll" Alias "e02dac" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal point As Integer(), _
    <Out()> ByVal dl As Double(), _
    ByVal eps As Double, _
    ByRef sigma As Double, _
    ByRef rank As Integer, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02dac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal point As Integer(), _
    <Out()> ByVal dl As Double(), _
    ByVal eps As Double, _
    ByRef sigma As Double, _
    ByRef rank As Integer, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_fit_grid Lib "CLW3225DA_nag.dll" Alias "e02dcc" ( _
    ByVal start As Nag_Start, _
    ByVal mx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal my As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal s As Double, _
    ByVal nxest As Integer, _
    ByVal nyest As Integer, _
    ByRef fp As Double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal mx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal my As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal s As Double, _
    ByVal nxest As Integer, _
    ByVal nyest As Integer, _
    ByRef fp As Double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_fit_scat Lib "CLW3225DA_nag.dll" Alias "e02ddc" ( _
    ByVal start As Nag_Start, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByVal s As Double, _
    ByVal nxest As Integer, _
    ByVal nyest As Integer, _
    ByRef fp As Double, _
    ByRef rank As Integer, _
    ByRef warmstartinf As Double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByVal s As Double, _
    ByVal nxest As Integer, _
    ByVal nyest As Integer, _
    ByRef fp As Double, _
    ByRef rank As Integer, _
    ByRef warmstartinf As Double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_eval Lib "CLW3225DA_nag.dll" Alias "e02dec" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal ff As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02dec Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal ff As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_eval_rect Lib "CLW3225DA_nag.dll" Alias "e02dfc" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal ff As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02dfc Lib "CLW3225DA_nag.dll" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal ff As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_deriv_rect Lib "CLW3225DA_nag.dll" Alias "e02dhc" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal nux As Integer, _
    ByVal nuy As Integer, _
    <Out()> ByVal z As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Sub e02dhc Lib "CLW3225DA_nag.dll" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal nux As Integer, _
    ByVal nuy As Integer, _
    <Out()> ByVal z As Double(), _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Sub nag_lone_fit Lib "CLW3225DA_nag.dll" Alias "e02gac" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal nplus2 As Integer, _
    ByVal toler As Double, _
    <Out()> ByVal x As Double(), _
    ByRef resid As Double, _
    ByRef rank As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02gac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal nplus2 As Integer, _
    ByVal toler As Double, _
    <Out()> ByVal x As Double(), _
    ByRef resid As Double, _
    ByRef rank As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_linf_fit Lib "CLW3225DA_nag.dll" Alias "e02gcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByRef relerr As Double, _
    <Out()> ByVal x As Double(), _
    ByRef resmax As Double, _
    ByRef rank As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByRef relerr As Double, _
    <Out()> ByVal x As Double(), _
    ByRef resmax As Double, _
    ByRef rank As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_fit_ts_scat Lib "CLW3225DA_nag.dll" Alias "e02jdc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal lsminp As Integer, _
    ByVal lsmaxp As Integer, _
    ByVal nxcels As Integer, _
    ByVal nycels As Integer, _
    ByVal lcoefs As Integer, _
    <Out()> ByVal coefs As Double(), _
    <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal f As Double(), _
    ByVal lsminp As Integer, _
    ByVal lsmaxp As Integer, _
    ByVal nxcels As Integer, _
    ByVal nycels As Integer, _
    ByVal lcoefs As Integer, _
    <Out()> ByVal coefs As Double(), _
    <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_ts_eval Lib "CLW3225DA_nag.dll" Alias "e02jec" ( _
    ByVal nevalv As Integer, _
    <[In]()> ByVal xevalv As Double(), _
    <[In]()> ByVal yevalv As Double(), _
    <[In]()> ByVal coefs As Double(), _
    <Out()> ByVal fevalv As Double(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02jec Lib "CLW3225DA_nag.dll" ( _
    ByVal nevalv As Integer, _
    <[In]()> ByVal xevalv As Double(), _
    <[In]()> ByVal yevalv As Double(), _
    <[In]()> ByVal coefs As Double(), _
    <Out()> ByVal fevalv As Double(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_spline_ts_eval_rect Lib "CLW3225DA_nag.dll" Alias "e02jfc" ( _
    ByVal nxeval As Integer, _
    ByVal nyeval As Integer, _
    <[In]()> ByVal xevalm As Double(), _
    <[In]()> ByVal yevalm As Double(), _
    <[In]()> ByVal coefs As Double(), _
    <Out()> ByVal fevalm As Double(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02jfc Lib "CLW3225DA_nag.dll" ( _
    ByVal nxeval As Integer, _
    ByVal nyeval As Integer, _
    <[In]()> ByVal xevalm As Double(), _
    <[In]()> ByVal yevalm As Double(), _
    <[In]()> ByVal coefs As Double(), _
    <Out()> ByVal fevalm As Double(), _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_pade Lib "CLW3225DA_nag.dll" Alias "e02rac" ( _
    ByVal ia As Integer, _
    ByVal ib As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02rac Lib "CLW3225DA_nag.dll" ( _
    ByVal ia As Integer, _
    ByVal ib As Integer, _
    <[In]()> ByVal c As Double(), _
    <Out()> ByVal a As Double(), _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_1d_pade_eval Lib "CLW3225DA_nag.dll" Alias "e02rbc" ( _
    <[In]()> ByVal a As Double(), _
    ByVal ia As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal ib As Integer, _
    ByVal x As Double, _
    ByRef ans As Double, _
    ByRef fail As NagError _
   )

   Declare Sub e02rbc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal a As Double(), _
    ByVal ia As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal ib As Integer, _
    ByVal x As Double, _
    ByRef ans As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2d_panel_sort Lib "CLW3225DA_nag.dll" Alias "e02zac" ( _
    ByVal px As Integer, _
    ByVal py As Integer, _
    <[In]()> ByVal lamda As Double(), _
    <[In]()> ByVal mu As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal point As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub e02zac Lib "CLW3225DA_nag.dll" ( _
    ByVal px As Integer, _
    ByVal py As Integer, _
    <[In]()> ByVal lamda As Double(), _
    <[In]()> ByVal mu As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal point As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fit_opt_set Lib "CLW3225DA_nag.dll" Alias "e02zkc" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e02zkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_fit_opt_get Lib "CLW3225DA_nag.dll" Alias "e02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e02zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


' chapter e04

Delegate Sub nag_opt_one_var_no_deriv_funct_DELEGATE( _
    ByVal xc As Double, _
    ByRef fc As Double, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_one_var_no_deriv Lib "CLW3225DA_nag.dll" Alias "e04abc" ( _
    ByVal funct As nag_opt_one_var_no_deriv_funct_DELEGATE, _
    ByVal e1 As Double, _
    ByVal e2 As Double, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByVal max_fun As Integer, _
    ByRef x As Double, _
    ByRef f As Double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04abc_funct_DELEGATE( _
    ByVal xc As Double, _
    ByRef fc As Double, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04abc Lib "CLW3225DA_nag.dll" ( _
    ByVal funct As e04abc_funct_DELEGATE, _
    ByVal e1 As Double, _
    ByVal e2 As Double, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByVal max_fun As Integer, _
    ByRef x As Double, _
    ByRef f As Double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_one_var_deriv_funct_DELEGATE( _
    ByVal xc As Double, _
    ByRef fc As Double, _
    ByRef gc As Double, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_one_var_deriv Lib "CLW3225DA_nag.dll" Alias "e04bbc" ( _
    ByVal funct As nag_opt_one_var_deriv_funct_DELEGATE, _
    ByVal e1 As Double, _
    ByVal e2 As Double, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByVal max_fun As Integer, _
    ByRef x As Double, _
    ByRef f As Double, _
    ByRef g As Double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04bbc_funct_DELEGATE( _
    ByVal xc As Double, _
    ByRef fc As Double, _
    ByRef gc As Double, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal funct As e04bbc_funct_DELEGATE, _
    ByVal e1 As Double, _
    ByVal e2 As Double, _
    ByRef a As Double, _
    ByRef b As Double, _
    ByVal max_fun As Integer, _
    ByRef x As Double, _
    ByRef f As Double, _
    ByRef g As Double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_simplex_easy_funct_DELEGATE( _
    ByVal n As Integer, _
    ByVal xc_rptr As IntPtr, _
    ByRef fc As Double, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_opt_simplex_easy_monit_DELEGATE( _
    ByVal fmin As Double, _
    ByVal fmax As Double, _
    ByVal sim_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal serror As Double, _
    ByVal vratio As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub E04CBK Lib "CLW3225DA_nag.dll" ( _
    ByVal fmin As Double, _
    ByVal fmax As Double, _
    ByVal sim_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal serror As Double, _
    ByVal vratio As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_opt_simplex_easy Lib "CLW3225DA_nag.dll" Alias "e04cbc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef f As Double, _
    ByVal tolf As Double, _
    ByVal tolx As Double, _
    ByVal funct As nag_opt_simplex_easy_funct_DELEGATE, _
    ByVal monit As nag_opt_simplex_easy_monit_DELEGATE, _
    ByVal maxcal As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04cbc_funct_DELEGATE( _
    ByVal n As Integer, _
    ByVal xc_rptr As IntPtr, _
    ByRef fc As Double, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub e04cbc_monit_DELEGATE( _
    ByVal fmin As Double, _
    ByVal fmax As Double, _
    ByVal sim_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal serror As Double, _
    ByVal vratio As Double, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub e04cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef f As Double, _
    ByVal tolf As Double, _
    ByVal tolx As Double, _
    ByVal funct As e04cbc_funct_DELEGATE, _
    ByVal monit As e04cbc_monit_DELEGATE, _
    ByVal maxcal As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_conj_grad_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_conj_grad Lib "CLW3225DA_nag.dll" Alias "e04dgc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_conj_grad_objfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04dgc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04dgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04dgc_objfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_lsq_no_deriv_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_lsq_no_deriv Lib "CLW3225DA_nag.dll" Alias "e04fcc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As nag_opt_lsq_no_deriv_lsqfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fsumsq As Double, _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04fcc_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As e04fcc_lsqfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fsumsq As Double, _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_lsq_deriv_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_lsq_deriv Lib "CLW3225DA_nag.dll" Alias "e04gbc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As nag_opt_lsq_deriv_lsqfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fsumsq As Double, _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04gbc_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As e04gbc_lsqfun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef fsumsq As Double, _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_check_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_check_deriv Lib "CLW3225DA_nag.dll" Alias "e04hcc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_check_deriv_objfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04hcc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04hcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04hcc_objfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_check_2nd_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub nag_opt_check_2nd_deriv_hessfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal h_rptr As IntPtr, _
    ByVal hd_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_check_2nd_deriv Lib "CLW3225DA_nag.dll" Alias "e04hdc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_check_2nd_deriv_objfun_DELEGATE, _
    ByVal hessfun As nag_opt_check_2nd_deriv_hessfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal g As Double(), _
    <Out()> ByVal hesl As Double(), _
    <Out()> ByVal hesd As Double(), _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04hdc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub e04hdc_hessfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal h_rptr As IntPtr, _
    ByVal hd_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04hdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04hdc_objfun_DELEGATE, _
    ByVal hessfun As e04hdc_hessfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal g As Double(), _
    <Out()> ByVal hesl As Double(), _
    <Out()> ByVal hesd As Double(), _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_bounds_no_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_bounds_no_deriv Lib "CLW3225DA_nag.dll" Alias "e04jbc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_bounds_no_deriv_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <[In](),Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04jbc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04jbc_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <[In](),Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_bounds_qa_no_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef f As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

Delegate Sub nag_opt_bounds_qa_no_deriv_monfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal nf As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f As Double, _
    ByVal rho As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub E04JCP Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nf As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f As Double, _
    ByVal rho As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub nag_opt_bounds_qa_no_deriv Lib "CLW3225DA_nag.dll" Alias "e04jcc" ( _
    ByVal objfun As nag_opt_bounds_qa_no_deriv_objfun_DELEGATE, _
    ByVal n As Integer, _
    ByVal npt As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal rhobeg As Double, _
    ByVal rhoend As Double, _
    ByVal monfun As nag_opt_bounds_qa_no_deriv_monfun_DELEGATE, _
    ByVal maxcal As Integer, _
    ByRef f As Double, _
    ByRef nf As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04jcc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef f As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

Delegate Sub e04jcc_monfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal nf As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f As Double, _
    ByVal rho As Double, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )


   Declare Sub e04jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal objfun As e04jcc_objfun_DELEGATE, _
    ByVal n As Integer, _
    ByVal npt As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal rhobeg As Double, _
    ByVal rhoend As Double, _
    ByVal monfun As e04jcc_monfun_DELEGATE, _
    ByVal maxcal As Integer, _
    ByRef f As Double, _
    ByRef nf As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_bounds_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_bounds_deriv Lib "CLW3225DA_nag.dll" Alias "e04kbc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_bounds_deriv_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <[In](),Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04kbc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04kbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04kbc_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <[In](),Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_bounds_2nd_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub nag_opt_bounds_2nd_deriv_hessfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal h_rptr As IntPtr, _
    ByVal hd_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_bounds_2nd_deriv Lib "CLW3225DA_nag.dll" Alias "e04lbc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_opt_bounds_2nd_deriv_objfun_DELEGATE, _
    ByVal hessfun As nag_opt_bounds_2nd_deriv_hessfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04lbc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub e04lbc_hessfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal h_rptr As IntPtr, _
    ByVal hd_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04lbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e04lbc_objfun_DELEGATE, _
    ByVal hessfun As e04lbc_hessfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_lp Lib "CLW3225DA_nag.dll" Alias "e04mfc" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub e04mfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_miqp_mps_read Lib "CLW3225DA_nag.dll" Alias "e04mxc" ( _
    ByVal fileid As Integer, ByVal maxn As Integer, ByVal maxm As Integer, _
    ByVal maxnnz As Integer, ByVal maxncolh As Integer, ByVal maxnnzh As Integer, _
    ByVal maxlintvar As Integer, ByVal mpslst As Integer, ByRef n As Integer, _
    ByRef m As Integer, ByRef nnz As Integer, ByRef ncolh As Integer, _
    ByRef nnzh As Integer, ByRef lintvar As Integer, ByRef iobj As Integer, _
    <Out()> ByVal a As Double(), <Out()> ByVal irowa As Integer(), <Out()> ByVal iccola As Integer(), _
    <Out()> ByVal bl As Double(), <Out()> ByVal bu As Double(), ByVal pnames As String, _
    ByRef nname As Integer, ByVal crname As String, <Out()> ByVal h As Double(), _
    <Out()> ByVal irowh As Integer(), <Out()> ByVal iccolh As Integer(), ByRef minmax As Integer, _
    <Out()> ByVal intvar As Integer(), ByRef fail As NagError _
   )

   Declare Sub e04mxc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, ByVal maxn As Integer, ByVal maxm As Integer, _
    ByVal maxnnz As Integer, ByVal maxncolh As Integer, ByVal maxnnzh As Integer, _
    ByVal maxlintvar As Integer, ByVal mpslst As Integer, ByRef n As Integer, _
    ByRef m As Integer, ByRef nnz As Integer, ByRef ncolh As Integer, _
    ByRef nnzh As Integer, ByRef lintvar As Integer, ByRef iobj As Integer, _
    <Out()> ByVal a As Double(), <Out()> ByVal irowa As Integer(), <Out()> ByVal iccola As Integer(), _
    <Out()> ByVal bl As Double(), <Out()> ByVal bu As Double(), ByVal pnames As String, _
    ByRef nname As Integer, ByVal crname As String, <Out()> ByVal h As Double(), _
    <Out()> ByVal irowh As Integer(), <Out()> ByVal iccolh As Integer(), ByRef minmax As Integer, _
    <Out()> ByVal intvar As Integer(), ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_mps_free Lib "CLW3225DA_nag.dll" Alias "e04myc" ( _
    ByRef aPTR As IntPtr, _
    ByRef haPTR As IntPtr, _
    ByRef kaPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef xsPTR As IntPtr _
   )

   Declare Sub e04myc Lib "CLW3225DA_nag.dll" ( _
    ByRef aPTR As IntPtr, _
    ByRef haPTR As IntPtr, _
    ByRef kaPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef xsPTR As IntPtr _
   )


   Declare Sub nag_opt_sparse_mps_read Lib "CLW3225DA_nag.dll" Alias "e04mzc" ( _
    ByVal mps_filePTR As IntPtr, _
    ByRef n As Integer, _
    ByRef m As Integer, _
    ByRef nnz As Integer, _
    ByRef iobj As Integer, _
    ByRef aPTR As IntPtr, _
    ByRef haPTR As IntPtr, _
    ByRef kaPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef xsPTR As IntPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub e04mzc Lib "CLW3225DA_nag.dll" ( _
    ByVal mps_filePTR As IntPtr, _
    ByRef n As Integer, _
    ByRef m As Integer, _
    ByRef nnz As Integer, _
    ByRef iobj As Integer, _
    ByRef aPTR As IntPtr, _
    ByRef haPTR As IntPtr, _
    ByRef kaPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef xsPTR As IntPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_lin_lsq Lib "CLW3225DA_nag.dll" Alias "e04ncc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    <[In](),Out()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    <[In](),Out()> ByVal kx As Integer(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub e04ncc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    <[In](),Out()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    <[In](),Out()> ByVal kx As Integer(), _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_qp_qphess_DELEGATE( _
    ByVal n As Integer, _
    ByVal jthcol As Integer, _
    ByVal h_rptr As IntPtr, _
    ByVal tdh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_qp Lib "CLW3225DA_nag.dll" Alias "e04nfc" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    ByVal qphess As nag_opt_qp_qphess_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04nfc_qphess_DELEGATE( _
    ByVal n As Integer, _
    ByVal jthcol As Integer, _
    ByVal h_rptr As IntPtr, _
    ByVal tdh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04nfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal cvec As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    ByVal qphess As e04nfc_qphess_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_sparse_convex_qp_qphx_DELEGATE( _
    ByVal ncolh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_sparse_convex_qp Lib "CLW3225DA_nag.dll" Alias "e04nkc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal nnz As Integer, _
    ByVal iobj As Integer, _
    ByVal ncolh As Integer, _
    ByVal qphx As nag_opt_sparse_convex_qp_qphx_DELEGATE, _
    <[In](),Out()> ByVal a As Double(), _
    <[In]()> ByVal ha As Integer(), _
    <[In]()> ByVal ka As Integer(), _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal xs As Double(), _
    ByRef ninf As Integer, _
    ByRef sinf As Double, _
    ByRef obj As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04nkc_qphx_DELEGATE( _
    ByVal ncolh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04nkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal nnz As Integer, _
    ByVal iobj As Integer, _
    ByVal ncolh As Integer, _
    ByVal qphx As e04nkc_qphx_DELEGATE, _
    <[In](),Out()> ByVal a As Double(), _
    <[In]()> ByVal ha As Integer(), _
    <[In]()> ByVal ka As Integer(), _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    <[In](),Out()> ByVal xs As Double(), _
    ByRef ninf As Integer, _
    ByRef sinf As Double, _
    ByRef obj As Double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_init Lib "CLW3225DA_nag.dll" Alias "e04npc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04npc Lib "CLW3225DA_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_sparse_convex_qp_solve_qphx_DELEGATE( _
    ByVal ncolh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub E04NSH Lib "CLW3225DA_nag.dll" ( _
    ByVal ncolh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_opt_sparse_convex_qp_solve Lib "CLW3225DA_nag.dll" Alias "e04nqc" ( _
    ByVal start As Nag_Start, ByVal qphx As nag_opt_sparse_convex_qp_solve_qphx_DELEGATE, ByVal m As Integer, _
    ByVal n As Integer, ByVal ne As Integer, ByVal nname As Integer, _
    ByVal lenc As Integer, ByVal ncolh As Integer, ByVal iobj As Integer, _
    ByVal objadd As Double, ByVal prob As String, <[In](),Out()> ByVal acol As Double(), _
    <[In]()> ByVal inda As Integer(), <[In]()> ByVal loca As Integer(), <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), <[In](),Out()> ByVal c As Double(), <[In]()> ByVal names As IntPtr(), _
    <[In]()> ByVal helast As Integer(), <[In](),Out()> ByVal hs As Integer(), <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal pi As Double(), <Out()> ByVal rc As Double(), ByRef ns As Integer, _
    ByRef ninf As Integer, ByRef sinf As Double, ByRef obj As Double, _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub e04nqc_qphx_DELEGATE( _
    ByVal ncolh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub e04nqc Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_Start, ByVal qphx As e04nqc_qphx_DELEGATE, ByVal m As Integer, _
    ByVal n As Integer, ByVal ne As Integer, ByVal nname As Integer, _
    ByVal lenc As Integer, ByVal ncolh As Integer, ByVal iobj As Integer, _
    ByVal objadd As Double, ByVal prob As String, <[In](),Out()> ByVal acol As Double(), _
    <[In]()> ByVal inda As Integer(), <[In]()> ByVal loca As Integer(), <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), <[In](),Out()> ByVal c As Double(), <[In]()> ByVal names As IntPtr(), _
    <[In]()> ByVal helast As Integer(), <[In](),Out()> ByVal hs As Integer(), <[In](),Out()> ByVal x As Double(), _
    <Out()> ByVal pi As Double(), <Out()> ByVal rc As Double(), ByRef ns As Integer, _
    ByRef ninf As Integer, ByRef sinf As Double, ByRef obj As Double, _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_set_file Lib "CLW3225DA_nag.dll" Alias "e04nrc" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04nrc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_set_string Lib "CLW3225DA_nag.dll" Alias "e04nsc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04nsc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_set_integer Lib "CLW3225DA_nag.dll" Alias "e04ntc" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04ntc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_set_double Lib "CLW3225DA_nag.dll" Alias "e04nuc" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04nuc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_get_integer Lib "CLW3225DA_nag.dll" Alias "e04nxc" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04nxc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_convex_qp_option_get_double Lib "CLW3225DA_nag.dll" Alias "e04nyc" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04nyc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_bnd_lin_lsq Lib "CLW3225DA_nag.dll" Alias "e04pcc" ( _
    ByVal itype As Nag_RegularizedType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef nfree As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal indx As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub e04pcc Lib "CLW3225DA_nag.dll" ( _
    ByVal itype As Nag_RegularizedType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef nfree As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal indx As Integer(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_nlp_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub nag_opt_nlp_confun_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncnlin As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_nlp Lib "CLW3225DA_nag.dll" Alias "e04ucc" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    ByVal ncnlin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal objfun As nag_opt_nlp_objfun_DELEGATE, _
    ByVal confun As nag_opt_nlp_confun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04ucc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub e04ucc_confun_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncnlin As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04ucc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    ByVal ncnlin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal objfun As e04ucc_objfun_DELEGATE, _
    ByVal confun As e04ucc_confun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_revcomm_option_set_file Lib "CLW3225DA_nag.dll" Alias "e04udc" ( _
    ByVal fileid As Integer, _
    <[In](),Out()> ByVal lwsav As Nag_Boolean(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef inform As NagError _
   )

   Declare Sub e04udc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    <[In](),Out()> ByVal lwsav As Nag_Boolean(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef inform As NagError _
   )


   Declare Sub nag_opt_nlp_revcomm_option_set_string Lib "CLW3225DA_nag.dll" Alias "e04uec" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal lwsav As Nag_Boolean(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef inform As NagError _
   )

   Declare Sub e04uec Lib "CLW3225DA_nag.dll" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal lwsav As Nag_Boolean(), _
    <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), _
    ByRef inform As NagError _
   )


   Declare Sub nag_opt_nlp_revcomm Lib "CLW3225DA_nag.dll" Alias "e04ufc" ( _
    ByRef irevcm As Integer, ByVal n As Integer, ByVal nclin As Integer, _
    ByVal ncnln As Integer, ByVal tda As Integer, ByVal tdcj As Integer, _
    ByVal tdr As Integer, <[In]()> ByVal a As Double(), <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), ByRef iter As Integer, <[In](),Out()> ByVal istate As Integer(), _
    <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal cjac As Double(), <[In](),Out()> ByVal clamda As Double(), _
    ByRef objf As Double, <[In](),Out()> ByVal objgrd As Double(), <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal x As Double(), <Out()> ByVal needc As Integer(), <[In](),Out()> ByVal iwork As Integer(), _
    ByVal liwork As Integer, <[In](),Out()> ByVal work As Double(), ByVal lwork As Integer, _
    ByVal cwsav As String, <[In](),Out()> ByVal lwsav As Nag_Boolean(), <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), ByRef fail As NagError _
   )

   Declare Sub e04ufc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, ByVal n As Integer, ByVal nclin As Integer, _
    ByVal ncnln As Integer, ByVal tda As Integer, ByVal tdcj As Integer, _
    ByVal tdr As Integer, <[In]()> ByVal a As Double(), <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), ByRef iter As Integer, <[In](),Out()> ByVal istate As Integer(), _
    <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal cjac As Double(), <[In](),Out()> ByVal clamda As Double(), _
    ByRef objf As Double, <[In](),Out()> ByVal objgrd As Double(), <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal x As Double(), <Out()> ByVal needc As Integer(), <[In](),Out()> ByVal iwork As Integer(), _
    ByVal liwork As Integer, <[In](),Out()> ByVal work As Double(), ByVal lwork As Integer, _
    ByVal cwsav As String, <[In](),Out()> ByVal lwsav As Nag_Boolean(), <[In](),Out()> ByVal iwsav As Integer(), _
    <[In](),Out()> ByVal rwsav As Double(), ByRef fail As NagError _
   )


Delegate Sub nag_opt_nlp_sparse_confun_DELEGATE( _
    ByVal ncnln As Integer, _
    ByVal njnln As Integer, _
    ByVal nnzjac As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub nag_opt_nlp_sparse_objfun_DELEGATE( _
    ByVal nonln As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal objgrad_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_nlp_sparse Lib "CLW3225DA_nag.dll" Alias "e04ugc" ( _
    ByVal confun As nag_opt_nlp_sparse_confun_DELEGATE, ByVal objfun As nag_opt_nlp_sparse_objfun_DELEGATE, ByVal n As Integer, _
    ByVal m As Integer, ByVal ncnln As Integer, ByVal nonln As Integer, _
    ByVal njnln As Integer, ByVal iobj As Integer, ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), <[In]()> ByVal ha As Integer(), <[In]()> ByVal ka As Integer(), _
    <[In](),Out()> ByVal bl As Double(), <[In](),Out()> ByVal bu As Double(), <[In](),Out()> ByVal xs As Double(), _
    ByRef ninf As Integer, ByRef sinf As Double, ByRef objf As Double, _
    ByRef comm As Nag_Comm, ByRef ops As Nag_E04_Opt, ByRef fail As NagError _
   )

Delegate Sub e04ugc_confun_DELEGATE( _
    ByVal ncnln As Integer, _
    ByVal njnln As Integer, _
    ByVal nnzjac As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub e04ugc_objfun_DELEGATE( _
    ByVal nonln As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal objgrad_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04ugc Lib "CLW3225DA_nag.dll" ( _
    ByVal confun As e04ugc_confun_DELEGATE, ByVal objfun As e04ugc_objfun_DELEGATE, ByVal n As Integer, _
    ByVal m As Integer, ByVal ncnln As Integer, ByVal nonln As Integer, _
    ByVal njnln As Integer, ByVal iobj As Integer, ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), <[In]()> ByVal ha As Integer(), <[In]()> ByVal ka As Integer(), _
    <[In](),Out()> ByVal bl As Double(), <[In](),Out()> ByVal bu As Double(), <[In](),Out()> ByVal xs As Double(), _
    ByRef ninf As Integer, ByRef sinf As Double, ByRef objf As Double, _
    ByRef comm As Nag_Comm, ByRef ops As Nag_E04_Opt, ByRef fail As NagError _
   )


Delegate Sub nag_opt_nlin_lsq_objfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub nag_opt_nlin_lsq_confun_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncnlin As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_nlin_lsq Lib "CLW3225DA_nag.dll" Alias "e04unc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    ByVal ncnlin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal objfun As nag_opt_nlin_lsq_objfun_DELEGATE, _
    ByVal confun As nag_opt_nlin_lsq_confun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04unc_objfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

Delegate Sub e04unc_confun_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncnlin As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal conf_rptr As IntPtr, _
    ByVal conjac_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04unc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nclin As Integer, _
    ByVal ncnlin As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal objfun As e04unc_objfun_DELEGATE, _
    ByVal confun As e04unc_confun_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_init Lib "CLW3225DA_nag.dll" Alias "e04vgc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vgc Lib "CLW3225DA_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_sparse_nlp_solve_usrfun_DELEGATE( _
    ByRef status As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal needf As Integer, _
    ByVal nf As Integer, _
    ByVal f_rptr As IntPtr, _
    ByVal needg As Integer, _
    ByVal leng As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_opt_sparse_nlp_solve Lib "CLW3225DA_nag.dll" Alias "e04vhc" ( _
    ByVal start As Nag_Start, ByVal nf As Integer, ByVal n As Integer, _
    ByVal nxname As Integer, ByVal nfname As Integer, ByVal objadd As Double, _
    ByRef objrow As Integer, ByVal prob As String, ByVal usrfun As nag_opt_sparse_nlp_solve_usrfun_DELEGATE, _
    <[In]()> ByVal iafun As Integer(), <[In]()> ByVal javar As Integer(), <[In]()> ByVal a As Double(), _
    ByVal lena As Integer, ByVal nea As Integer, <[In]()> ByVal igfun As Integer(), _
    <[In]()> ByVal jgvar As Integer(), ByVal leng As Integer, ByVal neg As Integer, _
    <[In]()> ByVal xlow As Double(), <[In]()> ByVal xupp As Double(), <[In]()> ByVal xnames As IntPtr(), _
    <[In]()> ByVal flow As Double(), <[In]()> ByVal fupp As Double(), <[In]()> ByVal fnames As IntPtr(), _
    <[In](),Out()> ByVal x As Double(), <[In](),Out()> ByVal xstate As Integer(), <Out()> ByVal xmul As Double(), _
    <[In](),Out()> ByVal f As Double(), <[In](),Out()> ByVal fstate As Integer(), <[In](),Out()> ByVal fmul As Double(), _
    ByRef ns As Integer, ByRef ninf As Integer, ByRef sinf As Double, _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub e04vhc_usrfun_DELEGATE( _
    ByRef status As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal needf As Integer, _
    ByVal nf As Integer, _
    ByVal f_rptr As IntPtr, _
    ByVal needg As Integer, _
    ByVal leng As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub e04vhc Lib "CLW3225DA_nag.dll" ( _
    ByVal start As Nag_Start, ByVal nf As Integer, ByVal n As Integer, _
    ByVal nxname As Integer, ByVal nfname As Integer, ByVal objadd As Double, _
    ByRef objrow As Integer, ByVal prob As String, ByVal usrfun As e04vhc_usrfun_DELEGATE, _
    <[In]()> ByVal iafun As Integer(), <[In]()> ByVal javar As Integer(), <[In]()> ByVal a As Double(), _
    ByVal lena As Integer, ByVal nea As Integer, <[In]()> ByVal igfun As Integer(), _
    <[In]()> ByVal jgvar As Integer(), ByVal leng As Integer, ByVal neg As Integer, _
    <[In]()> ByVal xlow As Double(), <[In]()> ByVal xupp As Double(), <[In]()> ByVal xnames As IntPtr(), _
    <[In]()> ByVal flow As Double(), <[In]()> ByVal fupp As Double(), <[In]()> ByVal fnames As IntPtr(), _
    <[In](),Out()> ByVal x As Double(), <[In](),Out()> ByVal xstate As Integer(), <Out()> ByVal xmul As Double(), _
    <[In](),Out()> ByVal f As Double(), <[In](),Out()> ByVal fstate As Integer(), <[In](),Out()> ByVal fmul As Double(), _
    ByRef ns As Integer, ByRef ninf As Integer, ByRef sinf As Double, _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


Delegate Sub nag_opt_sparse_nlp_jacobian_usrfun_DELEGATE( _
    ByRef status As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal needf As Integer, _
    ByVal nf As Integer, _
    ByVal f_rptr As IntPtr, _
    ByVal needg As Integer, _
    ByVal leng As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_opt_sparse_nlp_jacobian Lib "CLW3225DA_nag.dll" Alias "e04vjc" ( _
    ByVal nf As Integer, ByVal n As Integer, ByVal usrfun As nag_opt_sparse_nlp_jacobian_usrfun_DELEGATE, _
    <Out()> ByVal iafun As Integer(), <Out()> ByVal javar As Integer(), <Out()> ByVal a As Double(), _
    ByVal lena As Integer, ByRef nea As Integer, <Out()> ByVal igfun As Integer(), _
    <Out()> ByVal jgvar As Integer(), ByVal leng As Integer, ByRef neg As Integer, _
    <[In]()> ByVal x As Double(), <[In]()> ByVal xlow As Double(), <[In]()> ByVal xupp As Double(), _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub e04vjc_usrfun_DELEGATE( _
    ByRef status As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal needf As Integer, _
    ByVal nf As Integer, _
    ByVal f_rptr As IntPtr, _
    ByVal needg As Integer, _
    ByVal leng As Integer, _
    ByVal g_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub e04vjc Lib "CLW3225DA_nag.dll" ( _
    ByVal nf As Integer, ByVal n As Integer, ByVal usrfun As e04vjc_usrfun_DELEGATE, _
    <Out()> ByVal iafun As Integer(), <Out()> ByVal javar As Integer(), <Out()> ByVal a As Double(), _
    ByVal lena As Integer, ByRef nea As Integer, <Out()> ByVal igfun As Integer(), _
    <Out()> ByVal jgvar As Integer(), ByVal leng As Integer, ByRef neg As Integer, _
    <[In]()> ByVal x As Double(), <[In]()> ByVal xlow As Double(), <[In]()> ByVal xupp As Double(), _
    ByRef state As Nag_E04State, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_set_file Lib "CLW3225DA_nag.dll" Alias "e04vkc" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vkc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_set_string Lib "CLW3225DA_nag.dll" Alias "e04vlc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vlc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_set_integer Lib "CLW3225DA_nag.dll" Alias "e04vmc" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vmc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_set_double Lib "CLW3225DA_nag.dll" Alias "e04vnc" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vnc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_get_integer Lib "CLW3225DA_nag.dll" Alias "e04vrc" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vrc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_sparse_nlp_option_get_double Lib "CLW3225DA_nag.dll" Alias "e04vsc" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04vsc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_revcomm_init Lib "CLW3225DA_nag.dll" Alias "e04wbc" ( _
    ByVal rname As String, _
    ByVal cwsav As String, _
    ByVal lcwsav As Integer, _
    <Out()> ByVal lwsav As Nag_Boolean(), _
    ByVal llwsav As Integer, _
    <Out()> ByVal iwsav As Integer(), _
    ByVal liwsav As Integer, _
    <Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e04wbc Lib "CLW3225DA_nag.dll" ( _
    ByVal rname As String, _
    ByVal cwsav As String, _
    ByVal lcwsav As Integer, _
    <Out()> ByVal lwsav As Nag_Boolean(), _
    ByVal llwsav As Integer, _
    <Out()> ByVal iwsav As Integer(), _
    ByVal liwsav As Integer, _
    <Out()> ByVal rwsav As Double(), _
    ByVal lrwsav As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_init Lib "CLW3225DA_nag.dll" Alias "e04wcc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wcc Lib "CLW3225DA_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_nlp_solve_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal ccon_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub E04WDP Lib "CLW3225DA_nag.dll" ( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal ccon_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_opt_nlp_solve_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal grad_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_opt_nlp_solve Lib "CLW3225DA_nag.dll" Alias "e04wdc" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    ByVal tda As Integer, ByVal tdcj As Integer, ByVal tdh As Integer, _
    <[In]()> ByVal a As Double(), <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), _
    ByVal confun As nag_opt_nlp_solve_confun_DELEGATE, ByVal objfun As nag_opt_nlp_solve_objfun_DELEGATE, ByRef majits As Integer, _
    <[In](),Out()> ByVal istate As Integer(), <[In](),Out()> ByVal ccon As Double(), <[In](),Out()> ByVal cjac As Double(), _
    <[In](),Out()> ByVal clamda As Double(), ByRef objf As Double, <Out()> ByVal grad As Double(), _
    <[In](),Out()> ByVal h As Double(), <[In](),Out()> ByVal x As Double(), ByRef state As Nag_E04State, ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub e04wdc_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal ccon_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub e04wdc_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal grad_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub e04wdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    ByVal tda As Integer, ByVal tdcj As Integer, ByVal tdh As Integer, _
    <[In]()> ByVal a As Double(), <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), _
    ByVal confun As e04wdc_confun_DELEGATE, ByVal objfun As e04wdc_objfun_DELEGATE, ByRef majits As Integer, _
    <[In](),Out()> ByVal istate As Integer(), <[In](),Out()> ByVal ccon As Double(), <[In](),Out()> ByVal cjac As Double(), _
    <[In](),Out()> ByVal clamda As Double(), ByRef objf As Double, <Out()> ByVal grad As Double(), _
    <[In](),Out()> ByVal h As Double(), <[In](),Out()> ByVal x As Double(), ByRef state As Nag_E04State, ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_set_file Lib "CLW3225DA_nag.dll" Alias "e04wec" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wec Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_set_string Lib "CLW3225DA_nag.dll" Alias "e04wfc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wfc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_set_integer Lib "CLW3225DA_nag.dll" Alias "e04wgc" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wgc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_set_double Lib "CLW3225DA_nag.dll" Alias "e04whc" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04whc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_get_integer Lib "CLW3225DA_nag.dll" Alias "e04wkc" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wkc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_nlp_option_get_double Lib "CLW3225DA_nag.dll" Alias "e04wlc" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Sub e04wlc Lib "CLW3225DA_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_estimate_deriv_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_estimate_deriv Lib "CLW3225DA_nag.dll" Alias "e04xac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal objfun As nag_opt_estimate_deriv_objfun_DELEGATE, _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    <[In](),Out()> ByVal h_forward As Double(), _
    <Out()> ByVal h_central As Double(), _
    <Out()> ByVal hess As Double(), _
    ByVal tdhess As Integer, _
    ByRef deriv_info As Nag_DerivInfo(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04xac_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal g_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04xac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal objfun As e04xac_objfun_DELEGATE, _
    ByRef objf As Double, _
    <Out()> ByVal g As Double(), _
    <[In](),Out()> ByVal h_forward As Double(), _
    <Out()> ByVal h_central As Double(), _
    <Out()> ByVal hess As Double(), _
    ByVal tdhess As Integer, _
    ByRef deriv_info As Nag_DerivInfo(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_init Lib "CLW3225DA_nag.dll" Alias "e04xxc" ( _
    ByRef ops As Nag_E04_Opt _
   )

   Declare Sub e04xxc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_E04_Opt _
   )


   Declare Sub nag_opt_read Lib "CLW3225DA_nag.dll" Alias "e04xyc" ( _
    ByVal nmPTR As IntPtr, _
    ByVal opt_filePTR As IntPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfilePTR As IntPtr, _
    ByRef fail As NagError _
   )

   Declare Sub e04xyc Lib "CLW3225DA_nag.dll" ( _
    ByVal nmPTR As IntPtr, _
    ByVal opt_filePTR As IntPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfilePTR As IntPtr, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_free Lib "CLW3225DA_nag.dll" Alias "e04xzc" ( _
    ByRef ops As Nag_E04_Opt, _
    ByVal p_namePTR As IntPtr, _
    ByRef fail As NagError _
   )

   Declare Sub e04xzc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_E04_Opt, _
    ByVal p_namePTR As IntPtr, _
    ByRef fail As NagError _
   )


Delegate Sub nag_opt_lsq_check_deriv_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_opt_lsq_check_deriv Lib "CLW3225DA_nag.dll" Alias "e04yac" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As nag_opt_lsq_check_deriv_lsqfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e04yac_lsqfun_DELEGATE( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fvec_rptr As IntPtr, _
    ByVal fjac_rptr As IntPtr, _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub e04yac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal lsqfun As e04yac_lsqfun_DELEGATE, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal fvec As Double(), _
    <Out()> ByVal fjac As Double(), _
    ByVal tdfjac As Integer, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_opt_lsq_covariance Lib "CLW3225DA_nag.dll" Alias "e04ycc" ( _
    ByVal job As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fsumsq As Double, _
    <Out()> ByVal cj As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub e04ycc Lib "CLW3225DA_nag.dll" ( _
    ByVal job As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal fsumsq As Double, _
    <Out()> ByVal cj As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


' chapter e05

   Declare Sub nag_glopt_bnd_mcs_init Lib "CLW3225DA_nag.dll" Alias "e05jac" ( _
    ByVal n_r As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jac Lib "CLW3225DA_nag.dll" ( _
    ByVal n_r As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_glopt_bnd_mcs_solve_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef f As Double, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

Delegate Sub nag_glopt_bnd_mcs_solve_monit_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal xbest_rptr As IntPtr, _
    ByVal icount_iptr As IntPtr, _
    ByVal ninit As Integer, _
    ByVal list_rptr As IntPtr, _
    ByVal numpts_iptr As IntPtr, _
    ByVal initpt_iptr As IntPtr, _
    ByVal nbaskt As Integer, _
    ByVal xbaskt_rptr As IntPtr, _
    ByVal boxl_rptr As IntPtr, _
    ByVal boxu_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub E05JBK Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal xbest_rptr As IntPtr, _
    ByVal icount_iptr As IntPtr, _
    ByVal ninit As Integer, _
    ByVal list_rptr As IntPtr, _
    ByVal numpts_iptr As IntPtr, _
    ByVal initpt_iptr As IntPtr, _
    ByVal nbaskt As Integer, _
    ByVal xbaskt_rptr As IntPtr, _
    ByVal boxl_rptr As IntPtr, _
    ByVal boxu_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub nag_glopt_bnd_mcs_solve Lib "CLW3225DA_nag.dll" Alias "e05jbc" ( _
    ByVal n As Integer, _
    ByVal objfun As nag_glopt_bnd_mcs_solve_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    ByVal initmethod As Nag_MCSInitMethod, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    ByVal sdlist As Integer, _
    <[In](),Out()> ByVal list As Double(), _
    <[In](),Out()> ByVal numpts As Integer(), _
    <[In](),Out()> ByVal initpt As Integer(), _
    ByVal monit As nag_glopt_bnd_mcs_solve_monit_DELEGATE, _
    <Out()> ByVal x As Double(), _
    ByRef obj As Double, _
    ByRef state As Nag_E05State, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub e05jbc_objfun_DELEGATE( _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef f As Double, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

Delegate Sub e05jbc_monit_DELEGATE( _
    ByVal n As Integer, _
    ByVal ncall As Integer, _
    ByVal xbest_rptr As IntPtr, _
    ByVal icount_iptr As IntPtr, _
    ByVal ninit As Integer, _
    ByVal list_rptr As IntPtr, _
    ByVal numpts_iptr As IntPtr, _
    ByVal initpt_iptr As IntPtr, _
    ByVal nbaskt As Integer, _
    ByVal xbaskt_rptr As IntPtr, _
    ByVal boxl_rptr As IntPtr, _
    ByVal boxu_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )


   Declare Sub e05jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal objfun As e05jbc_objfun_DELEGATE, _
    ByVal bound As Nag_BoundType, _
    ByVal initmethod As Nag_MCSInitMethod, _
    <[In](),Out()> ByVal bl As Double(), _
    <[In](),Out()> ByVal bu As Double(), _
    ByVal sdlist As Integer, _
    <[In](),Out()> ByVal list As Double(), _
    <[In](),Out()> ByVal numpts As Integer(), _
    <[In](),Out()> ByVal initpt As Integer(), _
    ByVal monit As e05jbc_monit_DELEGATE, _
    <Out()> ByVal x As Double(), _
    ByRef obj As Double, _
    ByRef state As Nag_E05State, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optset_file Lib "CLW3225DA_nag.dll" Alias "e05jcc" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optset_string Lib "CLW3225DA_nag.dll" Alias "e05jdc" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optset_char Lib "CLW3225DA_nag.dll" Alias "e05jec" ( _
    ByVal optstr As String, _
    ByVal cvalue As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jec Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByVal cvalue As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optset_int Lib "CLW3225DA_nag.dll" Alias "e05jfc" ( _
    ByVal optstr As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jfc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByVal ivalue As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optset_real Lib "CLW3225DA_nag.dll" Alias "e05jgc" ( _
    ByVal optstr As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jgc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByVal rvalue As Double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Function nag_glopt_bnd_mcs_option_check Lib "CLW3225DA_nag.dll" Alias "e05jhc" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function e05jhc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   ) as Integer


   Declare Sub nag_glopt_bnd_mcs_optget_int Lib "CLW3225DA_nag.dll" Alias "e05jkc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_bnd_mcs_optget_real Lib "CLW3225DA_nag.dll" Alias "e05jlc" ( _
    ByVal optstr As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Sub e05jlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef rvalue As Double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


Delegate Sub nag_glopt_bnd_pso_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal vecout_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_bnd_pso_monmod_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub E05SXM Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub nag_glopt_bnd_pso Lib "CLW3225DA_nag.dll" Alias "e05sac" ( _
    ByVal ndim As Integer, _
    ByVal npar As Integer, _
    <Out()> ByVal xb As Double(), _
    ByRef fb As Double, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal objfun As nag_glopt_bnd_pso_objfun_DELEGATE, _
    ByVal monmod As nag_glopt_bnd_pso_monmod_DELEGATE, _
    <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), _
    ByRef COMM As Nag_Comm, _
    <Out()> ByVal itt As Integer(), _
    ByRef inform As Integer, _
    ByRef fail As NagError _
   )

Delegate Sub e05sac_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal vecout_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub e05sac_monmod_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )


   Declare Sub e05sac Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal npar As Integer, _
    <Out()> ByVal xb As Double(), _
    ByRef fb As Double, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    ByVal objfun As e05sac_objfun_DELEGATE, _
    ByVal monmod As e05sac_monmod_DELEGATE, _
    <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), _
    ByRef COMM As Nag_Comm, _
    <Out()> ByVal itt As Integer(), _
    ByRef inform As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_glopt_nlp_pso_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal vecout_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_nlp_pso_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncon As Integer, _
    ByVal ndim As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub E05SZM Lib "CLW3225DA_nag.dll" ( _
    ByRef mode As Integer, _
    ByVal ncon As Integer, _
    ByVal ndim As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_nlp_pso_monmod_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal ncon As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal cb_rptr As IntPtr, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal cbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub E05SYM Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, _
    ByVal ncon As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal cb_rptr As IntPtr, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal cbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )

   Declare Sub nag_glopt_nlp_pso Lib "CLW3225DA_nag.dll" Alias "e05sbc" ( _
    ByVal ndim As Integer, ByVal ncon As Integer, ByVal npar As Integer, _
    <Out()> ByVal xb As Double(), ByRef fb As Double, <Out()> ByVal cb As Double(), _
    <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), <[In](),Out()> ByVal xbest As Double(), _
    <[In](),Out()> ByVal fbest As Double(), <[In](),Out()> ByVal cbest As Double(), ByVal objfun As nag_glopt_nlp_pso_objfun_DELEGATE, _
    ByVal confun As nag_glopt_nlp_pso_confun_DELEGATE, ByVal monmod As nag_glopt_nlp_pso_monmod_DELEGATE, <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, _
    <Out()> ByVal itt As Integer(), ByRef inform As Integer, ByRef fail As NagError _
   )

Delegate Sub e05sbc_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ndim As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal vecout_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub e05sbc_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncon As Integer, _
    ByVal ndim As Integer, _
    ByVal tdcj As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub e05sbc_monmod_DELEGATE( _
    ByVal ndim As Integer, _
    ByVal ncon As Integer, _
    ByVal npar As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal xb_rptr As IntPtr, _
    ByVal fb As Double, _
    ByVal cb_rptr As IntPtr, _
    ByVal xbest_rptr As IntPtr, _
    ByVal fbest_rptr As IntPtr, _
    ByVal cbest_rptr As IntPtr, _
    ByVal itt_iptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef inform As Integer _
  )


   Declare Sub e05sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ndim As Integer, ByVal ncon As Integer, ByVal npar As Integer, _
    <Out()> ByVal xb As Double(), ByRef fb As Double, <Out()> ByVal cb As Double(), _
    <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), <[In](),Out()> ByVal xbest As Double(), _
    <[In](),Out()> ByVal fbest As Double(), <[In](),Out()> ByVal cbest As Double(), ByVal objfun As e05sbc_objfun_DELEGATE, _
    ByVal confun As e05sbc_confun_DELEGATE, ByVal monmod As e05sbc_monmod_DELEGATE, <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, _
    <Out()> ByVal itt As Integer(), ByRef inform As Integer, ByRef fail As NagError _
   )


Delegate Sub nag_glopt_nlp_multistart_sqp_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcjsl As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub E04UDM Lib "CLW3225DA_nag.dll" ( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcjsl As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_nlp_multistart_sqp_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal objgrd_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_nlp_multistart_sqp_start_DELEGATE( _
    ByVal npts As Integer, _
    ByVal quas_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal repeat As Nag_Boolean, _
    ByVal bl_rptr As IntPtr, _
    ByVal bu_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef mode As Integer _
  )

   Declare Sub E05UCZ Lib "CLW3225DA_nag.dll" ( _
    ByVal npts As Integer, _
    ByVal quas_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal repeat As Nag_Boolean, _
    ByVal bl_rptr As IntPtr, _
    ByVal bu_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef mode As Integer _
  )

   Declare Sub nag_glopt_nlp_multistart_sqp Lib "CLW3225DA_nag.dll" Alias "e05ucc" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    <[In]()> ByVal a As Double(), ByVal tda As Integer, <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), ByVal confun As nag_glopt_nlp_multistart_sqp_confun_DELEGATE, ByVal objfun As nag_glopt_nlp_multistart_sqp_objfun_DELEGATE, _
    ByVal npts As Integer, <Out()> ByVal x As Double(), ByVal ldx As Integer, _
    ByVal start As nag_glopt_nlp_multistart_sqp_start_DELEGATE, ByVal repeat As Nag_Boolean, ByVal nb As Integer, _
    <Out()> ByVal objf As Double(), <Out()> ByVal objgrd As Double(), ByVal ldobjgrd As Integer, _
    <Out()> ByVal iter As Integer(), <Out()> ByVal c As Double(), ByVal ldc As Integer, _
    <Out()> ByVal cjac As Double(), ByVal ldcjac As Integer, ByVal sdcjac As Integer, _
    <Out()> ByVal r As Double(), ByVal ldr As Integer, ByVal sdr As Integer, _
    <Out()> ByVal clamda As Double(), ByVal ldclamda As Integer, <Out()> ByVal istate As Integer(), _
    ByVal ldistate As Integer, <[In](),Out()> ByVal iopts As Integer(), <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )

Delegate Sub e05ucc_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal tdcjsl As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub e05ucc_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByRef objf As Double, _
    ByVal objgrd_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub e05ucc_start_DELEGATE( _
    ByVal npts As Integer, _
    ByVal quas_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal repeat As Nag_Boolean, _
    ByVal bl_rptr As IntPtr, _
    ByVal bu_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef mode As Integer _
  )


   Declare Sub e05ucc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    <[In]()> ByVal a As Double(), ByVal tda As Integer, <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), ByVal confun As e05ucc_confun_DELEGATE, ByVal objfun As e05ucc_objfun_DELEGATE, _
    ByVal npts As Integer, <Out()> ByVal x As Double(), ByVal ldx As Integer, _
    ByVal start As e05ucc_start_DELEGATE, ByVal repeat As Nag_Boolean, ByVal nb As Integer, _
    <Out()> ByVal objf As Double(), <Out()> ByVal objgrd As Double(), ByVal ldobjgrd As Integer, _
    <Out()> ByVal iter As Integer(), <Out()> ByVal c As Double(), ByVal ldc As Integer, _
    <Out()> ByVal cjac As Double(), ByVal ldcjac As Integer, ByVal sdcjac As Integer, _
    <Out()> ByVal r As Double(), ByVal ldr As Integer, ByVal sdr As Integer, _
    <Out()> ByVal clamda As Double(), ByVal ldclamda As Integer, <Out()> ByVal istate As Integer(), _
    ByVal ldistate As Integer, <[In](),Out()> ByVal iopts As Integer(), <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_glopt_nlp_multistart_sqp_lsq_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal pdcjsl As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub nag_glopt_nlp_multistart_sqp_lsq_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal pdfjsl As Integer, _
    ByVal needfi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByVal fjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_glopt_nlp_multistart_sqp_lsq_start_DELEGATE( _
    ByVal npts As Integer, _
    ByVal quas_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal repeat1 As Nag_Boolean, _
    ByVal bl_rptr As IntPtr, _
    ByVal bu_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef mode As Integer _
  )


   Declare Sub nag_glopt_nlp_multistart_sqp_lsq Lib "CLW3225DA_nag.dll" Alias "e05usc" ( _
    ByVal m As Integer, ByVal n As Integer, ByVal nclin As Integer, _
    ByVal ncnln As Integer, <[In]()> ByVal a As Double(), ByVal pda As Integer, _
    <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), <[In]()> ByVal y As Double(), _
    ByVal confun As nag_glopt_nlp_multistart_sqp_lsq_confun_DELEGATE, ByVal objfun As nag_glopt_nlp_multistart_sqp_lsq_objfun_DELEGATE, ByVal npts As Integer, _
    <Out()> ByVal x As Double(), ByVal pdx As Integer, ByVal start As nag_glopt_nlp_multistart_sqp_lsq_start_DELEGATE, _
    ByVal repeat1 As Nag_Boolean, ByVal nb As Integer, <Out()> ByVal objf As Double(), _
    <Out()> ByVal f As Double(), <Out()> ByVal fjac As Double(), ByVal ldfjac As Integer, _
    ByVal sdfjac As Integer, <Out()> ByVal iter As Integer(), <Out()> ByVal c As Double(), _
    ByVal pdc As Integer, <Out()> ByVal cjac As Double(), ByVal ldcjac As Integer, _
    ByVal sdcjac As Integer, <Out()> ByVal clamda As Double(), ByVal pdclamda As Integer, _
    <Out()> ByVal istate As Integer(), ByVal pdistate As Integer, <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, _
    <Out()> ByVal info As Integer(), ByRef fail As NagError _
   )

Delegate Sub e05usc_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal pdcjsl As Integer, _
    ByVal needc_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub e05usc_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal pdfjsl As Integer, _
    ByVal needfi As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal f_rptr As IntPtr, _
    ByVal fjsl_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub e05usc_start_DELEGATE( _
    ByVal npts As Integer, _
    ByVal quas_rptr As IntPtr, _
    ByVal n As Integer, _
    ByVal repeat1 As Nag_Boolean, _
    ByVal bl_rptr As IntPtr, _
    ByVal bu_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef mode As Integer _
  )


   Declare Sub e05usc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, ByVal n As Integer, ByVal nclin As Integer, _
    ByVal ncnln As Integer, <[In]()> ByVal a As Double(), ByVal pda As Integer, _
    <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), <[In]()> ByVal y As Double(), _
    ByVal confun As e05usc_confun_DELEGATE, ByVal objfun As e05usc_objfun_DELEGATE, ByVal npts As Integer, _
    <Out()> ByVal x As Double(), ByVal pdx As Integer, ByVal start As e05usc_start_DELEGATE, _
    ByVal repeat1 As Nag_Boolean, ByVal nb As Integer, <Out()> ByVal objf As Double(), _
    <Out()> ByVal f As Double(), <Out()> ByVal fjac As Double(), ByVal ldfjac As Integer, _
    ByVal sdfjac As Integer, <Out()> ByVal iter As Integer(), <Out()> ByVal c As Double(), _
    ByVal pdc As Integer, <Out()> ByVal cjac As Double(), ByVal ldcjac As Integer, _
    ByVal sdcjac As Integer, <Out()> ByVal clamda As Double(), ByVal pdclamda As Integer, _
    <Out()> ByVal istate As Integer(), ByVal pdistate As Integer, <[In](),Out()> ByVal iopts As Integer(), _
    <[In](),Out()> ByVal opts As Double(), ByRef COMM As Nag_Comm, _
    <Out()> ByVal info As Integer(), ByRef fail As NagError _
   )


   Declare Sub nag_glopt_opt_set Lib "CLW3225DA_nag.dll" Alias "e05zkc" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub e05zkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glopt_opt_get Lib "CLW3225DA_nag.dll" Alias "e05zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub e05zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


' chapter f01

   Declare Sub nag_real_gen_matrix_exp Lib "CLW3225DA_nag.dll" Alias "f01ecc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_matrix_exp Lib "CLW3225DA_nag.dll" Alias "f01edc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01edc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_real_symm_matrix_fun_f_DELEGATE( _
    ByRef flag As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fx_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_real_symm_matrix_fun Lib "CLW3225DA_nag.dll" Alias "f01efc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_real_symm_matrix_fun_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef flag As Integer, _
    ByRef fail As NagError _
   )

Delegate Sub f01efc_f_DELEGATE( _
    ByRef flag As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fx_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01efc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As f01efc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef flag As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_log Lib "CLW3225DA_nag.dll" Alias "f01ejc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01ejc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_fun_std Lib "CLW3225DA_nag.dll" Alias "f01ekc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01ekc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_real_gen_matrix_fun_num_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_real_gen_matrix_fun_num Lib "CLW3225DA_nag.dll" Alias "f01elc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_real_gen_matrix_fun_num_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01elc_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01elc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As f01elc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_real_gen_matrix_fun_usd_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_real_gen_matrix_fun_usd Lib "CLW3225DA_nag.dll" Alias "f01emc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_real_gen_matrix_fun_usd_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01emc_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01emc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As f01emc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef imnorm As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_sqrt Lib "CLW3225DA_nag.dll" Alias "f01enc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01enc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_tri_matrix_sqrt Lib "CLW3225DA_nag.dll" Alias "f01epc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01epc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_pow Lib "CLW3225DA_nag.dll" Alias "f01eqc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01eqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_exp Lib "CLW3225DA_nag.dll" Alias "f01fcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_herm_matrix_exp Lib "CLW3225DA_nag.dll" Alias "f01fdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_complex_herm_matrix_fun_f_DELEGATE( _
    ByRef flag As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fx_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_complex_herm_matrix_fun Lib "CLW3225DA_nag.dll" Alias "f01ffc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_complex_herm_matrix_fun_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef flag As Integer, _
    ByRef fail As NagError _
   )

Delegate Sub f01ffc_f_DELEGATE( _
    ByRef flag As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal fx_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As f01ffc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef flag As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_log Lib "CLW3225DA_nag.dll" Alias "f01fjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_fun_std Lib "CLW3225DA_nag.dll" Alias "f01fkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_complex_gen_matrix_fun_num_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_complex_gen_matrix_fun_num Lib "CLW3225DA_nag.dll" Alias "f01flc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_complex_gen_matrix_fun_num_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef fail As NagError _
   )

Delegate Sub f01flc_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01flc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As f01flc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_complex_gen_matrix_fun_usd_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_complex_gen_matrix_fun_usd Lib "CLW3225DA_nag.dll" Alias "f01fmc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_complex_gen_matrix_fun_usd_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef fail As NagError _
   )

Delegate Sub f01fmc_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01fmc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As f01fmc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_sqrt Lib "CLW3225DA_nag.dll" Alias "f01fnc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fnc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_tri_matrix_sqrt Lib "CLW3225DA_nag.dll" Alias "f01fpc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01fpc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_pow Lib "CLW3225DA_nag.dll" Alias "f01fqc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01fqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_actexp Lib "CLW3225DA_nag.dll" Alias "f01gac" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal t As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01gac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal t As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_actexp_rcomm Lib "CLW3225DA_nag.dll" Alias "f01gbc" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal t As Double, _
    ByVal tr As Double, _
    <[In](),Out()> ByVal b2 As Double(), _
    ByVal pdb2 As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal pdy As Integer, _
    <[In](),Out()> ByVal p As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f01gbc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal t As Double, _
    ByVal tr As Double, _
    <[In](),Out()> ByVal b2 As Double(), _
    ByVal pdb2 As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal pdy As Integer, _
    <[In](),Out()> ByVal p As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_actexp Lib "CLW3225DA_nag.dll" Alias "f01hac" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal t As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub f01hac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal t As Complex, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_actexp_rcomm Lib "CLW3225DA_nag.dll" Alias "f01hbc" ( _
    ByRef irevcm As Integer, ByVal n As Integer, ByVal m As Integer, _
    <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, ByVal t As Complex, _
    ByVal tr As Complex, <[In](),Out()> ByVal b2 As Complex(), ByVal pdb2 As Integer, _
    <[In](),Out()> ByVal x As Complex(), ByVal pdx As Integer, <[In](),Out()> ByVal y As Complex(), _
    ByVal pdy As Integer, <[In](),Out()> ByVal p As Complex(), <[In](),Out()> ByVal r As Complex(), _
    <[In](),Out()> ByVal z As Complex(), <[In](),Out()> ByVal ccomm As Complex(), <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), ByRef fail As NagError _
   )

   Declare Sub f01hbc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, ByVal n As Integer, ByVal m As Integer, _
    <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, ByVal t As Complex, _
    ByVal tr As Complex, <[In](),Out()> ByVal b2 As Complex(), ByVal pdb2 As Integer, _
    <[In](),Out()> ByVal x As Complex(), ByVal pdx As Integer, <[In](),Out()> ByVal y As Complex(), _
    ByVal pdy As Integer, <[In](),Out()> ByVal p As Complex(), <[In](),Out()> ByVal r As Complex(), _
    <[In](),Out()> ByVal z As Complex(), <[In](),Out()> ByVal ccomm As Complex(), <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_cond_std Lib "CLW3225DA_nag.dll" Alias "f01jac" ( _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jac Lib "CLW3225DA_nag.dll" ( _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_real_gen_matrix_cond_num_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_real_gen_matrix_cond_num Lib "CLW3225DA_nag.dll" Alias "f01jbc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_real_gen_matrix_cond_num_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01jbc_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As f01jbc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_real_gen_matrix_cond_usd_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_real_gen_matrix_cond_usd Lib "CLW3225DA_nag.dll" Alias "f01jcc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_real_gen_matrix_cond_usd_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01jcc_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal f As f01jcc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_cond_sqrt Lib "CLW3225DA_nag.dll" Alias "f01jdc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef alpha As Double, _
    ByRef condsa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef alpha As Double, _
    ByRef condsa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_cond_pow Lib "CLW3225DA_nag.dll" Alias "f01jec" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef condpa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef condpa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_frcht_pow Lib "CLW3225DA_nag.dll" Alias "f01jfc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_cond_exp Lib "CLW3225DA_nag.dll" Alias "f01jgc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef condea As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef condea As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_frcht_exp Lib "CLW3225DA_nag.dll" Alias "f01jhc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01jhc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_cond_log Lib "CLW3225DA_nag.dll" Alias "f01jjc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef condla As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01jjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef condla As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_real_gen_matrix_frcht_log Lib "CLW3225DA_nag.dll" Alias "f01jkc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01jkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Double(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_cond_std Lib "CLW3225DA_nag.dll" Alias "f01kac" ( _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kac Lib "CLW3225DA_nag.dll" ( _
    ByVal fun As Nag_MatFunType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_complex_gen_matrix_cond_num_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_complex_gen_matrix_cond_num Lib "CLW3225DA_nag.dll" Alias "f01kbc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_complex_gen_matrix_cond_num_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01kbc_f_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01kbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As f01kbc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


Delegate Sub nag_matop_complex_gen_matrix_cond_usd_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_matop_complex_gen_matrix_cond_usd Lib "CLW3225DA_nag.dll" Alias "f01kcc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As nag_matop_complex_gen_matrix_cond_usd_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )

Delegate Sub f01kcc_f_DELEGATE( _
    ByVal m As Integer, _
    ByRef iflag As Integer, _
    ByVal nz As Integer, _
    ByVal z_cptr As IntPtr, _
    ByVal fz_cptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f01kcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal f As f01kcc_f_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef iflag As Integer, _
    ByRef conda As Double, _
    ByRef norma As Double, _
    ByRef normfa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_cond_sqrt Lib "CLW3225DA_nag.dll" Alias "f01kdc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef alpha As Double, _
    ByRef condsa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef alpha As Double, _
    ByRef condsa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_cond_pow Lib "CLW3225DA_nag.dll" Alias "f01kec" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef condpa As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal p As Double, _
    ByRef condpa As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_frcht_pow Lib "CLW3225DA_nag.dll" Alias "f01kfc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByVal p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_cond_exp Lib "CLW3225DA_nag.dll" Alias "f01kgc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef condea As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef condea As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_frcht_exp Lib "CLW3225DA_nag.dll" Alias "f01khc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01khc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_cond_log Lib "CLW3225DA_nag.dll" Alias "f01kjc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef condla As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f01kjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef condla As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_matop_complex_gen_matrix_frcht_log Lib "CLW3225DA_nag.dll" Alias "f01kkc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f01kkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_cholesky_skyline Lib "CLW3225DA_nag.dll" Alias "f01mcc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lal As Integer, _
    <[In]()> ByVal row As Integer(), _
    <Out()> ByVal al As Double(), _
    <Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f01mcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lal As Integer, _
    <[In]()> ByVal row As Integer(), _
    <Out()> ByVal al As Double(), _
    <Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtrttp Lib "CLW3225DA_nag.dll" Alias "f01vac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f01vac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrttp Lib "CLW3225DA_nag.dll" Alias "f01vbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f01vbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtpttr Lib "CLW3225DA_nag.dll" Alias "f01vcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f01vcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztpttr Lib "CLW3225DA_nag.dll" Alias "f01vdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f01vdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrttf Lib "CLW3225DA_nag.dll" Alias "f01vec" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f01vec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrttf Lib "CLW3225DA_nag.dll" Alias "f01vfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f01vfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtfttr Lib "CLW3225DA_nag.dll" Alias "f01vgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f01vgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztfttr Lib "CLW3225DA_nag.dll" Alias "f01vhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f01vhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtpttf Lib "CLW3225DA_nag.dll" Alias "f01vjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f01vjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztpttf Lib "CLW3225DA_nag.dll" Alias "f01vkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f01vkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtfttp Lib "CLW3225DA_nag.dll" Alias "f01vlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    <Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f01vlc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    <Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztfttp Lib "CLW3225DA_nag.dll" Alias "f01vmc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f01vmc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )


' chapter f02

   Declare Sub nag_real_symm_eigenvalues Lib "CLW3225DA_nag.dll" Alias "f02aac" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f02aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_eigensystem Lib "CLW3225DA_nag.dll" Alias "f02abc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02abc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_general_eigenvalues Lib "CLW3225DA_nag.dll" Alias "f02adc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f02adc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_general_eigensystem Lib "CLW3225DA_nag.dll" Alias "f02aec" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02aec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_eigenvalues Lib "CLW3225DA_nag.dll" Alias "f02afc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Complex(), _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f02afc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Complex(), _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_eigensystem Lib "CLW3225DA_nag.dll" Alias "f02agc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f02agc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_hermitian_eigenvalues Lib "CLW3225DA_nag.dll" Alias "f02awc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f02awc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_hermitian_eigensystem Lib "CLW3225DA_nag.dll" Alias "f02axc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02axc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_general_eigensystem Lib "CLW3225DA_nag.dll" Alias "f02bjc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal alfa As Complex(), _
    <Out()> ByVal beta As Double(), _
    ByVal wantv As Nag_Boolean, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f02bjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal alfa As Complex(), _
    <Out()> ByVal beta As Double(), _
    ByVal wantv As Nag_Boolean, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <Out()> ByVal iter As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_eigensystem_sel Lib "CLW3225DA_nag.dll" Alias "f02ecc" ( _
    ByVal crit As Nag_Select_Eigenvalues, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    ByVal wl As Double, _
    ByVal wu As Double, _
    ByVal mest As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal crit As Nag_Select_Eigenvalues, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    ByVal wl As Double, _
    ByVal wu As Double, _
    ByVal mest As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_eigen_real_gen_sparse_arnoldi_monit_DELEGATE( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_cptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub F02EKZ Lib "CLW3225DA_nag.dll" ( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_cptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_eigen_real_gen_sparse_arnoldi_opt_DELEGATE( _
    ByVal icom_iptr As IntPtr, _
    ByVal com_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub F02EKY Lib "CLW3225DA_nag.dll" ( _
    ByVal icom_iptr As IntPtr, _
    ByVal com_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_eigen_real_gen_sparse_arnoldi Lib "CLW3225DA_nag.dll" Alias "f02ekc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    ByVal sigma As Double, _
    ByVal monit As nag_eigen_real_gen_sparse_arnoldi_monit_DELEGATE, _
    ByVal opt As nag_eigen_real_gen_sparse_arnoldi_opt_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub f02ekc_monit_DELEGATE( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_cptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub f02ekc_opt_DELEGATE( _
    ByVal icom_iptr As IntPtr, _
    ByVal com_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub f02ekc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    ByVal sigma As Double, _
    ByVal monit As f02ekc_monit_DELEGATE, _
    ByVal opt As f02ekc_opt_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Sub nag_eigen_real_symm_sparse_arnoldi_monit_DELEGATE( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_rptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub F02FKZ Lib "CLW3225DA_nag.dll" ( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_rptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_eigen_real_symm_sparse_arnoldi_opt_DELEGATE( _
    ByVal icom_iptr As IntPtr, _
    ByVal com_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub nag_eigen_real_symm_sparse_arnoldi Lib "CLW3225DA_nag.dll" Alias "f02fkc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    ByVal sigma As Double, _
    ByVal monit As nag_eigen_real_symm_sparse_arnoldi_monit_DELEGATE, _
    ByVal opt As nag_eigen_real_symm_sparse_arnoldi_opt_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub f02fkc_monit_DELEGATE( _
    ByVal ncv As Integer, _
    ByVal niter As Integer, _
    ByVal nconv As Integer, _
    ByVal w_rptr As IntPtr, _
    ByVal rzest_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub f02fkc_opt_DELEGATE( _
    ByVal icom_iptr As IntPtr, _
    ByVal com_rptr As IntPtr, _
    ByRef istat As Integer, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub f02fkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    ByVal sigma As Double, _
    ByVal monit As f02fkc_monit_DELEGATE, _
    ByVal opt As f02fkc_opt_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_eigensystem_sel Lib "CLW3225DA_nag.dll" Alias "f02gcc" ( _
    ByVal crit As Nag_Select_Eigenvalues, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    ByVal wl As Double, _
    ByVal wu As Double, _
    ByVal mest As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal crit As Nag_Select_Eigenvalues, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    ByVal wl As Double, _
    ByVal wu As Double, _
    ByVal mest As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal v As Complex(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_eigen_real_gen_quad Lib "CLW3225DA_nag.dll" Alias "f02jcc" ( _
    ByVal scal As Nag_ScaleType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_CondErrType, ByVal tol As Double, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, <[In](),Out()> ByVal c As Double(), ByVal pdc As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, <Out()> ByVal s As Double(), <Out()> ByVal bevl As Double(), _
    <Out()> ByVal bevr As Double(), ByRef iwarn As Integer, ByRef fail As NagError _
   )

   Declare Sub f02jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal scal As Nag_ScaleType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_CondErrType, ByVal tol As Double, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, <[In](),Out()> ByVal c As Double(), ByVal pdc As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, <Out()> ByVal s As Double(), <Out()> ByVal bevl As Double(), _
    <Out()> ByVal bevr As Double(), ByRef iwarn As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_eigen_complex_gen_quad Lib "CLW3225DA_nag.dll" Alias "f02jqc" ( _
    ByVal scal As Nag_ScaleType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_CondErrType, ByVal tol As Double, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, <[In](),Out()> ByVal c As Complex(), ByVal pdc As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, <Out()> ByVal vr As Complex(), ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), <Out()> ByVal bevl As Double(), <Out()> ByVal bevr As Double(), _
    ByRef iwarn As Integer, ByRef fail As NagError _
   )

   Declare Sub f02jqc Lib "CLW3225DA_nag.dll" ( _
    ByVal scal As Nag_ScaleType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_CondErrType, ByVal tol As Double, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, <[In](),Out()> ByVal c As Complex(), ByVal pdc As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, <Out()> ByVal vr As Complex(), ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), <Out()> ByVal bevl As Double(), <Out()> ByVal bevr As Double(), _
    ByRef iwarn As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_real_svd Lib "CLW3225DA_nag.dll" Alias "f02wec" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    ByVal ncolb As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    ByVal wantq As Nag_Boolean, _
    <Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    <Out()> ByVal sv As Double(), _
    ByVal wantp As Nag_Boolean, _
    <Out()> ByVal pt As Double(), _
    ByVal tdpt As Integer, _
    ByRef iter As Integer, _
    <Out()> ByVal e As Double(), _
    ByRef failinfo As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02wec Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    ByVal ncolb As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    ByVal wantq As Nag_Boolean, _
    <Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    <Out()> ByVal sv As Double(), _
    ByVal wantp As Nag_Boolean, _
    <Out()> ByVal pt As Double(), _
    ByVal tdpt As Integer, _
    ByRef iter As Integer, _
    <Out()> ByVal e As Double(), _
    ByRef failinfo As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_real_partial_svd_av_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal ax_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_real_partial_svd Lib "CLW3225DA_nag.dll" Alias "f02wgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal ncv As Integer, _
    ByVal av As nag_real_partial_svd_av_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal sigma As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub f02wgc_av_DELEGATE( _
    ByRef iflag As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal ax_rptr As IntPtr, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub f02wgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal ncv As Integer, _
    ByVal av As f02wgc_av_DELEGATE, _
    ByRef nconv As Integer, _
    <Out()> ByVal sigma As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal resid As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_svd Lib "CLW3225DA_nag.dll" Alias "f02xec" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    ByVal ncolb As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal tdb As Integer, _
    ByVal wantq As Nag_Boolean, _
    <Out()> ByVal q As Complex(), _
    ByVal tdq As Integer, _
    <Out()> ByVal sv As Double(), _
    ByVal wantp As Nag_Boolean, _
    <Out()> ByVal ph As Complex(), _
    ByVal tdph As Integer, _
    ByRef iter As Integer, _
    <Out()> ByVal e As Double(), _
    ByRef failinfo As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f02xec Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal tda As Integer, _
    ByVal ncolb As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal tdb As Integer, _
    ByVal wantq As Nag_Boolean, _
    <Out()> ByVal q As Complex(), _
    ByVal tdq As Integer, _
    <Out()> ByVal sv As Double(), _
    ByVal wantp As Nag_Boolean, _
    <Out()> ByVal ph As Complex(), _
    ByVal tdph As Integer, _
    ByRef iter As Integer, _
    <Out()> ByVal e As Double(), _
    ByRef failinfo As Integer, _
    ByRef fail As NagError _
   )


' chapter f03

   Declare Sub nag_det_real_gen Lib "CLW3225DA_nag.dll" Alias "f03bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f03bac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_det_real_sym Lib "CLW3225DA_nag.dll" Alias "f03bfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f03bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_det_real_band_sym Lib "CLW3225DA_nag.dll" Alias "f03bhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f03bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef d As Double, _
    ByRef id As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_det_complex_gen Lib "CLW3225DA_nag.dll" Alias "f03bnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef d As Complex, _
    <Out()> ByVal id As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f03bnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef d As Complex, _
    <Out()> ByVal id As Integer(), _
    ByRef fail As NagError _
   )


' chapter f04

   Declare Sub nag_real_gen_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_band_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_tridiag_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <Out()> ByVal du2 As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <Out()> ByVal du2 As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_posdef_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_posdef_packed_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_posdef_band_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_posdef_tridiag_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sym_packed_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04bjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04bjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_gen_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_band_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_tridiag_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04ccc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <Out()> ByVal du2 As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <Out()> ByVal du2 As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_posdef_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_posdef_packed_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_posdef_band_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_posdef_tridiag_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04chc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04chc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_herm_packed_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04cjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04cjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sym_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04dhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04dhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sym_packed_lin_solve Lib "CLW3225DA_nag.dll" Alias "f04djc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f04djc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef rcond As Double, _
    ByRef errbnd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_cholesky_skyline_solve Lib "CLW3225DA_nag.dll" Alias "f04mcc" ( _
    ByVal selct As Nag_SolveSystem, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal al As Double(), _
    ByVal lal As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal row As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f04mcc Lib "CLW3225DA_nag.dll" ( _
    ByVal selct As Nag_SolveSystem, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal al As Double(), _
    ByVal lal As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal row As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_linsys_real_gen_norm_rcomm Lib "CLW3225DA_nag.dll" Alias "f04ydc" ( _
    ByRef irevcm As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal pdy As Integer, _
    ByRef estnrm As Double, _
    ByVal t As Integer, _
    ByVal seed As Integer, _
    <[In](),Out()> ByVal work As Double(), _
    <[In](),Out()> ByVal iwork As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f04ydc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal pdy As Integer, _
    ByRef estnrm As Double, _
    ByVal t As Integer, _
    ByVal seed As Integer, _
    <[In](),Out()> ByVal work As Double(), _
    <[In](),Out()> ByVal iwork As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_linsys_complex_gen_norm_rcomm Lib "CLW3225DA_nag.dll" Alias "f04zdc" ( _
    ByRef irevcm As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal pdy As Integer, _
    ByRef estnrm As Double, _
    ByVal t As Integer, _
    ByVal seed As Integer, _
    <[In](),Out()> ByVal work As Complex(), _
    <[In](),Out()> ByVal rwork As Double(), _
    <[In](),Out()> ByVal iwork As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f04zdc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal pdy As Integer, _
    ByRef estnrm As Double, _
    ByVal t As Integer, _
    ByVal seed As Integer, _
    <[In](),Out()> ByVal work As Complex(), _
    <[In](),Out()> ByVal rwork As Double(), _
    <[In](),Out()> ByVal iwork As Integer(), _
    ByRef fail As NagError _
   )


' chapter f06

   Declare Sub nag_drscl Lib "CLW3225DA_nag.dll" Alias "f06fec" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer _
   )

   Declare Sub f06fec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer _
   )


   Declare Sub nag_zrscl Lib "CLW3225DA_nag.dll" Alias "f06kec" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer _
   )

   Declare Sub f06kec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer _
   )


' chapter f07

   Declare Sub nag_dgesv Lib "CLW3225DA_nag.dll" Alias "f07aac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07aac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgesvx Lib "CLW3225DA_nag.dll" Alias "f07abc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), ByVal pdaf As Integer, <[In](),Out()> ByVal ipiv As Integer(), _
    ByVal equed As Nag_EquilibrationType, <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef recip_growth_factor As Double, ByRef info As NagError _
   )

   Declare Sub f07abc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), ByVal pdaf As Integer, <[In](),Out()> ByVal ipiv As Integer(), _
    ByVal equed As Nag_EquilibrationType, <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef recip_growth_factor As Double, ByRef info As NagError _
   )


   Declare Sub nag_dsgesv Lib "CLW3225DA_nag.dll" Alias "f07acc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07acc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgetrf Lib "CLW3225DA_nag.dll" Alias "f07adc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07adc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgetrs Lib "CLW3225DA_nag.dll" Alias "f07aec" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07aec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeequ Lib "CLW3225DA_nag.dll" Alias "f07afc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07afc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgecon Lib "CLW3225DA_nag.dll" Alias "f07agc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07agc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgerfs Lib "CLW3225DA_nag.dll" Alias "f07ahc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07ahc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgetri Lib "CLW3225DA_nag.dll" Alias "f07ajc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07ajc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgesv Lib "CLW3225DA_nag.dll" Alias "f07anc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07anc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgesvx Lib "CLW3225DA_nag.dll" Alias "f07apc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), ByVal pdaf As Integer, <[In](),Out()> ByVal ipiv As Integer(), _
    ByVal equed As Nag_EquilibrationType, <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef recip_growth_factor As Double, ByRef info As NagError _
   )

   Declare Sub f07apc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), ByVal pdaf As Integer, <[In](),Out()> ByVal ipiv As Integer(), _
    ByVal equed As Nag_EquilibrationType, <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef recip_growth_factor As Double, ByRef info As NagError _
   )


   Declare Sub nag_zcgesv Lib "CLW3225DA_nag.dll" Alias "f07aqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgetrf Lib "CLW3225DA_nag.dll" Alias "f07arc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07arc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgetrs Lib "CLW3225DA_nag.dll" Alias "f07asc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07asc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeequ Lib "CLW3225DA_nag.dll" Alias "f07atc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07atc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgecon Lib "CLW3225DA_nag.dll" Alias "f07auc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07auc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgerfs Lib "CLW3225DA_nag.dll" Alias "f07avc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07avc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgetri Lib "CLW3225DA_nag.dll" Alias "f07awc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07awc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbsv Lib "CLW3225DA_nag.dll" Alias "f07bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07bac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbsvx Lib "CLW3225DA_nag.dll" Alias "f07bbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal kl As Integer, ByVal ku As Integer, ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), ByVal pdab As Integer, <[In](),Out()> ByVal afb As Double(), _
    ByVal pdafb As Integer, <[In](),Out()> ByVal ipiv As Integer(), ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, <Out()> ByVal x As Double(), ByVal pdx As Integer, _
    ByRef rcond As Double, <Out()> ByVal ferr As Double(), <Out()> ByVal berr As Double(), _
    ByRef recip_growth_factor As Double, ByRef info As NagError _
   )

   Declare Sub f07bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal kl As Integer, ByVal ku As Integer, ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), ByVal pdab As Integer, <[In](),Out()> ByVal afb As Double(), _
    ByVal pdafb As Integer, <[In](),Out()> ByVal ipiv As Integer(), ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, <Out()> ByVal x As Double(), ByVal pdx As Integer, _
    ByRef rcond As Double, <Out()> ByVal ferr As Double(), <Out()> ByVal berr As Double(), _
    ByRef recip_growth_factor As Double, ByRef info As NagError _
   )


   Declare Sub nag_dgbtrf Lib "CLW3225DA_nag.dll" Alias "f07bdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbtrs Lib "CLW3225DA_nag.dll" Alias "f07bec" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07bec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbequ Lib "CLW3225DA_nag.dll" Alias "f07bfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbcon Lib "CLW3225DA_nag.dll" Alias "f07bgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07bgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbrfs Lib "CLW3225DA_nag.dll" Alias "f07bhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbsv Lib "CLW3225DA_nag.dll" Alias "f07bnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07bnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbsvx Lib "CLW3225DA_nag.dll" Alias "f07bpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal kl As Integer, ByVal ku As Integer, ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), ByVal pdab As Integer, <[In](),Out()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, <[In](),Out()> ByVal ipiv As Integer(), ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, <Out()> ByVal x As Complex(), ByVal pdx As Integer, _
    ByRef rcond As Double, <Out()> ByVal ferr As Double(), <Out()> ByVal berr As Double(), _
    ByRef recip_growth_factor As Double, ByRef info As NagError _
   )

   Declare Sub f07bpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal kl As Integer, ByVal ku As Integer, ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), ByVal pdab As Integer, <[In](),Out()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, <[In](),Out()> ByVal ipiv As Integer(), ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal r As Double(), <[In](),Out()> ByVal c As Double(), <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, <Out()> ByVal x As Complex(), ByVal pdx As Integer, _
    ByRef rcond As Double, <Out()> ByVal ferr As Double(), <Out()> ByVal berr As Double(), _
    ByRef recip_growth_factor As Double, ByRef info As NagError _
   )


   Declare Sub nag_zgbtrf Lib "CLW3225DA_nag.dll" Alias "f07brc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07brc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbtrs Lib "CLW3225DA_nag.dll" Alias "f07bsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07bsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbequ Lib "CLW3225DA_nag.dll" Alias "f07btc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07btc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef rowcnd As Double, _
    ByRef colcnd As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbcon Lib "CLW3225DA_nag.dll" Alias "f07buc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07buc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbrfs Lib "CLW3225DA_nag.dll" Alias "f07bvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07bvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgtsv Lib "CLW3225DA_nag.dll" Alias "f07cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07cac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgtsvx Lib "CLW3225DA_nag.dll" Alias "f07cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In]()> ByVal dl As Double(), <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), <[In](),Out()> ByVal dlf As Double(), <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal duf As Double(), <[In](),Out()> ByVal du2 As Double(), <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), ByVal pdb As Integer, <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef info As NagError _
   )

   Declare Sub f07cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In]()> ByVal dl As Double(), <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), <[In](),Out()> ByVal dlf As Double(), <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal duf As Double(), <[In](),Out()> ByVal du2 As Double(), <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), ByVal pdb As Integer, <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef info As NagError _
   )


   Declare Sub nag_dgttrf Lib "CLW3225DA_nag.dll" Alias "f07cdc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <Out()> ByVal du2 As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal dl As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal du As Double(), _
    <Out()> ByVal du2 As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgttrs Lib "CLW3225DA_nag.dll" Alias "f07cec" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07cec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgtcon Lib "CLW3225DA_nag.dll" Alias "f07cgc" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07cgc Lib "CLW3225DA_nag.dll" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgtrfs Lib "CLW3225DA_nag.dll" Alias "f07chc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal dlf As Double(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal duf As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07chc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Double(), _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal du As Double(), _
    <[In]()> ByVal dlf As Double(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal duf As Double(), _
    <[In]()> ByVal du2 As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgtsv Lib "CLW3225DA_nag.dll" Alias "f07cnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07cnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgtsvx Lib "CLW3225DA_nag.dll" Alias "f07cpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In]()> ByVal dl As Complex(), <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), <[In](),Out()> ByVal dlf As Complex(), <[In](),Out()> ByVal df As Complex(), _
    <[In](),Out()> ByVal duf As Complex(), <[In](),Out()> ByVal du2 As Complex(), <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), ByVal pdb As Integer, <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef info As NagError _
   )

   Declare Sub f07cpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, ByVal trans As Nag_TransType, ByVal n As Integer, _
    ByVal nrhs As Integer, <[In]()> ByVal dl As Complex(), <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), <[In](),Out()> ByVal dlf As Complex(), <[In](),Out()> ByVal df As Complex(), _
    <[In](),Out()> ByVal duf As Complex(), <[In](),Out()> ByVal du2 As Complex(), <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), ByVal pdb As Integer, <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, ByRef rcond As Double, <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), ByRef info As NagError _
   )


   Declare Sub nag_zgttrf Lib "CLW3225DA_nag.dll" Alias "f07crc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <Out()> ByVal du2 As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07crc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal dl As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <[In](),Out()> ByVal du As Complex(), _
    <Out()> ByVal du2 As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgttrs Lib "CLW3225DA_nag.dll" Alias "f07csc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07csc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgtcon Lib "CLW3225DA_nag.dll" Alias "f07cuc" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07cuc Lib "CLW3225DA_nag.dll" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgtrfs Lib "CLW3225DA_nag.dll" Alias "f07cvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal dlf As Complex(), _
    <[In]()> ByVal df As Complex(), _
    <[In]()> ByVal duf As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07cvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal dl As Complex(), _
    <[In]()> ByVal d As Complex(), _
    <[In]()> ByVal du As Complex(), _
    <[In]()> ByVal dlf As Complex(), _
    <[In]()> ByVal df As Complex(), _
    <[In]()> ByVal duf As Complex(), _
    <[In]()> ByVal du2 As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dposv Lib "CLW3225DA_nag.dll" Alias "f07fac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dposvx Lib "CLW3225DA_nag.dll" Alias "f07fbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpotrf Lib "CLW3225DA_nag.dll" Alias "f07fdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpotrs Lib "CLW3225DA_nag.dll" Alias "f07fec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpoequ Lib "CLW3225DA_nag.dll" Alias "f07ffc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpocon Lib "CLW3225DA_nag.dll" Alias "f07fgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07fgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dporfs Lib "CLW3225DA_nag.dll" Alias "f07fhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07fhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpotri Lib "CLW3225DA_nag.dll" Alias "f07fjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zposv Lib "CLW3225DA_nag.dll" Alias "f07fnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zposvx Lib "CLW3225DA_nag.dll" Alias "f07fpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07fpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpotrf Lib "CLW3225DA_nag.dll" Alias "f07frc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07frc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpotrs Lib "CLW3225DA_nag.dll" Alias "f07fsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpoequ Lib "CLW3225DA_nag.dll" Alias "f07ftc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07ftc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpocon Lib "CLW3225DA_nag.dll" Alias "f07fuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07fuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zporfs Lib "CLW3225DA_nag.dll" Alias "f07fvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07fvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpotri Lib "CLW3225DA_nag.dll" Alias "f07fwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07fwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dppsv Lib "CLW3225DA_nag.dll" Alias "f07gac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07gac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dppsvx Lib "CLW3225DA_nag.dll" Alias "f07gbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal afp As Double(), _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal afp As Double(), _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpptrf Lib "CLW3225DA_nag.dll" Alias "f07gdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07gdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpptrs Lib "CLW3225DA_nag.dll" Alias "f07gec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07gec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dppequ Lib "CLW3225DA_nag.dll" Alias "f07gfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07gfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dppcon Lib "CLW3225DA_nag.dll" Alias "f07ggc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07ggc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpprfs Lib "CLW3225DA_nag.dll" Alias "f07ghc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal afp As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07ghc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal afp As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpptri Lib "CLW3225DA_nag.dll" Alias "f07gjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07gjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zppsv Lib "CLW3225DA_nag.dll" Alias "f07gnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07gnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zppsvx Lib "CLW3225DA_nag.dll" Alias "f07gpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07gpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpptrf Lib "CLW3225DA_nag.dll" Alias "f07grc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07grc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpptrs Lib "CLW3225DA_nag.dll" Alias "f07gsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07gsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zppequ Lib "CLW3225DA_nag.dll" Alias "f07gtc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07gtc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zppcon Lib "CLW3225DA_nag.dll" Alias "f07guc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07guc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpprfs Lib "CLW3225DA_nag.dll" Alias "f07gvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07gvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpptri Lib "CLW3225DA_nag.dll" Alias "f07gwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07gwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbsv Lib "CLW3225DA_nag.dll" Alias "f07hac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbsvx Lib "CLW3225DA_nag.dll" Alias "f07hbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbtrf Lib "CLW3225DA_nag.dll" Alias "f07hdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbtrs Lib "CLW3225DA_nag.dll" Alias "f07hec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbequ Lib "CLW3225DA_nag.dll" Alias "f07hfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07hfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbcon Lib "CLW3225DA_nag.dll" Alias "f07hgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07hgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbrfs Lib "CLW3225DA_nag.dll" Alias "f07hhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07hhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Double(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbsv Lib "CLW3225DA_nag.dll" Alias "f07hnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbsvx Lib "CLW3225DA_nag.dll" Alias "f07hpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07hpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    ByVal equed As Nag_EquilibrationType, _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbtrf Lib "CLW3225DA_nag.dll" Alias "f07hrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbtrs Lib "CLW3225DA_nag.dll" Alias "f07hsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07hsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbequ Lib "CLW3225DA_nag.dll" Alias "f07htc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07htc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal s As Double(), _
    ByRef scond As Double, _
    ByRef amax As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbcon Lib "CLW3225DA_nag.dll" Alias "f07huc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07huc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbrfs Lib "CLW3225DA_nag.dll" Alias "f07hvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07hvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal afb As Complex(), _
    ByVal pdafb As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dptsv Lib "CLW3225DA_nag.dll" Alias "f07jac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07jac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dptsvx Lib "CLW3225DA_nag.dll" Alias "f07jbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal ef As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal ef As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpttrf Lib "CLW3225DA_nag.dll" Alias "f07jdc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpttrs Lib "CLW3225DA_nag.dll" Alias "f07jec" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07jec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dptcon Lib "CLW3225DA_nag.dll" Alias "f07jgc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07jgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dptrfs Lib "CLW3225DA_nag.dll" Alias "f07jhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal ef As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07jhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal ef As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zptsv Lib "CLW3225DA_nag.dll" Alias "f07jnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07jnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zptsvx Lib "CLW3225DA_nag.dll" Alias "f07jpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal ef As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07jpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In](),Out()> ByVal df As Double(), _
    <[In](),Out()> ByVal ef As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpttrf Lib "CLW3225DA_nag.dll" Alias "f07jrc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07jrc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpttrs Lib "CLW3225DA_nag.dll" Alias "f07jsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07jsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zptcon Lib "CLW3225DA_nag.dll" Alias "f07juc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07juc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zptrfs Lib "CLW3225DA_nag.dll" Alias "f07jvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal ef As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07jvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Complex(), _
    <[In]()> ByVal df As Double(), _
    <[In]()> ByVal ef As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpstrf Lib "CLW3225DA_nag.dll" Alias "f07kdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal piv As Integer(), _
    ByRef rank As Integer, _
    ByVal tol As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07kdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal piv As Integer(), _
    ByRef rank As Integer, _
    ByVal tol As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpstrf Lib "CLW3225DA_nag.dll" Alias "f07krc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal piv As Integer(), _
    ByRef rank As Integer, _
    ByVal tol As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07krc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal piv As Integer(), _
    ByRef rank As Integer, _
    ByVal tol As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsysv Lib "CLW3225DA_nag.dll" Alias "f07mac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07mac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsysvx Lib "CLW3225DA_nag.dll" Alias "f07mbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07mbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsytrf Lib "CLW3225DA_nag.dll" Alias "f07mdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07mdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsytrs Lib "CLW3225DA_nag.dll" Alias "f07mec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07mec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsycon Lib "CLW3225DA_nag.dll" Alias "f07mgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07mgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsyrfs Lib "CLW3225DA_nag.dll" Alias "f07mhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07mhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Double(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsytri Lib "CLW3225DA_nag.dll" Alias "f07mjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07mjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhesv Lib "CLW3225DA_nag.dll" Alias "f07mnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07mnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhesvx Lib "CLW3225DA_nag.dll" Alias "f07mpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07mpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhetrf Lib "CLW3225DA_nag.dll" Alias "f07mrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07mrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhetrs Lib "CLW3225DA_nag.dll" Alias "f07msc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07msc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhecon Lib "CLW3225DA_nag.dll" Alias "f07muc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07muc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zherfs Lib "CLW3225DA_nag.dll" Alias "f07mvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07mvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhetri Lib "CLW3225DA_nag.dll" Alias "f07mwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07mwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsysv Lib "CLW3225DA_nag.dll" Alias "f07nnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07nnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zsysvx Lib "CLW3225DA_nag.dll" Alias "f07npc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07npc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsytrf Lib "CLW3225DA_nag.dll" Alias "f07nrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07nrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsytrs Lib "CLW3225DA_nag.dll" Alias "f07nsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07nsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zsycon Lib "CLW3225DA_nag.dll" Alias "f07nuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07nuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zsyrfs Lib "CLW3225DA_nag.dll" Alias "f07nvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07nvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal af As Complex(), _
    ByVal pdaf As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsytri Lib "CLW3225DA_nag.dll" Alias "f07nwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07nwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dspsv Lib "CLW3225DA_nag.dll" Alias "f07pac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07pac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspsvx Lib "CLW3225DA_nag.dll" Alias "f07pbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal afp As Double(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07pbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal afp As Double(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsptrf Lib "CLW3225DA_nag.dll" Alias "f07pdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07pdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsptrs Lib "CLW3225DA_nag.dll" Alias "f07pec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07pec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspcon Lib "CLW3225DA_nag.dll" Alias "f07pgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07pgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsprfs Lib "CLW3225DA_nag.dll" Alias "f07phc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal afp As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07phc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal afp As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsptri Lib "CLW3225DA_nag.dll" Alias "f07pjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07pjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpsv Lib "CLW3225DA_nag.dll" Alias "f07pnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07pnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpsvx Lib "CLW3225DA_nag.dll" Alias "f07ppc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07ppc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhptrf Lib "CLW3225DA_nag.dll" Alias "f07prc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07prc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhptrs Lib "CLW3225DA_nag.dll" Alias "f07psc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07psc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpcon Lib "CLW3225DA_nag.dll" Alias "f07puc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07puc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhprfs Lib "CLW3225DA_nag.dll" Alias "f07pvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07pvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhptri Lib "CLW3225DA_nag.dll" Alias "f07pwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07pwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zspsv Lib "CLW3225DA_nag.dll" Alias "f07qnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07qnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zspsvx Lib "CLW3225DA_nag.dll" Alias "f07qpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07qpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal fact As Nag_FactoredFormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal afp As Complex(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef rcond As Double, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsptrf Lib "CLW3225DA_nag.dll" Alias "f07qrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07qrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsptrs Lib "CLW3225DA_nag.dll" Alias "f07qsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07qsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zspcon Lib "CLW3225DA_nag.dll" Alias "f07quc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07quc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zsprfs Lib "CLW3225DA_nag.dll" Alias "f07qvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07qvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal afp As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsptri Lib "CLW3225DA_nag.dll" Alias "f07qwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f07qwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal ipiv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrtrs Lib "CLW3225DA_nag.dll" Alias "f07tec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07tec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrcon Lib "CLW3225DA_nag.dll" Alias "f07tgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07tgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrrfs Lib "CLW3225DA_nag.dll" Alias "f07thc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07thc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrtri Lib "CLW3225DA_nag.dll" Alias "f07tjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07tjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrtrs Lib "CLW3225DA_nag.dll" Alias "f07tsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07tsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrcon Lib "CLW3225DA_nag.dll" Alias "f07tuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07tuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrrfs Lib "CLW3225DA_nag.dll" Alias "f07tvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07tvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrtri Lib "CLW3225DA_nag.dll" Alias "f07twc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07twc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtptrs Lib "CLW3225DA_nag.dll" Alias "f07uec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07uec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtpcon Lib "CLW3225DA_nag.dll" Alias "f07ugc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07ugc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtprfs Lib "CLW3225DA_nag.dll" Alias "f07uhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07uhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtptri Lib "CLW3225DA_nag.dll" Alias "f07ujc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07ujc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztptrs Lib "CLW3225DA_nag.dll" Alias "f07usc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07usc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztpcon Lib "CLW3225DA_nag.dll" Alias "f07uuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07uuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztprfs Lib "CLW3225DA_nag.dll" Alias "f07uvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07uvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztptri Lib "CLW3225DA_nag.dll" Alias "f07uwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07uwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtbtrs Lib "CLW3225DA_nag.dll" Alias "f07vec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07vec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtbcon Lib "CLW3225DA_nag.dll" Alias "f07vgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07vgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtbrfs Lib "CLW3225DA_nag.dll" Alias "f07vhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07vhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztbtrs Lib "CLW3225DA_nag.dll" Alias "f07vsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07vsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztbcon Lib "CLW3225DA_nag.dll" Alias "f07vuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )

   Declare Sub f07vuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef rcond As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztbrfs Lib "CLW3225DA_nag.dll" Alias "f07vvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07vvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpftrf Lib "CLW3225DA_nag.dll" Alias "f07wdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07wdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpftrs Lib "CLW3225DA_nag.dll" Alias "f07wec" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ar As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07wec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ar As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpftri Lib "CLW3225DA_nag.dll" Alias "f07wjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07wjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtftri Lib "CLW3225DA_nag.dll" Alias "f07wkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f07wkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpftrf Lib "CLW3225DA_nag.dll" Alias "f07wrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07wrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zpftrs Lib "CLW3225DA_nag.dll" Alias "f07wsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f07wsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In]()> ByVal ar As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpftri Lib "CLW3225DA_nag.dll" Alias "f07wwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07wwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztftri Lib "CLW3225DA_nag.dll" Alias "f07wxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f07wxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ar As Complex(), _
    ByRef info As NagError _
   )


' chapter f08

   Declare Sub nag_dgels Lib "CLW3225DA_nag.dll" Alias "f08aac" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08aac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeqrt Lib "CLW3225DA_nag.dll" Alias "f08abc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08abc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgemqrt Lib "CLW3225DA_nag.dll" Alias "f08acc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08acc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeqrf Lib "CLW3225DA_nag.dll" Alias "f08aec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08aec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorgqr Lib "CLW3225DA_nag.dll" Alias "f08afc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08afc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormqr Lib "CLW3225DA_nag.dll" Alias "f08agc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08agc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgelqf Lib "CLW3225DA_nag.dll" Alias "f08ahc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08ahc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorglq Lib "CLW3225DA_nag.dll" Alias "f08ajc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08ajc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormlq Lib "CLW3225DA_nag.dll" Alias "f08akc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08akc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgels Lib "CLW3225DA_nag.dll" Alias "f08anc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08anc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeqrt Lib "CLW3225DA_nag.dll" Alias "f08apc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08apc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgemqrt Lib "CLW3225DA_nag.dll" Alias "f08aqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeqrf Lib "CLW3225DA_nag.dll" Alias "f08asc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08asc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zungqr Lib "CLW3225DA_nag.dll" Alias "f08atc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08atc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmqr Lib "CLW3225DA_nag.dll" Alias "f08auc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08auc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgelqf Lib "CLW3225DA_nag.dll" Alias "f08avc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08avc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunglq Lib "CLW3225DA_nag.dll" Alias "f08awc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08awc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmlq Lib "CLW3225DA_nag.dll" Alias "f08axc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08axc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgelsy Lib "CLW3225DA_nag.dll" Alias "f08bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtpqrt Lib "CLW3225DA_nag.dll" Alias "f08bbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtpmqrt Lib "CLW3225DA_nag.dll" Alias "f08bcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c1 As Double(), _
    ByVal pdc1 As Integer, _
    <[In](),Out()> ByVal c2 As Double(), _
    ByVal pdc2 As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c1 As Double(), _
    ByVal pdc1 As Integer, _
    <[In](),Out()> ByVal c2 As Double(), _
    ByVal pdc2 As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeqpf Lib "CLW3225DA_nag.dll" Alias "f08bec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08bec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeqp3 Lib "CLW3225DA_nag.dll" Alias "f08bfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtzrzf Lib "CLW3225DA_nag.dll" Alias "f08bhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormrz Lib "CLW3225DA_nag.dll" Alias "f08bkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgelsy Lib "CLW3225DA_nag.dll" Alias "f08bnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztpqrt Lib "CLW3225DA_nag.dll" Alias "f08bpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztpmqrt Lib "CLW3225DA_nag.dll" Alias "f08bqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c1 As Complex(), _
    ByVal pdc1 As Integer, _
    <[In](),Out()> ByVal c2 As Complex(), _
    ByVal pdc2 As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal c1 As Complex(), _
    ByVal pdc1 As Integer, _
    <[In](),Out()> ByVal c2 As Complex(), _
    ByVal pdc2 As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeqpf Lib "CLW3225DA_nag.dll" Alias "f08bsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08bsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeqp3 Lib "CLW3225DA_nag.dll" Alias "f08btc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08btc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal jpvt As Integer(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_ztzrzf Lib "CLW3225DA_nag.dll" Alias "f08bvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08bvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmrz Lib "CLW3225DA_nag.dll" Alias "f08bxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08bxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeqlf Lib "CLW3225DA_nag.dll" Alias "f08cec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08cec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorgql Lib "CLW3225DA_nag.dll" Alias "f08cfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08cfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormql Lib "CLW3225DA_nag.dll" Alias "f08cgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08cgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgerqf Lib "CLW3225DA_nag.dll" Alias "f08chc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08chc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorgrq Lib "CLW3225DA_nag.dll" Alias "f08cjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08cjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormrq Lib "CLW3225DA_nag.dll" Alias "f08ckc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ckc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeqlf Lib "CLW3225DA_nag.dll" Alias "f08csc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08csc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zungql Lib "CLW3225DA_nag.dll" Alias "f08ctc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ctc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmql Lib "CLW3225DA_nag.dll" Alias "f08cuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08cuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgerqf Lib "CLW3225DA_nag.dll" Alias "f08cvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08cvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zungrq Lib "CLW3225DA_nag.dll" Alias "f08cwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08cwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmrq Lib "CLW3225DA_nag.dll" Alias "f08cxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08cxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsyev Lib "CLW3225DA_nag.dll" Alias "f08fac" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08fac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsyevx Lib "CLW3225DA_nag.dll" Alias "f08fbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsyevd Lib "CLW3225DA_nag.dll" Alias "f08fcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsyevr Lib "CLW3225DA_nag.dll" Alias "f08fdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsytrd Lib "CLW3225DA_nag.dll" Alias "f08fec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08fec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorgtr Lib "CLW3225DA_nag.dll" Alias "f08ffc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormtr Lib "CLW3225DA_nag.dll" Alias "f08fgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08fgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ddisna Lib "CLW3225DA_nag.dll" Alias "f08flc" ( _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <Out()> ByVal sep As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08flc Lib "CLW3225DA_nag.dll" ( _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <Out()> ByVal sep As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zheev Lib "CLW3225DA_nag.dll" Alias "f08fnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08fnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zheevx Lib "CLW3225DA_nag.dll" Alias "f08fpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08fpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zheevd Lib "CLW3225DA_nag.dll" Alias "f08fqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08fqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zheevr Lib "CLW3225DA_nag.dll" Alias "f08frc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08frc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhetrd Lib "CLW3225DA_nag.dll" Alias "f08fsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08fsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zungtr Lib "CLW3225DA_nag.dll" Alias "f08ftc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ftc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmtr Lib "CLW3225DA_nag.dll" Alias "f08fuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08fuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspev Lib "CLW3225DA_nag.dll" Alias "f08gac" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspevx Lib "CLW3225DA_nag.dll" Alias "f08gbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dspevd Lib "CLW3225DA_nag.dll" Alias "f08gcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsptrd Lib "CLW3225DA_nag.dll" Alias "f08gec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08gec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dopgtr Lib "CLW3225DA_nag.dll" Alias "f08gfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal tau As Double(), _
    <Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal tau As Double(), _
    <Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dopmtr Lib "CLW3225DA_nag.dll" Alias "f08ggc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ggc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpev Lib "CLW3225DA_nag.dll" Alias "f08gnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpevx Lib "CLW3225DA_nag.dll" Alias "f08gpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08gpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpevd Lib "CLW3225DA_nag.dll" Alias "f08gqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhptrd Lib "CLW3225DA_nag.dll" Alias "f08gsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08gsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zupgtr Lib "CLW3225DA_nag.dll" Alias "f08gtc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal tau As Complex(), _
    <Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08gtc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal tau As Complex(), _
    <Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zupmtr Lib "CLW3225DA_nag.dll" Alias "f08guc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08guc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbev Lib "CLW3225DA_nag.dll" Alias "f08hac" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbevx Lib "CLW3225DA_nag.dll" Alias "f08hbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal kd As Integer, <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, <Out()> ByVal q As Double(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal kd As Integer, <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, <Out()> ByVal q As Double(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_dsbevd Lib "CLW3225DA_nag.dll" Alias "f08hcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbtrd Lib "CLW3225DA_nag.dll" Alias "f08hec" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbev Lib "CLW3225DA_nag.dll" Alias "f08hnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbevx Lib "CLW3225DA_nag.dll" Alias "f08hpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal kd As Integer, <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, <Out()> ByVal q As Complex(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08hpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal kd As Integer, <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, <Out()> ByVal q As Complex(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_zhbevd Lib "CLW3225DA_nag.dll" Alias "f08hqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbtrd Lib "CLW3225DA_nag.dll" Alias "f08hsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08hsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kd As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dstev Lib "CLW3225DA_nag.dll" Alias "f08jac" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dstevx Lib "CLW3225DA_nag.dll" Alias "f08jbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dstevd Lib "CLW3225DA_nag.dll" Alias "f08jcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dstevr Lib "CLW3225DA_nag.dll" Alias "f08jdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsteqr Lib "CLW3225DA_nag.dll" Alias "f08jec" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsterf Lib "CLW3225DA_nag.dll" Alias "f08jfc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08jfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dpteqr Lib "CLW3225DA_nag.dll" Alias "f08jgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dstedc Lib "CLW3225DA_nag.dll" Alias "f08jhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeEigVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeEigVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dstebz Lib "CLW3225DA_nag.dll" Alias "f08jjc" ( _
    ByVal range As Nag_RangeType, _
    ByVal rank As Nag_EigValRankType, _
    ByVal n As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByRef m As Integer, _
    ByRef nsplit As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal iblock As Integer(), _
    <Out()> ByVal isplit As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f08jjc Lib "CLW3225DA_nag.dll" ( _
    ByVal range As Nag_RangeType, _
    ByVal rank As Nag_EigValRankType, _
    ByVal n As Integer, _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByRef m As Integer, _
    ByRef nsplit As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal iblock As Integer(), _
    <Out()> ByVal isplit As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dstein Lib "CLW3225DA_nag.dll" Alias "f08jkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal iblock As Integer(), _
    <[In]()> ByVal isplit As Integer(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal ifailv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal iblock As Integer(), _
    <[In]()> ByVal isplit As Integer(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal ifailv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dstegr Lib "CLW3225DA_nag.dll" Alias "f08jlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jlc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zsteqr Lib "CLW3225DA_nag.dll" Alias "f08jsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpteqr Lib "CLW3225DA_nag.dll" Alias "f08juc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08juc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zstedc Lib "CLW3225DA_nag.dll" Alias "f08jvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeEigVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08jvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compz As Nag_ComputeEigVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zstein Lib "CLW3225DA_nag.dll" Alias "f08jxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal iblock As Integer(), _
    <[In]()> ByVal isplit As Integer(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal ifailv As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In]()> ByVal e As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <[In]()> ByVal iblock As Integer(), _
    <[In]()> ByVal isplit As Integer(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal ifailv As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zstegr Lib "CLW3225DA_nag.dll" Alias "f08jyc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08jyc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal isuppz As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgelss Lib "CLW3225DA_nag.dll" Alias "f08kac" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgesvd Lib "CLW3225DA_nag.dll" Alias "f08kbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, _
    ByVal jobvt As Nag_ComputeVTType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal work As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08kbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, _
    ByVal jobvt As Nag_ComputeVTType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal work As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgelsd Lib "CLW3225DA_nag.dll" Alias "f08kcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgesdd Lib "CLW3225DA_nag.dll" Alias "f08kdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgebrd Lib "CLW3225DA_nag.dll" Alias "f08kec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tauq As Double(), _
    <Out()> ByVal taup As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08kec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tauq As Double(), _
    <Out()> ByVal taup As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorgbr Lib "CLW3225DA_nag.dll" Alias "f08kfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08kfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormbr Lib "CLW3225DA_nag.dll" Alias "f08kgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgejsv Lib "CLW3225DA_nag.dll" Alias "f08khc" ( _
    ByVal order as Nag_OrderType, _
    ByVal joba As Nag_Preprocess, _
    ByVal jobu As Nag_LeftVecsType, _
    ByVal jobv As Nag_RightVecsType, _
    ByVal jobr As Nag_ZeroCols, _
    ByVal jobt As Nag_TransType, _
    ByVal jobp As Nag_Perturb, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal sva As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal work As Double(), _
    <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08khc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal joba As Nag_Preprocess, _
    ByVal jobu As Nag_LeftVecsType, _
    ByVal jobv As Nag_RightVecsType, _
    ByVal jobr As Nag_ZeroCols, _
    ByVal jobt As Nag_TransType, _
    ByVal jobp As Nag_Perturb, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal sva As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <Out()> ByVal work As Double(), _
    <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgesvj Lib "CLW3225DA_nag.dll" Alias "f08kjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal joba As Nag_MatrixType, _
    ByVal jobu As Nag_LeftVecsType, _
    ByVal jobv As Nag_RightVecsType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal sva As Double(), _
    ByVal mv As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal joba As Nag_MatrixType, _
    ByVal jobu As Nag_LeftVecsType, _
    ByVal jobv As Nag_RightVecsType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal sva As Double(), _
    ByVal mv As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgelss Lib "CLW3225DA_nag.dll" Alias "f08knc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08knc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgesvd Lib "CLW3225DA_nag.dll" Alias "f08kpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, _
    ByVal jobvt As Nag_ComputeVTType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal rwork As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08kpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, _
    ByVal jobvt As Nag_ComputeVTType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal rwork As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgelsd Lib "CLW3225DA_nag.dll" Alias "f08kqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal s As Double(), _
    ByVal rcond As Double, _
    ByRef rank As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgesdd Lib "CLW3225DA_nag.dll" Alias "f08krc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08krc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgebrd Lib "CLW3225DA_nag.dll" Alias "f08ksc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tauq As Complex(), _
    <Out()> ByVal taup As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ksc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal tauq As Complex(), _
    <Out()> ByVal taup As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zungbr Lib "CLW3225DA_nag.dll" Alias "f08ktc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ktc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmbr Lib "CLW3225DA_nag.dll" Alias "f08kuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08kuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgbbrd Lib "CLW3225DA_nag.dll" Alias "f08lec" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ncc As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <Out()> ByVal pt As Double(), _
    ByVal pdpt As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08lec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ncc As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <Out()> ByVal pt As Double(), _
    ByVal pdpt As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgbbrd Lib "CLW3225DA_nag.dll" Alias "f08lsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ncc As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <Out()> ByVal pt As Complex(), _
    ByVal pdpt As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08lsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ncc As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <Out()> ByVal pt As Complex(), _
    ByVal pdpt As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dbdsdc Lib "CLW3225DA_nag.dll" Alias "f08mdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal compq As Nag_ComputeSingularVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal iq As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08mdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal compq As Nag_ComputeSingularVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <Out()> ByVal q As Double(), _
    <Out()> ByVal iq As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dbdsqr Lib "CLW3225DA_nag.dll" Alias "f08mec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ncvt As Integer, _
    ByVal nru As Integer, _
    ByVal ncc As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08mec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ncvt As Integer, _
    ByVal nru As Integer, _
    ByVal ncc As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal vt As Double(), _
    ByVal pdvt As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal pdu As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zbdsqr Lib "CLW3225DA_nag.dll" Alias "f08msc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ncvt As Integer, _
    ByVal nru As Integer, _
    ByVal ncc As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08msc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ncvt As Integer, _
    ByVal nru As Integer, _
    ByVal ncc As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <[In](),Out()> ByVal e As Double(), _
    <[In](),Out()> ByVal vt As Complex(), _
    ByVal pdvt As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeev Lib "CLW3225DA_nag.dll" Alias "f08nac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08nac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgeevx Lib "CLW3225DA_nag.dll" Alias "f08nbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <Out()> ByVal wr As Double(), <Out()> ByVal wi As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, ByRef ilo As Integer, ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), ByRef abnrm As Double, <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )

   Declare Sub f08nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <Out()> ByVal wr As Double(), <Out()> ByVal wi As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, ByRef ilo As Integer, ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), ByRef abnrm As Double, <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )


   Declare Sub nag_dgehrd Lib "CLW3225DA_nag.dll" Alias "f08nec" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08nec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dorghr Lib "CLW3225DA_nag.dll" Alias "f08nfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08nfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dormhr Lib "CLW3225DA_nag.dll" Alias "f08ngc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ngc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgebal Lib "CLW3225DA_nag.dll" Alias "f08nhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08nhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgebak Lib "CLW3225DA_nag.dll" Alias "f08njc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal dnscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08njc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal dnscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeev Lib "CLW3225DA_nag.dll" Alias "f08nnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08nnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgeevx Lib "CLW3225DA_nag.dll" Alias "f08npc" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef abnrm As Double, _
    <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08npc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef abnrm As Double, _
    <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgehrd Lib "CLW3225DA_nag.dll" Alias "f08nsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08nsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunghr Lib "CLW3225DA_nag.dll" Alias "f08ntc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ntc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zunmhr Lib "CLW3225DA_nag.dll" Alias "f08nuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08nuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal tau As Complex(), _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zgebal Lib "CLW3225DA_nag.dll" Alias "f08nvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08nvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal dnscale As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgebak Lib "CLW3225DA_nag.dll" Alias "f08nwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal dnscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08nwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal dnscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_dgees_sel_DELEGATE( _
    ByVal wr As Double, _
    ByVal wi As Double _
  ) as Integer

   Declare Function F08PAZ Lib "CLW3225DA_nag.dll" ( _
    ByVal wr As Double, _
    ByVal wi As Double _
  ) as Integer

   Declare Sub nag_dgees Lib "CLW3225DA_nag.dll" Alias "f08pac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As nag_dgees_sel_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vs As Double(), _
    ByVal pdvs As Integer, _
    ByRef info As NagError _
   )

Delegate Function f08pac_sel_DELEGATE( _
    ByVal wr As Double, _
    ByVal wi As Double _
  ) as Integer


   Declare Sub f08pac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As f08pac_sel_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vs As Double(), _
    ByVal pdvs As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_dgeesx_sel_DELEGATE( _
    ByVal wr As Double, _
    ByVal wi As Double _
  ) as Integer


   Declare Sub nag_dgeesx Lib "CLW3225DA_nag.dll" Alias "f08pbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As nag_dgeesx_sel_DELEGATE, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vs As Double(), _
    ByVal pdvs As Integer, _
    ByRef rconde As Double, _
    ByRef rcondv As Double, _
    ByRef info As NagError _
   )

Delegate Function f08pbc_sel_DELEGATE( _
    ByVal wr As Double, _
    ByVal wi As Double _
  ) as Integer


   Declare Sub f08pbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As f08pbc_sel_DELEGATE, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <Out()> ByVal vs As Double(), _
    ByVal pdvs As Integer, _
    ByRef rconde As Double, _
    ByRef rcondv As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dhseqr Lib "CLW3225DA_nag.dll" Alias "f08pec" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08pec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dhsein Lib "CLW3225DA_nag.dll" Alias "f08pkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal eig_source As Nag_EigValsSourceType, _
    ByVal initv As Nag_InitVeenumtype, _
    <[In](),Out()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    <[In](),Out()> ByVal wr As Double(), _
    <[In]()> ByVal wi As Double(), _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal ifaill As Integer(), _
    <Out()> ByVal ifailr As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08pkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal eig_source As Nag_EigValsSourceType, _
    ByVal initv As Nag_InitVeenumtype, _
    <[In](),Out()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    <[In](),Out()> ByVal wr As Double(), _
    <[In]()> ByVal wi As Double(), _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal ifaill As Integer(), _
    <Out()> ByVal ifailr As Integer(), _
    ByRef info As NagError _
   )


Delegate Function nag_zgees_sel_DELEGATE( _
    ByVal w As Complex _
  ) as Integer

   Declare Function F08PNZ Lib "CLW3225DA_nag.dll" ( _
    ByVal w As Complex _
  ) as Integer

   Declare Sub nag_zgees Lib "CLW3225DA_nag.dll" Alias "f08pnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As nag_zgees_sel_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vs As Complex(), _
    ByVal pdvs As Integer, _
    ByRef info As NagError _
   )

Delegate Function f08pnc_sel_DELEGATE( _
    ByVal w As Complex _
  ) as Integer


   Declare Sub f08pnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As f08pnc_sel_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vs As Complex(), _
    ByVal pdvs As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_zgeesx_sel_DELEGATE( _
    ByVal w As Complex _
  ) as Integer


   Declare Sub nag_zgeesx Lib "CLW3225DA_nag.dll" Alias "f08ppc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As nag_zgeesx_sel_DELEGATE, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vs As Complex(), _
    ByVal pdvs As Integer, _
    ByRef rconde As Double, _
    ByRef rcondv As Double, _
    ByRef info As NagError _
   )

Delegate Function f08ppc_sel_DELEGATE( _
    ByVal w As Complex _
  ) as Integer


   Declare Sub f08ppc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvs As Nag_JobType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal sel As f08ppc_sel_DELEGATE, _
    ByVal sense As Nag_RCondType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal w As Complex(), _
    <Out()> ByVal vs As Complex(), _
    ByVal pdvs As Integer, _
    ByRef rconde As Double, _
    ByRef rcondv As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhseqr Lib "CLW3225DA_nag.dll" Alias "f08psc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal h As Complex(), _
    ByVal pdh As Integer, _
    <Out()> ByVal w As Complex(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08psc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal h As Complex(), _
    ByVal pdh As Integer, _
    <Out()> ByVal w As Complex(), _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhsein Lib "CLW3225DA_nag.dll" Alias "f08pxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal eig_source As Nag_EigValsSourceType, _
    ByVal initv As Nag_InitVeenumtype, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal h As Complex(), _
    ByVal pdh As Integer, _
    <[In](),Out()> ByVal w As Complex(), _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal ifaill As Integer(), _
    <Out()> ByVal ifailr As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08pxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal eig_source As Nag_EigValsSourceType, _
    ByVal initv As Nag_InitVeenumtype, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal h As Complex(), _
    ByVal pdh As Integer, _
    <[In](),Out()> ByVal w As Complex(), _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    <Out()> ByVal ifaill As Integer(), _
    <Out()> ByVal ifailr As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrexc Lib "CLW3225DA_nag.dll" Alias "f08qfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    ByRef ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrsen Lib "CLW3225DA_nag.dll" Alias "f08qgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    ByRef m As Integer, _
    ByRef s As Double, _
    ByRef sep As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08qgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <Out()> ByVal wr As Double(), _
    <Out()> ByVal wi As Double(), _
    ByRef m As Integer, _
    ByRef s As Double, _
    ByRef sep As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrsyl Lib "CLW3225DA_nag.dll" Alias "f08qhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trana As Nag_TransType, _
    ByVal tranb As Nag_TransType, _
    ByVal sign As Nag_SignType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef dnscale As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08qhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trana As Nag_TransType, _
    ByVal tranb As Nag_TransType, _
    ByVal sign As Nag_SignType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef dnscale As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrevc Lib "CLW3225DA_nag.dll" Alias "f08qkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In](),Out()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In](),Out()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtrsna Lib "CLW3225DA_nag.dll" Alias "f08qlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In]()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal sep As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qlc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal pdt As Integer, _
    <[In]()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal sep As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrexc Lib "CLW3225DA_nag.dll" Alias "f08qtc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByVal ifst As Integer, _
    ByVal ilst As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qtc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    ByVal ifst As Integer, _
    ByVal ilst As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrsen Lib "CLW3225DA_nag.dll" Alias "f08quc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <Out()> ByVal w As Complex(), _
    ByRef m As Integer, _
    ByRef s As Double, _
    ByRef sep As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08quc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <Out()> ByVal w As Complex(), _
    ByRef m As Integer, _
    ByRef s As Double, _
    ByRef sep As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrsyl Lib "CLW3225DA_nag.dll" Alias "f08qvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trana As Nag_TransType, _
    ByVal tranb As Nag_TransType, _
    ByVal sign As Nag_SignType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef scal As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08qvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trana As Nag_TransType, _
    ByVal tranb As Nag_TransType, _
    ByVal sign As Nag_SignType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef scal As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrevc Lib "CLW3225DA_nag.dll" Alias "f08qxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztrsna Lib "CLW3225DA_nag.dll" Alias "f08qyc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In]()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal sep As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08qyc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal t As Complex(), _
    ByVal pdt As Integer, _
    <[In]()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal sep As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dorcsd Lib "CLW3225DA_nag.dll" Alias "f08rac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu1 As Nag_ComputeUType, ByVal jobu2 As Nag_ComputeUType, ByVal jobv1t As Nag_ComputeVTType, _
    ByVal jobv2t As Nag_ComputeVTType, ByVal signs As Nag_SignsType, ByVal m As Integer, _
    ByVal p As Integer, ByVal q As Integer, <[In](),Out()> ByVal x11 As Double(), _
    ByVal pdx11 As Integer, <[In](),Out()> ByVal x12 As Double(), ByVal pdx12 As Integer, _
    <[In](),Out()> ByVal x21 As Double(), ByVal pdx21 As Integer, <[In](),Out()> ByVal x22 As Double(), _
    ByVal pdx22 As Integer, <Out()> ByVal theta As Double(), <Out()> ByVal u1 As Double(), _
    ByVal pdu1 As Integer, <Out()> ByVal u2 As Double(), ByVal pdu2 As Integer, _
    <Out()> ByVal v1t As Double(), ByVal pdv1t As Integer, <Out()> ByVal v2t As Double(), _
    ByVal pdv2t As Integer, ByRef info As NagError _
   )

   Declare Sub f08rac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu1 As Nag_ComputeUType, ByVal jobu2 As Nag_ComputeUType, ByVal jobv1t As Nag_ComputeVTType, _
    ByVal jobv2t As Nag_ComputeVTType, ByVal signs As Nag_SignsType, ByVal m As Integer, _
    ByVal p As Integer, ByVal q As Integer, <[In](),Out()> ByVal x11 As Double(), _
    ByVal pdx11 As Integer, <[In](),Out()> ByVal x12 As Double(), ByVal pdx12 As Integer, _
    <[In](),Out()> ByVal x21 As Double(), ByVal pdx21 As Integer, <[In](),Out()> ByVal x22 As Double(), _
    ByVal pdx22 As Integer, <Out()> ByVal theta As Double(), <Out()> ByVal u1 As Double(), _
    ByVal pdu1 As Integer, <Out()> ByVal u2 As Double(), ByVal pdu2 As Integer, _
    <Out()> ByVal v1t As Double(), ByVal pdv1t As Integer, <Out()> ByVal v2t As Double(), _
    ByVal pdv2t As Integer, ByRef info As NagError _
   )


   Declare Sub nag_zuncsd Lib "CLW3225DA_nag.dll" Alias "f08rnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu1 As Nag_ComputeUType, ByVal jobu2 As Nag_ComputeUType, ByVal jobv1t As Nag_ComputeVTType, _
    ByVal jobv2t As Nag_ComputeVTType, ByVal signs As Nag_SignsType, ByVal m As Integer, _
    ByVal p As Integer, ByVal q As Integer, <[In](),Out()> ByVal x11 As Complex(), _
    ByVal pdx11 As Integer, <[In](),Out()> ByVal x12 As Complex(), ByVal pdx12 As Integer, _
    <[In](),Out()> ByVal x21 As Complex(), ByVal pdx21 As Integer, <[In](),Out()> ByVal x22 As Complex(), _
    ByVal pdx22 As Integer, <Out()> ByVal theta As Double(), <Out()> ByVal u1 As Complex(), _
    ByVal pdu1 As Integer, <Out()> ByVal u2 As Complex(), ByVal pdu2 As Integer, _
    <Out()> ByVal v1t As Complex(), ByVal pdv1t As Integer, <Out()> ByVal v2t As Complex(), _
    ByVal pdv2t As Integer, ByRef info As NagError _
   )

   Declare Sub f08rnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu1 As Nag_ComputeUType, ByVal jobu2 As Nag_ComputeUType, ByVal jobv1t As Nag_ComputeVTType, _
    ByVal jobv2t As Nag_ComputeVTType, ByVal signs As Nag_SignsType, ByVal m As Integer, _
    ByVal p As Integer, ByVal q As Integer, <[In](),Out()> ByVal x11 As Complex(), _
    ByVal pdx11 As Integer, <[In](),Out()> ByVal x12 As Complex(), ByVal pdx12 As Integer, _
    <[In](),Out()> ByVal x21 As Complex(), ByVal pdx21 As Integer, <[In](),Out()> ByVal x22 As Complex(), _
    ByVal pdx22 As Integer, <Out()> ByVal theta As Double(), <Out()> ByVal u1 As Complex(), _
    ByVal pdu1 As Integer, <Out()> ByVal u2 As Complex(), ByVal pdu2 As Integer, _
    <Out()> ByVal v1t As Complex(), ByVal pdv1t As Integer, <Out()> ByVal v2t As Complex(), _
    ByVal pdv2t As Integer, ByRef info As NagError _
   )


   Declare Sub nag_dsygv Lib "CLW3225DA_nag.dll" Alias "f08sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08sac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsygvx Lib "CLW3225DA_nag.dll" Alias "f08sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, ByVal job As Nag_JobType, ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, ByVal job As Nag_JobType, ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_dsygvd Lib "CLW3225DA_nag.dll" Alias "f08scc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08scc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsygst Lib "CLW3225DA_nag.dll" Alias "f08sec" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08sec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhegv Lib "CLW3225DA_nag.dll" Alias "f08snc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08snc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhegvx Lib "CLW3225DA_nag.dll" Alias "f08spc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, ByVal job As Nag_JobType, ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08spc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, ByVal job As Nag_JobType, ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_zhegvd Lib "CLW3225DA_nag.dll" Alias "f08sqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08sqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal w As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhegst Lib "CLW3225DA_nag.dll" Alias "f08ssc" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ssc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspgv Lib "CLW3225DA_nag.dll" Alias "f08tac" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08tac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspgvx Lib "CLW3225DA_nag.dll" Alias "f08tbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08tbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dspgvd Lib "CLW3225DA_nag.dll" Alias "f08tcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08tcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In](),Out()> ByVal bp As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dspgst Lib "CLW3225DA_nag.dll" Alias "f08tec" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal bp As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08tec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Double(), _
    <[In]()> ByVal bp As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpgv Lib "CLW3225DA_nag.dll" Alias "f08tnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08tnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpgvx Lib "CLW3225DA_nag.dll" Alias "f08tpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08tpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal range As Nag_RangeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    ByVal vl As Double, _
    ByVal vu As Double, _
    ByVal il As Integer, _
    ByVal iu As Integer, _
    ByVal abstol As Double, _
    ByRef m As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpgvd Lib "CLW3225DA_nag.dll" Alias "f08tqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08tqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal itype As Integer, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal bp As Complex(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhpgst Lib "CLW3225DA_nag.dll" Alias "f08tsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal bp As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08tsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal comp_type As Nag_ComputeType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal ap As Complex(), _
    <[In]()> ByVal bp As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbgv Lib "CLW3225DA_nag.dll" Alias "f08uac" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08uac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbgvx Lib "CLW3225DA_nag.dll" Alias "f08ubc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal ka As Integer, ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), ByVal pdab As Integer, <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, <Out()> ByVal q As Double(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08ubc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal ka As Integer, ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), ByVal pdab As Integer, <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, <Out()> ByVal q As Double(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Double(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_dsbgvd Lib "CLW3225DA_nag.dll" Alias "f08ucc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ucc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dsbgst Lib "CLW3225DA_nag.dll" Alias "f08uec" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08uec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dpbstf Lib "CLW3225DA_nag.dll" Alias "f08ufc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ufc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal bb As Double(), _
    ByVal pdbb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbgv Lib "CLW3225DA_nag.dll" Alias "f08unc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08unc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbgvx Lib "CLW3225DA_nag.dll" Alias "f08upc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal ka As Integer, ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), ByVal pdab As Integer, <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, <Out()> ByVal q As Complex(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )

   Declare Sub f08upc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, ByVal range As Nag_RangeType, ByVal uplo As Nag_UploType, _
    ByVal n As Integer, ByVal ka As Integer, ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), ByVal pdab As Integer, <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, <Out()> ByVal q As Complex(), ByVal pdq As Integer, _
    ByVal vl As Double, ByVal vu As Double, ByVal il As Integer, _
    ByVal iu As Integer, ByVal abstol As Double, ByRef m As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    <Out()> ByVal jfail As Integer(), ByRef info As NagError _
   )


   Declare Sub nag_zhbgvd Lib "CLW3225DA_nag.dll" Alias "f08uqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08uqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zhbgst Lib "CLW3225DA_nag.dll" Alias "f08usc" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08usc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal vect As Nag_VectType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal ka As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    <Out()> ByVal x As Complex(), _
    ByVal pdx As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zpbstf Lib "CLW3225DA_nag.dll" Alias "f08utc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08utc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal kb As Integer, _
    <[In](),Out()> ByVal bb As Complex(), _
    ByVal pdbb As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dggsvd Lib "CLW3225DA_nag.dll" Alias "f08vac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal n As Integer, ByVal p As Integer, _
    ByRef k As Integer, ByRef l As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal v As Double(), ByVal pdv As Integer, _
    <Out()> ByVal q As Double(), ByVal pdq As Integer, <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08vac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal n As Integer, ByVal p As Integer, _
    ByRef k As Integer, ByRef l As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal v As Double(), ByVal pdv As Integer, _
    <Out()> ByVal q As Double(), ByVal pdq As Integer, <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dggsvp Lib "CLW3225DA_nag.dll" Alias "f08vec" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal tola As Double, ByVal tolb As Double, _
    ByRef k As Integer, ByRef l As Integer, <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal v As Double(), ByVal pdv As Integer, _
    <Out()> ByVal q As Double(), ByVal pdq As Integer, ByRef info As NagError _
   )

   Declare Sub f08vec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal tola As Double, ByVal tolb As Double, _
    ByRef k As Integer, ByRef l As Integer, <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal v As Double(), ByVal pdv As Integer, _
    <Out()> ByVal q As Double(), ByVal pdq As Integer, ByRef info As NagError _
   )


   Declare Sub nag_zggsvd Lib "CLW3225DA_nag.dll" Alias "f08vnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal n As Integer, ByVal p As Integer, _
    ByRef k As Integer, ByRef l As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, <Out()> ByVal v As Complex(), ByVal pdv As Integer, _
    <Out()> ByVal q As Complex(), ByVal pdq As Integer, <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )

   Declare Sub f08vnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal n As Integer, ByVal p As Integer, _
    ByRef k As Integer, ByRef l As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, <Out()> ByVal v As Complex(), ByVal pdv As Integer, _
    <Out()> ByVal q As Complex(), ByVal pdq As Integer, <Out()> ByVal iwork As Integer(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zggsvp Lib "CLW3225DA_nag.dll" Alias "f08vsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, ByVal tola As Double, ByVal tolb As Double, _
    ByRef k As Integer, ByRef l As Integer, <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, <Out()> ByVal v As Complex(), ByVal pdv As Integer, _
    <Out()> ByVal q As Complex(), ByVal pdq As Integer, ByRef info As NagError _
   )

   Declare Sub f08vsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, ByVal tola As Double, ByVal tolb As Double, _
    ByRef k As Integer, ByRef l As Integer, <Out()> ByVal u As Complex(), _
    ByVal pdu As Integer, <Out()> ByVal v As Complex(), ByVal pdv As Integer, _
    <Out()> ByVal q As Complex(), ByVal pdq As Integer, ByRef info As NagError _
   )


   Declare Sub nag_dggev Lib "CLW3225DA_nag.dll" Alias "f08wac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dggevx Lib "CLW3225DA_nag.dll" Alias "f08wbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, ByRef ilo As Integer, ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), <Out()> ByVal rscale As Double(), ByRef abnrm As Double, _
    ByRef bbnrm As Double, <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08wbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <Out()> ByVal vl As Double(), ByVal pdvl As Integer, <Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, ByRef ilo As Integer, ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), <Out()> ByVal rscale As Double(), ByRef abnrm As Double, _
    ByRef bbnrm As Double, <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dgghrd Lib "CLW3225DA_nag.dll" Alias "f08wec" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dggbal Lib "CLW3225DA_nag.dll" Alias "f08whc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08whc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dggbak Lib "CLW3225DA_nag.dll" Alias "f08wjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal lscale As Double(), _
    <[In]()> ByVal rscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal lscale As Double(), _
    <[In]()> ByVal rscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Double(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zggev Lib "CLW3225DA_nag.dll" Alias "f08wnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvl As Nag_LeftVecsType, _
    ByVal jobvr As Nag_RightVecsType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zggevx Lib "CLW3225DA_nag.dll" Alias "f08wpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, <Out()> ByVal vr As Complex(), ByVal pdvr As Integer, _
    ByRef ilo As Integer, ByRef ihi As Integer, <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), ByRef abnrm As Double, ByRef bbnrm As Double, _
    <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )

   Declare Sub f08wpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal balanc As Nag_BalanceType, ByVal jobvl As Nag_LeftVecsType, ByVal jobvr As Nag_RightVecsType, _
    ByVal sense As Nag_RCondType, ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, <Out()> ByVal vr As Complex(), ByVal pdvr As Integer, _
    ByRef ilo As Integer, ByRef ihi As Integer, <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), ByRef abnrm As Double, ByRef bbnrm As Double, _
    <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )


   Declare Sub nag_zgghrd Lib "CLW3225DA_nag.dll" Alias "f08wsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_zggbal Lib "CLW3225DA_nag.dll" Alias "f08wvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08wvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef ilo As Integer, _
    ByRef ihi As Integer, _
    <Out()> ByVal lscale As Double(), _
    <Out()> ByVal rscale As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zggbak Lib "CLW3225DA_nag.dll" Alias "f08wwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal lscale As Double(), _
    <[In]()> ByVal rscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08wwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal side As Nag_SideType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In]()> ByVal lscale As Double(), _
    <[In]()> ByVal rscale As Double(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal v As Complex(), _
    ByVal pdv As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_dgges_selctg_DELEGATE( _
    ByVal ar As Double, _
    ByVal ai As Double, _
    ByVal b As Double _
  ) as Integer

   Declare Function F08XAZ Lib "CLW3225DA_nag.dll" ( _
    ByVal ar As Double, _
    ByVal ai As Double, _
    ByVal b As Double _
  ) as Integer

   Declare Sub nag_dgges Lib "CLW3225DA_nag.dll" Alias "f08xac" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, _
    ByVal jobvsr As Nag_RightVecsType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As nag_dgges_selctg_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal vsl As Double(), _
    ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Double(), _
    ByVal pdvsr As Integer, _
    ByRef info As NagError _
   )

Delegate Function f08xac_selctg_DELEGATE( _
    ByVal ar As Double, _
    ByVal ai As Double, _
    ByVal b As Double _
  ) as Integer


   Declare Sub f08xac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, _
    ByVal jobvsr As Nag_RightVecsType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As f08xac_selctg_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal vsl As Double(), _
    ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Double(), _
    ByVal pdvsr As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_dggesx_selctg_DELEGATE( _
    ByVal ar As Double, _
    ByVal ai As Double, _
    ByVal b As Double _
  ) as Integer


   Declare Sub nag_dggesx Lib "CLW3225DA_nag.dll" Alias "f08xbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, ByVal jobvsr As Nag_RightVecsType, ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As nag_dggesx_selctg_DELEGATE, ByVal sense As Nag_RCondType, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByRef sdim As Integer, <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal vsl As Double(), _
    ByVal pdvsl As Integer, <Out()> ByVal vsr As Double(), ByVal pdvsr As Integer, _
    <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )

Delegate Function f08xbc_selctg_DELEGATE( _
    ByVal ar As Double, _
    ByVal ai As Double, _
    ByVal b As Double _
  ) as Integer


   Declare Sub f08xbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, ByVal jobvsr As Nag_RightVecsType, ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As f08xbc_selctg_DELEGATE, ByVal sense As Nag_RCondType, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByRef sdim As Integer, <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), <Out()> ByVal vsl As Double(), _
    ByVal pdvsl As Integer, <Out()> ByVal vsr As Double(), ByVal pdvsr As Integer, _
    <Out()> ByVal rconde As Double(), <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )


   Declare Sub nag_dhgeqz Lib "CLW3225DA_nag.dll" Alias "f08xec" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08xec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), _
    <Out()> ByVal alphai As Double(), _
    <Out()> ByVal beta As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_zgges_selctg_DELEGATE( _
    ByVal a As Complex, _
    ByVal b As Complex _
  ) as Integer

   Declare Function F08XNZ Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Complex, _
    ByVal b As Complex _
  ) as Integer

   Declare Sub nag_zgges Lib "CLW3225DA_nag.dll" Alias "f08xnc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, _
    ByVal jobvsr As Nag_RightVecsType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As nag_zgges_selctg_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <Out()> ByVal vsl As Complex(), _
    ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Complex(), _
    ByVal pdvsr As Integer, _
    ByRef info As NagError _
   )

Delegate Function f08xnc_selctg_DELEGATE( _
    ByVal a As Complex, _
    ByVal b As Complex _
  ) as Integer


   Declare Sub f08xnc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, _
    ByVal jobvsr As Nag_RightVecsType, _
    ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As f08xnc_selctg_DELEGATE, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef sdim As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <Out()> ByVal vsl As Complex(), _
    ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Complex(), _
    ByVal pdvsr As Integer, _
    ByRef info As NagError _
   )


Delegate Function nag_zggesx_selctg_DELEGATE( _
    ByVal a As Complex, _
    ByVal b As Complex _
  ) as Integer


   Declare Sub nag_zggesx Lib "CLW3225DA_nag.dll" Alias "f08xpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, ByVal jobvsr As Nag_RightVecsType, ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As nag_zggesx_selctg_DELEGATE, ByVal sense As Nag_RCondType, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, ByRef sdim As Integer, <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), <Out()> ByVal vsl As Complex(), ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Complex(), ByVal pdvsr As Integer, <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )

Delegate Function f08xpc_selctg_DELEGATE( _
    ByVal a As Complex, _
    ByVal b As Complex _
  ) as Integer


   Declare Sub f08xpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobvsl As Nag_LeftVecsType, ByVal jobvsr As Nag_RightVecsType, ByVal sort As Nag_SortEigValsType, _
    ByVal selctg As f08xpc_selctg_DELEGATE, ByVal sense As Nag_RCondType, ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, ByRef sdim As Integer, <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), <Out()> ByVal vsl As Complex(), ByVal pdvsl As Integer, _
    <Out()> ByVal vsr As Complex(), ByVal pdvsr As Integer, <Out()> ByVal rconde As Double(), _
    <Out()> ByVal rcondv As Double(), ByRef info As NagError _
   )


   Declare Sub nag_zhgeqz Lib "CLW3225DA_nag.dll" Alias "f08xsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08xsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal compq As Nag_ComputeQType, _
    ByVal compz As Nag_ComputeZType, _
    ByVal n As Integer, _
    ByVal ilo As Integer, _
    ByVal ihi As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), _
    <Out()> ByVal beta As Complex(), _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtgsja Lib "CLW3225DA_nag.dll" Alias "f08yec" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    ByVal k As Integer, ByVal l As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    ByVal tola As Double, ByVal tolb As Double, <Out()> ByVal alpha As Double(), _
    <Out()> ByVal beta As Double(), <[In](),Out()> ByVal u As Double(), ByVal pdu As Integer, _
    <[In](),Out()> ByVal v As Double(), ByVal pdv As Integer, <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, ByRef ncycle As Integer, ByRef info As NagError _
   )

   Declare Sub f08yec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    ByVal k As Integer, ByVal l As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    ByVal tola As Double, ByVal tolb As Double, <Out()> ByVal alpha As Double(), _
    <Out()> ByVal beta As Double(), <[In](),Out()> ByVal u As Double(), ByVal pdu As Integer, _
    <[In](),Out()> ByVal v As Double(), ByVal pdv As Integer, <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, ByRef ncycle As Integer, ByRef info As NagError _
   )


   Declare Sub nag_dtgexc Lib "CLW3225DA_nag.dll" Alias "f08yfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal wantq As Nag_Boolean, _
    ByVal wantz As Nag_Boolean, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08yfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal wantq As Nag_Boolean, _
    ByVal wantz As Nag_Boolean, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    ByRef ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtgsen Lib "CLW3225DA_nag.dll" Alias "f08ygc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ijob As Integer, ByVal wantq As Nag_Boolean, ByVal wantz As Nag_Boolean, _
    <[In]()> ByVal sel As Nag_Boolean(), ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <[In](),Out()> ByVal q As Double(), ByVal pdq As Integer, <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, ByRef m As Integer, ByRef pl As Double, _
    ByRef pr As Double, <Out()> ByVal dif As Double(), ByRef info As NagError _
   )

   Declare Sub f08ygc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ijob As Integer, ByVal wantq As Nag_Boolean, ByVal wantz As Nag_Boolean, _
    <[In]()> ByVal sel As Nag_Boolean(), ByVal n As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Double(), ByVal pdb As Integer, _
    <Out()> ByVal alphar As Double(), <Out()> ByVal alphai As Double(), <Out()> ByVal beta As Double(), _
    <[In](),Out()> ByVal q As Double(), ByVal pdq As Integer, <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, ByRef m As Integer, ByRef pl As Double, _
    ByRef pr As Double, <Out()> ByVal dif As Double(), ByRef info As NagError _
   )


   Declare Sub nag_dtgsyl Lib "CLW3225DA_nag.dll" Alias "f08yhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal ijob As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal e As Double(), _
    ByVal pde As Integer, _
    <[In](),Out()> ByVal f As Double(), _
    ByVal pdf As Integer, _
    ByRef dnscale As Double, _
    ByRef dif As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08yhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal ijob As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal e As Double(), _
    ByVal pde As Integer, _
    <[In](),Out()> ByVal f As Double(), _
    ByVal pdf As Integer, _
    ByRef dnscale As Double, _
    ByRef dif As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtgevc Lib "CLW3225DA_nag.dll" Alias "f08ykc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ykc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dtgsna Lib "CLW3225DA_nag.dll" Alias "f08ylc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal howmny As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal dif As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ylc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal howmny As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal vl As Double(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Double(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal dif As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztgsja Lib "CLW3225DA_nag.dll" Alias "f08ysc" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    ByVal k As Integer, ByVal l As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    ByVal tola As Double, ByVal tolb As Double, <Out()> ByVal alpha As Double(), _
    <Out()> ByVal beta As Double(), <[In](),Out()> ByVal u As Complex(), ByVal pdu As Integer, _
    <[In](),Out()> ByVal v As Complex(), ByVal pdv As Integer, <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, ByRef ncycle As Integer, ByRef info As NagError _
   )

   Declare Sub f08ysc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal jobu As Nag_ComputeUType, ByVal jobv As Nag_ComputeVType, ByVal jobq As Nag_ComputeQType, _
    ByVal m As Integer, ByVal p As Integer, ByVal n As Integer, _
    ByVal k As Integer, ByVal l As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    ByVal tola As Double, ByVal tolb As Double, <Out()> ByVal alpha As Double(), _
    <Out()> ByVal beta As Double(), <[In](),Out()> ByVal u As Complex(), ByVal pdu As Integer, _
    <[In](),Out()> ByVal v As Complex(), ByVal pdv As Integer, <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, ByRef ncycle As Integer, ByRef info As NagError _
   )


   Declare Sub nag_ztgexc Lib "CLW3225DA_nag.dll" Alias "f08ytc" ( _
    ByVal order as Nag_OrderType, _
    ByVal wantq As Nag_Boolean, _
    ByVal wantz As Nag_Boolean, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByVal ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08ytc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal wantq As Nag_Boolean, _
    ByVal wantz As Nag_Boolean, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, _
    <[In](),Out()> ByVal z As Complex(), _
    ByVal pdz As Integer, _
    ByVal ifst As Integer, _
    ByRef ilst As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztgsen Lib "CLW3225DA_nag.dll" Alias "f08yuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ijob As Integer, ByVal wantq As Nag_Boolean, ByVal wantz As Nag_Boolean, _
    <[In]()> ByVal sel As Nag_Boolean(), ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, <[In](),Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    ByRef m As Integer, ByRef pl As Double, ByRef pr As Double, _
    <Out()> ByVal dif As Double(), ByRef info As NagError _
   )

   Declare Sub f08yuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ijob As Integer, ByVal wantq As Nag_Boolean, ByVal wantz As Nag_Boolean, _
    <[In]()> ByVal sel As Nag_Boolean(), ByVal n As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, <[In](),Out()> ByVal b As Complex(), ByVal pdb As Integer, _
    <Out()> ByVal alpha As Complex(), <Out()> ByVal beta As Complex(), <[In](),Out()> ByVal q As Complex(), _
    ByVal pdq As Integer, <[In](),Out()> ByVal z As Complex(), ByVal pdz As Integer, _
    ByRef m As Integer, ByRef pl As Double, ByRef pr As Double, _
    <Out()> ByVal dif As Double(), ByRef info As NagError _
   )


   Declare Sub nag_ztgsyl Lib "CLW3225DA_nag.dll" Alias "f08yvc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal ijob As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    <[In]()> ByVal d As Complex(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    <[In](),Out()> ByVal f As Complex(), _
    ByVal pdf As Integer, _
    ByRef dnscale As Double, _
    ByRef dif As Double, _
    ByRef info As NagError _
   )

   Declare Sub f08yvc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal ijob As Integer, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    <[In]()> ByVal d As Complex(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal e As Complex(), _
    ByVal pde As Integer, _
    <[In](),Out()> ByVal f As Complex(), _
    ByVal pdf As Integer, _
    ByRef dnscale As Double, _
    ByRef dif As Double, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztgevc Lib "CLW3225DA_nag.dll" Alias "f08yxc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08yxc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In](),Out()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_ztgsna Lib "CLW3225DA_nag.dll" Alias "f08yyc" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal dif As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )

   Declare Sub f08yyc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal job As Nag_JobType, _
    ByVal how_many As Nag_HowManyType, _
    <[In]()> ByVal sel As Nag_Boolean(), _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal vl As Complex(), _
    ByVal pdvl As Integer, _
    <[In]()> ByVal vr As Complex(), _
    ByVal pdvr As Integer, _
    <Out()> ByVal s As Double(), _
    <Out()> ByVal dif As Double(), _
    ByVal mm As Integer, _
    ByRef m As Integer, _
    ByRef info As NagError _
   )


   Declare Sub nag_dgglse Lib "CLW3225DA_nag.dll" Alias "f08zac" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08zac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dggglm Lib "CLW3225DA_nag.dll" Alias "f08zbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08zbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dggqrf Lib "CLW3225DA_nag.dll" Alias "f08zec" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08zec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_dggrqf Lib "CLW3225DA_nag.dll" Alias "f08zfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Double(), _
    ByRef info As NagError _
   )

   Declare Sub f08zfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Double(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zgglse Lib "CLW3225DA_nag.dll" Alias "f08znc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08znc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal c As Complex(), _
    <[In](),Out()> ByVal d As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zggglm Lib "CLW3225DA_nag.dll" Alias "f08zpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal d As Complex(), _
    <Out()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08zpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal d As Complex(), _
    <Out()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zggqrf Lib "CLW3225DA_nag.dll" Alias "f08zsc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08zsc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Complex(), _
    ByRef info As NagError _
   )


   Declare Sub nag_zggrqf Lib "CLW3225DA_nag.dll" Alias "f08ztc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Complex(), _
    ByRef info As NagError _
   )

   Declare Sub f08ztc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal taua As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    <Out()> ByVal taub As Complex(), _
    ByRef info As NagError _
   )


' chapter f11

   Declare Sub nag_sparse_nsym_basic_setup Lib "CLW3225DA_nag.dll" Alias "f11bdc" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseNsym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseNsym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_basic_solver Lib "CLW3225DA_nag.dll" Alias "f11bec" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11bec Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_basic_diagnostic Lib "CLW3225DA_nag.dll" Alias "f11bfc" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    <[In]()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11bfc Lib "CLW3225DA_nag.dll" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    <[In]()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_basic_setup Lib "CLW3225DA_nag.dll" Alias "f11brc" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseNsym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11brc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseNsym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_basic_solver Lib "CLW3225DA_nag.dll" Alias "f11bsc" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11bsc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_basic_diagnostic Lib "CLW3225DA_nag.dll" Alias "f11btc" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11btc Lib "CLW3225DA_nag.dll" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_fac Lib "CLW3225DA_nag.dll" Alias "f11dac" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal pstrat As Nag_SparseNsym_Piv, _
    ByVal milu As Nag_SparseNsym_Fact, _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <Out()> ByVal istr As Integer(), _
    <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal pstrat As Nag_SparseNsym_Piv, _
    ByVal milu As Nag_SparseNsym_Fact, _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <Out()> ByVal istr As Integer(), _
    <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_precon_ilu_solve Lib "CLW3225DA_nag.dll" Alias "f11dbc" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_fac_sol Lib "CLW3225DA_nag.dll" Alias "f11dcc" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), <[In]()> ByVal ipivp As Integer(), <[In]()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), <[In]()> ByVal b As Double(), _
    ByVal m As Integer, ByVal tol As Double, ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), ByRef rnorm As Double, ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, ByRef fail As NagError _
   )

   Declare Sub f11dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), <[In]()> ByVal ipivp As Integer(), <[In]()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), <[In]()> ByVal b As Double(), _
    ByVal m As Integer, ByVal tol As Double, ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), ByRef rnorm As Double, ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_precon_ssor_solve Lib "CLW3225DA_nag.dll" Alias "f11ddc" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_sol Lib "CLW3225DA_nag.dll" Alias "f11dec" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Double(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub f11dec Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Double(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_precon_bdilu Lib "CLW3225DA_nag.dll" Alias "f11dfc" ( _
    ByVal n As Integer, ByVal nnz As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal la As Integer, <[In](),Out()> ByVal irow As Integer(), <[In](),Out()> ByVal icol As Integer(), _
    ByVal nb As Integer, <[In]()> ByVal istb As Integer(), <[In]()> ByVal indb As Integer(), _
    ByVal lindb As Integer, <[In]()> ByVal lfill As Integer(), <[In]()> ByVal dtol As Double(), _
    ByVal pstrat As Nag_SparseNsym_Piv, ByVal milu As Nag_SparseNsym_Fact, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <Out()> ByVal istr As Integer(), <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, <Out()> ByVal npivm As Integer(), ByRef fail As NagError _
   )

   Declare Sub f11dfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal nnz As Integer, <[In](),Out()> ByVal a As Double(), _
    ByVal la As Integer, <[In](),Out()> ByVal irow As Integer(), <[In](),Out()> ByVal icol As Integer(), _
    ByVal nb As Integer, <[In]()> ByVal istb As Integer(), <[In]()> ByVal indb As Integer(), _
    ByVal lindb As Integer, <[In]()> ByVal lfill As Integer(), <[In]()> ByVal dtol As Double(), _
    ByVal pstrat As Nag_SparseNsym_Piv, ByVal milu As Nag_SparseNsym_Fact, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <Out()> ByVal istr As Integer(), <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, <Out()> ByVal npivm As Integer(), ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_precon_bdilu_solve Lib "CLW3225DA_nag.dll" Alias "f11dgc" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), ByVal nb As Integer, <[In]()> ByVal istb As Integer(), _
    <[In]()> ByVal indb As Integer(), ByVal lindb As Integer, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Double(), ByVal m As Integer, ByVal tol As Double, _
    ByVal maxitn As Integer, <[In](),Out()> ByVal x As Double(), ByRef rnorm As Double, _
    ByRef itn As Integer, ByRef fail As NagError _
   )

   Declare Sub f11dgc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), ByVal nb As Integer, <[In]()> ByVal istb As Integer(), _
    <[In]()> ByVal indb As Integer(), ByVal lindb As Integer, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Double(), ByVal m As Integer, ByVal tol As Double, _
    ByVal maxitn As Integer, <[In](),Out()> ByVal x As Double(), ByRef rnorm As Double, _
    ByRef itn As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_jacobi Lib "CLW3225DA_nag.dll" Alias "f11dkc" ( _
    ByVal store As Nag_SparseNsym_Store, _
    ByVal trans As Nag_TransType, _
    ByVal init As Nag_InitializeA, _
    ByVal niter As Integer, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal diag As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11dkc Lib "CLW3225DA_nag.dll" ( _
    ByVal store As Nag_SparseNsym_Store, _
    ByVal trans As Nag_TransType, _
    ByVal init As Nag_InitializeA, _
    ByVal niter As Integer, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal diag As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_fac Lib "CLW3225DA_nag.dll" Alias "f11dnc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal pstrat As Nag_SparseNsym_Piv, _
    ByVal milu As Nag_SparseNsym_Fact, _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <Out()> ByVal istr As Integer(), _
    <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11dnc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal pstrat As Nag_SparseNsym_Piv, _
    ByVal milu As Nag_SparseNsym_Fact, _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <Out()> ByVal istr As Integer(), _
    <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_precon_ilu_solve Lib "CLW3225DA_nag.dll" Alias "f11dpc" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11dpc Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_fac_sol Lib "CLW3225DA_nag.dll" Alias "f11dqc" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11dqc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_precon_ssor_solve Lib "CLW3225DA_nag.dll" Alias "f11drc" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Complex(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11drc Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Complex(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_sol Lib "CLW3225DA_nag.dll" Alias "f11dsc" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Complex(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11dsc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, _
    ByVal precon As Nag_SparseNsym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Complex(), _
    ByVal m As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_precon_bdilu Lib "CLW3225DA_nag.dll" Alias "f11dtc" ( _
    ByVal n As Integer, ByVal nnz As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, <[In](),Out()> ByVal irow As Integer(), <[In](),Out()> ByVal icol As Integer(), _
    ByVal nb As Integer, <[In]()> ByVal istb As Integer(), <[In]()> ByVal indb As Integer(), _
    ByVal lindb As Integer, <[In]()> ByVal lfill As Integer(), <[In]()> ByVal dtol As Double(), _
    ByVal pstrat As Nag_SparseNsym_Piv, ByVal milu As Nag_SparseNsym_Fact, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <Out()> ByVal istr As Integer(), <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, <Out()> ByVal npivm As Integer(), ByRef fail As NagError _
   )

   Declare Sub f11dtc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal nnz As Integer, <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, <[In](),Out()> ByVal irow As Integer(), <[In](),Out()> ByVal icol As Integer(), _
    ByVal nb As Integer, <[In]()> ByVal istb As Integer(), <[In]()> ByVal indb As Integer(), _
    ByVal lindb As Integer, <[In]()> ByVal lfill As Integer(), <[In]()> ByVal dtol As Double(), _
    ByVal pstrat As Nag_SparseNsym_Piv, ByVal milu As Nag_SparseNsym_Fact, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <Out()> ByVal istr As Integer(), <Out()> ByVal idiag As Integer(), _
    ByRef nnzc As Integer, <Out()> ByVal npivm As Integer(), ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_precon_bdilu_solve Lib "CLW3225DA_nag.dll" Alias "f11duc" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), ByVal nb As Integer, <[In]()> ByVal istb As Integer(), _
    <[In]()> ByVal indb As Integer(), ByVal lindb As Integer, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Complex(), ByVal m As Integer, ByVal tol As Double, _
    ByVal maxitn As Integer, <[In](),Out()> ByVal x As Complex(), ByRef rnorm As Double, _
    ByRef itn As Integer, ByRef fail As NagError _
   )

   Declare Sub f11duc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseNsym_Method, ByVal n As Integer, ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), ByVal la As Integer, <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), ByVal nb As Integer, <[In]()> ByVal istb As Integer(), _
    <[In]()> ByVal indb As Integer(), ByVal lindb As Integer, <[In](),Out()> ByVal ipivp As Integer(), _
    <[In](),Out()> ByVal ipivq As Integer(), <[In]()> ByVal istr As Integer(), <[In]()> ByVal idiag As Integer(), _
    <[In]()> ByVal b As Complex(), ByVal m As Integer, ByVal tol As Double, _
    ByVal maxitn As Integer, <[In](),Out()> ByVal x As Complex(), ByRef rnorm As Double, _
    ByRef itn As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_jacobi Lib "CLW3225DA_nag.dll" Alias "f11dxc" ( _
    ByVal store As Nag_SparseNsym_Store, _
    ByVal trans As Nag_TransType, _
    ByVal init As Nag_InitializeA, _
    ByVal niter As Integer, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal b As Complex(), _
    <Out()> ByVal x As Complex(), _
    <[In](),Out()> ByVal diag As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11dxc Lib "CLW3225DA_nag.dll" ( _
    ByVal store As Nag_SparseNsym_Store, _
    ByVal trans As Nag_TransType, _
    ByVal init As Nag_InitializeA, _
    ByVal niter As Integer, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal b As Complex(), _
    <Out()> ByVal x As Complex(), _
    <[In](),Out()> ByVal diag As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_basic_setup Lib "CLW3225DA_nag.dll" Alias "f11gdc" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal sigcmp As Nag_SparseSym_Bisection, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseSym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal sigtol As Double, _
    ByVal maxits As Integer, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11gdc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal sigcmp As Nag_SparseSym_Bisection, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseSym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal sigtol As Double, _
    ByVal maxits As Integer, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_basic_solver Lib "CLW3225DA_nag.dll" Alias "f11gec" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11gec Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_basic_diagnostic Lib "CLW3225DA_nag.dll" Alias "f11gfc" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    ByRef its As Integer, _
    ByRef sigerr As Double, _
    <[In]()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11gfc Lib "CLW3225DA_nag.dll" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    ByRef its As Integer, _
    ByRef sigerr As Double, _
    <[In]()> ByVal work As Double(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_basic_setup Lib "CLW3225DA_nag.dll" Alias "f11grc" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal sigcmp As Nag_SparseSym_Bisection, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseSym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal sigtol As Double, _
    ByVal maxits As Integer, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11grc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal sigcmp As Nag_SparseSym_Bisection, _
    ByVal norm As Nag_NormType, _
    ByVal weight As Nag_SparseSym_Weight, _
    ByVal iterm As Integer, _
    ByVal n As Integer, _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    ByVal anorm As Double, _
    ByVal sigmax As Double, _
    ByVal sigtol As Double, _
    ByVal maxits As Integer, _
    ByVal monit As Integer, _
    ByRef lwreq As Integer, _
    <Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_basic_solver Lib "CLW3225DA_nag.dll" Alias "f11gsc" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11gsc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal u As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_basic_diagnostic Lib "CLW3225DA_nag.dll" Alias "f11gtc" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    ByRef its As Integer, _
    ByRef sigerr As Double, _
    <[In]()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11gtc Lib "CLW3225DA_nag.dll" ( _
    ByRef itn As Integer, _
    ByRef stplhs As Double, _
    ByRef stprhs As Double, _
    ByRef anorm As Double, _
    ByRef sigmax As Double, _
    ByRef its As Integer, _
    ByRef sigerr As Double, _
    <[In]()> ByVal work As Complex(), _
    ByVal lwork As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_chol_fac Lib "CLW3225DA_nag.dll" Alias "f11jac" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal mic As Nag_SparseSym_Fact, _
    ByVal dscale As Double, _
    ByVal pstrat As Nag_SparseSym_Piv, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <Out()> ByVal istr As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub f11jac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal mic As Nag_SparseSym_Fact, _
    ByVal dscale As Double, _
    ByVal pstrat As Nag_SparseSym_Piv, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <Out()> ByVal istr As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_precon_ichol_solve Lib "CLW3225DA_nag.dll" Alias "f11jbc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_chol_sol Lib "CLW3225DA_nag.dll" Alias "f11jcc" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub f11jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_precon_ssor_solve Lib "CLW3225DA_nag.dll" Alias "f11jdc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_sol Lib "CLW3225DA_nag.dll" Alias "f11jec" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )

   Declare Sub f11jec Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef comm As Nag_Sparse_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_chol_fac Lib "CLW3225DA_nag.dll" Alias "f11jnc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal mic As Nag_SparseSym_Fact, _
    ByVal dscale As Double, _
    ByVal pstrat As Nag_SparseSym_Piv, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <Out()> ByVal istr As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11jnc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal lfill As Integer, _
    ByVal dtol As Double, _
    ByVal mic As Nag_SparseSym_Fact, _
    ByVal dscale As Double, _
    ByVal pstrat As Nag_SparseSym_Piv, _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <Out()> ByVal istr As Integer(), _
    ByRef nnzc As Integer, _
    ByRef npivm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_precon_ichol_solve Lib "CLW3225DA_nag.dll" Alias "f11jpc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11jpc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_chol_sol Lib "CLW3225DA_nag.dll" Alias "f11jqc" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11jqc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal la As Integer, _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In](),Out()> ByVal ipiv As Integer(), _
    <[In]()> ByVal istr As Integer(), _
    <[In]()> ByVal b As Complex(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_precon_ssor_solve Lib "CLW3225DA_nag.dll" Alias "f11jrc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11jrc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    <[In]()> ByVal rdiag As Double(), _
    ByVal omega As Double, _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal y As Complex(), _
    <Out()> ByVal x As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_sol Lib "CLW3225DA_nag.dll" Alias "f11jsc" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Complex(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    <Out()> ByVal rdiag As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11jsc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SparseSym_Method, _
    ByVal precon As Nag_SparseSym_PrecType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal omega As Double, _
    <[In]()> ByVal b As Complex(), _
    ByVal tol As Double, _
    ByVal maxitn As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByRef rnorm As Double, _
    ByRef itn As Integer, _
    <Out()> ByVal rdiag As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_column_permutation Lib "CLW3225DA_nag.dll" Alias "f11mdc" ( _
    ByVal spec As Nag_ColumnPermutationType, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In](),Out()> ByVal iprm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11mdc Lib "CLW3225DA_nag.dll" ( _
    ByVal spec As Nag_ColumnPermutationType, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In](),Out()> ByVal iprm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_lu_factorize Lib "CLW3225DA_nag.dll" Alias "f11mec" ( _
    ByVal n As Integer, _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In](),Out()> ByVal iprm As Integer(), _
    ByVal thresh As Double, _
    ByVal nzlmx As Integer, _
    ByRef nzlumx As Integer, _
    ByVal nzumx As Integer, _
    <Out()> ByVal il As Integer(), _
    <Out()> ByVal lval As Double(), _
    <Out()> ByVal iu As Integer(), _
    <Out()> ByVal uval As Double(), _
    ByRef nnzl As Integer, _
    ByRef nnzu As Integer, _
    ByRef flop As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f11mec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In](),Out()> ByVal iprm As Integer(), _
    ByVal thresh As Double, _
    ByVal nzlmx As Integer, _
    ByRef nzlumx As Integer, _
    ByVal nzumx As Integer, _
    <Out()> ByVal il As Integer(), _
    <Out()> ByVal lval As Double(), _
    <Out()> ByVal iu As Integer(), _
    <Out()> ByVal uval As Double(), _
    ByRef nnzl As Integer, _
    ByRef nnzu As Integer, _
    ByRef flop As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_solve_lu Lib "CLW3225DA_nag.dll" Alias "f11mfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11mfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal nrhs As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_condition_number_lu Lib "CLW3225DA_nag.dll" Alias "f11mgc" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f11mgc Lib "CLW3225DA_nag.dll" ( _
    ByVal norm As Nag_NormType, _
    ByVal n As Integer, _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal anorm As Double, _
    ByRef rcond As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_refine_lu Lib "CLW3225DA_nag.dll" Alias "f11mhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal nrhs As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11mhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByVal nrhs As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <Out()> ByVal ferr As Double(), _
    <Out()> ByVal berr As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_matrix_product Lib "CLW3225DA_nag.dll" Alias "f11mkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f11mkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_matrix_norm Lib "CLW3225DA_nag.dll" Alias "f11mlc" ( _
    ByVal norm As Nag_NormType, _
    ByRef anorm As Double, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11mlc Lib "CLW3225DA_nag.dll" ( _
    ByVal norm As Nag_NormType, _
    ByRef anorm As Double, _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal a As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_superlu_diagnostic_lu Lib "CLW3225DA_nag.dll" Alias "f11mmc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByRef rpg As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f11mmc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal iprm As Integer(), _
    <[In]()> ByVal il As Integer(), _
    <[In]()> ByVal lval As Double(), _
    <[In]()> ByVal iu As Integer(), _
    <[In]()> ByVal uval As Double(), _
    ByRef rpg As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_matvec Lib "CLW3225DA_nag.dll" Alias "f11xac" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11xac Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_matvec Lib "CLW3225DA_nag.dll" Alias "f11xec" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f11xec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_matvec Lib "CLW3225DA_nag.dll" Alias "f11xnc" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11xnc Lib "CLW3225DA_nag.dll" ( _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseNsym_CheckData, _
    <[In]()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_matvec Lib "CLW3225DA_nag.dll" Alias "f11xsc" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f11xsc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal a As Complex(), _
    <[In]()> ByVal irow As Integer(), _
    <[In]()> ByVal icol As Integer(), _
    ByVal check As Nag_SparseSym_CheckData, _
    <[In]()> ByVal x As Complex(), _
    <Out()> ByVal y As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_rcm Lib "CLW3225DA_nag.dll" Alias "f11yec" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal lopts As Nag_Boolean(), _
    <[In]()> ByVal mask As Integer(), _
    <Out()> ByVal perm As Integer(), _
    <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11yec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nnz As Integer, _
    <[In]()> ByVal icolzp As Integer(), _
    <[In]()> ByVal irowix As Integer(), _
    <[In]()> ByVal lopts As Nag_Boolean(), _
    <[In]()> ByVal mask As Integer(), _
    <Out()> ByVal perm As Integer(), _
    <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nsym_sort Lib "CLW3225DA_nag.dll" Alias "f11zac" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseNsym_Dups, _
    ByVal zero As Nag_SparseNsym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11zac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseNsym_Dups, _
    ByVal zero As Nag_SparseNsym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_sym_sort Lib "CLW3225DA_nag.dll" Alias "f11zbc" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseSym_Dups, _
    ByVal zero As Nag_SparseSym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11zbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseSym_Dups, _
    ByVal zero As Nag_SparseSym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_nherm_sort Lib "CLW3225DA_nag.dll" Alias "f11znc" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseNsym_Dups, _
    ByVal zero As Nag_SparseNsym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11znc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseNsym_Dups, _
    ByVal zero As Nag_SparseNsym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sparse_herm_sort Lib "CLW3225DA_nag.dll" Alias "f11zpc" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseSym_Dups, _
    ByVal zero As Nag_SparseSym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f11zpc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByRef nnz As Integer, _
    <[In](),Out()> ByVal a As Complex(), _
    <[In](),Out()> ByVal irow As Integer(), _
    <[In](),Out()> ByVal icol As Integer(), _
    ByVal dup As Nag_SparseSym_Dups, _
    ByVal zero As Nag_SparseSym_Zeros, _
    <Out()> ByVal istr As Integer(), _
    ByRef fail As NagError _
   )


' chapter f12

   Declare Sub nag_real_sparse_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12aac" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sparse_eigensystem_iter Lib "CLW3225DA_nag.dll" Alias "f12abc" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12abc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sparse_eigensystem_sol Lib "CLW3225DA_nag.dll" Alias "f12acc" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal dr As Double(), _
    <Out()> ByVal di As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal sigmar As Double, _
    ByVal sigmai As Double, _
    <[In]()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12acc Lib "CLW3225DA_nag.dll" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal dr As Double(), _
    <Out()> ByVal di As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal sigmar As Double, _
    ByVal sigmai As Double, _
    <[In]()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sparse_eigensystem_option Lib "CLW3225DA_nag.dll" Alias "f12adc" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f12adc Lib "CLW3225DA_nag.dll" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_sparse_eigensystem_monit Lib "CLW3225DA_nag.dll" Alias "f12aec" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritzr As Double(), _
    <Out()> ByVal ritzi As Double(), _
    <Out()> ByVal rzest As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Double() _
   )

   Declare Sub f12aec Lib "CLW3225DA_nag.dll" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritzr As Double(), _
    <Out()> ByVal ritzi As Double(), _
    <Out()> ByVal rzest As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Double() _
   )


   Declare Sub nag_real_banded_sparse_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12afc" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12afc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_banded_sparse_eigensystem_sol Lib "CLW3225DA_nag.dll" Alias "f12agc" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    <[In]()> ByVal mb As Double(), _
    ByVal sigmar As Double, _
    ByVal sigmai As Double, _
    ByRef nconv As Integer, _
    <Out()> ByVal dr As Double(), _
    <Out()> ByVal di As Double(), _
    <Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal resid As Double(), _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12agc Lib "CLW3225DA_nag.dll" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    <[In]()> ByVal mb As Double(), _
    ByVal sigmar As Double, _
    ByVal sigmai As Double, _
    ByRef nconv As Integer, _
    <Out()> ByVal dr As Double(), _
    <Out()> ByVal di As Double(), _
    <Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal resid As Double(), _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sparse_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12anc" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Complex(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12anc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Complex(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sparse_eigensystem_iter Lib "CLW3225DA_nag.dll" Alias "f12apc" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12apc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sparse_eigensystem_sol Lib "CLW3225DA_nag.dll" Alias "f12aqc" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Complex(), _
    <Out()> ByVal z As Complex(), _
    ByVal sigma As Complex, _
    <[In]()> ByVal resid As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12aqc Lib "CLW3225DA_nag.dll" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Complex(), _
    <Out()> ByVal z As Complex(), _
    ByVal sigma As Complex, _
    <[In]()> ByVal resid As Complex(), _
    <[In](),Out()> ByVal v As Complex(), _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sparse_eigensystem_option Lib "CLW3225DA_nag.dll" Alias "f12arc" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f12arc Lib "CLW3225DA_nag.dll" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_sparse_eigensystem_monit Lib "CLW3225DA_nag.dll" Alias "f12asc" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritz As Complex(), _
    <Out()> ByVal rzest As Complex(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Complex() _
   )

   Declare Sub f12asc Lib "CLW3225DA_nag.dll" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritz As Complex(), _
    <Out()> ByVal rzest As Complex(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Complex() _
   )


   Declare Sub nag_complex_banded_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12atc" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Complex(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12atc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Complex(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_banded_eigensystem_solve Lib "CLW3225DA_nag.dll" Alias "f12auc" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    <[In]()> ByVal mb As Complex(), _
    ByVal sigma As Complex, _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Complex(), _
    <Out()> ByVal z As Complex(), _
    <[In](),Out()> ByVal resid As Complex(), _
    <Out()> ByVal v As Complex(), _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12auc Lib "CLW3225DA_nag.dll" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    <[In]()> ByVal mb As Complex(), _
    ByVal sigma As Complex, _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Complex(), _
    <Out()> ByVal z As Complex(), _
    <[In](),Out()> ByVal resid As Complex(), _
    <Out()> ByVal v As Complex(), _
    <[In](),Out()> ByVal comm As Complex(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_sparse_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12fac" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12fac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_sparse_eigensystem_iter Lib "CLW3225DA_nag.dll" Alias "f12fbc" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12fbc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, _
    <[In](),Out()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    ByRef xPTR As IntPtr, _
    ByRef yPTR As IntPtr, _
    ByRef mxPTR As IntPtr, _
    ByRef nshift As Integer, _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_sparse_eigensystem_sol Lib "CLW3225DA_nag.dll" Alias "f12fcc" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal sigma As Double, _
    <[In]()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12fcc Lib "CLW3225DA_nag.dll" ( _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal sigma As Double, _
    <[In]()> ByVal resid As Double(), _
    <[In](),Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_sparse_eigensystem_option Lib "CLW3225DA_nag.dll" Alias "f12fdc" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f12fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal str As String, _
    <[In](),Out()> ByVal icomm As Integer(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_sparse_eigensystem_monit Lib "CLW3225DA_nag.dll" Alias "f12fec" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritz As Double(), _
    <Out()> ByVal rzest As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Double() _
   )

   Declare Sub f12fec Lib "CLW3225DA_nag.dll" ( _
    ByRef niter As Integer, _
    ByRef nconv As Integer, _
    <Out()> ByVal ritz As Double(), _
    <Out()> ByVal rzest As Double(), _
    <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal comm As Double() _
   )


   Declare Sub nag_real_symm_banded_sparse_eigensystem_init Lib "CLW3225DA_nag.dll" Alias "f12ffc" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f12ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nev As Integer, _
    ByVal ncv As Integer, _
    <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    <Out()> ByVal comm As Double(), _
    ByVal lcomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_real_symm_banded_sparse_eigensystem_sol Lib "CLW3225DA_nag.dll" Alias "f12fgc" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    <[In]()> ByVal mb As Double(), _
    ByVal sigma As Double, _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal resid As Double(), _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub f12fgc Lib "CLW3225DA_nag.dll" ( _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    <[In]()> ByVal mb As Double(), _
    ByVal sigma As Double, _
    ByRef nconv As Integer, _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal z As Double(), _
    <[In](),Out()> ByVal resid As Double(), _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByRef fail As NagError _
   )


' chapter f16

   Declare Sub nag_iload Lib "CLW3225DA_nag.dll" Alias "f16dbc" ( _
    ByVal n As Integer, _
    ByVal alpha As Integer, _
    <Out()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Integer, _
    <Out()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_isum Lib "CLW3225DA_nag.dll" Alias "f16dlc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function f16dlc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Integer


   Declare Sub nag_imax_val Lib "CLW3225DA_nag.dll" Alias "f16dnc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16dnc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_imin_val Lib "CLW3225DA_nag.dll" Alias "f16dpc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16dpc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_iamax_val Lib "CLW3225DA_nag.dll" Alias "f16dqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16dqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_iamin_val Lib "CLW3225DA_nag.dll" Alias "f16drc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16drc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Integer(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef i As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ddot Lib "CLW3225DA_nag.dll" Alias "f16eac" ( _
    ByVal conj As Nag_ConjType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16eac Lib "CLW3225DA_nag.dll" ( _
    ByVal conj As Nag_ConjType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_daxpby Lib "CLW3225DA_nag.dll" Alias "f16ecc" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dwaxpby Lib "CLW3225DA_nag.dll" Alias "f16ehc" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    <Out()> ByVal w As Double(), _
    ByVal incw As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ehc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    <Out()> ByVal w As Double(), _
    ByVal incw As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_dsum Lib "CLW3225DA_nag.dll" Alias "f16elc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function f16elc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_dload Lib "CLW3225DA_nag.dll" Alias "f16fbc" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zaxpby Lib "CLW3225DA_nag.dll" Alias "f16gcc" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zwaxpby Lib "CLW3225DA_nag.dll" Alias "f16ghc" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    <Out()> ByVal w As Complex(), _
    ByVal incw As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ghc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    <Out()> ByVal w As Complex(), _
    ByVal incw As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_zsum Lib "CLW3225DA_nag.dll" Alias "f16glc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function f16glc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   ) as Complex


   Declare Sub nag_zload Lib "CLW3225DA_nag.dll" Alias "f16hbc" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dmax_val Lib "CLW3225DA_nag.dll" Alias "f16jnc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jnc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dmin_val Lib "CLW3225DA_nag.dll" Alias "f16jpc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jpc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_damax_val Lib "CLW3225DA_nag.dll" Alias "f16jqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_damin_val Lib "CLW3225DA_nag.dll" Alias "f16jrc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jrc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zamax_val Lib "CLW3225DA_nag.dll" Alias "f16jsc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jsc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zamin_val Lib "CLW3225DA_nag.dll" Alias "f16jtc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16jtc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef k As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dgemv Lib "CLW3225DA_nag.dll" Alias "f16pac" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dgbmv Lib "CLW3225DA_nag.dll" Alias "f16pbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsymv Lib "CLW3225DA_nag.dll" Alias "f16pcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsbmv Lib "CLW3225DA_nag.dll" Alias "f16pdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dspmv Lib "CLW3225DA_nag.dll" Alias "f16pec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtrmv Lib "CLW3225DA_nag.dll" Alias "f16pfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtbmv Lib "CLW3225DA_nag.dll" Alias "f16pgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtpmv Lib "CLW3225DA_nag.dll" Alias "f16phc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16phc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtrsv Lib "CLW3225DA_nag.dll" Alias "f16pjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtbsv Lib "CLW3225DA_nag.dll" Alias "f16pkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtpsv Lib "CLW3225DA_nag.dll" Alias "f16plc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16plc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ap As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dger Lib "CLW3225DA_nag.dll" Alias "f16pmc" ( _
    ByVal order as Nag_OrderType, _
    ByVal conj As Nag_ConjType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16pmc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal conj As Nag_ConjType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsyr Lib "CLW3225DA_nag.dll" Alias "f16ppc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ppc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dspr Lib "CLW3225DA_nag.dll" Alias "f16pqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f16pqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsyr2 Lib "CLW3225DA_nag.dll" Alias "f16prc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16prc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dspr2 Lib "CLW3225DA_nag.dll" Alias "f16psc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f16psc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtr_copy Lib "CLW3225DA_nag.dll" Alias "f16qec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16qec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dge_copy Lib "CLW3225DA_nag.dll" Alias "f16qfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16qfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtr_load Lib "CLW3225DA_nag.dll" Alias "f16qgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    ByVal diag As Double, _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16qgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    ByVal diag As Double, _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dge_load Lib "CLW3225DA_nag.dll" Alias "f16qhc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    ByVal diag As Double, _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16qhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    ByVal diag As Double, _
    <Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dge_norm Lib "CLW3225DA_nag.dll" Alias "f16rac" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dgb_norm Lib "CLW3225DA_nag.dll" Alias "f16rbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsy_norm Lib "CLW3225DA_nag.dll" Alias "f16rcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsp_norm Lib "CLW3225DA_nag.dll" Alias "f16rdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Double(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsb_norm Lib "CLW3225DA_nag.dll" Alias "f16rec" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal ab As Double(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsf_norm Lib "CLW3225DA_nag.dll" Alias "f16rkc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16rkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Double(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zgemv Lib "CLW3225DA_nag.dll" Alias "f16sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zgbmv Lib "CLW3225DA_nag.dll" Alias "f16sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhemv Lib "CLW3225DA_nag.dll" Alias "f16scc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16scc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhbmv Lib "CLW3225DA_nag.dll" Alias "f16sdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhpmv Lib "CLW3225DA_nag.dll" Alias "f16sec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztrmv Lib "CLW3225DA_nag.dll" Alias "f16sfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztbmv Lib "CLW3225DA_nag.dll" Alias "f16sgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztpmv Lib "CLW3225DA_nag.dll" Alias "f16shc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16shc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztrsv Lib "CLW3225DA_nag.dll" Alias "f16sjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16sjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztbsv Lib "CLW3225DA_nag.dll" Alias "f16skc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16skc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztpsv Lib "CLW3225DA_nag.dll" Alias "f16slc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16slc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In](),Out()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zger Lib "CLW3225DA_nag.dll" Alias "f16smc" ( _
    ByVal order as Nag_OrderType, _
    ByVal conj As Nag_ConjType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16smc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal conj As Nag_ConjType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zher Lib "CLW3225DA_nag.dll" Alias "f16spc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16spc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhpr Lib "CLW3225DA_nag.dll" Alias "f16sqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f16sqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_zher2 Lib "CLW3225DA_nag.dll" Alias "f16src" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16src Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhpr2 Lib "CLW3225DA_nag.dll" Alias "f16ssc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f16ssc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    <[In]()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal ap As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsymv Lib "CLW3225DA_nag.dll" Alias "f16tac" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16tac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zspmv Lib "CLW3225DA_nag.dll" Alias "f16tcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16tcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ap As Complex(), _
    <[In]()> ByVal x As Complex(), _
    ByVal incx As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal y As Complex(), _
    ByVal incy As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztr_copy Lib "CLW3225DA_nag.dll" Alias "f16tec" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16tec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zge_copy Lib "CLW3225DA_nag.dll" Alias "f16tfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16tfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal trans As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztr_load Lib "CLW3225DA_nag.dll" Alias "f16tgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    ByVal diag As Complex, _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16tgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    ByVal diag As Complex, _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zge_load Lib "CLW3225DA_nag.dll" Alias "f16thc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    ByVal diag As Complex, _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16thc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    ByVal diag As Complex, _
    <Out()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zge_norm Lib "CLW3225DA_nag.dll" Alias "f16uac" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16uac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zgb_norm Lib "CLW3225DA_nag.dll" Alias "f16ubc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16ubc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhe_norm Lib "CLW3225DA_nag.dll" Alias "f16ucc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16ucc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhp_norm Lib "CLW3225DA_nag.dll" Alias "f16udc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16udc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhb_norm Lib "CLW3225DA_nag.dll" Alias "f16uec" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16uec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal ab As Complex(), _
    ByVal pdab As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsy_norm Lib "CLW3225DA_nag.dll" Alias "f16ufc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16ufc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsp_norm Lib "CLW3225DA_nag.dll" Alias "f16ugc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16ugc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ap As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhf_norm Lib "CLW3225DA_nag.dll" Alias "f16ukc" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )

   Declare Sub f16ukc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal norm As Nag_NormType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal n As Integer, _
    <[In]()> ByVal ar As Complex(), _
    ByRef r As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dgemm Lib "CLW3225DA_nag.dll" Alias "f16yac" ( _
    ByVal order as Nag_OrderType, _
    ByVal transa As Nag_TransType, _
    ByVal transb As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16yac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transa As Nag_TransType, _
    ByVal transb As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsymm Lib "CLW3225DA_nag.dll" Alias "f16ycc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ycc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtrmm Lib "CLW3225DA_nag.dll" Alias "f16yfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16yfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtrsm Lib "CLW3225DA_nag.dll" Alias "f16yjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16yjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dtfsm Lib "CLW3225DA_nag.dll" Alias "f16ylc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ar As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ylc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal ar As Double(), _
    <[In](),Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsyrk Lib "CLW3225DA_nag.dll" Alias "f16ypc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ypc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsfrk Lib "CLW3225DA_nag.dll" Alias "f16yqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal cr As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub f16yqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal cr As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dsyr2k Lib "CLW3225DA_nag.dll" Alias "f16yrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16yrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zgemm Lib "CLW3225DA_nag.dll" Alias "f16zac" ( _
    ByVal order as Nag_OrderType, _
    ByVal transa As Nag_TransType, _
    ByVal transb As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transa As Nag_TransType, _
    ByVal transb As Nag_TransType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhemm Lib "CLW3225DA_nag.dll" Alias "f16zcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztrmm Lib "CLW3225DA_nag.dll" Alias "f16zfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztrsm Lib "CLW3225DA_nag.dll" Alias "f16zjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ztfsm Lib "CLW3225DA_nag.dll" Alias "f16zlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ar As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal ar As Complex(), _
    <[In](),Out()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zherk Lib "CLW3225DA_nag.dll" Alias "f16zpc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zpc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zhfrk Lib "CLW3225DA_nag.dll" Alias "f16zqc" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal cr As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub f16zqc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal transr As Nag_RFP_Store, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Double, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal cr As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_zher2k Lib "CLW3225DA_nag.dll" Alias "f16zrc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zrc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Double, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsymm Lib "CLW3225DA_nag.dll" Alias "f16ztc" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16ztc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal side As Nag_SideType, _
    ByVal uplo As Nag_UploType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsyrk Lib "CLW3225DA_nag.dll" Alias "f16zuc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zuc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_zsyr2k Lib "CLW3225DA_nag.dll" Alias "f16zwc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub f16zwc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal trans As Nag_TransType, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal alpha As Complex, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    <[In]()> ByVal b As Complex(), _
    ByVal pdb As Integer, _
    ByVal beta As Complex, _
    <[In](),Out()> ByVal c As Complex(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


' chapter g01

   Declare Sub nag_summary_stats_1var Lib "CLW3225DA_nag.dll" Alias "g01aac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef nvalid As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    ByRef wsum As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef nvalid As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    ByRef wsum As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_summary_stats_freq Lib "CLW3225DA_nag.dll" Alias "g01adc" ( _
    ByVal k As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal ifreq As Integer(), _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g01adc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal ifreq As Integer(), _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef n As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_frequency_table Lib "CLW3225DA_nag.dll" Alias "g01aec" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal num_class As Integer, _
    ByVal classb As Nag_ClassBoundary, _
    <[In](),Out()> ByVal dnint As Double(), _
    <Out()> ByVal ifreq As Integer(), _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01aec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal num_class As Integer, _
    ByVal classb As Nag_ClassBoundary, _
    <[In](),Out()> ByVal dnint As Double(), _
    <Out()> ByVal ifreq As Integer(), _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_5pt_summary_stats Lib "CLW3225DA_nag.dll" Alias "g01alc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01alc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_double_quantiles Lib "CLW3225DA_nag.dll" Alias "g01amc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal rv As Double(), _
    ByVal nq As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01amc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal rv As Double(), _
    ByVal nq As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_approx_quantiles_fixed Lib "CLW3225DA_nag.dll" Alias "g01anc" ( _
    ByRef ind As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal rv As Double(), _
    ByVal nb As Integer, _
    ByVal eps As Double, _
    ByRef np As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByVal nq As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g01anc Lib "CLW3225DA_nag.dll" ( _
    ByRef ind As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal rv As Double(), _
    ByVal nb As Integer, _
    ByVal eps As Double, _
    ByRef np As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByVal nq As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_approx_quantiles_arbitrary Lib "CLW3225DA_nag.dll" Alias "g01apc" ( _
    ByRef ind As Integer, _
    <[In]()> ByVal rv As Double(), _
    ByVal nb As Integer, _
    ByVal eps As Double, _
    ByRef np As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByVal nq As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g01apc Lib "CLW3225DA_nag.dll" ( _
    ByRef ind As Integer, _
    <[In]()> ByVal rv As Double(), _
    ByVal nb As Integer, _
    ByVal eps As Double, _
    ByRef np As Integer, _
    <[In]()> ByVal q As Double(), _
    <Out()> ByVal qv As Double(), _
    ByVal nq As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_summary_stats_onevar Lib "CLW3225DA_nag.dll" Alias "g01atc" ( _
    ByVal nb As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef pn As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01atc Lib "CLW3225DA_nag.dll" ( _
    ByVal nb As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef pn As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_summary_stats_onevar_combine Lib "CLW3225DA_nag.dll" Alias "g01auc" ( _
    ByVal b As Integer, _
    <[In]()> ByVal mrcomm As Double(), _
    ByRef pn As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01auc Lib "CLW3225DA_nag.dll" ( _
    ByVal b As Integer, _
    <[In]()> ByVal mrcomm As Double(), _
    ByRef pn As Integer, _
    ByRef xmean As Double, _
    ByRef xsd As Double, _
    ByRef xskew As Double, _
    ByRef xkurt As Double, _
    ByRef xmin As Double, _
    ByRef xmax As Double, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_binomial_dist Lib "CLW3225DA_nag.dll" Alias "g01bjc" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01bjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_poisson_dist Lib "CLW3225DA_nag.dll" Alias "g01bkc" ( _
    ByVal rlamda As Double, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01bkc Lib "CLW3225DA_nag.dll" ( _
    ByVal rlamda As Double, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_hypergeom_dist Lib "CLW3225DA_nag.dll" Alias "g01blc" ( _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01blc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal l As Integer, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    ByRef plek As Double, _
    ByRef pgtk As Double, _
    ByRef peqk As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_normal_scores_exact Lib "CLW3225DA_nag.dll" Alias "g01dac" ( _
    ByVal n As Integer, _
    <Out()> ByVal pp As Double(), _
    ByVal etol As Double, _
    ByRef errest As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <Out()> ByVal pp As Double(), _
    ByVal etol As Double, _
    ByRef errest As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_normal_scores_var Lib "CLW3225DA_nag.dll" Alias "g01dcc" ( _
    ByVal n As Integer, _
    ByVal exp1 As Double, _
    ByVal exp2 As Double, _
    ByVal sumssq As Double, _
    <Out()> ByVal vec As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal exp1 As Double, _
    ByVal exp2 As Double, _
    ByVal sumssq As Double, _
    <Out()> ByVal vec As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_shapiro_wilk_test Lib "CLW3225DA_nag.dll" Alias "g01ddc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal calc_wts As Nag_Boolean, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef w As Double, _
    ByRef pw As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal calc_wts As Nag_Boolean, _
    <[In](),Out()> ByVal a As Double(), _
    ByRef w As Double, _
    ByRef pw As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ranks_and_scores Lib "CLW3225DA_nag.dll" Alias "g01dhc" ( _
    ByVal scores As Nag_Scores, _
    ByVal ties As Nag_Ties, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01dhc Lib "CLW3225DA_nag.dll" ( _
    ByVal scores As Nag_Scores, _
    ByVal ties As Nag_Ties, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_prob_normal Lib "CLW3225DA_nag.dll" Alias "g01eac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01eac Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_students_t Lib "CLW3225DA_nag.dll" Alias "g01ebc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal t As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal t As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_chi_sq Lib "CLW3225DA_nag.dll" Alias "g01ecc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal x As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_f_dist Lib "CLW3225DA_nag.dll" Alias "g01edc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal f As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01edc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal f As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_prob_beta_dist Lib "CLW3225DA_nag.dll" Alias "g01eec" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef p As Double, _
    ByRef q As Double, _
    ByRef pdf As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01eec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef p As Double, _
    ByRef q As Double, _
    ByRef pdf As Double, _
    ByRef fail As NagError _
   )


   Declare Function nag_gamma_dist Lib "CLW3225DA_nag.dll" Alias "g01efc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal g As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01efc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal g As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_studentized_range Lib "CLW3225DA_nag.dll" Alias "g01emc" ( _
    ByVal q As Double, _
    ByVal v As Double, _
    ByVal ir As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01emc Lib "CLW3225DA_nag.dll" ( _
    ByVal q As Double, _
    ByVal v As Double, _
    ByVal ir As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_prob_durbin_watson Lib "CLW3225DA_nag.dll" Alias "g01epc" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    ByVal d As Double, _
    ByRef pdl As Double, _
    ByRef pdu As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01epc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    ByVal d As Double, _
    ByRef pdl As Double, _
    ByRef pdu As Double, _
    ByRef fail As NagError _
   )


   Declare Function nag_prob_von_mises Lib "CLW3225DA_nag.dll" Alias "g01erc" ( _
    ByVal t As Double, _
    ByVal vk As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01erc Lib "CLW3225DA_nag.dll" ( _
    ByVal t As Double, _
    ByVal vk As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_landau Lib "CLW3225DA_nag.dll" Alias "g01etc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01etc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_prob_vavilov Lib "CLW3225DA_nag.dll" Alias "g01euc" ( _
    ByVal x As Double, _
    <[In]()> ByVal comm_arr As Double() _
   ) as Double

   Declare Function g01euc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    <[In]()> ByVal comm_arr As Double() _
   ) as Double


   Declare Function nag_prob_dickey_fuller_unit Lib "CLW3225DA_nag.dll" Alias "g01ewc" ( _
    ByVal method As Nag_TS_URProbMethod, _
    ByVal typ As Nag_TS_URTestType, _
    ByVal n As Integer, _
    ByVal ts As Double, _
    ByVal nsamp As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ewc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_TS_URProbMethod, _
    ByVal typ As Nag_TS_URTestType, _
    ByVal n As Integer, _
    ByVal ts As Double, _
    ByVal nsamp As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_1_sample_ks Lib "CLW3225DA_nag.dll" Alias "g01eyc" ( _
    ByVal n As Integer, _
    ByVal d As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01eyc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal d As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_2_sample_ks Lib "CLW3225DA_nag.dll" Alias "g01ezc" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal d As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ezc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    ByVal n2 As Integer, _
    ByVal d As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_normal Lib "CLW3225DA_nag.dll" Alias "g01fac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fac Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_students_t Lib "CLW3225DA_nag.dll" Alias "g01fbc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal p As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_chi_sq Lib "CLW3225DA_nag.dll" Alias "g01fcc" ( _
    ByVal p As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal p As Double, _
    ByVal df As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_f_dist Lib "CLW3225DA_nag.dll" Alias "g01fdc" ( _
    ByVal p As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal p As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_beta Lib "CLW3225DA_nag.dll" Alias "g01fec" ( _
    ByVal p As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fec Lib "CLW3225DA_nag.dll" ( _
    ByVal p As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_gamma_dist Lib "CLW3225DA_nag.dll" Alias "g01ffc" ( _
    ByVal p As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal p As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_studentized_range Lib "CLW3225DA_nag.dll" Alias "g01fmc" ( _
    ByVal p As Double, _
    ByVal v As Double, _
    ByVal ir As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01fmc Lib "CLW3225DA_nag.dll" ( _
    ByVal p As Double, _
    ByVal v As Double, _
    ByVal ir As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_deviates_landau Lib "CLW3225DA_nag.dll" Alias "g01ftc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01ftc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_non_central_students_t Lib "CLW3225DA_nag.dll" Alias "g01gbc" ( _
    ByVal t As Double, _
    ByVal df As Double, _
    ByVal delta As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal t As Double, _
    ByVal df As Double, _
    ByVal delta As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_non_central_chi_sq Lib "CLW3225DA_nag.dll" Alias "g01gcc" ( _
    ByVal x As Double, _
    ByVal df As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal df As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_non_central_f_dist Lib "CLW3225DA_nag.dll" Alias "g01gdc" ( _
    ByVal f As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01gdc Lib "CLW3225DA_nag.dll" ( _
    ByVal f As Double, _
    ByVal df1 As Double, _
    ByVal df2 As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_prob_non_central_beta_dist Lib "CLW3225DA_nag.dll" Alias "g01gec" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01gec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal lambda As Double, _
    ByVal tol As Double, _
    ByVal max_iter As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bivariate_normal_dist Lib "CLW3225DA_nag.dll" Alias "g01hac" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal rho As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01hac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal rho As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_multi_normal Lib "CLW3225DA_nag.dll" Alias "g01hbc" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal mean As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByVal tdsig As Integer, _
    ByVal tol As Double, _
    ByVal maxpts As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal mean As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByVal tdsig As Integer, _
    ByVal tol As Double, _
    ByVal maxpts As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bivariate_students_t Lib "CLW3225DA_nag.dll" Alias "g01hcc" ( _
    ByVal tail As Nag_TailProbability, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal df As Integer, _
    ByVal rho As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01hcc Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal df As Integer, _
    ByVal rho As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_multi_students_t Lib "CLW3225DA_nag.dll" Alias "g01hdc" ( _
    ByVal n As Integer, _
    ByVal tail As Nag_TailProbability, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal nu As Double, _
    <[In]()> ByVal delta As Double(), _
    ByVal iscov As Nag_Boolean, _
    <[In](),Out()> ByVal rc As Double(), _
    ByVal pdrc As Integer, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal numsub As Integer, _
    ByVal nsampl As Integer, _
    ByVal fmax As Integer, _
    ByRef errest As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01hdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal tail As Nag_TailProbability, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal nu As Double, _
    <[In]()> ByVal delta As Double(), _
    ByVal iscov As Nag_Boolean, _
    <[In](),Out()> ByVal rc As Double(), _
    ByVal pdrc As Integer, _
    ByVal epsabs As Double, _
    ByVal epsrel As Double, _
    ByVal numsub As Integer, _
    ByVal nsampl As Integer, _
    ByVal fmax As Integer, _
    ByRef errest As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_prob_lin_non_central_chi_sq Lib "CLW3225DA_nag.dll" Alias "g01jcc" ( _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal mult As Integer(), _
    <[In]()> ByVal rlamda As Double(), _
    ByVal n As Integer, _
    ByVal c As Double, _
    ByRef p As Double, _
    ByRef pdf As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g01jcc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal mult As Integer(), _
    <[In]()> ByVal rlamda As Double(), _
    ByVal n As Integer, _
    ByVal c As Double, _
    ByRef p As Double, _
    ByRef pdf As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_lin_chi_sq Lib "CLW3225DA_nag.dll" Alias "g01jdc" ( _
    ByVal method As Nag_LCCMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal rlam As Double(), _
    ByVal d As Double, _
    ByVal c As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g01jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_LCCMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal rlam As Double(), _
    ByVal d As Double, _
    ByVal c As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )


   Declare Function nag_normal_pdf Lib "CLW3225DA_nag.dll" Alias "g01kac" ( _
    ByVal x As Double, _
    ByVal xmean As Double, _
    ByVal xstd As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01kac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal xmean As Double, _
    ByVal xstd As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_gamma_pdf Lib "CLW3225DA_nag.dll" Alias "g01kfc" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function g01kfc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_gamma_pdf_vector Lib "CLW3225DA_nag.dll" Alias "g01kkc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal pdf As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01kkc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal pdf As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_normal_pdf_vector Lib "CLW3225DA_nag.dll" Alias "g01kqc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal pdf As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01kqc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal pdf As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_multi_normal_pdf_vector Lib "CLW3225DA_nag.dll" Alias "g01lbc" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal iuld As Nag_MatrixType, _
    <[In]()> ByVal sig As Double(), _
    ByVal pdsig As Integer, _
    <Out()> ByVal pdf As Double(), _
    ByRef rank As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g01lbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ilog As Nag_Boolean, _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal iuld As Nag_MatrixType, _
    <[In]()> ByVal sig As Double(), _
    ByVal pdsig As Integer, _
    <Out()> ByVal pdf As Double(), _
    ByRef rank As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_mills_ratio Lib "CLW3225DA_nag.dll" Alias "g01mbc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01mbc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_prob_density_landau Lib "CLW3225DA_nag.dll" Alias "g01mtc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01mtc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_prob_density_vavilov Lib "CLW3225DA_nag.dll" Alias "g01muc" ( _
    ByVal x As Double, _
    <[In]()> ByVal comm_arr As Double() _
   ) as Double

   Declare Function g01muc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    <[In]()> ByVal comm_arr As Double() _
   ) as Double


   Declare Sub nag_moments_quad_form Lib "CLW3225DA_nag.dll" Alias "g01nac" ( _
    ByVal order as Nag_OrderType, _
    ByVal mom As Nag_SelectMoments, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal emu As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByVal pdsig As Integer, _
    ByVal l As Integer, _
    <Out()> ByVal rkum As Double(), _
    <Out()> ByVal rmom As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01nac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mom As Nag_SelectMoments, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    <[In]()> ByVal emu As Double(), _
    <[In]()> ByVal sigma As Double(), _
    ByVal pdsig As Integer, _
    ByVal l As Integer, _
    <Out()> ByVal rkum As Double(), _
    <Out()> ByVal rmom As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_moments_ratio_quad_forms Lib "CLW3225DA_nag.dll" Alias "g01nbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ratio_type As Nag_MomentType, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal a As Double(), ByVal pda As Integer, <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, <[In]()> ByVal c As Double(), ByVal pdc As Integer, _
    <[In]()> ByVal ela As Double(), <[In]()> ByVal emu As Double(), <[In]()> ByVal sigma As Double(), _
    ByVal pdsig As Integer, ByVal l1 As Integer, ByVal l2 As Integer, _
    ByRef lmax As Integer, <Out()> ByVal rmom As Double(), ByRef abserr As Double, _
    ByVal eps As Double, ByRef fail As NagError _
   )

   Declare Sub g01nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ratio_type As Nag_MomentType, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal a As Double(), ByVal pda As Integer, <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, <[In]()> ByVal c As Double(), ByVal pdc As Integer, _
    <[In]()> ByVal ela As Double(), <[In]()> ByVal emu As Double(), <[In]()> ByVal sigma As Double(), _
    ByVal pdsig As Integer, ByVal l1 As Integer, ByVal l2 As Integer, _
    ByRef lmax As Integer, <Out()> ByVal rmom As Double(), ByRef abserr As Double, _
    ByVal eps As Double, ByRef fail As NagError _
   )


   Declare Function nag_moment_1_landau Lib "CLW3225DA_nag.dll" Alias "g01ptc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01ptc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_moment_2_landau Lib "CLW3225DA_nag.dll" Alias "g01qtc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01qtc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_prob_der_landau Lib "CLW3225DA_nag.dll" Alias "g01rtc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function g01rtc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Sub nag_prob_normal_vector Lib "CLW3225DA_nag.dll" Alias "g01sac" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sac Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_students_t_vector Lib "CLW3225DA_nag.dll" Alias "g01sbc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lt As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lt As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_chi_sq_vector Lib "CLW3225DA_nag.dll" Alias "g01scc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01scc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lx As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_f_vector Lib "CLW3225DA_nag.dll" Alias "g01sdc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lf As Integer, _
    <[In]()> ByVal f As Double(), _
    ByVal ldf1 As Integer, _
    <[In]()> ByVal df1 As Double(), _
    ByVal ldf2 As Integer, _
    <[In]()> ByVal df2 As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sdc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lf As Integer, _
    <[In]()> ByVal f As Double(), _
    ByVal ldf1 As Integer, _
    <[In]()> ByVal df1 As Double(), _
    ByVal ldf2 As Integer, _
    <[In]()> ByVal df2 As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_beta_vector Lib "CLW3225DA_nag.dll" Alias "g01sec" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lbeta As Integer, _
    <[In]()> ByVal beta As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sec Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lbeta As Integer, _
    <[In]()> ByVal beta As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_gamma_vector Lib "CLW3225DA_nag.dll" Alias "g01sfc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lg As Integer, _
    <[In]()> ByVal g As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sfc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lg As Integer, _
    <[In]()> ByVal g As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_binomial_vector Lib "CLW3225DA_nag.dll" Alias "g01sjc" ( _
    ByVal ln As Integer, _
    <[In]()> ByVal n As Integer(), _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01sjc Lib "CLW3225DA_nag.dll" ( _
    ByVal ln As Integer, _
    <[In]()> ByVal n As Integer(), _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_poisson_vector Lib "CLW3225DA_nag.dll" Alias "g01skc" ( _
    ByVal ll As Integer, _
    <[In]()> ByVal l As Double(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01skc Lib "CLW3225DA_nag.dll" ( _
    ByVal ll As Integer, _
    <[In]()> ByVal l As Double(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_prob_hypergeom_vector Lib "CLW3225DA_nag.dll" Alias "g01slc" ( _
    ByVal ln As Integer, _
    <[In]()> ByVal n As Integer(), _
    ByVal ll As Integer, _
    <[In]()> ByVal l As Integer(), _
    ByVal lm As Integer, _
    <[In]()> ByVal m As Integer(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01slc Lib "CLW3225DA_nag.dll" ( _
    ByVal ln As Integer, _
    <[In]()> ByVal n As Integer(), _
    ByVal ll As Integer, _
    <[In]()> ByVal l As Integer(), _
    ByVal lm As Integer, _
    <[In]()> ByVal m As Integer(), _
    ByVal lk As Integer, _
    <[In]()> ByVal k As Integer(), _
    <Out()> ByVal plek As Double(), _
    <Out()> ByVal pgtk As Double(), _
    <Out()> ByVal peqk As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_normal_vector Lib "CLW3225DA_nag.dll" Alias "g01tac" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tac Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal lxmu As Integer, _
    <[In]()> ByVal xmu As Double(), _
    ByVal lxstd As Integer, _
    <[In]()> ByVal xstd As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_students_t_vector Lib "CLW3225DA_nag.dll" Alias "g01tbc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal t As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal t As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_chi_sq_vector Lib "CLW3225DA_nag.dll" Alias "g01tcc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tcc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf As Integer, _
    <[In]()> ByVal df As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_f_vector Lib "CLW3225DA_nag.dll" Alias "g01tdc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf1 As Integer, _
    <[In]()> ByVal df1 As Double(), _
    ByVal ldf2 As Integer, _
    <[In]()> ByVal df2 As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tdc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal ldf1 As Integer, _
    <[In]()> ByVal df1 As Double(), _
    ByVal ldf2 As Integer, _
    <[In]()> ByVal df2 As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_beta_vector Lib "CLW3225DA_nag.dll" Alias "g01tec" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tec Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal beta As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_deviates_gamma_vector Lib "CLW3225DA_nag.dll" Alias "g01tfc" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal g As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g01tfc Lib "CLW3225DA_nag.dll" ( _
    ByVal ltail As Integer, _
    ByVal tail As Nag_TailProbability, _
    ByVal lp As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal la As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal lb As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal tol As Double, _
    <Out()> ByVal g As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_moving_average Lib "CLW3225DA_nag.dll" Alias "g01wac" ( _
    ByVal m As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal iwt As Nag_Weightstype, _
    <[In]()> ByVal wt As Double(), _
    ByRef pn As Integer, _
    <Out()> ByVal rmean As Double(), _
    <Out()> ByVal rsd As Double(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01wac Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal nb As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal iwt As Nag_Weightstype, _
    <[In]()> ByVal wt As Double(), _
    ByRef pn As Integer, _
    <Out()> ByVal rmean As Double(), _
    <Out()> ByVal rsd As Double(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_init_vavilov Lib "CLW3225DA_nag.dll" Alias "g01zuc" ( _
    ByVal rkappa As Double, _
    ByVal beta2 As Double, _
    ByVal mode As Integer, _
    ByRef xl As Double, _
    ByRef xu As Double, _
    <Out()> ByVal comm_arr As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g01zuc Lib "CLW3225DA_nag.dll" ( _
    ByVal rkappa As Double, _
    ByVal beta2 As Double, _
    ByVal mode As Integer, _
    ByRef xl As Double, _
    ByRef xu As Double, _
    <Out()> ByVal comm_arr As Double(), _
    ByRef fail As NagError _
   )


' chapter g02

   Declare Sub nag_nearest_correlation Lib "CLW3225DA_nag.dll" Alias "g02aac" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal errtol As Double, _
    ByVal maxits As Integer, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmgrd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02aac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal errtol As Double, _
    ByVal maxits As Integer, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmgrd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_nearest_correlation_bounded Lib "CLW3225DA_nag.dll" Alias "g02abc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal opt As Nag_NearCorr_ProbType, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal w As Double(), _
    ByVal errtol As Double, _
    ByVal maxits As Integer, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmgrd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02abc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal opt As Nag_NearCorr_ProbType, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal w As Double(), _
    ByVal errtol As Double, _
    ByVal maxits As Integer, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmgrd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_nearest_correlation_k_factor Lib "CLW3225DA_nag.dll" Alias "g02aec" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal errtol As Double, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmpgd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02aec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal errtol As Double, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef feval As Integer, _
    ByRef nrmpgd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_nearest_correlation_h_weight Lib "CLW3225DA_nag.dll" Alias "g02ajc" ( _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    ByVal errtol As Double, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef norm As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02ajc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal alpha As Double, _
    <[In](),Out()> ByVal h As Double(), _
    ByVal pdh As Integer, _
    ByVal errtol As Double, _
    ByVal maxit As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef iter As Integer, _
    ByRef norm As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_nearest_correlation_shrinking Lib "CLW3225DA_nag.dll" Alias "g02anc" ( _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal errtol As Double, _
    ByVal eigtol As Double, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef alpha As Double, _
    ByRef iter As Integer, _
    ByRef eigmin As Double, _
    ByRef norm As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02anc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal g As Double(), _
    ByVal pdg As Integer, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal errtol As Double, _
    ByVal eigtol As Double, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef alpha As Double, _
    ByRef iter As Integer, _
    ByRef eigmin As Double, _
    ByRef norm As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ken_spe_corr_coeff Lib "CLW3225DA_nag.dll" Alias "g02brc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal svar As Integer(), _
    <[In]()> ByVal sobs As Integer(), _
    <Out()> ByVal corr As Double(), _
    ByVal tdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02brc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal svar As Integer(), _
    <[In]()> ByVal sobs As Integer(), _
    <Out()> ByVal corr As Double(), _
    ByVal tdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_sqs_update Lib "CLW3225DA_nag.dll" Alias "g02btc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As Integer, _
    ByVal wt As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef sw As Double, _
    <[In](),Out()> ByVal xbar As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02btc Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As Integer, _
    ByVal wt As Double, _
    <[In]()> ByVal x As Double(), _
    ByVal incx As Integer, _
    ByRef sw As Double, _
    <[In](),Out()> ByVal xbar As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_sqs Lib "CLW3225DA_nag.dll" Alias "g02buc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal wt As Double(), _
    ByRef sw As Double, _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02buc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal wt As Double(), _
    ByRef sw As Double, _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal c As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_cov_to_corr Lib "CLW3225DA_nag.dll" Alias "g02bwc" ( _
    ByVal m As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02bwc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_corr_cov Lib "CLW3225DA_nag.dll" Alias "g02bxc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal sx As Integer(), _
    <[In]()> ByVal wt As Double(), _
    ByRef sw As Double, _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal std As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02bxc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal sx As Integer(), _
    <[In]()> ByVal wt As Double(), _
    ByRef sw As Double, _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal std As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_partial_corr Lib "CLW3225DA_nag.dll" Alias "g02byc" ( _
    ByVal m As Integer, _
    ByVal ny As Integer, _
    ByVal nx As Integer, _
    <[In]()> ByVal sz As Integer(), _
    <[In]()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tdp As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02byc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal ny As Integer, _
    ByVal nx As Integer, _
    <[In]()> ByVal sz As Integer(), _
    <[In]()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tdp As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_sum_sqs_combine Lib "CLW3225DA_nag.dll" Alias "g02bzc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As Integer, _
    ByRef xsw As Double, _
    <[In](),Out()> ByVal xmean As Double(), _
    <[In](),Out()> ByVal xc As Double(), _
    ByVal ysw As Double, _
    <[In]()> ByVal ymean As Double(), _
    <[In]()> ByVal yc As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02bzc Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal m As Integer, _
    ByRef xsw As Double, _
    <[In](),Out()> ByVal xmean As Double(), _
    <[In](),Out()> ByVal xc As Double(), _
    ByVal ysw As Double, _
    <[In]()> ByVal ymean As Double(), _
    <[In]()> ByVal yc As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_simple_linear_regression Lib "CLW3225DA_nag.dll" Alias "g02cac" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef a As Double, _
    ByRef b As Double, _
    ByRef a_serr As Double, _
    ByRef b_serr As Double, _
    ByRef rsq As Double, _
    ByRef rss As Double, _
    ByRef df As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02cac Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef a As Double, _
    ByRef b As Double, _
    ByRef a_serr As Double, _
    ByRef b_serr As Double, _
    ByRef rsq As Double, _
    ByRef rss As Double, _
    ByRef df As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regress_confid_interval Lib "CLW3225DA_nag.dll" Alias "g02cbc" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal clm As Double, _
    ByVal clp As Double, _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal yml As Double(), _
    <Out()> ByVal ymu As Double(), _
    <Out()> ByVal yl As Double(), _
    <Out()> ByVal yu As Double(), _
    <Out()> ByVal h As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef rms As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_SumSquare, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal clm As Double, _
    ByVal clp As Double, _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal yml As Double(), _
    <Out()> ByVal ymu As Double(), _
    <Out()> ByVal yl As Double(), _
    <Out()> ByVal yu As Double(), _
    <Out()> ByVal h As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef rms As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear Lib "CLW3225DA_nag.dll" Alias "g02dac" ( _
    ByVal mean As Nag_IncludeMean, ByVal n As Integer, <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, ByVal m As Integer, <[In]()> ByVal sx As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), <Out()> ByVal q As Double(), ByVal tdq As Integer, _
    ByRef svd As Nag_Boolean, ByRef rank As Integer, <Out()> ByVal p As Double(), _
    ByVal tol As Double, <Out()> ByVal com_ar As Double(), ByRef fail As NagError _
   )

   Declare Sub g02dac Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_IncludeMean, ByVal n As Integer, <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, ByVal m As Integer, <[In]()> ByVal sx As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), <Out()> ByVal q As Double(), ByVal tdq As Integer, _
    ByRef svd As Nag_Boolean, ByRef rank As Integer, <Out()> ByVal p As Double(), _
    ByVal tol As Double, <Out()> ByVal com_ar As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_addrem_obs Lib "CLW3225DA_nag.dll" Alias "g02dcc" ( _
    ByVal update As Nag_UpdateObserv, _
    ByVal mean As Nag_IncludeMean, _
    ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal nr As Integer, _
    ByVal tdx As Integer, _
    ByVal ix As Integer, _
    ByVal y As Double, _
    <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal update As Nag_UpdateObserv, _
    ByVal mean As Nag_IncludeMean, _
    ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal nr As Integer, _
    ByVal tdx As Integer, _
    ByVal ix As Integer, _
    ByVal y As Double, _
    <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_upd_model Lib "CLW3225DA_nag.dll" Alias "g02ddc" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef svd As Nag_Boolean, _
    ByRef rank As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef svd As Nag_Boolean, _
    ByRef rank As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_add_var Lib "CLW3225DA_nag.dll" Alias "g02dec" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    <[In](),Out()> ByVal p As Double(), _
    <[In]()> ByVal wt As Double(), _
    <[In]()> ByVal x As Double(), _
    ByRef rss As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02dec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    <[In](),Out()> ByVal p As Double(), _
    <[In]()> ByVal wt As Double(), _
    <[In]()> ByVal x As Double(), _
    ByRef rss As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_delete_var Lib "CLW3225DA_nag.dll" Alias "g02dfc" ( _
    ByVal ip As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal indx As Integer, _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02dfc Lib "CLW3225DA_nag.dll" ( _
    ByVal ip As Integer, _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal indx As Integer, _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_newyvar Lib "CLW3225DA_nag.dll" Alias "g02dgc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In](),Out()> ByVal cov As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal svd As Nag_Boolean, _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal res As Double(), _
    <[In]()> ByVal com_ar As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02dgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal wt As Double(), _
    ByRef rss As Double, _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In](),Out()> ByVal cov As Double(), _
    <[In](),Out()> ByVal q As Double(), _
    ByVal tdq As Integer, _
    ByVal svd As Nag_Boolean, _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal res As Double(), _
    <[In]()> ByVal com_ar As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_tran_model Lib "CLW3225DA_nag.dll" Alias "g02dkc" ( _
    ByVal ip As Integer, _
    ByVal iconst As Integer, _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal rss As Double, _
    ByVal df As Double, _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02dkc Lib "CLW3225DA_nag.dll" ( _
    ByVal ip As Integer, _
    ByVal iconst As Integer, _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal rss As Double, _
    ByVal df As Double, _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_mult_linear_est_func Lib "CLW3225DA_nag.dll" Alias "g02dnc" ( _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef est As Nag_Boolean, _
    ByRef stat As Double, _
    ByRef sestat As Double, _
    ByRef t As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02dnc Lib "CLW3225DA_nag.dll" ( _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), _
    <[In]()> ByVal p As Double(), _
    <[In]()> ByVal f As Double(), _
    ByRef est As Nag_Boolean, _
    ByRef stat As Double, _
    ByRef sestat As Double, _
    ByRef t As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_all_regsn Lib "CLW3225DA_nag.dll" Alias "g02eac" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal var_names As IntPtr(), _
    <[In]()> ByVal sx As Integer(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef nmod As Integer, _
    <Out()> ByVal model As IntPtr(), _
    <Out()> ByVal rss As Double(), _
    <Out()> ByVal nterms As Integer(), _
    <Out()> ByVal mrank As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g02eac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal var_names As IntPtr(), _
    <[In]()> ByVal sx As Integer(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByRef nmod As Integer, _
    <Out()> ByVal model As IntPtr(), _
    <Out()> ByVal rss As Double(), _
    <Out()> ByVal nterms As Integer(), _
    <Out()> ByVal mrank As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_cp_stat Lib "CLW3225DA_nag.dll" Alias "g02ecc" ( _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    ByVal sigsq As Double, _
    ByVal tss As Double, _
    ByVal nmod As Integer, _
    <[In]()> ByVal nterms As Integer(), _
    <[In]()> ByVal rss As Double(), _
    <Out()> ByVal rsq As Double(), _
    <Out()> ByVal cp As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, _
    ByVal sigsq As Double, _
    ByVal tss As Double, _
    ByVal nmod As Integer, _
    <[In]()> ByVal nterms As Integer(), _
    <[In]()> ByVal rss As Double(), _
    <Out()> ByVal rsq As Double(), _
    <Out()> ByVal cp As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_step_regsn Lib "CLW3225DA_nag.dll" Alias "g02eec" ( _
    ByVal order as Nag_OrderType, _
    ByRef istep As Integer, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <[In]()> ByVal var_names As IntPtr(), <[In]()> ByVal sx As Integer(), ByVal maxip As Integer, _
    <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), ByVal fin As Double, _
    ByRef addvar As Nag_Boolean, <Out()> ByVal newvar As IntPtr(), ByRef chrss As Double, _
    ByRef f As Double, <[In](),Out()> ByVal model As IntPtr(), ByRef nterm As Integer, _
    ByRef rss As Double, ByRef idf As Integer, ByRef ifr As Integer, _
    <[In](),Out()> ByVal free_vars As IntPtr(), <Out()> ByVal exss As Double(), <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, <[In](),Out()> ByVal p As Double(), ByRef fail As NagError _
   )

   Declare Sub g02eec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByRef istep As Integer, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <[In]()> ByVal var_names As IntPtr(), <[In]()> ByVal sx As Integer(), ByVal maxip As Integer, _
    <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), ByVal fin As Double, _
    ByRef addvar As Nag_Boolean, <Out()> ByVal newvar As IntPtr(), ByRef chrss As Double, _
    ByRef f As Double, <[In](),Out()> ByVal model As IntPtr(), ByRef nterm As Integer, _
    ByRef rss As Double, ByRef idf As Integer, ByRef ifr As Integer, _
    <[In](),Out()> ByVal free_vars As IntPtr(), <Out()> ByVal exss As Double(), <[In](),Out()> ByVal q As Double(), _
    ByVal pdq As Integer, <[In](),Out()> ByVal p As Double(), ByRef fail As NagError _
   )


Delegate Sub nag_full_step_regsn_monfun_DELEGATE( _
    ByVal flag As Nag_FullStepwise, _
    ByVal var As Integer, _
    ByVal val As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub G02EFH Lib "CLW3225DA_nag.dll" ( _
    ByVal flag As Nag_FullStepwise, _
    ByVal var As Integer, _
    ByVal val As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_full_step_regsn Lib "CLW3225DA_nag.dll" Alias "g02efc" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal wmean As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal sw As Double, _
    <[In](),Out()> ByVal isx As Integer(), _
    ByVal fin As Double, _
    ByVal fout As Double, _
    ByVal tau As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    ByRef rsq As Double, _
    ByRef rms As Double, _
    ByRef df As Integer, _
    ByVal monfun As nag_full_step_regsn_monfun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g02efc_monfun_DELEGATE( _
    ByVal flag As Nag_FullStepwise, _
    ByVal var As Integer, _
    ByVal val As Double, _
    ByRef COMM As Nag_Comm _
  )


   Declare Sub g02efc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal wmean As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal sw As Double, _
    <[In](),Out()> ByVal isx As Integer(), _
    ByVal fin As Double, _
    ByVal fout As Double, _
    ByVal tau As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), _
    ByRef rsq As Double, _
    ByRef rms As Double, _
    ByRef df As Integer, _
    ByVal monfun As g02efc_monfun_DELEGATE, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_std_resid_influence Lib "CLW3225DA_nag.dll" Alias "g02fac" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    ByVal nres As Integer, _
    <[In]()> ByVal res As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal rms As Double, _
    <Out()> ByVal sres As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02fac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal ip As Integer, _
    ByVal nres As Integer, _
    <[In]()> ByVal res As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal rms As Double, _
    <Out()> ByVal sres As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_durbin_watson_stat Lib "CLW3225DA_nag.dll" Alias "g02fcc" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In]()> ByVal res As Double(), _
    ByRef d As Double, _
    ByRef pdl As Double, _
    ByRef pdu As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In]()> ByVal res As Double(), _
    ByRef d As Double, _
    ByRef pdl As Double, _
    ByRef pdu As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glm_normal Lib "CLW3225DA_nag.dll" Alias "g02gac" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByRef dnscale As Double, _
    ByVal ex_power As Double, ByRef rss As Double, ByRef df As Double, _
    <Out()> ByVal b As Double(), ByRef rank As Integer, <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal v As Double(), ByVal tdv As Integer, _
    ByVal tol As Double, ByVal max_iter As Integer, ByVal print_iter As Integer, _
    ByVal outfile As String, ByVal eps As Double, ByRef fail As NagError _
   )

   Declare Sub g02gac Lib "CLW3225DA_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByRef dnscale As Double, _
    ByVal ex_power As Double, ByRef rss As Double, ByRef df As Double, _
    <Out()> ByVal b As Double(), ByRef rank As Integer, <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal v As Double(), ByVal tdv As Integer, _
    ByVal tol As Double, ByVal max_iter As Integer, ByVal print_iter As Integer, _
    ByVal outfile As String, ByVal eps As Double, ByRef fail As NagError _
   )


   Declare Sub nag_glm_binomial Lib "CLW3225DA_nag.dll" Alias "g02gbc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal binom_t As Double(), <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), _
    ByRef dev As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    ByRef rank As Integer, <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), _
    <Out()> ByVal v As Double(), ByVal tdv As Integer, ByVal tol As Double, _
    ByVal max_iter As Integer, ByVal print_iter As Integer, ByVal outfile As String, _
    ByVal eps As Double, ByRef fail As NagError _
   )

   Declare Sub g02gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal binom_t As Double(), <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), _
    ByRef dev As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    ByRef rank As Integer, <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), _
    <Out()> ByVal v As Double(), ByVal tdv As Integer, ByVal tol As Double, _
    ByVal max_iter As Integer, ByVal print_iter As Integer, ByVal outfile As String, _
    ByVal eps As Double, ByRef fail As NagError _
   )


   Declare Sub nag_glm_poisson Lib "CLW3225DA_nag.dll" Alias "g02gcc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByVal ex_power As Double, _
    ByRef dev As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    ByRef rank As Integer, <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), _
    <Out()> ByVal v As Double(), ByVal tdv As Integer, ByVal tol As Double, _
    ByVal max_iter As Integer, ByVal print_iter As Integer, ByVal outfile As String, _
    ByVal eps As Double, ByRef fail As NagError _
   )

   Declare Sub g02gcc Lib "CLW3225DA_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByVal ex_power As Double, _
    ByRef dev As Double, ByRef df As Double, <Out()> ByVal b As Double(), _
    ByRef rank As Integer, <Out()> ByVal se As Double(), <Out()> ByVal cov As Double(), _
    <Out()> ByVal v As Double(), ByVal tdv As Integer, ByVal tol As Double, _
    ByVal max_iter As Integer, ByVal print_iter As Integer, ByVal outfile As String, _
    ByVal eps As Double, ByRef fail As NagError _
   )


   Declare Sub nag_glm_gamma Lib "CLW3225DA_nag.dll" Alias "g02gdc" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByRef dnscale As Double, _
    ByVal ex_power As Double, ByRef dev As Double, ByRef df As Double, _
    <Out()> ByVal b As Double(), ByRef rank As Integer, <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal v As Double(), ByVal tdv As Integer, _
    ByVal tol As Double, ByVal max_iter As Integer, ByVal print_iter As Integer, _
    ByVal outfile As String, ByVal eps As Double, ByRef fail As NagError _
   )

   Declare Sub g02gdc Lib "CLW3225DA_nag.dll" ( _
    ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, ByVal m As Integer, _
    <[In]()> ByVal sx As Integer(), ByVal ip As Integer, <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal offset As Double(), ByRef dnscale As Double, _
    ByVal ex_power As Double, ByRef dev As Double, ByRef df As Double, _
    <Out()> ByVal b As Double(), ByRef rank As Integer, <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal v As Double(), ByVal tdv As Integer, _
    ByVal tol As Double, ByVal max_iter As Integer, ByVal print_iter As Integer, _
    ByVal outfile As String, ByVal eps As Double, ByRef fail As NagError _
   )


   Declare Sub nag_glm_tran_model Lib "CLW3225DA_nag.dll" Alias "g02gkc" ( _
    ByVal ip As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal dnscale As Double, _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02gkc Lib "CLW3225DA_nag.dll" ( _
    ByVal ip As Integer, _
    ByVal nclin As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal dnscale As Double, _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal cov As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_glm_est_func Lib "CLW3225DA_nag.dll" Alias "g02gnc" ( _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), _
    <[In]()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <[In]()> ByVal f As Double(), _
    ByRef est As Nag_Boolean, _
    ByRef stat As Double, _
    ByRef sestat As Double, _
    ByRef z As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g02gnc Lib "CLW3225DA_nag.dll" ( _
    ByVal ip As Integer, _
    ByVal rank As Integer, _
    <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), _
    <[In]()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    <[In]()> ByVal f As Double(), _
    ByRef est As Nag_Boolean, _
    ByRef stat As Double, _
    ByRef sestat As Double, _
    ByRef z As Double, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_glm_predict Lib "CLW3225DA_nag.dll" Alias "g02gpc" ( _
    ByVal errfn As Nag_Distributions, ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal m As Integer, <[In]()> ByVal sx As Integer(), ByVal ip As Integer, _
    <[In]()> ByVal binom_t As Double(), <[In]()> ByVal offset As Double(), <[In]()> ByVal wt As Double(), _
    ByVal dnscale As Double, ByVal ex_power As Double, <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), ByVal vfobs As Nag_Boolean, <Out()> ByVal eta As Double(), _
    <Out()> ByVal seeta As Double(), <Out()> ByVal pred As Double(), <Out()> ByVal sepred As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02gpc Lib "CLW3225DA_nag.dll" ( _
    ByVal errfn As Nag_Distributions, ByVal link As Nag_Link, ByVal mean As Nag_IncludeMean, _
    ByVal n As Integer, <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal m As Integer, <[In]()> ByVal sx As Integer(), ByVal ip As Integer, _
    <[In]()> ByVal binom_t As Double(), <[In]()> ByVal offset As Double(), <[In]()> ByVal wt As Double(), _
    ByVal dnscale As Double, ByVal ex_power As Double, <[In]()> ByVal b As Double(), _
    <[In]()> ByVal cov As Double(), ByVal vfobs As Nag_Boolean, <Out()> ByVal eta As Double(), _
    <Out()> ByVal seeta As Double(), <Out()> ByVal pred As Double(), <Out()> ByVal sepred As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_robust_m_regsn_estim Lib "CLW3225DA_nag.dll" Alias "g02hac" ( _
    ByVal regtype As Nag_RegType, ByVal psifun As Nag_PsiFun, ByVal sigma_est As Nag_SigmaEst, _
    ByVal covmat_est As Nag_CovMatrixEst, ByVal n As Integer, ByVal m As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal tdx As Integer, <[In](),Out()> ByVal y As Double(), _
    ByVal cpsi As Double, <[In]()> ByVal hpsi As Double(), ByVal cucv As Double, _
    ByVal dchi As Double, <[In](),Out()> ByVal theta As Double(), ByRef sigma As Double, _
    <Out()> ByVal c As Double(), ByVal tdc As Integer, <Out()> ByVal rs As Double(), _
    <Out()> ByVal wt As Double(), ByVal tol As Double, ByVal max_iter As Integer, _
    ByVal print_iter As Integer, ByVal outfile As String, <Out()> ByVal info As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02hac Lib "CLW3225DA_nag.dll" ( _
    ByVal regtype As Nag_RegType, ByVal psifun As Nag_PsiFun, ByVal sigma_est As Nag_SigmaEst, _
    ByVal covmat_est As Nag_CovMatrixEst, ByVal n As Integer, ByVal m As Integer, _
    <[In](),Out()> ByVal x As Double(), ByVal tdx As Integer, <[In](),Out()> ByVal y As Double(), _
    ByVal cpsi As Double, <[In]()> ByVal hpsi As Double(), ByVal cucv As Double, _
    ByVal dchi As Double, <[In](),Out()> ByVal theta As Double(), ByRef sigma As Double, _
    <Out()> ByVal c As Double(), ByVal tdc As Integer, <Out()> ByVal rs As Double(), _
    <Out()> ByVal wt As Double(), ByVal tol As Double, ByVal max_iter As Integer, _
    ByVal print_iter As Integer, ByVal outfile As String, <Out()> ByVal info As Double(), _
    ByRef fail As NagError _
   )


Delegate Function nag_robust_m_regsn_wts_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_robust_m_regsn_wts Lib "CLW3225DA_nag.dll" Alias "g02hbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As nag_robust_m_regsn_wts_ucv_DELEGATE, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal bl As Double, _
    ByVal bd As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByVal nitmon As Integer, _
    ByVal outfile As String, _
    ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function g02hbc_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub g02hbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As g02hbc_ucv_DELEGATE, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal a As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal bl As Double, _
    ByVal bd As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByVal nitmon As Integer, _
    ByVal outfile As String, _
    ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_robust_m_regsn_user_fn_chi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Function G02HDZ Lib "CLW3225DA_nag.dll" ( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_robust_m_regsn_user_fn_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_robust_m_regsn_user_fn Lib "CLW3225DA_nag.dll" Alias "g02hdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal chi As nag_robust_m_regsn_user_fn_chi_DELEGATE, ByVal psi As nag_robust_m_regsn_user_fn_psi_DELEGATE, ByVal psip0 As Double, _
    ByVal beta As Double, ByVal regtype As Nag_RegType, ByVal sigma_est As Nag_SigmaEst, _
    ByVal n As Integer, ByVal m As Integer, <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In](),Out()> ByVal y As Double(), <[In](),Out()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByRef k As Integer, ByRef sigma As Double, _
    <Out()> ByVal rs As Double(), ByVal tol As Double, ByVal eps As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByRef nit As Integer, ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function g02hdc_chi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double


Delegate Function g02hdc_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub g02hdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal chi As g02hdc_chi_DELEGATE, ByVal psi As g02hdc_psi_DELEGATE, ByVal psip0 As Double, _
    ByVal beta As Double, ByVal regtype As Nag_RegType, ByVal sigma_est As Nag_SigmaEst, _
    ByVal n As Integer, ByVal m As Integer, <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In](),Out()> ByVal y As Double(), <[In](),Out()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByRef k As Integer, ByRef sigma As Double, _
    <Out()> ByVal rs As Double(), ByVal tol As Double, ByVal eps As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByRef nit As Integer, ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


Delegate Function nag_robust_m_regsn_param_var_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_robust_m_regsn_param_var_psp_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_robust_m_regsn_param_var Lib "CLW3225DA_nag.dll" Alias "g02hfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal psi As nag_robust_m_regsn_param_var_psi_DELEGATE, _
    ByVal psp As nag_robust_m_regsn_param_var_psp_DELEGATE, _
    ByVal regtype As Nag_RegType, _
    ByVal covmat_est As Nag_CovMatrixEst, _
    ByVal sigma As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal rs As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <Out()> ByVal cov As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal comm_arr As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function g02hfc_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function g02hfc_psp_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub g02hfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal psi As g02hfc_psi_DELEGATE, _
    ByVal psp As g02hfc_psp_DELEGATE, _
    ByVal regtype As Nag_RegType, _
    ByVal covmat_est As Nag_CovMatrixEst, _
    ByVal sigma As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal rs As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <Out()> ByVal cov As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal comm_arr As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_robust_corr_estim Lib "CLW3225DA_nag.dll" Alias "g02hkc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal eps As Double, _
    <Out()> ByVal cov As Double(), _
    <Out()> ByVal theta As Double(), _
    ByVal max_iter As Integer, _
    ByVal print_iter As Integer, _
    ByVal outfile As String, _
    ByVal tol As Double, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02hkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal eps As Double, _
    <Out()> ByVal cov As Double(), _
    <Out()> ByVal theta As Double(), _
    ByVal max_iter As Integer, _
    ByVal print_iter As Integer, _
    ByVal outfile As String, _
    ByVal tol As Double, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )


Delegate Sub nag_robust_m_corr_user_fn_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef u As Double, _
    ByRef ud As Double, _
    ByRef w As Double, _
    ByRef wd As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_robust_m_corr_user_fn Lib "CLW3225DA_nag.dll" Alias "g02hlc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As nag_robust_m_corr_user_fn_ucv_DELEGATE, ByVal indm As Integer, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <Out()> ByVal cov As Double(), <[In](),Out()> ByVal a As Double(), <Out()> ByVal wt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByVal bl As Double, ByVal bd As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByVal tol As Double, ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub g02hlc_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef u As Double, _
    ByRef ud As Double, _
    ByRef w As Double, _
    ByRef wd As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub g02hlc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As g02hlc_ucv_DELEGATE, ByVal indm As Integer, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <Out()> ByVal cov As Double(), <[In](),Out()> ByVal a As Double(), <Out()> ByVal wt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByVal bl As Double, ByVal bd As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByVal tol As Double, ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


Delegate Sub nag_robust_m_corr_user_fn_no_derr_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef u As Double, _
    ByRef w As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_robust_m_corr_user_fn_no_derr Lib "CLW3225DA_nag.dll" Alias "g02hmc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As nag_robust_m_corr_user_fn_no_derr_ucv_DELEGATE, ByVal indm As Integer, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <Out()> ByVal cov As Double(), <[In](),Out()> ByVal a As Double(), <Out()> ByVal wt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByVal bl As Double, ByVal bd As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByVal tol As Double, ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub g02hmc_ucv_DELEGATE( _
    ByVal t As Double, _
    ByRef u As Double, _
    ByRef w As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub g02hmc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ucv As g02hmc_ucv_DELEGATE, ByVal indm As Integer, ByVal n As Integer, _
    ByVal m As Integer, <[In]()> ByVal x As Double(), ByVal pdx As Integer, _
    <Out()> ByVal cov As Double(), <[In](),Out()> ByVal a As Double(), <Out()> ByVal wt As Double(), _
    <[In](),Out()> ByVal theta As Double(), ByVal bl As Double, ByVal bd As Double, _
    ByVal maxit As Integer, ByVal nitmon As Integer, ByVal outfile As String, _
    ByVal tol As Double, ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_reml_mixed_regsn Lib "CLW3225DA_nag.dll" Alias "g02jac" ( _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal tddat As Integer, <[In]()> ByVal levels As Integer(), ByVal yvid As Integer, _
    ByVal cwid As Integer, ByVal nfv As Integer, <[In]()> ByVal fvid As Integer(), _
    ByVal fint As Integer, ByVal nrv As Integer, <[In]()> ByVal rvid As Integer(), _
    ByVal nvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal rint As Integer, _
    ByVal svid As Integer, <[In](),Out()> ByVal gamma As Double(), ByRef nff As Integer, _
    ByRef nrf As Integer, ByRef df As Integer, ByRef reml As Double, _
    ByVal lb As Integer, <Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    ByVal maxit As Integer, ByVal tol As Double, ByRef warn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02jac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal tddat As Integer, <[In]()> ByVal levels As Integer(), ByVal yvid As Integer, _
    ByVal cwid As Integer, ByVal nfv As Integer, <[In]()> ByVal fvid As Integer(), _
    ByVal fint As Integer, ByVal nrv As Integer, <[In]()> ByVal rvid As Integer(), _
    ByVal nvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal rint As Integer, _
    ByVal svid As Integer, <[In](),Out()> ByVal gamma As Double(), ByRef nff As Integer, _
    ByRef nrf As Integer, ByRef df As Integer, ByRef reml As Double, _
    ByVal lb As Integer, <Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    ByVal maxit As Integer, ByVal tol As Double, ByRef warn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ml_mixed_regsn Lib "CLW3225DA_nag.dll" Alias "g02jbc" ( _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal tddat As Integer, <[In]()> ByVal levels As Integer(), ByVal yvid As Integer, _
    ByVal cwid As Integer, ByVal nfv As Integer, <[In]()> ByVal fvid As Integer(), _
    ByVal fint As Integer, ByVal nrv As Integer, <[In]()> ByVal rvid As Integer(), _
    ByVal nvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal rint As Integer, _
    ByVal svid As Integer, <[In](),Out()> ByVal gamma As Double(), ByRef nff As Integer, _
    ByRef nrf As Integer, ByRef df As Integer, ByRef ml As Double, _
    ByVal lb As Integer, <Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    ByVal maxit As Integer, ByVal tol As Double, ByRef warn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal tddat As Integer, <[In]()> ByVal levels As Integer(), ByVal yvid As Integer, _
    ByVal cwid As Integer, ByVal nfv As Integer, <[In]()> ByVal fvid As Integer(), _
    ByVal fint As Integer, ByVal nrv As Integer, <[In]()> ByVal rvid As Integer(), _
    ByVal nvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal rint As Integer, _
    ByVal svid As Integer, <[In](),Out()> ByVal gamma As Double(), ByRef nff As Integer, _
    ByRef nrf As Integer, ByRef df As Integer, ByRef ml As Double, _
    ByVal lb As Integer, <Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    ByVal maxit As Integer, ByVal tol As Double, ByRef warn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_hier_mixed_init Lib "CLW3225DA_nag.dll" Alias "g02jcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal pddat As Integer, <[In]()> ByVal levels As Integer(), <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal dnfixed As Integer(), ByVal lfixed As Integer, _
    ByVal nrndm As Integer, <[In]()> ByVal rndm As Integer(), ByVal lrndm As Integer, _
    ByRef nff As Integer, ByRef nlsv As Integer, ByRef nrf As Integer, _
    <Out()> ByVal rcomm As Double(), ByVal lrcomm As Integer, <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, ByRef fail As NagError _
   )

   Declare Sub g02jcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal ncol As Integer, <[In]()> ByVal dat As Double(), _
    ByVal pddat As Integer, <[In]()> ByVal levels As Integer(), <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), <[In]()> ByVal dnfixed As Integer(), ByVal lfixed As Integer, _
    ByVal nrndm As Integer, <[In]()> ByVal rndm As Integer(), ByVal lrndm As Integer, _
    ByRef nff As Integer, ByRef nlsv As Integer, ByRef nrf As Integer, _
    <Out()> ByVal rcomm As Double(), ByVal lrcomm As Integer, <Out()> ByVal icomm As Integer(), _
    ByVal licomm As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_reml_hier_mixed_regsn Lib "CLW3225DA_nag.dll" Alias "g02jdc" ( _
    ByVal lvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal nvpr As Integer, _
    <[In](),Out()> ByVal gamma As Double(), ByRef effn As Integer, ByRef rnkx As Integer, _
    ByRef ncov As Integer, ByRef lnlike As Double, ByVal lb As Integer, _
    <Out()> ByVal id As Integer(), ByVal pdid As Integer, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal czz As Double(), ByVal pdczz As Integer, _
    <Out()> ByVal cxx As Double(), ByVal pdcxx As Integer, <Out()> ByVal cxz As Double(), _
    ByVal pdcxz As Integer, <[In]()> ByVal rcomm As Double(), <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal iopt As Integer(), ByVal liopt As Integer, <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, ByRef fail As NagError _
   )

   Declare Sub g02jdc Lib "CLW3225DA_nag.dll" ( _
    ByVal lvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal nvpr As Integer, _
    <[In](),Out()> ByVal gamma As Double(), ByRef effn As Integer, ByRef rnkx As Integer, _
    ByRef ncov As Integer, ByRef lnlike As Double, ByVal lb As Integer, _
    <Out()> ByVal id As Integer(), ByVal pdid As Integer, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal czz As Double(), ByVal pdczz As Integer, _
    <Out()> ByVal cxx As Double(), ByVal pdcxx As Integer, <Out()> ByVal cxz As Double(), _
    ByVal pdcxz As Integer, <[In]()> ByVal rcomm As Double(), <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal iopt As Integer(), ByVal liopt As Integer, <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_ml_hier_mixed_regsn Lib "CLW3225DA_nag.dll" Alias "g02jec" ( _
    ByVal lvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal nvpr As Integer, _
    <[In](),Out()> ByVal gamma As Double(), ByRef effn As Integer, ByRef rnkx As Integer, _
    ByRef ncov As Integer, ByRef lnlike As Double, ByVal lb As Integer, _
    <Out()> ByVal id As Integer(), ByVal pdid As Integer, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal czz As Double(), ByVal pdczz As Integer, _
    <Out()> ByVal cxx As Double(), ByVal pdcxx As Integer, <Out()> ByVal cxz As Double(), _
    ByVal pdcxz As Integer, <[In]()> ByVal rcomm As Double(), <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal iopt As Integer(), ByVal liopt As Integer, <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, ByRef fail As NagError _
   )

   Declare Sub g02jec Lib "CLW3225DA_nag.dll" ( _
    ByVal lvpr As Integer, <[In]()> ByVal vpr As Integer(), ByVal nvpr As Integer, _
    <[In](),Out()> ByVal gamma As Double(), ByRef effn As Integer, ByRef rnkx As Integer, _
    ByRef ncov As Integer, ByRef lnlike As Double, ByVal lb As Integer, _
    <Out()> ByVal id As Integer(), ByVal pdid As Integer, <Out()> ByVal b As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal czz As Double(), ByVal pdczz As Integer, _
    <Out()> ByVal cxx As Double(), ByVal pdcxx As Integer, <Out()> ByVal cxz As Double(), _
    ByVal pdcxz As Integer, <[In]()> ByVal rcomm As Double(), <[In]()> ByVal icomm As Integer(), _
    <[In]()> ByVal iopt As Integer(), ByVal liopt As Integer, <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_regsn_ridge_opt Lib "CLW3225DA_nag.dll" Alias "g02kac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal tau As Double, <[In]()> ByVal y As Double(), ByRef h As Double, _
    ByVal opt As Nag_PredictError, ByRef niter As Integer, ByVal tol As Double, _
    ByRef nep As Double, ByVal orig As Nag_EstimatesOption, <Out()> ByVal b As Double(), _
    <Out()> ByVal vif As Double(), <Out()> ByVal res As Double(), ByRef rss As Double, _
    ByRef df As Integer, ByVal optloo As Nag_OptionLOO, <Out()> ByVal perr As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02kac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal tau As Double, <[In]()> ByVal y As Double(), ByRef h As Double, _
    ByVal opt As Nag_PredictError, ByRef niter As Integer, ByVal tol As Double, _
    ByRef nep As Double, ByVal orig As Nag_EstimatesOption, <Out()> ByVal b As Double(), _
    <Out()> ByVal vif As Double(), <Out()> ByVal res As Double(), ByRef rss As Double, _
    ByRef df As Integer, ByVal optloo As Nag_OptionLOO, <Out()> ByVal perr As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_ridge Lib "CLW3225DA_nag.dll" Alias "g02kbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    <[In]()> ByVal y As Double(), ByVal lh As Integer, <[In]()> ByVal h As Double(), _
    <Out()> ByVal nep As Double(), ByVal wantb As Nag_ParaOption, <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal wantvf As Nag_VIFOption, <Out()> ByVal vf As Double(), _
    ByVal pdvf As Integer, ByVal lpec As Integer, ByVal pec As Nag_PredictError, _
    <Out()> ByVal pe As Double(), ByVal pdpe As Integer, ByRef fail As NagError _
   )

   Declare Sub g02kbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    <[In]()> ByVal y As Double(), ByVal lh As Integer, <[In]()> ByVal h As Double(), _
    <Out()> ByVal nep As Double(), ByVal wantb As Nag_ParaOption, <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal wantvf As Nag_VIFOption, <Out()> ByVal vf As Double(), _
    ByVal pdvf As Integer, ByVal lpec As Integer, ByVal pec As Nag_PredictError, _
    <Out()> ByVal pe As Double(), ByVal pdpe As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_pls_orth_scores_svd Lib "CLW3225DA_nag.dll" Alias "g02lac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal mx As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal my As Integer, <[In]()> ByVal y As Double(), ByVal pdy As Integer, _
    <Out()> ByVal xbar As Double(), <Out()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, _
    <[In](),Out()> ByVal xstd As Double(), <[In](),Out()> ByVal ystd As Double(), ByVal maxfac As Integer, _
    <Out()> ByVal xres As Double(), ByVal pdxres As Integer, <Out()> ByVal yres As Double(), _
    ByVal pdyres As Integer, <Out()> ByVal w As Double(), ByVal pdw As Integer, _
    <Out()> ByVal p As Double(), ByVal pdp As Integer, <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, <Out()> ByVal c As Double(), ByVal pdc As Integer, _
    <Out()> ByVal u As Double(), ByVal pdu As Integer, <Out()> ByVal xcv As Double(), _
    <Out()> ByVal ycv As Double(), ByVal pdycv As Integer, ByRef fail As NagError _
   )

   Declare Sub g02lac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal mx As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal my As Integer, <[In]()> ByVal y As Double(), ByVal pdy As Integer, _
    <Out()> ByVal xbar As Double(), <Out()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, _
    <[In](),Out()> ByVal xstd As Double(), <[In](),Out()> ByVal ystd As Double(), ByVal maxfac As Integer, _
    <Out()> ByVal xres As Double(), ByVal pdxres As Integer, <Out()> ByVal yres As Double(), _
    ByVal pdyres As Integer, <Out()> ByVal w As Double(), ByVal pdw As Integer, _
    <Out()> ByVal p As Double(), ByVal pdp As Integer, <Out()> ByVal t As Double(), _
    ByVal pdt As Integer, <Out()> ByVal c As Double(), ByVal pdc As Integer, _
    <Out()> ByVal u As Double(), ByVal pdu As Integer, <Out()> ByVal xcv As Double(), _
    <Out()> ByVal ycv As Double(), ByVal pdycv As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_pls_orth_scores_wold Lib "CLW3225DA_nag.dll" Alias "g02lbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal mx As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal my As Integer, <[In]()> ByVal y As Double(), ByVal pdy As Integer, _
    <Out()> ByVal xbar As Double(), <Out()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, _
    <[In](),Out()> ByVal xstd As Double(), <[In](),Out()> ByVal ystd As Double(), ByVal maxfac As Integer, _
    ByVal maxit As Integer, ByVal tau As Double, <Out()> ByVal xres As Double(), _
    ByVal pdxres As Integer, <Out()> ByVal yres As Double(), ByVal pdyres As Integer, _
    <Out()> ByVal w As Double(), ByVal pdw As Integer, <Out()> ByVal p As Double(), _
    ByVal pdp As Integer, <Out()> ByVal t As Double(), ByVal pdt As Integer, _
    <Out()> ByVal c As Double(), ByVal pdc As Integer, <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal xcv As Double(), <Out()> ByVal ycv As Double(), _
    ByVal pdycv As Integer, ByRef fail As NagError _
   )

   Declare Sub g02lbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal mx As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal ip As Integer, _
    ByVal my As Integer, <[In]()> ByVal y As Double(), ByVal pdy As Integer, _
    <Out()> ByVal xbar As Double(), <Out()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, _
    <[In](),Out()> ByVal xstd As Double(), <[In](),Out()> ByVal ystd As Double(), ByVal maxfac As Integer, _
    ByVal maxit As Integer, ByVal tau As Double, <Out()> ByVal xres As Double(), _
    ByVal pdxres As Integer, <Out()> ByVal yres As Double(), ByVal pdyres As Integer, _
    <Out()> ByVal w As Double(), ByVal pdw As Integer, <Out()> ByVal p As Double(), _
    ByVal pdp As Integer, <Out()> ByVal t As Double(), ByVal pdt As Integer, _
    <Out()> ByVal c As Double(), ByVal pdc As Integer, <Out()> ByVal u As Double(), _
    ByVal pdu As Integer, <Out()> ByVal xcv As Double(), <Out()> ByVal ycv As Double(), _
    ByVal pdycv As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_pls_orth_scores_fit Lib "CLW3225DA_nag.dll" Alias "g02lcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As Integer, ByVal my As Integer, ByVal maxfac As Integer, _
    ByVal nfact As Integer, <[In]()> ByVal p As Double(), ByVal pdp As Integer, _
    <[In]()> ByVal c As Double(), ByVal pdc As Integer, <[In]()> ByVal w As Double(), _
    ByVal pdw As Integer, ByVal rcond As Double, <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal orig As Nag_EstimatesOption, <[In]()> ByVal xbar As Double(), _
    <[In]()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, <[In]()> ByVal xstd As Double(), _
    <[In]()> ByVal ystd As Double(), <Out()> ByVal ob As Double(), ByVal pdob As Integer, _
    ByVal vipopt As Integer, <[In]()> ByVal ycv As Double(), ByVal pdycv As Integer, _
    <Out()> ByVal vip As Double(), ByVal pdvip As Integer, ByRef fail As NagError _
   )

   Declare Sub g02lcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As Integer, ByVal my As Integer, ByVal maxfac As Integer, _
    ByVal nfact As Integer, <[In]()> ByVal p As Double(), ByVal pdp As Integer, _
    <[In]()> ByVal c As Double(), ByVal pdc As Integer, <[In]()> ByVal w As Double(), _
    ByVal pdw As Integer, ByVal rcond As Double, <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, ByVal orig As Nag_EstimatesOption, <[In]()> ByVal xbar As Double(), _
    <[In]()> ByVal ybar As Double(), ByVal iscale As Nag_ScalePredictor, <[In]()> ByVal xstd As Double(), _
    <[In]()> ByVal ystd As Double(), <Out()> ByVal ob As Double(), ByVal pdob As Integer, _
    ByVal vipopt As Integer, <[In]()> ByVal ycv As Double(), ByVal pdycv As Integer, _
    <Out()> ByVal vip As Double(), ByVal pdvip As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_pls_orth_scores_pred Lib "CLW3225DA_nag.dll" Alias "g02ldc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As Integer, _
    ByVal my As Integer, _
    ByVal orig As Nag_EstimatesOption, _
    <[In]()> ByVal xbar As Double(), _
    <[In]()> ByVal ybar As Double(), _
    ByVal iscale As Nag_ScalePredictor, _
    <[In]()> ByVal xstd As Double(), _
    <[In]()> ByVal ystd As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal n As Integer, _
    ByVal mz As Integer, _
    <[In]()> ByVal isz As Integer(), _
    <[In]()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal yhat As Double(), _
    ByVal pdyhat As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02ldc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ip As Integer, _
    ByVal my As Integer, _
    ByVal orig As Nag_EstimatesOption, _
    <[In]()> ByVal xbar As Double(), _
    <[In]()> ByVal ybar As Double(), _
    ByVal iscale As Nag_ScalePredictor, _
    <[In]()> ByVal xstd As Double(), _
    <[In]()> ByVal ystd As Double(), _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    ByVal n As Integer, _
    ByVal mz As Integer, _
    <[In]()> ByVal isz As Integer(), _
    <[In]()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <Out()> ByVal yhat As Double(), _
    ByVal pdyhat As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_lars Lib "CLW3225DA_nag.dll" Alias "g02mac" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal prey As Nag_LARSPreProcess, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal mnstep As Integer, _
    ByRef ip As Integer, _
    ByRef nstep As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal fitsum As Double(), _
    <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02mac Lib "CLW3225DA_nag.dll" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal prey As Nag_LARSPreProcess, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal pdd As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal mnstep As Integer, _
    ByRef ip As Integer, _
    ByRef nstep As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal fitsum As Double(), _
    <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_lars_xtx Lib "CLW3225DA_nag.dll" Alias "g02mbc" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal intcpt As Nag_LARSPreProcess, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal dtd As Double(), _
    ByVal pddtd As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal dty As Double(), _
    ByVal yty As Double, _
    ByVal mnstep As Integer, _
    ByRef ip As Integer, _
    ByRef nstep As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal fitsum As Double(), _
    <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02mbc Lib "CLW3225DA_nag.dll" ( _
    ByVal mtype As Nag_LARSModelType, _
    ByVal pred As Nag_LARSPreProcess, _
    ByVal intcpt As Nag_LARSPreProcess, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal dtd As Double(), _
    ByVal pddtd As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal dty As Double(), _
    ByVal yty As Double, _
    ByVal mnstep As Integer, _
    ByRef ip As Integer, _
    ByRef nstep As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <Out()> ByVal fitsum As Double(), _
    <[In]()> ByVal ropt As Double(), _
    ByVal lropt As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_lars_param Lib "CLW3225DA_nag.dll" Alias "g02mcc" ( _
    ByVal nstep As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal fitsum As Double(), _
    ByVal ktype As Nag_LARSTargetType, _
    <[In]()> ByVal nk As Double(), _
    ByVal lnk As Integer, _
    <Out()> ByVal nb As Double(), _
    ByVal pdnb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02mcc Lib "CLW3225DA_nag.dll" ( _
    ByVal nstep As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal fitsum As Double(), _
    ByVal ktype As Nag_LARSTargetType, _
    <[In]()> ByVal nk As Double(), _
    ByVal lnk As Integer, _
    <Out()> ByVal nb As Double(), _
    ByVal pdnb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_quant_linear_iid Lib "CLW3225DA_nag.dll" Alias "g02qfc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal ntau As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef df As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal bl As Double(), _
    <Out()> ByVal bu As Double(), _
    <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g02qfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal ntau As Integer, _
    <[In]()> ByVal tau As Double(), _
    ByRef df As Double, _
    <Out()> ByVal b As Double(), _
    <Out()> ByVal bl As Double(), _
    <Out()> ByVal bu As Double(), _
    <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_regsn_quant_linear Lib "CLW3225DA_nag.dll" Alias "g02qgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal intcpt As Nag_IncludeIntercept, ByVal n As Integer, ByVal m As Integer, _
    <[In]()> ByVal dat As Double(), ByVal pddat As Integer, <[In]()> ByVal isx As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), _
    ByVal ntau As Integer, <[In]()> ByVal tau As Double(), ByRef df As Double, _
    <[In](),Out()> ByVal b As Double(), <Out()> ByVal bl As Double(), <Out()> ByVal bu As Double(), _
    <Out()> ByVal ch As Double(), <Out()> ByVal res As Double(), <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), <[In](),Out()> ByVal state As Integer(), <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g02qgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal intcpt As Nag_IncludeIntercept, ByVal n As Integer, ByVal m As Integer, _
    <[In]()> ByVal dat As Double(), ByVal pddat As Integer, <[In]()> ByVal isx As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal y As Double(), <[In]()> ByVal wt As Double(), _
    ByVal ntau As Integer, <[In]()> ByVal tau As Double(), ByRef df As Double, _
    <[In](),Out()> ByVal b As Double(), <Out()> ByVal bl As Double(), <Out()> ByVal bu As Double(), _
    <Out()> ByVal ch As Double(), <Out()> ByVal res As Double(), <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), <[In](),Out()> ByVal state As Integer(), <Out()> ByVal info As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_g02_opt_set Lib "CLW3225DA_nag.dll" Alias "g02zkc" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g02zkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_g02_opt_get Lib "CLW3225DA_nag.dll" Alias "g02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g02zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


' chapter g03

   Declare Sub nag_mv_prin_comp Lib "CLW3225DA_nag.dll" Alias "g03aac" ( _
    ByVal pcmatrix As Nag_PrinCompMat, _
    ByVal scores As Nag_PrinCompScores, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In](),Out()> ByVal s As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal nvar As Integer, _
    <Out()> ByVal e As Double(), _
    ByVal tde As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tdp As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03aac Lib "CLW3225DA_nag.dll" ( _
    ByVal pcmatrix As Nag_PrinCompMat, _
    ByVal scores As Nag_PrinCompScores, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In](),Out()> ByVal s As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal nvar As Integer, _
    <Out()> ByVal e As Double(), _
    ByVal tde As Integer, _
    <Out()> ByVal p As Double(), _
    ByVal tdp As Integer, _
    <Out()> ByVal v As Double(), _
    ByVal tdv As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_canon_var Lib "CLW3225DA_nag.dll" Alias "g03acc" ( _
    ByVal weight As Nag_Weightstype, ByVal n As Integer, ByVal m As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, <[In]()> ByVal isx As Integer(), _
    ByVal nx As Integer, <[In]()> ByVal ing As Integer(), ByVal ng As Integer, _
    <[In]()> ByVal wt As Double(), <Out()> ByVal nig As Integer(), <Out()> ByVal cvm As Double(), _
    ByVal tdcvm As Integer, <Out()> ByVal e As Double(), ByVal tde As Integer, _
    ByRef ncv As Integer, <Out()> ByVal cvx As Double(), ByVal tdcvx As Integer, _
    ByVal tol As Double, ByRef irankx As Integer, ByRef fail As NagError _
   )

   Declare Sub g03acc Lib "CLW3225DA_nag.dll" ( _
    ByVal weight As Nag_Weightstype, ByVal n As Integer, ByVal m As Integer, _
    <[In]()> ByVal x As Double(), ByVal tdx As Integer, <[In]()> ByVal isx As Integer(), _
    ByVal nx As Integer, <[In]()> ByVal ing As Integer(), ByVal ng As Integer, _
    <[In]()> ByVal wt As Double(), <Out()> ByVal nig As Integer(), <Out()> ByVal cvm As Double(), _
    ByVal tdcvm As Integer, <Out()> ByVal e As Double(), ByVal tde As Integer, _
    ByRef ncv As Integer, <Out()> ByVal cvx As Double(), ByVal tdcvx As Integer, _
    ByVal tol As Double, ByRef irankx As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_mv_canon_corr Lib "CLW3225DA_nag.dll" Alias "g03adc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal tdz As Integer, _
    <[In]()> ByVal isz As Integer(), _
    ByVal nx As Integer, _
    ByVal ny As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal e As Double(), _
    ByVal tde As Integer, _
    ByRef ncv As Integer, _
    <Out()> ByVal cvx As Double(), _
    ByVal tdcvx As Integer, _
    <Out()> ByVal cvy As Double(), _
    ByVal tdcvy As Integer, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g03adc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal tdz As Integer, _
    <[In]()> ByVal isz As Integer(), _
    ByVal nx As Integer, _
    ByVal ny As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal e As Double(), _
    ByVal tde As Integer, _
    ByRef ncv As Integer, _
    <Out()> ByVal cvx As Double(), _
    ByVal tdcvx As Integer, _
    <Out()> ByVal cvy As Double(), _
    ByVal tdcvy As Integer, _
    ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_orthomax Lib "CLW3225DA_nag.dll" Alias "g03bac" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal g As Double, _
    ByVal nvar As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal fl As Double(), _
    ByVal tdf As Integer, _
    <Out()> ByVal flr As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    ByVal acc As Double, _
    ByVal maxit As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03bac Lib "CLW3225DA_nag.dll" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal g As Double, _
    ByVal nvar As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal fl As Double(), _
    ByVal tdf As Integer, _
    <Out()> ByVal flr As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    ByVal acc As Double, _
    ByVal maxit As Integer, _
    ByRef iter As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_procustes Lib "CLW3225DA_nag.dll" Alias "g03bcc" ( _
    ByVal stand As Nag_TransNorm, _
    ByVal pscale As Nag_RotationScale, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tdy As Integer, _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    ByRef alpha As Double, _
    ByRef rss As Double, _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g03bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal stand As Nag_TransNorm, _
    ByVal pscale As Nag_RotationScale, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    ByVal tdy As Integer, _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    ByRef alpha As Double, _
    ByRef rss As Double, _
    <Out()> ByVal res As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_promax Lib "CLW3225DA_nag.dll" Alias "g03bdc" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal ro As Double(), _
    ByVal pdro As Integer, _
    ByVal power As Double, _
    <Out()> ByVal fp As Double(), _
    ByVal pdfp As Integer, _
    <Out()> ByVal r As Double(), _
    ByVal pdr As Integer, _
    <Out()> ByVal phi As Double(), _
    ByVal pdphi As Integer, _
    <Out()> ByVal fs As Double(), _
    ByVal pdfs As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal stand As Nag_RotationLoading, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal ro As Double(), _
    ByVal pdro As Integer, _
    ByVal power As Double, _
    <Out()> ByVal fp As Double(), _
    ByVal pdfp As Integer, _
    <Out()> ByVal r As Double(), _
    ByVal pdr As Integer, _
    <Out()> ByVal phi As Double(), _
    ByVal pdphi As Integer, _
    <Out()> ByVal fs As Double(), _
    ByVal pdfs As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_factor Lib "CLW3225DA_nag.dll" Alias "g03cac" ( _
    ByVal matrix As Nag_FacMat, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal nvar As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nfac As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal stat As Double(), _
    <Out()> ByVal com As Double(), _
    <Out()> ByVal psi As Double(), _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal fl As Double(), _
    ByVal tdfl As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByVal eps As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g03cac Lib "CLW3225DA_nag.dll" ( _
    ByVal matrix As Nag_FacMat, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal nvar As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nfac As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal e As Double(), _
    <Out()> ByVal stat As Double(), _
    <Out()> ByVal com As Double(), _
    <Out()> ByVal psi As Double(), _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal fl As Double(), _
    ByVal tdfl As Integer, _
    ByRef ops As Nag_E04_Opt, _
    ByVal eps As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_fac_score Lib "CLW3225DA_nag.dll" Alias "g03ccc" ( _
    ByVal method As Nag_FacScoreMethod, _
    ByVal rotate As Nag_FacRotation, _
    ByVal nvar As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal fl As Double(), _
    ByVal tdfl As Integer, _
    <[In]()> ByVal psi As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In]()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal fs As Double(), _
    ByVal tdfs As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_FacScoreMethod, _
    ByVal rotate As Nag_FacRotation, _
    ByVal nvar As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal fl As Double(), _
    ByVal tdfl As Integer, _
    <[In]()> ByVal psi As Double(), _
    <[In]()> ByVal e As Double(), _
    <[In]()> ByVal r As Double(), _
    ByVal tdr As Integer, _
    <Out()> ByVal fs As Double(), _
    ByVal tdfs As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_discrim Lib "CLW3225DA_nag.dll" Alias "g03dac" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nvar As Integer, _
    <[In]()> ByVal ing As Integer(), _
    ByVal ng As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal nig As Integer(), _
    <Out()> ByVal gmean As Double(), _
    ByVal tdg As Integer, _
    <Out()> ByVal det As Double(), _
    <Out()> ByVal gc As Double(), _
    ByRef stat As Double, _
    ByRef df As Double, _
    ByRef sig As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g03dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nvar As Integer, _
    <[In]()> ByVal ing As Integer(), _
    ByVal ng As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal nig As Integer(), _
    <Out()> ByVal gmean As Double(), _
    ByVal tdg As Integer, _
    <Out()> ByVal det As Double(), _
    <Out()> ByVal gc As Double(), _
    ByRef stat As Double, _
    ByRef df As Double, _
    ByRef sig As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_discrim_mahaldist Lib "CLW3225DA_nag.dll" Alias "g03dbc" ( _
    ByVal equal As Nag_GroupCovars, _
    ByVal mode As Nag_MahalDist, _
    ByVal nvar As Integer, _
    ByVal ng As Integer, _
    <[In]()> ByVal gmean As Double(), _
    ByVal tdg As Integer, _
    <[In]()> ByVal gc As Double(), _
    ByVal nobs As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <Out()> ByVal d As Double(), _
    ByVal tdd As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal equal As Nag_GroupCovars, _
    ByVal mode As Nag_MahalDist, _
    ByVal nvar As Integer, _
    ByVal ng As Integer, _
    <[In]()> ByVal gmean As Double(), _
    ByVal tdg As Integer, _
    <[In]()> ByVal gc As Double(), _
    ByVal nobs As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <Out()> ByVal d As Double(), _
    ByVal tdd As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_discrim_group Lib "CLW3225DA_nag.dll" Alias "g03dcc" ( _
    ByVal typ As Nag_DiscrimMethod, ByVal equal As Nag_GroupCovars, ByVal priors As Nag_PriorProbability, _
    ByVal nvar As Integer, ByVal ng As Integer, <[In]()> ByVal nig As Integer(), _
    <[In]()> ByVal gmean As Double(), ByVal tdg As Integer, <[In]()> ByVal gc As Double(), _
    <[In]()> ByVal det As Double(), ByVal nobs As Integer, ByVal m As Integer, _
    <[In]()> ByVal isx As Integer(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    <[In](),Out()> ByVal prior As Double(), <Out()> ByVal p As Double(), ByVal tdp As Integer, _
    <Out()> ByVal iag As Integer(), ByVal atiq As Nag_Boolean, <Out()> ByVal ati As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g03dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_DiscrimMethod, ByVal equal As Nag_GroupCovars, ByVal priors As Nag_PriorProbability, _
    ByVal nvar As Integer, ByVal ng As Integer, <[In]()> ByVal nig As Integer(), _
    <[In]()> ByVal gmean As Double(), ByVal tdg As Integer, <[In]()> ByVal gc As Double(), _
    <[In]()> ByVal det As Double(), ByVal nobs As Integer, ByVal m As Integer, _
    <[In]()> ByVal isx As Integer(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    <[In](),Out()> ByVal prior As Double(), <Out()> ByVal p As Double(), ByVal tdp As Integer, _
    <Out()> ByVal iag As Integer(), ByVal atiq As Nag_Boolean, <Out()> ByVal ati As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_distance_mat Lib "CLW3225DA_nag.dll" Alias "g03eac" ( _
    ByVal update As Nag_MatUpdate, _
    ByVal dist As Nag_DistanceType, _
    ByVal dnscale As Nag_VarScaleType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g03eac Lib "CLW3225DA_nag.dll" ( _
    ByVal update As Nag_MatUpdate, _
    ByVal dist As Nag_DistanceType, _
    ByVal dnscale As Nag_VarScaleType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In](),Out()> ByVal s As Double(), _
    <[In](),Out()> ByVal d As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_hierar_cluster_analysis Lib "CLW3225DA_nag.dll" Alias "g03ecc" ( _
    ByVal method As Nag_ClusterMethod, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal ilc As Integer(), _
    <Out()> ByVal iuc As Integer(), _
    <Out()> ByVal cd As Double(), _
    <Out()> ByVal iord As Integer(), _
    <Out()> ByVal dord As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g03ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_ClusterMethod, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal d As Double(), _
    <Out()> ByVal ilc As Integer(), _
    <Out()> ByVal iuc As Integer(), _
    <Out()> ByVal cd As Double(), _
    <Out()> ByVal iord As Integer(), _
    <Out()> ByVal dord As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_kmeans_cluster_analysis Lib "CLW3225DA_nag.dll" Alias "g03efc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nvar As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal cmeans As Double(), _
    ByVal tdc As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal inc As Integer(), _
    <Out()> ByVal nic As Integer(), _
    <Out()> ByVal css As Double(), _
    <Out()> ByVal csw As Double(), _
    ByVal maxit As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03efc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal isx As Integer(), _
    ByVal nvar As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal cmeans As Double(), _
    ByVal tdc As Integer, _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal inc As Integer(), _
    <Out()> ByVal nic As Integer(), _
    <Out()> ByVal css As Double(), _
    <Out()> ByVal csw As Double(), _
    ByVal maxit As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_dendrogram Lib "CLW3225DA_nag.dll" Alias "g03ehc" ( _
    ByVal orient As Nag_DendOrient, _
    ByVal n As Integer, _
    <[In]()> ByVal dord As Double(), _
    ByVal dmin As Double, _
    ByVal dstep As Double, _
    ByVal nsym As Integer, _
    ByVal c As String, _
    ByRef fail As NagError _
   )

   Declare Sub g03ehc Lib "CLW3225DA_nag.dll" ( _
    ByVal orient As Nag_DendOrient, _
    ByVal n As Integer, _
    <[In]()> ByVal dord As Double(), _
    ByVal dmin As Double, _
    ByVal dstep As Double, _
    ByVal nsym As Integer, _
    ByVal c As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_cluster_indicator Lib "CLW3225DA_nag.dll" Alias "g03ejc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal cd As Double(), _
    <[In]()> ByVal iord As Integer(), _
    <[In]()> ByVal dord As Double(), _
    ByRef k As Integer, _
    ByRef dlevel As Double, _
    <Out()> ByVal ic As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g03ejc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal cd As Double(), _
    <[In]()> ByVal iord As Integer(), _
    <[In]()> ByVal dord As Double(), _
    ByRef k As Integer, _
    ByRef dlevel As Double, _
    <Out()> ByVal ic As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_prin_coord_analysis Lib "CLW3225DA_nag.dll" Alias "g03fac" ( _
    ByVal roots As Nag_Eigenvalues, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal ndim As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <Out()> ByVal eval As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g03fac Lib "CLW3225DA_nag.dll" ( _
    ByVal roots As Nag_Eigenvalues, _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal ndim As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <Out()> ByVal eval As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_ordinal_multidimscale Lib "CLW3225DA_nag.dll" Alias "g03fcc" ( _
    ByVal typ As Nag_ScaleCriterion, _
    ByVal n As Integer, _
    ByVal ndim As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef stress As Double, _
    <Out()> ByVal dfit As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub g03fcc Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_ScaleCriterion, _
    ByVal n As Integer, _
    ByVal ndim As Integer, _
    <[In]()> ByVal d As Double(), _
    <[In](),Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef stress As Double, _
    <Out()> ByVal dfit As Double(), _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mv_gaussian_mixture Lib "CLW3225DA_nag.dll" Alias "g03gac" ( _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal nvar As Integer, _
    ByVal ng As Integer, ByVal popt As Nag_Boolean, <[In](),Out()> ByVal prob As Double(), _
    ByVal tdprob As Integer, ByRef niter As Integer, ByVal riter As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal g As Double(), ByVal sopt As Nag_VarCovar, _
    <Out()> ByVal s As Double(), <Out()> ByVal f As Double(), ByVal tol As Double, _
    ByRef loglik As Double, ByRef fail As NagError _
   )

   Declare Sub g03gac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, <[In]()> ByVal isx As Integer(), ByVal nvar As Integer, _
    ByVal ng As Integer, ByVal popt As Nag_Boolean, <[In](),Out()> ByVal prob As Double(), _
    ByVal tdprob As Integer, ByRef niter As Integer, ByVal riter As Integer, _
    <Out()> ByVal w As Double(), <Out()> ByVal g As Double(), ByVal sopt As Nag_VarCovar, _
    <Out()> ByVal s As Double(), <Out()> ByVal f As Double(), ByVal tol As Double, _
    ByRef loglik As Double, ByRef fail As NagError _
   )


   Declare Sub nag_mv_dend_free Lib "CLW3225DA_nag.dll" Alias "g03xzc" ( _
    ByVal c As String _
   )

   Declare Sub g03xzc Lib "CLW3225DA_nag.dll" ( _
    ByVal c As String _
   )


   Declare Sub nag_mv_z_scores Lib "CLW3225DA_nag.dll" Alias "g03zac" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal nvar As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal s As Double(), _
    <[In]()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal tdz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g03zac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByVal nvar As Integer, _
    <[In]()> ByVal isx As Integer(), _
    <[In]()> ByVal s As Double(), _
    <[In]()> ByVal e As Double(), _
    <Out()> ByVal z As Double(), _
    ByVal tdz As Integer, _
    ByRef fail As NagError _
   )


' chapter g04

   Declare Sub nag_anova_random Lib "CLW3225DA_nag.dll" Alias "g04bbc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal blocks As Nag_Blocks, _
    ByVal iblock As Integer, _
    ByVal nt As Integer, _
    <[In]()> ByVal it As Integer(), _
    ByRef gmean As Double, _
    <Out()> ByVal bmean As Double(), _
    <Out()> ByVal tmean As Double(), _
    <Out()> ByVal table As Double(), _
    <Out()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <Out()> ByVal irep As Integer(), _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal ef As Double(), _
    ByVal tol As Double, _
    ByVal irdf As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g04bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal blocks As Nag_Blocks, _
    ByVal iblock As Integer, _
    ByVal nt As Integer, _
    <[In]()> ByVal it As Integer(), _
    ByRef gmean As Double, _
    <Out()> ByVal bmean As Double(), _
    <Out()> ByVal tmean As Double(), _
    <Out()> ByVal table As Double(), _
    <Out()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <Out()> ByVal irep As Integer(), _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal ef As Double(), _
    ByVal tol As Double, _
    ByVal irdf As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_anova_row_col Lib "CLW3225DA_nag.dll" Alias "g04bcc" ( _
    ByVal nrep As Integer, ByVal nrow As Integer, ByVal ncol As Integer, _
    <[In]()> ByVal y As Double(), ByVal nt As Integer, <[In]()> ByVal it As Integer(), _
    ByRef gmean As Double, <Out()> ByVal tmean As Double(), <Out()> ByVal table As Double(), _
    <Out()> ByVal c As Double(), ByVal tdc As Integer, <Out()> ByVal irep As Integer(), _
    <Out()> ByVal rpmean As Double(), <Out()> ByVal rmean As Double(), <Out()> ByVal cmean As Double(), _
    <Out()> ByVal r As Double(), <Out()> ByVal ef As Double(), ByVal tol As Double, _
    ByVal irdf As Integer, ByRef fail As NagError _
   )

   Declare Sub g04bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal nrep As Integer, ByVal nrow As Integer, ByVal ncol As Integer, _
    <[In]()> ByVal y As Double(), ByVal nt As Integer, <[In]()> ByVal it As Integer(), _
    ByRef gmean As Double, <Out()> ByVal tmean As Double(), <Out()> ByVal table As Double(), _
    <Out()> ByVal c As Double(), ByVal tdc As Integer, <Out()> ByVal irep As Integer(), _
    <Out()> ByVal rpmean As Double(), <Out()> ByVal rmean As Double(), <Out()> ByVal cmean As Double(), _
    <Out()> ByVal r As Double(), <Out()> ByVal ef As Double(), ByVal tol As Double, _
    ByVal irdf As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_anova_factorial Lib "CLW3225DA_nag.dll" Alias "g04cac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal nfac As Integer, _
    <[In]()> ByVal lfac As Integer(), _
    ByVal nblock As Integer, _
    ByVal inter As Integer, _
    ByVal irdf As Integer, _
    ByRef mterm As Integer, _
    ByRef tablePTR As IntPtr, _
    ByRef tmeanPTR As IntPtr, _
    ByRef maxt As Integer, _
    ByRef ePTR As IntPtr, _
    ByRef imeanPTR As IntPtr, _
    ByRef semeanPTR As IntPtr, _
    ByRef bmeanPTR As IntPtr, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g04cac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal nfac As Integer, _
    <[In]()> ByVal lfac As Integer(), _
    ByVal nblock As Integer, _
    ByVal inter As Integer, _
    ByVal irdf As Integer, _
    ByRef mterm As Integer, _
    ByRef tablePTR As IntPtr, _
    ByRef tmeanPTR As IntPtr, _
    ByRef maxt As Integer, _
    ByRef ePTR As IntPtr, _
    ByRef imeanPTR As IntPtr, _
    ByRef semeanPTR As IntPtr, _
    ByRef bmeanPTR As IntPtr, _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_anova_factorial_free Lib "CLW3225DA_nag.dll" Alias "g04czc" ( _
    ByRef tablePTR As IntPtr, _
    ByRef tmeanPTR As IntPtr, _
    ByRef ePTR As IntPtr, _
    ByRef imeanPTR As IntPtr, _
    ByRef semeanPTR As IntPtr, _
    ByRef bmeanPTR As IntPtr _
   )

   Declare Sub g04czc Lib "CLW3225DA_nag.dll" ( _
    ByRef tablePTR As IntPtr, _
    ByRef tmeanPTR As IntPtr, _
    ByRef ePTR As IntPtr, _
    ByRef imeanPTR As IntPtr, _
    ByRef semeanPTR As IntPtr, _
    ByRef bmeanPTR As IntPtr _
   )


   Declare Sub nag_anova_confid_interval Lib "CLW3225DA_nag.dll" Alias "g04dbc" ( _
    ByVal typ As Nag_IntervalType, _
    ByVal nt As Integer, _
    <[In]()> ByVal tmean As Double(), _
    ByVal rdf As Double, _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    ByVal clevel As Double, _
    <Out()> ByVal cil As Double(), _
    <Out()> ByVal ciu As Double(), _
    <Out()> ByVal isig As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g04dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_IntervalType, _
    ByVal nt As Integer, _
    <[In]()> ByVal tmean As Double(), _
    ByVal rdf As Double, _
    <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    ByVal clevel As Double, _
    <Out()> ByVal cil As Double(), _
    <Out()> ByVal ciu As Double(), _
    <Out()> ByVal isig As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_dummy_vars Lib "CLW3225DA_nag.dll" Alias "g04eac" ( _
    ByVal typ As Nag_DummyType, _
    ByVal n As Integer, _
    ByVal levels As Integer, _
    <[In]()> ByVal factor As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal v As Double(), _
    <Out()> ByVal num_reps As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g04eac Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_DummyType, _
    ByVal n As Integer, _
    ByVal levels As Integer, _
    <[In]()> ByVal factor As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    <[In]()> ByVal v As Double(), _
    <Out()> ByVal num_reps As Double(), _
    ByRef fail As NagError _
   )


' chapter g05

   Declare Sub nag_rand_init_repeatable Lib "CLW3225DA_nag.dll" Alias "g05kfc" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As Integer, _
    <[In]()> ByVal seed As Integer(), _
    ByVal lseed As Integer, _
    <Out()> ByVal state As Integer(), _
    ByRef lstate As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05kfc Lib "CLW3225DA_nag.dll" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As Integer, _
    <[In]()> ByVal seed As Integer(), _
    ByVal lseed As Integer, _
    <Out()> ByVal state As Integer(), _
    ByRef lstate As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_init_nonrepeatable Lib "CLW3225DA_nag.dll" Alias "g05kgc" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As Integer, _
    <Out()> ByVal state As Integer(), _
    ByRef lstate As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05kgc Lib "CLW3225DA_nag.dll" ( _
    ByVal genid As Nag_BaseRNG, _
    ByVal subid As Integer, _
    <Out()> ByVal state As Integer(), _
    ByRef lstate As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_leap_frog Lib "CLW3225DA_nag.dll" Alias "g05khc" ( _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05khc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_skip_ahead Lib "CLW3225DA_nag.dll" Alias "g05kjc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05kjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_skip_ahead_power2 Lib "CLW3225DA_nag.dll" Alias "g05kkc" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05kkc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_permute Lib "CLW3225DA_nag.dll" Alias "g05ncc" ( _
    <[In](),Out()> ByVal indx As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ncc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal indx As Integer(), _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_sample Lib "CLW3225DA_nag.dll" Alias "g05ndc" ( _
    <[In]()> ByVal ipop As Integer(), _
    ByVal n As Integer, _
    <Out()> ByVal isampl As Integer(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ndc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal ipop As Integer(), _
    ByVal n As Integer, _
    <Out()> ByVal isampl As Integer(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_sample_unequal Lib "CLW3225DA_nag.dll" Alias "g05nec" ( _
    ByVal sortorder As Nag_SortOrder, _
    <[In]()> ByVal wt As Double(), _
    <[In]()> ByVal ipop As Integer(), _
    ByVal n As Integer, _
    <Out()> ByVal isampl As Integer(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05nec Lib "CLW3225DA_nag.dll" ( _
    ByVal sortorder As Nag_SortOrder, _
    <[In]()> ByVal wt As Double(), _
    <[In]()> ByVal ipop As Integer(), _
    ByVal n As Integer, _
    <Out()> ByVal isampl As Integer(), _
    ByVal m As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_agarchI Lib "CLW3225DA_nag.dll" Alias "g05pdc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pdc Lib "CLW3225DA_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_agarchII Lib "CLW3225DA_nag.dll" Alias "g05pec" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pec Lib "CLW3225DA_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_garchGJR Lib "CLW3225DA_nag.dll" Alias "g05pfc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pfc Lib "CLW3225DA_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_egarch Lib "CLW3225DA_nag.dll" Alias "g05pgc" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pgc Lib "CLW3225DA_nag.dll" ( _
    ByVal dist As Nag_ErrorDistn, _
    ByVal num As Integer, _
    ByVal ip As Integer, _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal df As Integer, _
    <Out()> ByVal ht As Double(), _
    <Out()> ByVal et As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_arma Lib "CLW3225DA_nag.dll" Alias "g05phc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal xmean As Double, _
    ByVal ip As Integer, _
    <[In]()> ByVal phi As Double(), _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal avar As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef var As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05phc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal xmean As Double, _
    ByVal ip As Integer, _
    <[In]()> ByVal phi As Double(), _
    ByVal iq As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal avar As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef var As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_varma Lib "CLW3225DA_nag.dll" Alias "g05pjc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal xmean As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal phi As Double(), _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    <[In]()> ByVal var As Double(), _
    ByVal pdv As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05pjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal xmean As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal phi As Double(), _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    <[In]()> ByVal var As Double(), _
    ByVal pdv As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_exp_smooth Lib "CLW3225DA_nag.dll" Alias "g05pmc" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal n As Integer, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As Integer, _
    <[In]()> ByVal param As Double(), _
    <[In]()> ByVal init As Double(), _
    ByVal var As Double, _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <[In]()> ByVal e As Double(), _
    ByVal en As Integer, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pmc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal n As Integer, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As Integer, _
    <[In]()> ByVal param As Double(), _
    <[In]()> ByVal init As Double(), _
    ByVal var As Double, _
    <[In](),Out()> ByVal r As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <[In]()> ByVal e As Double(), _
    ByVal en As Integer, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_kfold_xyw Lib "CLW3225DA_nag.dll" Alias "g05pvc" ( _
    ByVal k As Integer, _
    ByVal fold As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal sordx As Nag_DataByObsOrVar, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal w As Double(), _
    ByRef nt As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pvc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal fold As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal sordx As Nag_DataByObsOrVar, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal w As Double(), _
    ByRef nt As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_subsamp_xyw Lib "CLW3225DA_nag.dll" Alias "g05pwc" ( _
    ByVal nt As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal sordx As Nag_DataByObsOrVar, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal w As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05pwc Lib "CLW3225DA_nag.dll" ( _
    ByVal nt As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal sordx As Nag_DataByObsOrVar, _
    <[In](),Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In](),Out()> ByVal y As Double(), _
    <[In](),Out()> ByVal w As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_orthog_matrix Lib "CLW3225DA_nag.dll" Alias "g05pxc" ( _
    ByVal side As Nag_SideType, _
    ByVal init As Nag_InitializeA, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05pxc Lib "CLW3225DA_nag.dll" ( _
    ByVal side As Nag_SideType, _
    ByVal init As Nag_InitializeA, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <[In](),Out()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_corr_matrix Lib "CLW3225DA_nag.dll" Alias "g05pyc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal eps As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05pyc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal d As Double(), _
    ByVal eps As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_2_way_table Lib "CLW3225DA_nag.dll" Alias "g05pzc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal nrow As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal totr As Integer(), _
    <[In]()> ByVal totc As Integer(), _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05pzc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal nrow As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal totr As Integer(), _
    <[In]()> ByVal totc As Integer(), _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_copula_students_t Lib "CLW3225DA_nag.dll" Alias "g05rcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal df As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal df As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_copula_normal Lib "CLW3225DA_nag.dll" Alias "g05rdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bivariate_copula_clayton Lib "CLW3225DA_nag.dll" Alias "g05rec" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bivariate_copula_frank Lib "CLW3225DA_nag.dll" Alias "g05rfc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bivariate_copula_plackett Lib "CLW3225DA_nag.dll" Alias "g05rgc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_copula_clayton Lib "CLW3225DA_nag.dll" Alias "g05rhc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rhc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_copula_frank Lib "CLW3225DA_nag.dll" Alias "g05rjc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_copula_gumbel Lib "CLW3225DA_nag.dll" Alias "g05rkc" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rkc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In](),Out()> ByVal state As Integer(), _
    ByVal theta As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal sdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_matrix_multi_students_t Lib "CLW3225DA_nag.dll" Alias "g05ryc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal df As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal xmu As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05ryc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal df As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal xmu As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_matrix_multi_normal Lib "CLW3225DA_nag.dll" Alias "g05rzc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal xmu As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05rzc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal xmu As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_basic Lib "CLW3225DA_nag.dll" Alias "g05sac" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_beta Lib "CLW3225DA_nag.dll" Alias "g05sbc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_cauchy Lib "CLW3225DA_nag.dll" Alias "g05scc" ( _
    ByVal n As Integer, _
    ByVal xmed As Double, _
    ByVal semiqr As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05scc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmed As Double, _
    ByVal semiqr As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_chi_sq Lib "CLW3225DA_nag.dll" Alias "g05sdc" ( _
    ByVal n As Integer, _
    ByVal df As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal df As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_dirichlet Lib "CLW3225DA_nag.dll" Alias "g05sec" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05sec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_exp Lib "CLW3225DA_nag.dll" Alias "g05sfc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_exp_mix Lib "CLW3225DA_nag.dll" Alias "g05sgc" ( _
    ByVal n As Integer, _
    ByVal nmix As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sgc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal nmix As Integer, _
    <[In]()> ByVal a As Double(), _
    <[In]()> ByVal wgt As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_f Lib "CLW3225DA_nag.dll" Alias "g05shc" ( _
    ByVal n As Integer, _
    ByVal df1 As Integer, _
    ByVal df2 As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05shc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal df1 As Integer, _
    ByVal df2 As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_gamma Lib "CLW3225DA_nag.dll" Alias "g05sjc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_normal Lib "CLW3225DA_nag.dll" Alias "g05skc" ( _
    ByVal n As Integer, _
    ByVal xmu As Double, _
    ByVal var As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05skc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmu As Double, _
    ByVal var As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_logistic Lib "CLW3225DA_nag.dll" Alias "g05slc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05slc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_lognormal Lib "CLW3225DA_nag.dll" Alias "g05smc" ( _
    ByVal n As Integer, _
    ByVal xmu As Double, _
    ByVal var As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05smc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmu As Double, _
    ByVal var As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_students_t Lib "CLW3225DA_nag.dll" Alias "g05snc" ( _
    ByVal n As Integer, _
    ByVal df As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05snc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal df As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_triangular Lib "CLW3225DA_nag.dll" Alias "g05spc" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmed As Double, _
    ByVal xmax As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05spc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmin As Double, _
    ByVal xmed As Double, _
    ByVal xmax As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_uniform Lib "CLW3225DA_nag.dll" Alias "g05sqc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05sqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_von_mises Lib "CLW3225DA_nag.dll" Alias "g05src" ( _
    ByVal n As Integer, _
    ByVal vk As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05src Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal vk As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_weibull Lib "CLW3225DA_nag.dll" Alias "g05ssc" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ssc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Double, _
    ByVal b As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_binomial Lib "CLW3225DA_nag.dll" Alias "g05tac" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tac Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_logical Lib "CLW3225DA_nag.dll" Alias "g05tbc" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Nag_Boolean(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Nag_Boolean(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_geom Lib "CLW3225DA_nag.dll" Alias "g05tcc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tcc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_gen_discrete Lib "CLW3225DA_nag.dll" Alias "g05tdc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal np As Integer, _
    ByVal ip1 As Integer, _
    ByVal itype As Nag_DiscreteDistrib, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tdc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    <[In]()> ByVal p As Double(), _
    ByVal np As Integer, _
    ByVal ip1 As Integer, _
    ByVal itype As Nag_DiscreteDistrib, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_hypergeometric Lib "CLW3225DA_nag.dll" Alias "g05tec" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal ns As Integer, _
    ByVal np As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tec Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal ns As Integer, _
    ByVal np As Integer, _
    ByVal m As Integer, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_logarithmic Lib "CLW3225DA_nag.dll" Alias "g05tfc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal a As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tfc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal a As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_gen_multinomial Lib "CLW3225DA_nag.dll" Alias "g05tgc" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal p As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05tgc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal k As Integer, _
    <[In]()> ByVal p As Double(), _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByVal pdx As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_neg_bin Lib "CLW3225DA_nag.dll" Alias "g05thc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05thc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal p As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_poisson Lib "CLW3225DA_nag.dll" Alias "g05tjc" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal lambda As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tjc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_ModeRNG, _
    ByVal n As Integer, _
    ByVal lambda As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByVal lr As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_compd_poisson Lib "CLW3225DA_nag.dll" Alias "g05tkc" ( _
    ByVal m As Integer, _
    <[In]()> ByVal vlamda As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tkc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    <[In]()> ByVal vlamda As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_discrete_uniform Lib "CLW3225DA_nag.dll" Alias "g05tlc" ( _
    ByVal n As Integer, _
    ByVal a As Integer, _
    ByVal b As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05tlc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal a As Integer, _
    ByVal b As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal x As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bb_init Lib "CLW3225DA_nag.dll" Alias "g05xac" ( _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal times As Double(), _
    ByVal ntimes As Integer, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05xac Lib "CLW3225DA_nag.dll" ( _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal times As Double(), _
    ByVal ntimes As Integer, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bb Lib "CLW3225DA_nag.dll" Alias "g05xbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As Integer, _
    ByVal d As Integer, _
    <[In]()> ByVal start As Double(), _
    ByVal a As Integer, _
    <[In]()> ByVal term As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05xbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As Integer, _
    ByVal d As Integer, _
    <[In]()> ByVal start As Double(), _
    ByVal a As Integer, _
    <[In]()> ByVal term As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bb_inc_init Lib "CLW3225DA_nag.dll" Alias "g05xcc" ( _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal times As Double(), _
    ByVal ntimes As Integer, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05xcc Lib "CLW3225DA_nag.dll" ( _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    <[In]()> ByVal times As Double(), _
    ByVal ntimes As Integer, _
    <Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bb_inc Lib "CLW3225DA_nag.dll" Alias "g05xdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As Integer, _
    ByVal d As Integer, _
    ByVal a As Integer, _
    <[In]()> ByVal diff As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05xdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal npaths As Integer, _
    ByVal d As Integer, _
    ByVal a As Integer, _
    <[In]()> ByVal diff As Double(), _
    <[In](),Out()> ByVal z As Double(), _
    ByVal pdz As Integer, _
    <[In]()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    <Out()> ByVal b As Double(), _
    ByVal pdb As Integer, _
    <[In]()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_bb_make_bridge_order Lib "CLW3225DA_nag.dll" Alias "g05xec" ( _
    ByVal bgord As Nag_BridgeOrder, _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    ByVal ntimes As Integer, _
    <[In]()> ByVal intime As Double(), _
    ByVal nmove As Integer, _
    <[In]()> ByVal move As Integer(), _
    <Out()> ByVal times As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05xec Lib "CLW3225DA_nag.dll" ( _
    ByVal bgord As Nag_BridgeOrder, _
    ByVal t0 As Double, _
    ByVal tend As Double, _
    ByVal ntimes As Integer, _
    <[In]()> ByVal intime As Double(), _
    ByVal nmove As Integer, _
    <[In]()> ByVal move As Integer(), _
    <Out()> ByVal times As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quasi_rand_normal Lib "CLW3225DA_nag.dll" Alias "g05yjc" ( _
    ByVal order as Nag_OrderType, _
    <[In]()> ByVal xmean As Double(), _
    <[In]()> ByVal std As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05yjc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In]()> ByVal xmean As Double(), _
    <[In]()> ByVal std As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quasi_rand_lognormal Lib "CLW3225DA_nag.dll" Alias "g05ykc" ( _
    ByVal order as Nag_OrderType, _
    <[In]()> ByVal xmean As Double(), _
    <[In]()> ByVal std As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ykc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    <[In]()> ByVal xmean As Double(), _
    <[In]()> ByVal std As Double(), _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quasi_init Lib "CLW3225DA_nag.dll" Alias "g05ylc" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal idim As Integer, _
    <Out()> ByVal iref As Integer(), _
    ByVal liref As Integer, _
    ByVal iskip As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g05ylc Lib "CLW3225DA_nag.dll" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal idim As Integer, _
    <Out()> ByVal iref As Integer(), _
    ByVal liref As Integer, _
    ByVal iskip As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_quasi_rand_uniform Lib "CLW3225DA_nag.dll" Alias "g05ymc" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ymc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, _
    <Out()> ByVal quas As Double(), _
    ByVal pdquas As Integer, _
    <[In](),Out()> ByVal iref As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_quasi_init_scrambled Lib "CLW3225DA_nag.dll" Alias "g05ync" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal stype As Nag_QuasiRandom_Scrambling, _
    ByVal idim As Integer, _
    <Out()> ByVal iref As Integer(), _
    ByVal liref As Integer, _
    ByVal iskip As Integer, _
    ByVal nsdigi As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ync Lib "CLW3225DA_nag.dll" ( _
    ByVal genid As Nag_QuasiRandom_Sequence, _
    ByVal stype As Nag_QuasiRandom_Scrambling, _
    ByVal idim As Integer, _
    <Out()> ByVal iref As Integer(), _
    ByVal liref As Integer, _
    ByVal iskip As Integer, _
    ByVal nsdigi As Integer, _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_rand_field_1d_user_setup_cov1_DELEGATE( _
    ByVal x As Double, _
    ByRef gamma As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_rand_field_1d_user_setup Lib "CLW3225DA_nag.dll" Alias "g05zmc" ( _
    ByVal ns As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal maxm As Integer, _
    ByVal var As Double, _
    ByVal cov1 As nag_rand_field_1d_user_setup_cov1_DELEGATE, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef m As Integer, _
    ByRef approx As Integer, _
    ByRef rho As Double, _
    ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g05zmc_cov1_DELEGATE( _
    ByVal x As Double, _
    ByRef gamma As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub g05zmc Lib "CLW3225DA_nag.dll" ( _
    ByVal ns As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal maxm As Integer, _
    ByVal var As Double, _
    ByVal cov1 As g05zmc_cov1_DELEGATE, _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef m As Integer, _
    ByRef approx As Integer, _
    ByRef rho As Double, _
    ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_field_1d_predef_setup Lib "CLW3225DA_nag.dll" Alias "g05znc" ( _
    ByVal ns As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal maxm As Integer, _
    ByVal var As Double, _
    ByVal cov As Nag_Variogram, _
    ByVal np As Integer, _
    <[In]()> ByVal prams As Double(), _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef m As Integer, _
    ByRef approx As Integer, _
    ByRef rho As Double, _
    ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05znc Lib "CLW3225DA_nag.dll" ( _
    ByVal ns As Integer, _
    ByVal xmin As Double, _
    ByVal xmax As Double, _
    ByVal maxm As Integer, _
    ByVal var As Double, _
    ByVal cov As Nag_Variogram, _
    ByVal np As Integer, _
    <[In]()> ByVal prams As Double(), _
    ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, _
    <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef m As Integer, _
    ByRef approx As Integer, _
    ByRef rho As Double, _
    ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_field_1d_generate Lib "CLW3225DA_nag.dll" Alias "g05zpc" ( _
    ByVal ns As Integer, _
    ByVal s As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05zpc Lib "CLW3225DA_nag.dll" ( _
    ByVal ns As Integer, _
    ByVal s As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_rand_field_2d_user_setup_cov2_DELEGATE( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef gamma As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_rand_field_2d_user_setup Lib "CLW3225DA_nag.dll" Alias "g05zqc" ( _
    <[In]()> ByVal ns As Integer(), ByVal xmin As Double, ByVal xmax As Double, _
    ByVal ymin As Double, ByVal ymax As Double, <[In]()> ByVal maxm As Integer(), _
    ByVal var As Double, ByVal cov2 As nag_rand_field_2d_user_setup_cov2_DELEGATE, ByVal parity As Nag_Parity, _
    ByVal pad As Nag_EmbedPad, ByVal corr As Nag_EmbedScale, <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), <Out()> ByVal yy As Double(), <Out()> ByVal m As Integer(), _
    ByRef approx As Integer, ByRef rho As Double, ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g05zqc_cov2_DELEGATE( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef gamma As Double, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub g05zqc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal ns As Integer(), ByVal xmin As Double, ByVal xmax As Double, _
    ByVal ymin As Double, ByVal ymax As Double, <[In]()> ByVal maxm As Integer(), _
    ByVal var As Double, ByVal cov2 As g05zqc_cov2_DELEGATE, ByVal parity As Nag_Parity, _
    ByVal pad As Nag_EmbedPad, ByVal corr As Nag_EmbedScale, <Out()> ByVal lam As Double(), _
    <Out()> ByVal xx As Double(), <Out()> ByVal yy As Double(), <Out()> ByVal m As Integer(), _
    ByRef approx As Integer, ByRef rho As Double, ByRef icount As Integer, _
    <Out()> ByVal eig As Double(), ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_field_2d_predef_setup Lib "CLW3225DA_nag.dll" Alias "g05zrc" ( _
    <[In]()> ByVal ns As Integer(), ByVal xmin As Double, ByVal xmax As Double, _
    ByVal ymin As Double, ByVal ymax As Double, <[In]()> ByVal maxm As Integer(), _
    ByVal var As Double, ByVal cov As Nag_Variogram, ByVal norm As Nag_NormType, _
    ByVal np As Integer, <[In]()> ByVal prams As Double(), ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, <Out()> ByVal lam As Double(), <Out()> ByVal xx As Double(), _
    <Out()> ByVal yy As Double(), <Out()> ByVal m As Integer(), ByRef approx As Integer, _
    ByRef rho As Double, ByRef icount As Integer, <Out()> ByVal eig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05zrc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal ns As Integer(), ByVal xmin As Double, ByVal xmax As Double, _
    ByVal ymin As Double, ByVal ymax As Double, <[In]()> ByVal maxm As Integer(), _
    ByVal var As Double, ByVal cov As Nag_Variogram, ByVal norm As Nag_NormType, _
    ByVal np As Integer, <[In]()> ByVal prams As Double(), ByVal pad As Nag_EmbedPad, _
    ByVal corr As Nag_EmbedScale, <Out()> ByVal lam As Double(), <Out()> ByVal xx As Double(), _
    <Out()> ByVal yy As Double(), <Out()> ByVal m As Integer(), ByRef approx As Integer, _
    ByRef rho As Double, ByRef icount As Integer, <Out()> ByVal eig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_field_2d_generate Lib "CLW3225DA_nag.dll" Alias "g05zsc" ( _
    <[In]()> ByVal ns As Integer(), _
    ByVal s As Integer, _
    <[In]()> ByVal m As Integer(), _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05zsc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal ns As Integer(), _
    ByVal s As Integer, _
    <[In]()> ByVal m As Integer(), _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rand_field_fracbm_generate Lib "CLW3225DA_nag.dll" Alias "g05ztc" ( _
    ByVal ns As Integer, _
    ByVal s As Integer, _
    ByVal m As Integer, _
    ByVal xmax As Double, _
    ByVal h As Double, _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g05ztc Lib "CLW3225DA_nag.dll" ( _
    ByVal ns As Integer, _
    ByVal s As Integer, _
    ByVal m As Integer, _
    ByVal xmax As Double, _
    ByVal h As Double, _
    <[In]()> ByVal lam As Double(), _
    ByVal rho As Double, _
    <[In](),Out()> ByVal state As Integer(), _
    <Out()> ByVal z As Double(), _
    <Out()> ByVal xx As Double(), _
    ByRef fail As NagError _
   )


' chapter g07

   Declare Sub nag_binomial_ci Lib "CLW3225DA_nag.dll" Alias "g07aac" ( _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal clevel As Double, _
    ByRef pl As Double, _
    ByRef pu As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal k As Integer, _
    ByVal clevel As Double, _
    ByRef pl As Double, _
    ByRef pu As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_poisson_ci Lib "CLW3225DA_nag.dll" Alias "g07abc" ( _
    ByVal n As Integer, _
    ByVal xmean As Double, _
    ByVal clevel As Double, _
    ByRef tl As Double, _
    ByRef tu As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07abc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal xmean As Double, _
    ByVal clevel As Double, _
    ByRef tl As Double, _
    ByRef tu As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_censored_normal Lib "CLW3225DA_nag.dll" Alias "g07bbc" ( _
    ByVal method As Nag_CEMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal xc As Double(), _
    <[In]()> ByVal ic As Integer(), _
    ByRef xmu As Double, _
    ByRef xsig As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef sexmu As Double, _
    ByRef sexsig As Double, _
    ByRef corr As Double, _
    ByRef dev As Double, _
    <Out()> ByVal nobs As Integer(), _
    ByRef nit As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g07bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_CEMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal xc As Double(), _
    <[In]()> ByVal ic As Integer(), _
    ByRef xmu As Double, _
    ByRef xsig As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef sexmu As Double, _
    ByRef sexsig As Double, _
    ByRef corr As Double, _
    ByRef dev As Double, _
    <Out()> ByVal nobs As Integer(), _
    ByRef nit As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_estim_weibull Lib "CLW3225DA_nag.dll" Alias "g07bec" ( _
    ByVal cens As Nag_CestMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal ic As Integer(), _
    ByRef beta As Double, _
    ByRef gamma As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef sebeta As Double, _
    ByRef segam As Double, _
    ByRef corr As Double, _
    ByRef dev As Double, _
    ByRef nit As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g07bec Lib "CLW3225DA_nag.dll" ( _
    ByVal cens As Nag_CestMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal ic As Integer(), _
    ByRef beta As Double, _
    ByRef gamma As Double, _
    ByVal tol As Double, _
    ByVal maxit As Integer, _
    ByRef sebeta As Double, _
    ByRef segam As Double, _
    ByRef corr As Double, _
    ByRef dev As Double, _
    ByRef nit As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_estim_gen_pareto Lib "CLW3225DA_nag.dll" Alias "g07bfc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal optopt As Nag_OptimOpt, _
    ByRef xi As Double, _
    ByRef beta As Double, _
    <Out()> ByVal asvc As Double(), _
    <Out()> ByVal obsvc As Double(), _
    ByRef ll As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal optopt As Nag_OptimOpt, _
    ByRef xi As Double, _
    ByRef beta As Double, _
    <Out()> ByVal asvc As Double(), _
    <Out()> ByVal obsvc As Double(), _
    ByRef ll As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2_sample_t_test Lib "CLW3225DA_nag.dll" Alias "g07cac" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal equal As Nag_PopVar, _
    ByVal nx As Integer, _
    ByVal ny As Integer, _
    ByVal xmean As Double, _
    ByVal ymean As Double, _
    ByVal xstd As Double, _
    ByVal ystd As Double, _
    ByVal clevel As Double, _
    ByRef t As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef dl As Double, _
    ByRef du As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07cac Lib "CLW3225DA_nag.dll" ( _
    ByVal tail As Nag_TailProbability, _
    ByVal equal As Nag_PopVar, _
    ByVal nx As Integer, _
    ByVal ny As Integer, _
    ByVal xmean As Double, _
    ByVal ymean As Double, _
    ByVal xstd As Double, _
    ByVal ystd As Double, _
    ByVal clevel As Double, _
    ByRef t As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef dl As Double, _
    ByRef du As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_median_1var Lib "CLW3225DA_nag.dll" Alias "g07dac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef xme As Double, _
    ByRef xmd As Double, _
    ByRef xsd As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal y As Double(), _
    ByRef xme As Double, _
    ByRef xmd As Double, _
    ByRef xsd As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_robust_m_estim_1var Lib "CLW3225DA_nag.dll" Alias "g07dbc" ( _
    ByVal sigma_est As Nag_SigmaSimulEst, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal psifun As Nag_PsiFun, _
    ByVal c As Double, _
    ByVal h1 As Double, _
    ByVal h2 As Double, _
    ByVal h3 As Double, _
    ByVal dchi As Double, _
    ByRef theta As Double, _
    ByRef sigma As Double, _
    ByVal maxit As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal rs As Double(), _
    ByRef nit As Integer, _
    <Out()> ByVal sorted_x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g07dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal sigma_est As Nag_SigmaSimulEst, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal psifun As Nag_PsiFun, _
    ByVal c As Double, _
    ByVal h1 As Double, _
    ByVal h2 As Double, _
    ByVal h3 As Double, _
    ByVal dchi As Double, _
    ByRef theta As Double, _
    ByRef sigma As Double, _
    ByVal maxit As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal rs As Double(), _
    ByRef nit As Integer, _
    <Out()> ByVal sorted_x As Double(), _
    ByRef fail As NagError _
   )


Delegate Function nag_robust_m_estim_1var_usr_chi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function nag_robust_m_estim_1var_usr_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub nag_robust_m_estim_1var_usr Lib "CLW3225DA_nag.dll" Alias "g07dcc" ( _
    ByVal chi As nag_robust_m_estim_1var_usr_chi_DELEGATE, _
    ByVal psi As nag_robust_m_estim_1var_usr_psi_DELEGATE, _
    ByVal isigma As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal beta As Double, _
    ByRef theta As Double, _
    ByRef sigma As Double, _
    ByVal maxit As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal rs As Double(), _
    ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Function g07dcc_chi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

Delegate Function g07dcc_psi_DELEGATE( _
    ByVal t As Double, _
    ByRef COMM As Nag_Comm _
  ) as Double

   Declare Sub g07dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal chi As g07dcc_chi_DELEGATE, _
    ByVal psi As g07dcc_psi_DELEGATE, _
    ByVal isigma As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal beta As Double, _
    ByRef theta As Double, _
    ByRef sigma As Double, _
    ByVal maxit As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal rs As Double(), _
    ByRef nit As Integer, _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_robust_trimmed_1var Lib "CLW3225DA_nag.dll" Alias "g07ddc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal alpha As Double, _
    ByRef tmean As Double, _
    ByRef wmean As Double, _
    ByRef tvar As Double, _
    ByRef wvar As Double, _
    ByRef k As Integer, _
    <Out()> ByVal sx As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g07ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal alpha As Double, _
    ByRef tmean As Double, _
    ByRef wmean As Double, _
    ByRef tvar As Double, _
    ByRef wvar As Double, _
    ByRef k As Integer, _
    <Out()> ByVal sx As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rank_ci_1var Lib "CLW3225DA_nag.dll" Alias "g07eac" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal clevel As Double, _
    ByRef theta As Double, _
    ByRef thetal As Double, _
    ByRef thetau As Double, _
    ByRef estcl As Double, _
    ByRef wlower As Double, _
    ByRef wupper As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07eac Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal clevel As Double, _
    ByRef theta As Double, _
    ByRef thetal As Double, _
    ByRef thetau As Double, _
    ByRef estcl As Double, _
    ByRef wlower As Double, _
    ByRef wupper As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rank_ci_2var Lib "CLW3225DA_nag.dll" Alias "g07ebc" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal clevel As Double, _
    ByRef theta As Double, _
    ByRef thetal As Double, _
    ByRef thetau As Double, _
    ByRef estcl As Double, _
    ByRef ulower As Double, _
    ByRef uupper As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g07ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_RCIMethod, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal clevel As Double, _
    ByRef theta As Double, _
    ByRef thetal As Double, _
    ByRef thetau As Double, _
    ByRef estcl As Double, _
    ByRef ulower As Double, _
    ByRef uupper As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_outlier_peirce Lib "CLW3225DA_nag.dll" Alias "g07gac" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal mean As Double, _
    ByVal var As Double, _
    <Out()> ByVal iout As Integer(), _
    ByRef niout As Integer, _
    ByVal ldiff As Integer, _
    <Out()> ByVal diff As Double(), _
    <Out()> ByVal llamb As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g07gac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal mean As Double, _
    ByVal var As Double, _
    <Out()> ByVal iout As Integer(), _
    ByRef niout As Integer, _
    ByVal ldiff As Integer, _
    <Out()> ByVal diff As Double(), _
    <Out()> ByVal llamb As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_outlier_peirce_two_var Lib "CLW3225DA_nag.dll" Alias "g07gbc" ( _
    ByVal n As Integer, _
    ByVal e As Double, _
    ByVal var1 As Double, _
    ByVal var2 As Double, _
    ByRef x As Double, _
    ByRef lx As Double, _
    ByRef ux As Double, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function g07gbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal e As Double, _
    ByVal var1 As Double, _
    ByVal var2 As Double, _
    ByRef x As Double, _
    ByRef lx As Double, _
    ByRef ux As Double, _
    ByRef fail As NagError _
   ) as Integer


' chapter g08

   Declare Sub nag_sign_test Lib "CLW3225DA_nag.dll" Alias "g08aac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef s As Integer, _
    ByRef p As Double, _
    ByRef non_tied As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g08aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef s As Integer, _
    ByRef p As Double, _
    ByRef non_tied As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_median_test Lib "CLW3225DA_nag.dll" Alias "g08acc" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByRef below As Integer, _
    ByRef above As Integer, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08acc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByRef below As Integer, _
    ByRef above As Integer, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_friedman_test Lib "CLW3225DA_nag.dll" Alias "g08aec" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef fr As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08aec Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal tdx As Integer, _
    ByRef fr As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_kruskal_wallis_test Lib "CLW3225DA_nag.dll" Alias "g08afc" ( _
    ByVal k As Integer, _
    <[In]()> ByVal l As Integer(), _
    <[In]()> ByVal x As Double(), _
    ByVal lx As Integer, _
    ByRef h As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08afc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    <[In]()> ByVal l As Integer(), _
    <[In]()> ByVal x As Double(), _
    ByVal lx As Integer, _
    ByRef h As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_wilcoxon_test Lib "CLW3225DA_nag.dll" Alias "g08agc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal median As Double, _
    ByVal tail As Nag_TailProbability, _
    ByVal zeros As Nag_IncSignZeros, _
    ByRef w As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef non_zero As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g08agc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal median As Double, _
    ByVal tail As Nag_TailProbability, _
    ByVal zeros As Nag_IncSignZeros, _
    ByRef w As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef non_zero As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mann_whitney Lib "CLW3225DA_nag.dll" Alias "g08amc" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal tail As Nag_TailProbability, _
    ByVal exact As Nag_CompProb, _
    ByRef u As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08amc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal tail As Nag_TailProbability, _
    ByVal exact As Nag_CompProb, _
    ByRef u As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_1_sample_ks_test Lib "CLW3225DA_nag.dll" Alias "g08cbc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal dist As Nag_Distributions, _
    <[In](),Out()> ByVal par As Double(), _
    ByVal estima As Nag_ParaEstimates, _
    ByVal ntype As Nag_TestStatistics, _
    ByRef d As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal dist As Nag_Distributions, _
    <[In](),Out()> ByVal par As Double(), _
    ByVal estima As Nag_ParaEstimates, _
    ByVal ntype As Nag_TestStatistics, _
    ByRef d As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_2_sample_ks_test Lib "CLW3225DA_nag.dll" Alias "g08cdc" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal dtype As Nag_TestStatistics, _
    ByRef d As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal n1 As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal n2 As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal dtype As Nag_TestStatistics, _
    ByRef d As Double, _
    ByRef z As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_chi_sq_goodness_of_fit_test Lib "CLW3225DA_nag.dll" Alias "g08cgc" ( _
    ByVal nclass As Integer, _
    <[In]()> ByVal ifreq As Integer(), _
    <[In]()> ByVal ci As Double(), _
    ByVal dist As Nag_Distributions, _
    <[In]()> ByVal par As Double(), _
    ByVal npest As Integer, _
    <[In]()> ByVal prob As Double(), _
    ByRef chisq As Double, _
    ByRef p As Double, _
    ByRef ndf As Integer, _
    <Out()> ByVal eval As Double(), _
    <Out()> ByVal chisqi As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g08cgc Lib "CLW3225DA_nag.dll" ( _
    ByVal nclass As Integer, _
    <[In]()> ByVal ifreq As Integer(), _
    <[In]()> ByVal ci As Double(), _
    ByVal dist As Nag_Distributions, _
    <[In]()> ByVal par As Double(), _
    ByVal npest As Integer, _
    <[In]()> ByVal prob As Double(), _
    ByRef chisq As Double, _
    ByRef p As Double, _
    ByRef ndf As Integer, _
    <Out()> ByVal eval As Double(), _
    <Out()> ByVal chisqi As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_anderson_darling_stat Lib "CLW3225DA_nag.dll" Alias "g08chc" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   ) as Double

   Declare Function g08chc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_anderson_darling_uniform_prob Lib "CLW3225DA_nag.dll" Alias "g08cjc" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef a2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08cjc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In](),Out()> ByVal y As Double(), _
    ByRef a2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_anderson_darling_normal_prob Lib "CLW3225DA_nag.dll" Alias "g08ckc" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In]()> ByVal y As Double(), _
    ByRef ybar As Double, _
    ByRef yvar As Double, _
    ByRef a2 As Double, _
    ByRef aa2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08ckc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In]()> ByVal y As Double(), _
    ByRef ybar As Double, _
    ByRef yvar As Double, _
    ByRef a2 As Double, _
    ByRef aa2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_anderson_darling_exp_prob Lib "CLW3225DA_nag.dll" Alias "g08clc" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In]()> ByVal y As Double(), _
    ByRef ybar As Double, _
    ByRef a2 As Double, _
    ByRef aa2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08clc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal issort As Nag_Boolean, _
    <[In]()> ByVal y As Double(), _
    ByRef ybar As Double, _
    ByRef a2 As Double, _
    ByRef aa2 As Double, _
    ByRef p As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_runs_test Lib "CLW3225DA_nag.dll" Alias "g08eac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_run As Integer, _
    ByRef nruns As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08eac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_run As Integer, _
    ByRef nruns As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pairs_test Lib "CLW3225DA_nag.dll" Alias "g08ebc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_count As Integer, _
    ByVal lag As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_count As Integer, _
    ByVal lag As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_triplets_test Lib "CLW3225DA_nag.dll" Alias "g08ecc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_count As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal max_count As Integer, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_gaps_test Lib "CLW3225DA_nag.dll" Alias "g08edc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal num_gaps As Integer, _
    ByVal max_gap As Integer, _
    ByVal lower As Double, _
    ByVal upper As Double, _
    ByVal length As Double, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g08edc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal num_gaps As Integer, _
    ByVal max_gap As Integer, _
    ByVal lower As Double, _
    ByVal upper As Double, _
    ByVal length As Double, _
    ByRef chi As Double, _
    ByRef df As Double, _
    ByRef prob As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_rank_regsn Lib "CLW3225DA_nag.dll" Alias "g08rac" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As Integer, _
    <[In](),Out()> ByVal nv As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal idist As Integer, _
    ByVal nmax As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal prvr As Double(), _
    ByVal pdparvar As Integer, _
    <Out()> ByVal irank As Integer(), _
    <Out()> ByVal zin As Double(), _
    <Out()> ByVal eta As Double(), _
    <Out()> ByVal vapvec As Double(), _
    <Out()> ByVal parest As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g08rac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As Integer, _
    <[In](),Out()> ByVal nv As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    ByVal idist As Integer, _
    ByVal nmax As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal prvr As Double(), _
    ByVal pdparvar As Integer, _
    <Out()> ByVal irank As Integer(), _
    <Out()> ByVal zin As Double(), _
    <Out()> ByVal eta As Double(), _
    <Out()> ByVal vapvec As Double(), _
    <Out()> ByVal parest As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_rank_regsn_censored Lib "CLW3225DA_nag.dll" Alias "g08rbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As Integer, _
    <[In]()> ByVal nv As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal icen As Integer(), _
    ByVal gamma As Double, _
    ByVal nmax As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal prvr As Double(), _
    ByVal pdprvr As Integer, _
    <Out()> ByVal irank As Integer(), _
    <Out()> ByVal zin As Double(), _
    <Out()> ByVal eta As Double(), _
    <Out()> ByVal vapvec As Double(), _
    <Out()> ByVal parest As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g08rbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal ns As Integer, _
    <[In]()> ByVal nv As Integer(), _
    <[In]()> ByVal y As Double(), _
    ByVal p As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal pdx As Integer, _
    <[In]()> ByVal icen As Integer(), _
    ByVal gamma As Double, _
    ByVal nmax As Integer, _
    ByVal tol As Double, _
    <Out()> ByVal prvr As Double(), _
    ByVal pdprvr As Integer, _
    <Out()> ByVal irank As Integer(), _
    <Out()> ByVal zin As Double(), _
    <Out()> ByVal eta As Double(), _
    <Out()> ByVal vapvec As Double(), _
    <Out()> ByVal parest As Double(), _
    ByRef fail As NagError _
   )


' chapter g10

   Declare Sub nag_smooth_spline_fit Lib "CLW3225DA_nag.dll" Alias "g10abc" ( _
    ByVal mode As Nag_SmoothFitType, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal rho As Double, _
    <Out()> ByVal yhat As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g10abc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_SmoothFitType, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    ByVal rho As Double, _
    <Out()> ByVal yhat As Double(), _
    <[In](),Out()> ByVal c As Double(), _
    ByVal pdc As Integer, _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), _
    <[In](),Out()> ByVal comm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_smooth_spline_estim Lib "CLW3225DA_nag.dll" Alias "g10acc" ( _
    ByVal method As Nag_SmoothParamMethods, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal coeff As Double(), _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), _
    ByRef crit As Double, _
    ByRef rho As Double, _
    ByVal u As Double, _
    ByVal tol As Double, _
    ByVal maxcal As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g10acc Lib "CLW3225DA_nag.dll" ( _
    ByVal method As Nag_SmoothParamMethods, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal coeff As Double(), _
    ByRef rss As Double, _
    ByRef df As Double, _
    <Out()> ByVal res As Double(), _
    <Out()> ByVal h As Double(), _
    ByRef crit As Double, _
    ByRef rho As Double, _
    ByVal u As Double, _
    ByVal tol As Double, _
    ByVal maxcal As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_kernel_density_estim Lib "CLW3225DA_nag.dll" Alias "g10bac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal window As Double, _
    ByVal low As Double, _
    ByVal high As Double, _
    ByVal ns As Integer, _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal t As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g10bac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal window As Double, _
    ByVal low As Double, _
    ByVal high As Double, _
    ByVal ns As Integer, _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal t As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_kernel_density_gauss Lib "CLW3225DA_nag.dll" Alias "g10bbc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal wtype As Nag_WindowType, _
    ByRef window As Double, _
    ByRef slo As Double, _
    ByRef shi As Double, _
    ByVal ns As Integer, _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal t As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g10bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal wtype As Nag_WindowType, _
    ByRef window As Double, _
    ByRef slo As Double, _
    ByRef shi As Double, _
    ByVal ns As Integer, _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal t As Double(), _
    ByVal fcall As Nag_Boolean, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_running_median_smoother Lib "CLW3225DA_nag.dll" Alias "g10cac" ( _
    ByVal smoother As Nag_Smooth_Type, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal rough As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g10cac Lib "CLW3225DA_nag.dll" ( _
    ByVal smoother As Nag_Smooth_Type, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    <Out()> ByVal smooth As Double(), _
    <Out()> ByVal rough As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_order_data Lib "CLW3225DA_nag.dll" Alias "g10zac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByRef nord As Integer, _
    <Out()> ByVal xord As Double(), _
    <Out()> ByVal yord As Double(), _
    <Out()> ByVal wwt As Double(), _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g10zac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal weights As Double(), _
    ByRef nord As Integer, _
    <Out()> ByVal xord As Double(), _
    <Out()> ByVal yord As Double(), _
    <Out()> ByVal wwt As Double(), _
    ByRef rss As Double, _
    ByRef fail As NagError _
   )


' chapter g11

   Declare Sub nag_chi_sq_2_way_table Lib "CLW3225DA_nag.dll" Alias "g11aac" ( _
    ByVal nrow As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal nobst As Integer(), _
    ByVal tdt As Integer, _
    <Out()> ByVal expt As Double(), _
    <Out()> ByVal chist As Double(), _
    ByRef prob As Double, _
    ByRef chi As Double, _
    ByRef g As Double, _
    ByRef df As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g11aac Lib "CLW3225DA_nag.dll" ( _
    ByVal nrow As Integer, _
    ByVal ncol As Integer, _
    <[In]()> ByVal nobst As Integer(), _
    ByVal tdt As Integer, _
    <Out()> ByVal expt As Double(), _
    <Out()> ByVal chist As Double(), _
    ByRef prob As Double, _
    ByRef chi As Double, _
    ByRef g As Double, _
    ByRef df As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tabulate_stats Lib "CLW3225DA_nag.dll" Alias "g11bac" ( _
    ByVal stat As Nag_TableStats, _
    ByVal update As Nag_TableUpdate, _
    ByVal weight As Nag_Weightstype, _
    ByVal n As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal sf As Integer(), _
    <[In]()> ByVal lfac As Integer(), _
    <[In]()> ByVal factor As Integer(), _
    ByVal tdf As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    <[In](),Out()> ByVal table As Double(), _
    ByVal maxt As Integer, _
    ByRef ncells As Integer, _
    ByRef ndim As Integer, _
    <Out()> ByVal idim As Integer(), _
    <[In](),Out()> ByVal count As Integer(), _
    <[In](),Out()> ByVal comm_ar As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g11bac Lib "CLW3225DA_nag.dll" ( _
    ByVal stat As Nag_TableStats, _
    ByVal update As Nag_TableUpdate, _
    ByVal weight As Nag_Weightstype, _
    ByVal n As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal sf As Integer(), _
    <[In]()> ByVal lfac As Integer(), _
    <[In]()> ByVal factor As Integer(), _
    ByVal tdf As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    <[In](),Out()> ByVal table As Double(), _
    ByVal maxt As Integer, _
    ByRef ncells As Integer, _
    ByRef ndim As Integer, _
    <Out()> ByVal idim As Integer(), _
    <[In](),Out()> ByVal count As Integer(), _
    <[In](),Out()> ByVal comm_ar As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tabulate_percentile Lib "CLW3225DA_nag.dll" Alias "g11bbc" ( _
    ByVal typ As Nag_TabulateVar, _
    ByVal n As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal sf As Integer(), _
    <[In]()> ByVal lfac As Integer(), _
    <[In]()> ByVal factor As Integer(), _
    ByVal tdf As Integer, _
    ByVal percnt As Double, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal table As Double(), _
    ByVal maxt As Integer, _
    ByRef ncells As Integer, _
    ByRef ndim As Integer, _
    <Out()> ByVal idim As Integer(), _
    <Out()> ByVal count As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g11bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_TabulateVar, _
    ByVal n As Integer, _
    ByVal nfac As Integer, _
    <[In]()> ByVal sf As Integer(), _
    <[In]()> ByVal lfac As Integer(), _
    <[In]()> ByVal factor As Integer(), _
    ByVal tdf As Integer, _
    ByVal percnt As Double, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal wt As Double(), _
    <Out()> ByVal table As Double(), _
    ByVal maxt As Integer, _
    ByRef ncells As Integer, _
    ByRef ndim As Integer, _
    <Out()> ByVal idim As Integer(), _
    <Out()> ByVal count As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tabulate_margin Lib "CLW3225DA_nag.dll" Alias "g11bcc" ( _
    ByVal stat As Nag_TableStats, _
    <[In]()> ByVal table As Double(), _
    ByVal ncells As Integer, _
    ByVal ndim As Integer, _
    <[In]()> ByVal idim As Integer(), _
    <[In]()> ByVal isdim As Integer(), _
    <Out()> ByVal sub_table As Double(), _
    ByVal maxst As Integer, _
    ByRef mcells As Integer, _
    ByRef mdim As Integer, _
    <Out()> ByVal mlevel As Integer(), _
    <Out()> ByVal comm_ar As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g11bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal stat As Nag_TableStats, _
    <[In]()> ByVal table As Double(), _
    ByVal ncells As Integer, _
    ByVal ndim As Integer, _
    <[In]()> ByVal idim As Integer(), _
    <[In]()> ByVal isdim As Integer(), _
    <Out()> ByVal sub_table As Double(), _
    ByVal maxst As Integer, _
    ByRef mcells As Integer, _
    ByRef mdim As Integer, _
    <Out()> ByVal mlevel As Integer(), _
    <Out()> ByVal comm_ar As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_condl_logistic Lib "CLW3225DA_nag.dll" Alias "g11cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal pdz As Integer, <[In]()> ByVal isz As Integer(), _
    ByVal p As Integer, <[In]()> ByVal ic As Integer(), <[In]()> ByVal isi As Integer(), _
    ByRef dev As Double, <[In](),Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    <Out()> ByVal sc As Double(), <Out()> ByVal cov As Double(), <Out()> ByVal nca As Integer(), _
    <Out()> ByVal nct As Integer(), ByVal tol As Double, ByVal maxit As Integer, _
    ByVal iprint As Integer, ByVal outfile As String, ByRef fail As NagError _
   )

   Declare Sub g11cac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal pdz As Integer, <[In]()> ByVal isz As Integer(), _
    ByVal p As Integer, <[In]()> ByVal ic As Integer(), <[In]()> ByVal isi As Integer(), _
    ByRef dev As Double, <[In](),Out()> ByVal b As Double(), <Out()> ByVal se As Double(), _
    <Out()> ByVal sc As Double(), <Out()> ByVal cov As Double(), <Out()> ByVal nca As Integer(), _
    <Out()> ByVal nct As Integer(), ByVal tol As Double, ByVal maxit As Integer, _
    ByVal iprint As Integer, ByVal outfile As String, ByRef fail As NagError _
   )


   Declare Sub nag_binary_factor Lib "CLW3225DA_nag.dll" Alias "g11sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As Integer, ByVal n As Integer, ByVal gprob As Nag_Boolean, _
    ByVal ns As Integer, <[In](),Out()> ByVal x As Nag_Boolean(), ByVal pdx As Integer, _
    <[In](),Out()> ByVal irl As Integer(), <[In](),Out()> ByVal a As Double(), <[In](),Out()> ByVal c As Double(), _
    ByVal iprint As Integer, ByVal outfile As String, ByVal cgetol As Double, _
    ByVal maxit As Integer, ByVal chisqr As Nag_Boolean, ByRef niter As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal pigam As Double(), <Out()> ByVal cm As Double(), _
    ByVal pdcm As Integer, <Out()> ByVal g As Double(), <Out()> ByVal expp As Double(), _
    ByVal pde As Integer, <Out()> ByVal obs As Double(), <Out()> ByVal exf As Double(), _
    <Out()> ByVal y As Double(), <Out()> ByVal iob As Integer(), ByRef rlogl As Double, _
    ByRef chi As Double, ByRef idf As Integer, ByRef siglev As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g11sac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As Integer, ByVal n As Integer, ByVal gprob As Nag_Boolean, _
    ByVal ns As Integer, <[In](),Out()> ByVal x As Nag_Boolean(), ByVal pdx As Integer, _
    <[In](),Out()> ByVal irl As Integer(), <[In](),Out()> ByVal a As Double(), <[In](),Out()> ByVal c As Double(), _
    ByVal iprint As Integer, ByVal outfile As String, ByVal cgetol As Double, _
    ByVal maxit As Integer, ByVal chisqr As Nag_Boolean, ByRef niter As Integer, _
    <Out()> ByVal alpha As Double(), <Out()> ByVal pigam As Double(), <Out()> ByVal cm As Double(), _
    ByVal pdcm As Integer, <Out()> ByVal g As Double(), <Out()> ByVal expp As Double(), _
    ByVal pde As Integer, <Out()> ByVal obs As Double(), <Out()> ByVal exf As Double(), _
    <Out()> ByVal y As Double(), <Out()> ByVal iob As Integer(), ByRef rlogl As Double, _
    ByRef chi As Double, ByRef idf As Integer, ByRef siglev As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_binary_factor_service Lib "CLW3225DA_nag.dll" Alias "g11sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    ByRef ns As Integer, _
    <[In](),Out()> ByVal x As Nag_Boolean(), _
    ByVal pdx As Integer, _
    <Out()> ByVal irl As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g11sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    ByRef ns As Integer, _
    <[In](),Out()> ByVal x As Nag_Boolean(), _
    ByVal pdx As Integer, _
    <Out()> ByVal irl As Integer(), _
    ByRef fail As NagError _
   )


' chapter g12

   Declare Sub nag_prod_limit_surviv_fn Lib "CLW3225DA_nag.dll" Alias "g12aac" ( _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal freq As Integer(), _
    ByRef nd As Integer, _
    <Out()> ByVal tp As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal psig As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g12aac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal freq As Integer(), _
    ByRef nd As Integer, _
    <Out()> ByVal tp As Double(), _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal psig As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_surviv_logrank Lib "CLW3225DA_nag.dll" Alias "g12abc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal grp As Integer(), _
    ByVal ngrp As Integer, _
    <[In]()> ByVal ifreq As Integer(), _
    <[In]()> ByVal wt As Double(), _
    ByRef ts As Double, _
    ByRef df As Integer, _
    ByRef p As Double, _
    <Out()> ByVal obsd As Double(), _
    <Out()> ByVal expt As Double(), _
    ByRef nd As Integer, _
    <Out()> ByVal di As Integer(), _
    <Out()> ByVal ni As Integer(), _
    ByVal ldn As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g12abc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal t As Double(), _
    <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal grp As Integer(), _
    ByVal ngrp As Integer, _
    <[In]()> ByVal ifreq As Integer(), _
    <[In]()> ByVal wt As Double(), _
    ByRef ts As Double, _
    ByRef df As Integer, _
    ByRef p As Double, _
    <Out()> ByVal obsd As Double(), _
    <Out()> ByVal expt As Double(), _
    ByRef nd As Integer, _
    <Out()> ByVal di As Integer(), _
    <Out()> ByVal ni As Integer(), _
    ByVal ldn As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_surviv_cox_model Lib "CLW3225DA_nag.dll" Alias "g12bac" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal tdz As Integer, <[In]()> ByVal sz As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal t As Double(), <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal omega As Double(), <[In]()> ByVal isi As Integer(), ByRef dev As Double, _
    <[In](),Out()> ByVal b As Double(), <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal res As Double(), ByRef nd As Integer, _
    <Out()> ByVal tp As Double(), <Out()> ByVal sur As Double(), ByVal tdsur As Integer, _
    ByVal ndmax As Integer, ByVal tol As Double, ByVal max_iter As Integer, _
    ByVal iprint As Integer, ByVal outfile As String, ByRef fail As NagError _
   )

   Declare Sub g12bac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal tdz As Integer, <[In]()> ByVal sz As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal t As Double(), <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal omega As Double(), <[In]()> ByVal isi As Integer(), ByRef dev As Double, _
    <[In](),Out()> ByVal b As Double(), <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), _
    <Out()> ByVal cov As Double(), <Out()> ByVal res As Double(), ByRef nd As Integer, _
    <Out()> ByVal tp As Double(), <Out()> ByVal sur As Double(), ByVal tdsur As Integer, _
    ByVal ndmax As Integer, ByVal tol As Double, ByVal max_iter As Integer, _
    ByVal iprint As Integer, ByVal outfile As String, ByRef fail As NagError _
   )


   Declare Sub nag_surviv_risk_sets Lib "CLW3225DA_nag.dll" Alias "g12zac" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal pdz As Integer, <[In]()> ByVal isz As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal t As Double(), <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal isi As Integer(), ByRef num As Integer, <Out()> ByVal ixs As Integer(), _
    ByRef nxs As Integer, <Out()> ByVal x As Double(), ByVal mxn As Integer, _
    <Out()> ByVal id As Integer(), ByRef nd As Integer, <Out()> ByVal tp As Double(), _
    <Out()> ByVal irs As Integer(), ByRef fail As NagError _
   )

   Declare Sub g12zac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal n As Integer, ByVal m As Integer, ByVal ns As Integer, _
    <[In]()> ByVal z As Double(), ByVal pdz As Integer, <[In]()> ByVal isz As Integer(), _
    ByVal ip As Integer, <[In]()> ByVal t As Double(), <[In]()> ByVal ic As Integer(), _
    <[In]()> ByVal isi As Integer(), ByRef num As Integer, <Out()> ByVal ixs As Integer(), _
    ByRef nxs As Integer, <Out()> ByVal x As Double(), ByVal mxn As Integer, _
    <Out()> ByVal id As Integer(), ByRef nd As Integer, <Out()> ByVal tp As Double(), _
    <Out()> ByVal irs As Integer(), ByRef fail As NagError _
   )


' chapter g13

   Declare Sub nag_tsa_diff Lib "CLW3225DA_nag.dll" Alias "g13aac" ( _
    <[In]()> ByVal x As Double(), _
    ByVal nx As Integer, _
    ByVal d As Integer, _
    ByVal ds As Integer, _
    ByVal s As Integer, _
    <Out()> ByVal xd As Double(), _
    ByRef nxd As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13aac Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal x As Double(), _
    ByVal nx As Integer, _
    ByVal d As Integer, _
    ByVal ds As Integer, _
    ByVal s As Integer, _
    <Out()> ByVal xd As Double(), _
    ByRef nxd As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_auto_corr Lib "CLW3225DA_nag.dll" Alias "g13abc" ( _
    <[In]()> ByVal x As Double(), _
    ByVal nx As Integer, _
    ByVal nk As Integer, _
    ByRef mean As Double, _
    ByRef var As Double, _
    <Out()> ByVal r As Double(), _
    ByRef stat As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13abc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal x As Double(), _
    ByVal nx As Integer, _
    ByVal nk As Integer, _
    ByRef mean As Double, _
    ByRef var As Double, _
    <Out()> ByVal r As Double(), _
    ByRef stat As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_auto_corr_part Lib "CLW3225DA_nag.dll" Alias "g13acc" ( _
    <[In]()> ByVal r As Double(), _
    ByVal nk As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal v As Double(), _
    <Out()> ByVal ar As Double(), _
    ByRef nvl As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13acc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal r As Double(), _
    ByVal nk As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal p As Double(), _
    <Out()> ByVal v As Double(), _
    <Out()> ByVal ar As Double(), _
    ByRef nvl As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_exp_smooth Lib "CLW3225DA_nag.dll" Alias "g13amc" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As Integer, _
    <[In]()> ByVal param As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal k As Integer, _
    <[In](),Out()> ByVal init As Double(), _
    ByVal nf As Integer, _
    <Out()> ByVal fv As Double(), _
    <Out()> ByVal fse As Double(), _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef dv As Double, _
    ByRef ad As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13amc Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Nag_InitialValues, _
    ByVal itype As Nag_ExpSmoothType, _
    ByVal p As Integer, _
    <[In]()> ByVal param As Double(), _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal k As Integer, _
    <[In](),Out()> ByVal init As Double(), _
    ByVal nf As Integer, _
    <Out()> ByVal fv As Double(), _
    <Out()> ByVal fse As Double(), _
    <Out()> ByVal yhat As Double(), _
    <Out()> ByVal res As Double(), _
    ByRef dv As Double, _
    ByRef ad As Double, _
    <[In](),Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_resid_corr Lib "CLW3225DA_nag.dll" Alias "g13asc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal n As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal par As Double(), _
    ByVal narma As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal rc As Double(), _
    ByVal tdrc As Integer, _
    ByRef chi As Double, _
    ByRef df As Integer, _
    ByRef siglev As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13asc Lib "CLW3225DA_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal n As Integer, _
    <[In]()> ByVal v As Double(), _
    ByVal m As Integer, _
    <[In]()> ByVal par As Double(), _
    ByVal narma As Integer, _
    <Out()> ByVal r As Double(), _
    <Out()> ByVal rc As Double(), _
    ByVal tdrc As Integer, _
    ByRef chi As Double, _
    ByRef df As Integer, _
    ByRef siglev As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_mean_range Lib "CLW3225DA_nag.dll" Alias "g13auc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal m As Integer, _
    ByVal rs As Nag_RangeStat, _
    <Out()> ByVal y As Double(), _
    <Out()> ByVal mean As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13auc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal m As Integer, _
    ByVal rs As Nag_RangeStat, _
    <Out()> ByVal y As Double(), _
    <Out()> ByVal mean As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_tsa_dickey_fuller_unit Lib "CLW3225DA_nag.dll" Alias "g13awc" ( _
    ByVal typ As Nag_TS_URTestType, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByRef fail As NagError _
   ) as Double

   Declare Function g13awc Lib "CLW3225DA_nag.dll" ( _
    ByVal typ As Nag_TS_URTestType, _
    ByVal p As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_tsa_arma_filter Lib "CLW3225DA_nag.dll" Alias "g13bac" ( _
    <[In]()> ByVal y As Double(), _
    ByVal ny As Integer, _
    ByRef arimaf As Nag_ArimaOrder, _
    ByRef arimav As Nag_ArimaOrder, _
    <[In]()> ByVal par As Double(), _
    ByVal npar As Integer, _
    ByVal cy As Double, _
    <Out()> ByVal b As Double(), _
    ByVal nb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13bac Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal y As Double(), _
    ByVal ny As Integer, _
    ByRef arimaf As Nag_ArimaOrder, _
    ByRef arimav As Nag_ArimaOrder, _
    <[In]()> ByVal par As Double(), _
    ByVal npar As Integer, _
    ByVal cy As Double, _
    <Out()> ByVal b As Double(), _
    ByVal nb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_transf_filter Lib "CLW3225DA_nag.dll" Alias "g13bbc" ( _
    <[In]()> ByVal y As Double(), _
    ByVal ny As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef arimas As Nag_ArimaOrder, _
    <[In]()> ByVal par As Double(), _
    ByVal npar As Integer, _
    ByVal cy As Double, _
    <Out()> ByVal b As Double(), _
    ByVal nb As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13bbc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal y As Double(), _
    ByVal ny As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef arimas As Nag_ArimaOrder, _
    <[In]()> ByVal par As Double(), _
    ByVal npar As Integer, _
    ByVal cy As Double, _
    <Out()> ByVal b As Double(), _
    ByVal nb As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_cross_corr Lib "CLW3225DA_nag.dll" Alias "g13bcc" ( _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal nxy As Integer, _
    ByVal nl As Integer, _
    ByRef s As Double, _
    ByRef r0 As Double, _
    <Out()> ByVal r As Double(), _
    ByRef stat As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13bcc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByVal nxy As Integer, _
    ByVal nl As Integer, _
    ByRef s As Double, _
    ByRef r0 As Double, _
    <Out()> ByVal r As Double(), _
    ByRef stat As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_transf_prelim_fit Lib "CLW3225DA_nag.dll" Alias "g13bdc" ( _
    ByVal r0 As Double, _
    <[In]()> ByVal r As Double(), _
    ByVal nl As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByVal s As Double, _
    <Out()> ByVal wds As Double(), _
    <Out()> ByVal isf As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub g13bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal r0 As Double, _
    <[In]()> ByVal r As Double(), _
    ByVal nl As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByVal s As Double, _
    <Out()> ByVal wds As Double(), _
    <Out()> ByVal isf As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_inp_model_estim Lib "CLW3225DA_nag.dll" Alias "g13bec" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In](),Out()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nxxy As Integer, _
    <[In]()> ByVal xxy As Double(), _
    ByVal tdxxy As Integer, _
    <Out()> ByVal sd As Double(), _
    ByRef rss As Double, _
    ByRef objf As Double, _
    ByRef df As Double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub g13bec Lib "CLW3225DA_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In](),Out()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nxxy As Integer, _
    <[In]()> ByVal xxy As Double(), _
    ByVal tdxxy As Integer, _
    <Out()> ByVal sd As Double(), _
    ByRef rss As Double, _
    ByRef objf As Double, _
    ByRef df As Double, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_inp_update Lib "CLW3225DA_nag.dll" Alias "g13bgc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nser As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In]()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nnv As Integer, _
    <[In](),Out()> ByVal xxyn As Double(), _
    ByVal tdxxyn As Integer, _
    ByVal kzef As Integer, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub g13bgc Lib "CLW3225DA_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nser As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In]()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nnv As Integer, _
    <[In](),Out()> ByVal xxyn As Double(), _
    ByVal tdxxyn As Integer, _
    ByVal kzef As Integer, _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_inp_model_forecast Lib "CLW3225DA_nag.dll" Alias "g13bjc" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In](),Out()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nev As Integer, _
    ByVal nfv As Integer, _
    <[In]()> ByVal xxy As Double(), _
    ByVal tdxxy As Integer, _
    <[In](),Out()> ByVal rmsxy As Double(), _
    <[In]()> ByVal mrx As Integer(), _
    ByVal tdmrx As Integer, _
    <[In]()> ByVal parx As Double(), _
    ByVal ldparx As Integer, _
    ByVal tdparx As Integer, _
    <Out()> ByVal fva As Double(), _
    <Out()> ByVal fsd As Double(), _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub g13bjc Lib "CLW3225DA_nag.dll" ( _
    ByRef arimav As Nag_ArimaOrder, _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    <[In](),Out()> ByVal para As Double(), _
    ByVal npara As Integer, _
    ByVal nev As Integer, _
    ByVal nfv As Integer, _
    <[In]()> ByVal xxy As Double(), _
    ByVal tdxxy As Integer, _
    <[In](),Out()> ByVal rmsxy As Double(), _
    <[In]()> ByVal mrx As Integer(), _
    ByVal tdmrx As Integer, _
    <[In]()> ByVal parx As Double(), _
    ByVal ldparx As Integer, _
    ByVal tdparx As Integer, _
    <Out()> ByVal fva As Double(), _
    <Out()> ByVal fsd As Double(), _
    ByRef ops As Nag_G13_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_options_init Lib "CLW3225DA_nag.dll" Alias "g13bxc" ( _
    ByRef ops As Nag_G13_Opt _
   )

   Declare Sub g13bxc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_G13_Opt _
   )


   Declare Sub nag_tsa_transf_orders Lib "CLW3225DA_nag.dll" Alias "g13byc" ( _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef fail As NagError _
   )

   Declare Sub g13byc Lib "CLW3225DA_nag.dll" ( _
    ByVal nseries As Integer, _
    ByRef transfv As Nag_TransfOrder, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_trans_free Lib "CLW3225DA_nag.dll" Alias "g13bzc" ( _
    ByRef transfv As Nag_TransfOrder _
   )

   Declare Sub g13bzc Lib "CLW3225DA_nag.dll" ( _
    ByRef transfv As Nag_TransfOrder _
   )


   Declare Sub nag_tsa_spectrum_univar_cov Lib "CLW3225DA_nag.dll" Alias "g13cac" ( _
    ByVal nx As Integer, _
    ByVal mtx As Integer, _
    ByVal px As Double, _
    ByVal iw As Integer, _
    ByVal mw As Integer, _
    ByVal ic As Integer, _
    ByVal nc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal kc As Integer, _
    ByVal l As Integer, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByVal nxg As Integer, _
    <[In](),Out()> ByVal xg As Double(), _
    ByRef ng As Integer, _
    <Out()> ByVal stats As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13cac Lib "CLW3225DA_nag.dll" ( _
    ByVal nx As Integer, _
    ByVal mtx As Integer, _
    ByVal px As Double, _
    ByVal iw As Integer, _
    ByVal mw As Integer, _
    ByVal ic As Integer, _
    ByVal nc As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal kc As Integer, _
    ByVal l As Integer, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    ByVal nxg As Integer, _
    <[In](),Out()> ByVal xg As Double(), _
    ByRef ng As Integer, _
    <Out()> ByVal stats As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_spectrum_univar Lib "CLW3225DA_nag.dll" Alias "g13cbc" ( _
    ByVal nx As Integer, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal px As Double, _
    ByVal mw As Integer, _
    ByVal pw As Double, _
    ByVal l As Integer, _
    ByVal kc As Integer, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    <[In]()> ByVal x As Double(), _
    ByRef gPTR As IntPtr, _
    ByRef ng As Integer, _
    <Out()> ByVal stats As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal nx As Integer, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal px As Double, _
    ByVal mw As Integer, _
    ByVal pw As Double, _
    ByVal l As Integer, _
    ByVal kc As Integer, _
    ByVal lg_spect As Nag_LoggedSpectra, _
    <[In]()> ByVal x As Double(), _
    ByRef gPTR As IntPtr, _
    ByRef ng As Integer, _
    <Out()> ByVal stats As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_spectrum_bivar_cov Lib "CLW3225DA_nag.dll" Alias "g13ccc" ( _
    ByVal nxy As Integer, _
    ByVal mtxy_correction As NagMeanOrTrend, _
    ByVal pxy As Double, _
    ByVal iw As Integer, _
    ByVal mw As Integer, _
    ByVal ish As Integer, _
    ByVal ic As Integer, _
    ByVal nc As Integer, _
    <[In](),Out()> ByVal cxy As Double(), _
    <[In](),Out()> ByVal cyx As Double(), _
    ByVal kc As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal xg As Double(), _
    <[In](),Out()> ByVal yg As Double(), _
    <Out()> ByVal g As Complex(), _
    ByRef ng As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal nxy As Integer, _
    ByVal mtxy_correction As NagMeanOrTrend, _
    ByVal pxy As Double, _
    ByVal iw As Integer, _
    ByVal mw As Integer, _
    ByVal ish As Integer, _
    ByVal ic As Integer, _
    ByVal nc As Integer, _
    <[In](),Out()> ByVal cxy As Double(), _
    <[In](),Out()> ByVal cyx As Double(), _
    ByVal kc As Integer, _
    ByVal l As Integer, _
    <[In](),Out()> ByVal xg As Double(), _
    <[In](),Out()> ByVal yg As Double(), _
    <Out()> ByVal g As Complex(), _
    ByRef ng As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_spectrum_bivar Lib "CLW3225DA_nag.dll" Alias "g13cdc" ( _
    ByVal nxy As Integer, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal pxy As Double, _
    ByVal mw As Integer, _
    ByVal s As Integer, _
    ByVal pw As Double, _
    ByVal l As Integer, _
    ByVal kc As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef g As Complex, _
    ByRef ng As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal nxy As Integer, _
    ByVal mt_correction As NagMeanOrTrend, _
    ByVal pxy As Double, _
    ByVal mw As Integer, _
    ByVal s As Integer, _
    ByVal pw As Double, _
    ByVal l As Integer, _
    ByVal kc As Integer, _
    <[In]()> ByVal x As Double(), _
    <[In]()> ByVal y As Double(), _
    ByRef g As Complex, _
    ByRef ng As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_cross_spectrum_bivar Lib "CLW3225DA_nag.dll" Alias "g13cec" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal calw As Double(), _
    <Out()> ByVal caup As Double(), _
    ByRef t As Double, _
    <Out()> ByVal sc As Double(), _
    <Out()> ByVal sclw As Double(), _
    <Out()> ByVal scup As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13cec Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    <Out()> ByVal ca As Double(), _
    <Out()> ByVal calw As Double(), _
    <Out()> ByVal caup As Double(), _
    ByRef t As Double, _
    <Out()> ByVal sc As Double(), _
    <Out()> ByVal sclw As Double(), _
    <Out()> ByVal scup As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_gain_phase_bivar Lib "CLW3225DA_nag.dll" Alias "g13cfc" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    <Out()> ByVal gn As Double(), _
    <Out()> ByVal gnlw As Double(), _
    <Out()> ByVal gnup As Double(), _
    <Out()> ByVal ph As Double(), _
    <Out()> ByVal phlw As Double(), _
    <Out()> ByVal phup As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13cfc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    <Out()> ByVal gn As Double(), _
    <Out()> ByVal gnlw As Double(), _
    <Out()> ByVal gnup As Double(), _
    <Out()> ByVal ph As Double(), _
    <Out()> ByVal phlw As Double(), _
    <Out()> ByVal phup As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_noise_spectrum_bivar Lib "CLW3225DA_nag.dll" Alias "g13cgc" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    ByVal l As Integer, _
    ByVal n As Integer, _
    <Out()> ByVal er As Double(), _
    ByRef erlw As Double, _
    ByRef erup As Double, _
    <Out()> ByVal rf As Double(), _
    ByRef rfse As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13cgc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal xg As Double(), _
    <[In]()> ByVal yg As Double(), _
    <[In]()> ByVal xyg As Complex(), _
    ByVal ng As Integer, _
    <[In]()> ByVal stats As Double(), _
    ByVal l As Integer, _
    ByVal n As Integer, _
    <Out()> ByVal er As Double(), _
    ByRef erlw As Double, _
    ByRef erup As Double, _
    <Out()> ByVal rf As Double(), _
    ByRef rfse As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_auto_corr_part Lib "CLW3225DA_nag.dll" Alias "g13dbc" ( _
    <[In]()> ByVal c0 As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal ns As Integer, _
    ByVal nl As Integer, _
    ByVal nk As Integer, _
    <Out()> ByVal p As Double(), _
    ByRef v0 As Double, _
    <Out()> ByVal v As Double(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal db As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal wb As Double(), _
    ByRef nvp As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13dbc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal c0 As Double(), _
    <[In]()> ByVal c As Double(), _
    ByVal ns As Integer, _
    ByVal nl As Integer, _
    ByVal nk As Integer, _
    <Out()> ByVal p As Double(), _
    ByRef v0 As Double, _
    <Out()> ByVal v As Double(), _
    <Out()> ByVal d As Double(), _
    <Out()> ByVal db As Double(), _
    <Out()> ByVal w As Double(), _
    <Out()> ByVal wb As Double(), _
    ByRef nvp As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_varma_estimate Lib "CLW3225DA_nag.dll" Alias "g13ddc" ( _
    ByVal k As Integer, ByVal n As Integer, ByVal ip As Integer, _
    ByVal iq As Integer, ByVal mean As Nag_IncludeMean, <[In](),Out()> ByVal par As Double(), _
    ByVal npar As Integer, <[In](),Out()> ByVal qq As Double(), ByVal kmax As Integer, _
    <[In]()> ByVal w As Double(), <[In]()> ByVal parhld As Nag_Boolean(), ByVal exact As Nag_Boolean, _
    ByVal iprint As Integer, ByVal cgetol As Double, ByVal maxcal As Integer, _
    ByVal ishow As Integer, ByVal outfile As String, ByRef niter As Integer, _
    ByRef rlogl As Double, <Out()> ByVal v As Double(), <Out()> ByVal g As Double(), _
    <Out()> ByVal cm As Double(), ByVal pdcm As Integer, ByRef fail As NagError _
   )

   Declare Sub g13ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, ByVal n As Integer, ByVal ip As Integer, _
    ByVal iq As Integer, ByVal mean As Nag_IncludeMean, <[In](),Out()> ByVal par As Double(), _
    ByVal npar As Integer, <[In](),Out()> ByVal qq As Double(), ByVal kmax As Integer, _
    <[In]()> ByVal w As Double(), <[In]()> ByVal parhld As Nag_Boolean(), ByVal exact As Nag_Boolean, _
    ByVal iprint As Integer, ByVal cgetol As Double, ByVal maxcal As Integer, _
    ByVal ishow As Integer, ByVal outfile As String, ByRef niter As Integer, _
    ByRef rlogl As Double, <Out()> ByVal v As Double(), <Out()> ByVal g As Double(), _
    <Out()> ByVal cm As Double(), ByVal pdcm As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_tsa_varma_forecast Lib "CLW3225DA_nag.dll" Alias "g13djc" ( _
    ByVal k As Integer, ByVal n As Integer, <[In]()> ByVal z As Double(), _
    ByVal kmax As Integer, <[In]()> ByVal tr As Integer(), <[In]()> ByVal id As Integer(), _
    <[In]()> ByVal delta As Double(), ByVal ip As Integer, ByVal iq As Integer, _
    ByVal mean As Nag_IncludeMean, <[In]()> ByVal par As Double(), ByVal lpar As Integer, _
    <[In](),Out()> ByVal qq As Double(), <[In]()> ByVal v As Double(), ByVal lmax As Integer, _
    <Out()> ByVal predz As Double(), <Out()> ByVal sefz As Double(), <Out()> ByVal dnref As Double(), _
    ByVal lref As Integer, ByRef fail As NagError _
   )

   Declare Sub g13djc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, ByVal n As Integer, <[In]()> ByVal z As Double(), _
    ByVal kmax As Integer, <[In]()> ByVal tr As Integer(), <[In]()> ByVal id As Integer(), _
    <[In]()> ByVal delta As Double(), ByVal ip As Integer, ByVal iq As Integer, _
    ByVal mean As Nag_IncludeMean, <[In]()> ByVal par As Double(), ByVal lpar As Integer, _
    <[In](),Out()> ByVal qq As Double(), <[In]()> ByVal v As Double(), ByVal lmax As Integer, _
    <Out()> ByVal predz As Double(), <Out()> ByVal sefz As Double(), <Out()> ByVal dnref As Double(), _
    ByVal lref As Integer, ByRef fail As NagError _
   )


   Declare Sub nag_tsa_varma_update Lib "CLW3225DA_nag.dll" Alias "g13dkc" ( _
    ByVal k As Integer, _
    ByVal lmax As Integer, _
    ByVal m As Integer, _
    ByRef mlastPTR As IntPtr, _
    <[In]()> ByVal z As Double(), _
    ByVal kmax As Integer, _
    <[In](),Out()> ByVal dnref As Double(), _
    ByVal lref As Integer, _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal predz As Double(), _
    <[In](),Out()> ByVal sefz As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13dkc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal lmax As Integer, _
    ByVal m As Integer, _
    ByRef mlastPTR As IntPtr, _
    <[In]()> ByVal z As Double(), _
    ByVal kmax As Integer, _
    <[In](),Out()> ByVal dnref As Double(), _
    ByVal lref As Integer, _
    <Out()> ByVal v As Double(), _
    <[In](),Out()> ByVal predz As Double(), _
    <[In](),Out()> ByVal sefz As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_diff Lib "CLW3225DA_nag.dll" Alias "g13dlc" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal tr As Integer(), _
    <[In]()> ByVal id As Integer(), _
    <[In]()> ByVal delta As Double(), _
    <Out()> ByVal w As Double(), _
    ByRef nd As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13dlc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    <[In]()> ByVal tr As Integer(), _
    <[In]()> ByVal id As Integer(), _
    <[In]()> ByVal delta As Double(), _
    <Out()> ByVal w As Double(), _
    ByRef nd As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_cross_corr Lib "CLW3225DA_nag.dll" Alias "g13dmc" ( _
    ByVal matrix As Nag_CovOrCorr, _
    ByVal k As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal r0 As Double(), _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13dmc Lib "CLW3225DA_nag.dll" ( _
    ByVal matrix As Nag_CovOrCorr, _
    ByVal k As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal w As Double(), _
    <Out()> ByVal wmean As Double(), _
    <Out()> ByVal r0 As Double(), _
    <Out()> ByVal r As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_part_lag_corr Lib "CLW3225DA_nag.dll" Alias "g13dnc" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal r0 As Double(), _
    <[In]()> ByVal r As Double(), _
    ByRef maxlag As Integer, _
    <[In](),Out()> ByVal parlag As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal pvalue As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13dnc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal r0 As Double(), _
    <[In]()> ByVal r As Double(), _
    ByRef maxlag As Integer, _
    <[In](),Out()> ByVal parlag As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal pvalue As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_multi_part_regsn Lib "CLW3225DA_nag.dll" Alias "g13dpc" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal m As Integer, _
    ByRef maxlag As Integer, _
    <Out()> ByVal parlag As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal qq As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal pvalue As Double(), _
    <Out()> ByVal loglhd As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13dpc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal z As Double(), _
    ByVal m As Integer, _
    ByRef maxlag As Integer, _
    <Out()> ByVal parlag As Double(), _
    <Out()> ByVal se As Double(), _
    <Out()> ByVal qq As Double(), _
    <Out()> ByVal x As Double(), _
    <Out()> ByVal pvalue As Double(), _
    <Out()> ByVal loglhd As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_varma_diagnostic Lib "CLW3225DA_nag.dll" Alias "g13dsc" ( _
    ByVal k As Integer, ByVal n As Integer, <[In]()> ByVal v As Double(), _
    ByVal kmax As Integer, ByVal ip As Integer, ByVal iq As Integer, _
    ByVal m As Integer, <[In]()> ByVal par As Double(), <[In]()> ByVal parhld As Nag_Boolean(), _
    <[In](),Out()> ByVal qq As Double(), ByVal ishow As Integer, ByVal outfile As String, _
    <Out()> ByVal r0 As Double(), <Out()> ByVal r As Double(), <Out()> ByVal rcm As Double(), _
    ByVal pdrcm As Integer, ByRef chi As Double, ByRef idf As Integer, _
    ByRef siglev As Double, ByRef fail As NagError _
   )

   Declare Sub g13dsc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, ByVal n As Integer, <[In]()> ByVal v As Double(), _
    ByVal kmax As Integer, ByVal ip As Integer, ByVal iq As Integer, _
    ByVal m As Integer, <[In]()> ByVal par As Double(), <[In]()> ByVal parhld As Nag_Boolean(), _
    <[In](),Out()> ByVal qq As Double(), ByVal ishow As Integer, ByVal outfile As String, _
    <Out()> ByVal r0 As Double(), <Out()> ByVal r As Double(), <Out()> ByVal rcm As Double(), _
    ByVal pdrcm As Integer, ByRef chi As Double, ByRef idf As Integer, _
    ByRef siglev As Double, ByRef fail As NagError _
   )


   Declare Sub nag_tsa_arma_roots Lib "CLW3225DA_nag.dll" Alias "g13dxc" ( _
    ByVal k As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal par As Double(), _
    <Out()> ByVal rr As Double(), _
    <Out()> ByVal ri As Double(), _
    <Out()> ByVal rmod As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13dxc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal ip As Integer, _
    <[In]()> ByVal par As Double(), _
    <Out()> ByVal rr As Double(), _
    <Out()> ByVal ri As Double(), _
    <Out()> ByVal rmod As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_kalman_sqrt_filt_cov_var Lib "CLW3225DA_nag.dll" Alias "g13eac" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal s As Double(), ByVal tds As Integer, <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, <[In]()> ByVal b As Double(), ByVal tdb As Integer, _
    <[In]()> ByVal q As Double(), ByVal tdq As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal r As Double(), ByVal tdr As Integer, _
    <Out()> ByVal k As Double(), ByVal tdk As Integer, <Out()> ByVal h As Double(), _
    ByVal tdh As Integer, ByVal tol As Double, ByRef fail As NagError _
   )

   Declare Sub g13eac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal s As Double(), ByVal tds As Integer, <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, <[In]()> ByVal b As Double(), ByVal tdb As Integer, _
    <[In]()> ByVal q As Double(), ByVal tdq As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal r As Double(), ByVal tdr As Integer, _
    <Out()> ByVal k As Double(), ByVal tdk As Integer, <Out()> ByVal h As Double(), _
    ByVal tdh As Integer, ByVal tol As Double, ByRef fail As NagError _
   )


   Declare Sub nag_kalman_sqrt_filt_cov_invar Lib "CLW3225DA_nag.dll" Alias "g13ebc" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal s As Double(), ByVal tds As Integer, <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, <[In]()> ByVal b As Double(), ByVal tdb As Integer, _
    <[In]()> ByVal q As Double(), ByVal tdq As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal r As Double(), ByVal tdr As Integer, _
    <Out()> ByVal k As Double(), ByVal tdk As Integer, <Out()> ByVal h As Double(), _
    ByVal tdh As Integer, ByVal tol As Double, ByRef fail As NagError _
   )

   Declare Sub g13ebc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal s As Double(), ByVal tds As Integer, <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, <[In]()> ByVal b As Double(), ByVal tdb As Integer, _
    <[In]()> ByVal q As Double(), ByVal tdq As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal r As Double(), ByVal tdr As Integer, _
    <Out()> ByVal k As Double(), ByVal tdk As Integer, <Out()> ByVal h As Double(), _
    ByVal tdh As Integer, ByVal tol As Double, ByRef fail As NagError _
   )


   Declare Sub nag_kalman_sqrt_filt_info_var Lib "CLW3225DA_nag.dll" Alias "g13ecc" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    ByVal inp_ab As Nag_ab_input, <[In](),Out()> ByVal t As Double(), ByVal tdt As Integer, _
    <[In]()> ByVal ainv As Double(), ByVal tda As Integer, <[In]()> ByVal b As Double(), _
    ByVal tdb As Integer, <[In]()> ByVal rinv As Double(), ByVal tdr As Integer, _
    <[In]()> ByVal c As Double(), ByVal tdc As Integer, <[In]()> ByVal qinv As Double(), _
    ByVal tdq As Integer, <[In](),Out()> ByVal x As Double(), <[In]()> ByVal rinvy As Double(), _
    <[In]()> ByVal z As Double(), ByVal tol As Double, ByRef fail As NagError _
   )

   Declare Sub g13ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    ByVal inp_ab As Nag_ab_input, <[In](),Out()> ByVal t As Double(), ByVal tdt As Integer, _
    <[In]()> ByVal ainv As Double(), ByVal tda As Integer, <[In]()> ByVal b As Double(), _
    ByVal tdb As Integer, <[In]()> ByVal rinv As Double(), ByVal tdr As Integer, _
    <[In]()> ByVal c As Double(), ByVal tdc As Integer, <[In]()> ByVal qinv As Double(), _
    ByVal tdq As Integer, <[In](),Out()> ByVal x As Double(), <[In]()> ByVal rinvy As Double(), _
    <[In]()> ByVal z As Double(), ByVal tol As Double, ByRef fail As NagError _
   )


   Declare Sub nag_kalman_sqrt_filt_info_invar Lib "CLW3225DA_nag.dll" Alias "g13edc" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal t As Double(), ByVal tdt As Integer, <[In]()> ByVal ainv As Double(), _
    ByVal tda As Integer, <[In]()> ByVal ainvb As Double(), ByVal tdai As Integer, _
    <[In]()> ByVal rinv As Double(), ByVal tdr As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal qinv As Double(), ByVal tdq As Integer, _
    <[In](),Out()> ByVal x As Double(), <[In]()> ByVal rinvy As Double(), <[In]()> ByVal z As Double(), _
    ByVal tol As Double, ByRef fail As NagError _
   )

   Declare Sub g13edc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal m As Integer, ByVal p As Integer, _
    <[In](),Out()> ByVal t As Double(), ByVal tdt As Integer, <[In]()> ByVal ainv As Double(), _
    ByVal tda As Integer, <[In]()> ByVal ainvb As Double(), ByVal tdai As Integer, _
    <[In]()> ByVal rinv As Double(), ByVal tdr As Integer, <[In]()> ByVal c As Double(), _
    ByVal tdc As Integer, <[In]()> ByVal qinv As Double(), ByVal tdq As Integer, _
    <[In](),Out()> ByVal x As Double(), <[In]()> ByVal rinvy As Double(), <[In]()> ByVal z As Double(), _
    ByVal tol As Double, ByRef fail As NagError _
   )


   Declare Sub nag_kalman_unscented_state_revcom Lib "CLW3225DA_nag.dll" Alias "g13ejc" ( _
    ByRef irevcm As Integer, ByVal mx As Integer, ByVal my As Integer, _
    <[In]()> ByVal y As Double(), <[In]()> ByVal lx As Double(), ByVal pdlx As Integer, _
    <[In]()> ByVal ly As Double(), ByVal pdly As Integer, <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal st As Double(), ByVal pdst As Integer, ByRef n As Integer, _
    <[In](),Out()> ByVal xt As Double(), ByVal pdxt As Integer, <[In](),Out()> ByVal fxt As Double(), _
    ByVal pdfxt As Integer, <[In]()> ByVal ropt As Double(), ByVal lropt As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), ByVal licomm As Integer, <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, ByRef fail As NagError _
   )

   Declare Sub g13ejc Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, ByVal mx As Integer, ByVal my As Integer, _
    <[In]()> ByVal y As Double(), <[In]()> ByVal lx As Double(), ByVal pdlx As Integer, _
    <[In]()> ByVal ly As Double(), ByVal pdly As Integer, <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal st As Double(), ByVal pdst As Integer, ByRef n As Integer, _
    <[In](),Out()> ByVal xt As Double(), ByVal pdxt As Integer, <[In](),Out()> ByVal fxt As Double(), _
    ByVal pdfxt As Integer, <[In]()> ByVal ropt As Double(), ByVal lropt As Integer, _
    <[In](),Out()> ByVal icomm As Integer(), ByVal licomm As Integer, <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, ByRef fail As NagError _
   )


Delegate Sub nag_kalman_unscented_state_f_DELEGATE( _
    ByVal mx As Integer, _
    ByVal n As Integer, _
    ByVal xt_rptr As IntPtr, _
    ByVal fxt_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

Delegate Sub nag_kalman_unscented_state_h_DELEGATE( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    ByVal n As Integer, _
    ByVal yt_rptr As IntPtr, _
    ByVal hyt_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub nag_kalman_unscented_state Lib "CLW3225DA_nag.dll" Alias "g13ekc" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal lx As Double(), _
    <[In]()> ByVal ly As Double(), _
    ByVal f As nag_kalman_unscented_state_f_DELEGATE, _
    ByVal h As nag_kalman_unscented_state_h_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal st As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g13ekc_f_DELEGATE( _
    ByVal mx As Integer, _
    ByVal n As Integer, _
    ByVal xt_rptr As IntPtr, _
    ByVal fxt_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

Delegate Sub g13ekc_h_DELEGATE( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    ByVal n As Integer, _
    ByVal yt_rptr As IntPtr, _
    ByVal hyt_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub g13ekc Lib "CLW3225DA_nag.dll" ( _
    ByVal mx As Integer, _
    ByVal my As Integer, _
    <[In]()> ByVal y As Double(), _
    <[In]()> ByVal lx As Double(), _
    <[In]()> ByVal ly As Double(), _
    ByVal f As g13ekc_f_DELEGATE, _
    ByVal h As g13ekc_h_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    <[In](),Out()> ByVal st As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_trans_hessenberg_observer Lib "CLW3225DA_nag.dll" Alias "g13ewc" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    ByVal reduceto As Nag_ObserverForm, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal tdu As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13ewc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal p As Integer, _
    ByVal reduceto As Nag_ObserverForm, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal c As Double(), _
    ByVal tdc As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal tdu As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_trans_hessenberg_controller Lib "CLW3225DA_nag.dll" Alias "g13exc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal reduceto As Nag_ControllerForm, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal tdu As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub g13exc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    ByVal reduceto As Nag_ControllerForm, _
    <[In](),Out()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In](),Out()> ByVal b As Double(), _
    ByVal tdb As Integer, _
    <[In](),Out()> ByVal u As Double(), _
    ByVal tdu As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_estimate_agarchI Lib "CLW3225DA_nag.dll" Alias "g13fac" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, ByVal isym As Integer, _
    <[In](),Out()> ByVal theta As Double(), <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), _
    <Out()> ByVal covar As Double(), ByVal tdc As Integer, ByRef hp As Double, _
    <Out()> ByVal et As Double(), <Out()> ByVal ht As Double(), ByRef lgf As Double, _
    ByVal stat_opt As Nag_Garch_Stationary_Type, ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, _
    ByVal tol As Double, ByRef fail As NagError _
   )

   Declare Sub g13fac Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, ByVal isym As Integer, _
    <[In](),Out()> ByVal theta As Double(), <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), _
    <Out()> ByVal covar As Double(), ByVal tdc As Integer, ByRef hp As Double, _
    <Out()> ByVal et As Double(), <Out()> ByVal ht As Double(), ByRef lgf As Double, _
    ByVal stat_opt As Nag_Garch_Stationary_Type, ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, _
    ByVal tol As Double, ByRef fail As NagError _
   )


   Declare Sub nag_forecast_agarchI Lib "CLW3225DA_nag.dll" Alias "g13fbc" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13fbc Lib "CLW3225DA_nag.dll" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_estimate_agarchII Lib "CLW3225DA_nag.dll" Alias "g13fcc" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, <[In](),Out()> ByVal theta As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), <Out()> ByVal covar As Double(), _
    ByVal tdc As Integer, ByRef hp As Double, <Out()> ByVal et As Double(), _
    <Out()> ByVal ht As Double(), ByRef lgf As Double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13fcc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, <[In](),Out()> ByVal theta As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), <Out()> ByVal covar As Double(), _
    ByVal tdc As Integer, ByRef hp As Double, <Out()> ByVal et As Double(), _
    <Out()> ByVal ht As Double(), ByRef lgf As Double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_forecast_agarchII Lib "CLW3225DA_nag.dll" Alias "g13fdc" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13fdc Lib "CLW3225DA_nag.dll" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_estimate_garchGJR Lib "CLW3225DA_nag.dll" Alias "g13fec" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, <[In](),Out()> ByVal theta As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), <Out()> ByVal covar As Double(), _
    ByVal tdc As Integer, ByRef hp As Double, <Out()> ByVal et As Double(), _
    <Out()> ByVal ht As Double(), ByRef lgf As Double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, ByVal tol As Double, _
    ByRef fail As NagError _
   )

   Declare Sub g13fec Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal yt As Double(), <[In]()> ByVal x As Double(), ByVal tdx As Integer, _
    ByVal num As Integer, ByVal p As Integer, ByVal q As Integer, _
    ByVal nreg As Integer, ByVal mn As Integer, <[In](),Out()> ByVal theta As Double(), _
    <Out()> ByVal se As Double(), <Out()> ByVal sc As Double(), <Out()> ByVal covar As Double(), _
    ByVal tdc As Integer, ByRef hp As Double, <Out()> ByVal et As Double(), _
    <Out()> ByVal ht As Double(), ByRef lgf As Double, ByVal stat_opt As Nag_Garch_Stationary_Type, _
    ByVal est_opt As Nag_Garch_Est_Initial_Type, ByVal max_iter As Integer, ByVal tol As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_forecast_garchGJR Lib "CLW3225DA_nag.dll" Alias "g13ffc" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13ffc Lib "CLW3225DA_nag.dll" ( _
    ByVal num As Integer, _
    ByVal nt As Integer, _
    ByVal p As Integer, _
    ByVal q As Integer, _
    <[In]()> ByVal theta As Double(), _
    ByVal gamma As Double, _
    <Out()> ByVal fht As Double(), _
    <[In]()> ByVal ht As Double(), _
    <[In]()> ByVal et As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_inhom_iema Lib "CLW3225DA_nag.dll" Alias "g13mec" ( _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal iema As Double(), _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByRef pn As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13mec Lib "CLW3225DA_nag.dll" ( _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal iema As Double(), _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByRef pn As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_inhom_iema_all Lib "CLW3225DA_nag.dll" Alias "g13mfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal nb As Integer, _
    <[In]()> ByVal z As Double(), _
    <Out()> ByVal iema As Double(), _
    ByVal pdiema As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As Double, _
    <[In]()> ByVal x As Double(), _
    ByRef pn As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13mfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal nb As Integer, _
    <[In]()> ByVal z As Double(), _
    <Out()> ByVal iema As Double(), _
    ByVal pdiema As Integer, _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As Double, _
    <[In]()> ByVal x As Double(), _
    ByRef pn As Integer, _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_inhom_ma Lib "CLW3225DA_nag.dll" Alias "g13mgc" ( _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal ma As Double(), _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As Double, _
    ByRef pn As Integer, _
    <Out()> ByVal wma As Double(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13mgc Lib "CLW3225DA_nag.dll" ( _
    ByVal nb As Integer, _
    <[In](),Out()> ByVal ma As Double(), _
    <[In]()> ByVal t As Double(), _
    ByVal tau As Double, _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    <[In]()> ByVal sinit As Double(), _
    <[In]()> ByVal inter As Nag_TS_Interpolation(), _
    ByVal ftype As Nag_TS_Transform, _
    ByRef p As Double, _
    ByRef pn As Integer, _
    <Out()> ByVal wma As Double(), _
    <[In](),Out()> ByVal rcomm As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_cp_pelt Lib "CLW3225DA_nag.dll" Alias "g13nac" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    <[In]()> ByVal param As Double(), _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    <Out()> ByVal sparam As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13nac Lib "CLW3225DA_nag.dll" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    <[In]()> ByVal param As Double(), _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    <Out()> ByVal sparam As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_tsa_cp_pelt_user_costfn_DELEGATE( _
    ByVal ts As Integer, _
    ByVal nr As Integer, _
    ByVal r_iptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub nag_tsa_cp_pelt_user Lib "CLW3225DA_nag.dll" Alias "g13nbc" ( _
    ByVal n As Integer, _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    ByVal k As Double, _
    ByVal costfn As nag_tsa_cp_pelt_user_costfn_DELEGATE, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g13nbc_costfn_DELEGATE( _
    ByVal ts As Integer, _
    ByVal nr As Integer, _
    ByVal r_iptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub g13nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    ByVal k As Double, _
    ByVal costfn As g13nbc_costfn_DELEGATE, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_cp_binary Lib "CLW3225DA_nag.dll" Alias "g13ndc" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    <[In]()> ByVal param As Double(), _
    ByVal mdepth As Integer, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    <Out()> ByVal sparam As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub g13ndc Lib "CLW3225DA_nag.dll" ( _
    ByVal ctyp As Nag_TS_ChangeType, _
    ByVal n As Integer, _
    <[In]()> ByVal y As Double(), _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    <[In]()> ByVal param As Double(), _
    ByVal mdepth As Integer, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    <Out()> ByVal sparam As Double(), _
    ByRef fail As NagError _
   )


Delegate Sub nag_tsa_cp_binary_user_chgpfn_DELEGATE( _
    ByVal side As Nag_TS_SegSide, _
    ByVal u As Integer, _
    ByVal w As Integer, _
    ByVal minss As Integer, _
    ByRef v As Integer, _
    ByVal cost_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub nag_tsa_cp_binary_user Lib "CLW3225DA_nag.dll" Alias "g13nec" ( _
    ByVal n As Integer, _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    ByVal mdepth As Integer, _
    ByVal chgpfn As nag_tsa_cp_binary_user_chgpfn_DELEGATE, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub g13nec_chgpfn_DELEGATE( _
    ByVal side As Nag_TS_SegSide, _
    ByVal u As Integer, _
    ByVal w As Integer, _
    ByVal minss As Integer, _
    ByRef v As Integer, _
    ByVal cost_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub g13nec Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal beta As Double, _
    ByVal minss As Integer, _
    ByVal mdepth As Integer, _
    ByVal chgpfn As g13nec_chgpfn_DELEGATE, _
    ByRef ntau As Integer, _
    <Out()> ByVal tau As Integer(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_tsa_free Lib "CLW3225DA_nag.dll" Alias "g13xzc" ( _
    ByRef ops As Nag_G13_Opt _
   )

   Declare Sub g13xzc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_G13_Opt _
   )


' chapter h

Delegate Sub nag_ip_bb_qphess_DELEGATE( _
    ByVal n As Integer, _
    ByVal jthcol As Integer, _
    ByVal h_rptr As IntPtr, _
    ByVal tdh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub nag_ip_bb Lib "CLW3225DA_nag.dll" Alias "h02bbc" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal intvar As Nag_Boolean(), _
    <[In]()> ByVal cvec As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    ByVal qphess As nag_ip_bb_qphess_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_H02_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub h02bbc_qphess_DELEGATE( _
    ByVal n As Integer, _
    ByVal jthcol As Integer, _
    ByVal h_rptr As IntPtr, _
    ByVal tdh As Integer, _
    ByVal x_rptr As IntPtr, _
    ByVal hx_rptr As IntPtr, _
    ByRef comm As Nag_Comm _
  )

   Declare Sub h02bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal tda As Integer, _
    <[In]()> ByVal bl As Double(), _
    <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal intvar As Nag_Boolean(), _
    <[In]()> ByVal cvec As Double(), _
    <[In]()> ByVal h As Double(), _
    ByVal tdh As Integer, _
    ByVal qphess As h02bbc_qphess_DELEGATE, _
    <[In](),Out()> ByVal x As Double(), _
    ByRef objf As Double, _
    ByRef ops As Nag_H02_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ip_mps_read Lib "CLW3225DA_nag.dll" Alias "h02buc" ( _
    ByVal mps_file As String, _
    ByVal minimize As Nag_Boolean, _
    ByRef n As Integer, _
    ByRef m As Integer, _
    ByRef aPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef intvarPTR As IntPtr, _
    ByRef cvecPTR As IntPtr, _
    ByRef xPTR As IntPtr, _
    ByRef ops As Nag_H02_Opt, _
    ByRef fail As NagError _
   )

   Declare Sub h02buc Lib "CLW3225DA_nag.dll" ( _
    ByVal mps_file As String, _
    ByVal minimize As Nag_Boolean, _
    ByRef n As Integer, _
    ByRef m As Integer, _
    ByRef aPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef intvarPTR As IntPtr, _
    ByRef cvecPTR As IntPtr, _
    ByRef xPTR As IntPtr, _
    ByRef ops As Nag_H02_Opt, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ip_mps_free Lib "CLW3225DA_nag.dll" Alias "h02bvc" ( _
    ByRef aPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef intvarPTR As IntPtr, _
    ByRef cvecPTR As IntPtr, _
    ByRef xPTR As IntPtr _
   )

   Declare Sub h02bvc Lib "CLW3225DA_nag.dll" ( _
    ByRef aPTR As IntPtr, _
    ByRef blPTR As IntPtr, _
    ByRef buPTR As IntPtr, _
    ByRef intvarPTR As IntPtr, _
    ByRef cvecPTR As IntPtr, _
    ByRef xPTR As IntPtr _
   )


Delegate Sub nag_mip_sqp_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal varcon_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub H02DDM Lib "CLW3225DA_nag.dll" ( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal varcon_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

Delegate Sub nag_mip_sqp_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal varcon_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByRef objmip As Double, _
    ByVal objgrd_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub nag_mip_sqp Lib "CLW3225DA_nag.dll" Alias "h02dac" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    <[In]()> ByVal a As Double(), ByVal pda As Integer, <[In]()> ByVal d As Double(), _
    <Out()> ByVal ax As Double(), <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal varcon As Integer(), <[In](),Out()> ByVal x As Double(), ByVal confun As nag_mip_sqp_confun_DELEGATE, _
    <Out()> ByVal c As Double(), <Out()> ByVal cjac As Double(), ByVal objfun As nag_mip_sqp_objfun_DELEGATE, _
    <Out()> ByVal objgrd As Double(), ByVal maxit As Integer, ByVal acc As Double, _
    ByRef objmip As Double, <[In]()> ByVal iopts As Integer(), <[In]()> ByVal opts As Double(), ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )

Delegate Sub h02dac_confun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal ncnln As Integer, _
    ByVal n As Integer, _
    ByVal varcon_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByVal c_rptr As IntPtr, _
    ByVal cjac_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )


Delegate Sub h02dac_objfun_DELEGATE( _
    ByRef mode As Integer, _
    ByVal n As Integer, _
    ByVal varcon_iptr As IntPtr, _
    ByVal x_rptr As IntPtr, _
    ByRef objmip As Double, _
    ByVal objgrd_rptr As IntPtr, _
    ByVal nstate As Integer, _
    ByRef COMM As Nag_Comm _
  )

   Declare Sub h02dac Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, ByVal nclin As Integer, ByVal ncnln As Integer, _
    <[In]()> ByVal a As Double(), ByVal pda As Integer, <[In]()> ByVal d As Double(), _
    <Out()> ByVal ax As Double(), <[In]()> ByVal bl As Double(), <[In]()> ByVal bu As Double(), _
    <[In]()> ByVal varcon As Integer(), <[In](),Out()> ByVal x As Double(), ByVal confun As h02dac_confun_DELEGATE, _
    <Out()> ByVal c As Double(), <Out()> ByVal cjac As Double(), ByVal objfun As h02dac_objfun_DELEGATE, _
    <Out()> ByVal objgrd As Double(), ByVal maxit As Integer, ByVal acc As Double, _
    ByRef objmip As Double, <[In]()> ByVal iopts As Integer(), <[In]()> ByVal opts As Double(), ByRef COMM As Nag_Comm, ByRef fail As NagError _
   )


   Declare Sub nag_ip_init Lib "CLW3225DA_nag.dll" Alias "h02xxc" ( _
    ByRef ops As Nag_H02_Opt _
   )

   Declare Sub h02xxc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_H02_Opt _
   )


   Declare Sub nag_ip_read Lib "CLW3225DA_nag.dll" Alias "h02xyc" ( _
    ByVal nm As String, _
    ByVal opt_file As String, _
    ByRef ops As Nag_H02_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub h02xyc Lib "CLW3225DA_nag.dll" ( _
    ByVal nm As String, _
    ByVal opt_file As String, _
    ByRef ops As Nag_H02_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_ip_free Lib "CLW3225DA_nag.dll" Alias "h02xzc" ( _
    ByRef ops As Nag_H02_Opt, _
    ByVal p_name As String, _
    ByRef fail As NagError _
   )

   Declare Sub h02xzc Lib "CLW3225DA_nag.dll" ( _
    ByRef ops As Nag_H02_Opt, _
    ByVal p_name As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mip_opt_set Lib "CLW3225DA_nag.dll" Alias "h02zkc" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub h02zkc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    <[In](),Out()> ByVal iopts As Integer(), _
    ByVal liopts As Integer, _
    <[In](),Out()> ByVal opts As Double(), _
    ByVal lopts As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_mip_opt_get Lib "CLW3225DA_nag.dll" Alias "h02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub h02zlc Lib "CLW3225DA_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As Integer, _
    ByRef rvalue As Double, _
    ByVal cvalue As String, _
    ByVal lcvalue As Integer, _
    ByRef optype As Nag_VariableType, _
    <[In]()> ByVal iopts As Integer(), _
    <[In]()> ByVal opts As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_transport Lib "CLW3225DA_nag.dll" Alias "h03abc" ( _
    <[In]()> ByVal cost As Double(), _
    ByVal tdcost As Integer, _
    <[In]()> ByVal avail As Double(), _
    ByVal navail As Integer, _
    <[In]()> ByVal req As Double(), _
    ByVal nreq As Integer, _
    ByVal maxit As Integer, _
    ByRef numit As Integer, _
    <Out()> ByVal optq As Double(), _
    <Out()> ByVal source As Integer(), _
    <Out()> ByVal dest As Integer(), _
    ByRef optcost As Double, _
    <Out()> ByVal unitcost As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub h03abc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal cost As Double(), _
    ByVal tdcost As Integer, _
    <[In]()> ByVal avail As Double(), _
    ByVal navail As Integer, _
    <[In]()> ByVal req As Double(), _
    ByVal nreq As Integer, _
    ByVal maxit As Integer, _
    ByRef numit As Integer, _
    <Out()> ByVal optq As Double(), _
    <Out()> ByVal source As Integer(), _
    <Out()> ByVal dest As Integer(), _
    ByRef optcost As Double, _
    <Out()> ByVal unitcost As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_mip_tsp_simann Lib "CLW3225DA_nag.dll" Alias "h03bbc" ( _
    ByVal nc As Integer, _
    <[In]()> ByVal dm As Double(), _
    ByVal bound As Double, _
    ByVal targc As Double, _
    <Out()> ByVal path As Integer(), _
    ByRef cost As Double, _
    ByRef tmode As Integer, _
    <Out()> ByVal alg_stats As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub h03bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal nc As Integer, _
    <[In]()> ByVal dm As Double(), _
    ByVal bound As Double, _
    ByVal targc As Double, _
    <Out()> ByVal path As Integer(), _
    ByRef cost As Double, _
    ByRef tmode As Integer, _
    <Out()> ByVal alg_stats As Double(), _
    <[In](),Out()> ByVal state As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_best_subset_given_size_revcomm Lib "CLW3225DA_nag.dll" Alias "h05aac" ( _
    ByRef irevcm As Integer, ByVal mincr As Integer, ByVal m As Integer, _
    ByVal ip As Integer, ByVal nbest As Integer, ByRef drop As Integer, _
    ByRef lz As Integer, <[In](),Out()> ByVal z As Integer(), ByRef la As Integer, _
    <[In](),Out()> ByVal a As Integer(), <[In](),Out()> ByVal bscore As Double(), <[In](),Out()> ByVal bz As Integer(), _
    ByVal mincnt As Integer, ByVal gamma As Double, <[In]()> ByVal acc As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), ByVal licomm As Integer, <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, ByRef fail As NagError _
   )

   Declare Sub h05aac Lib "CLW3225DA_nag.dll" ( _
    ByRef irevcm As Integer, ByVal mincr As Integer, ByVal m As Integer, _
    ByVal ip As Integer, ByVal nbest As Integer, ByRef drop As Integer, _
    ByRef lz As Integer, <[In](),Out()> ByVal z As Integer(), ByRef la As Integer, _
    <[In](),Out()> ByVal a As Integer(), <[In](),Out()> ByVal bscore As Double(), <[In](),Out()> ByVal bz As Integer(), _
    ByVal mincnt As Integer, ByVal gamma As Double, <[In]()> ByVal acc As Double(), _
    <[In](),Out()> ByVal icomm As Integer(), ByVal licomm As Integer, <[In](),Out()> ByVal rcomm As Double(), _
    ByVal lrcomm As Integer, ByRef fail As NagError _
   )


Delegate Sub nag_best_subset_given_size_f_DELEGATE( _
    ByVal m As Integer, _
    ByVal drop As Integer, _
    ByVal lz As Integer, _
    ByVal z_iptr As IntPtr, _
    ByVal la As Integer, _
    ByVal a_iptr As IntPtr, _
    ByVal score_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub nag_best_subset_given_size Lib "CLW3225DA_nag.dll" Alias "h05abc" ( _
    ByVal mincr As Integer, _
    ByVal m As Integer, _
    ByVal ip As Integer, _
    ByVal nbest As Integer, _
    ByRef la As Integer, _
    <Out()> ByVal bscore As Double(), _
    <Out()> ByVal bz As Integer(), _
    ByVal f As nag_best_subset_given_size_f_DELEGATE, _
    ByVal mincnt As Integer, _
    ByVal gamma As Double, _
    <[In]()> ByVal acc As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )

Delegate Sub h05abc_f_DELEGATE( _
    ByVal m As Integer, _
    ByVal drop As Integer, _
    ByVal lz As Integer, _
    ByVal z_iptr As IntPtr, _
    ByVal la As Integer, _
    ByVal a_iptr As IntPtr, _
    ByVal score_rptr As IntPtr, _
    ByRef COMM As Nag_Comm, _
    ByRef info As Integer _
  )

   Declare Sub h05abc Lib "CLW3225DA_nag.dll" ( _
    ByVal mincr As Integer, _
    ByVal m As Integer, _
    ByVal ip As Integer, _
    ByVal nbest As Integer, _
    ByRef la As Integer, _
    <Out()> ByVal bscore As Double(), _
    <Out()> ByVal bz As Integer(), _
    ByVal f As h05abc_f_DELEGATE, _
    ByVal mincnt As Integer, _
    ByVal gamma As Double, _
    <[In]()> ByVal acc As Double(), _
    ByRef COMM As Nag_Comm, _
    ByRef fail As NagError _
   )


' chapter m01

   Declare Sub nag_double_sort Lib "CLW3225DA_nag.dll" Alias "m01cac" ( _
    <[In](),Out()> ByVal vec As Double(), _
    ByVal n As Integer, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

   Declare Sub m01cac Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal vec As Double(), _
    ByVal n As Integer, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )


Delegate Function nag_quicksort_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub nag_quicksort Lib "CLW3225DA_nag.dll" Alias "m01csc" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As nag_quicksort_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

Delegate Function m01csc_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub m01csc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As m01csc_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )


Delegate Function nag_stable_sort_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub nag_stable_sort Lib "CLW3225DA_nag.dll" Alias "m01ctc" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As nag_stable_sort_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

Delegate Function m01ctc_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub m01ctc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As m01ctc_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )


Delegate Function nag_chain_sort_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub nag_chain_sort Lib "CLW3225DA_nag.dll" Alias "m01cuc" ( _
    ByRef basePTR As IntPtr, _
    ByVal offset As IntPtr, _
    ByVal compare As nag_chain_sort_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

Delegate Function m01cuc_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub m01cuc Lib "CLW3225DA_nag.dll" ( _
    ByRef basePTR As IntPtr, _
    ByVal offset As IntPtr, _
    ByVal compare As m01cuc_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )


Delegate Function nag_rank_sort_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub nag_rank_sort Lib "CLW3225DA_nag.dll" Alias "m01dsc" ( _
    <[In]()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As nag_rank_sort_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef ranks As Integer(), _
    ByRef fail As NagError _
   )

Delegate Function m01dsc_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Sub m01dsc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As m01dsc_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByRef ranks As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_reorder_vector Lib "CLW3225DA_nag.dll" Alias "m01esc" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal indices As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub m01esc Lib "CLW3225DA_nag.dll" ( _
    <[In](),Out()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal size As Integer, _
    ByVal stride As IntPtr, _
    ByVal indices As Integer(), _
    ByRef fail As NagError _
   )


Delegate Function nag_search_vector_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Function nag_search_vector Lib "CLW3225DA_nag.dll" Alias "m01fsc" ( _
    ByVal keyPTR As IntPtr, _
    <[In]()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As nag_search_vector_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByVal final As Nag_SearchMatch, _
    ByRef matchPTR As IntPtr, _
    ByRef fail As NagError _
   ) as Integer

Delegate Function m01fsc_compare_DELEGATE( _
    ByVal a As IntPtr, _
    ByVal b As IntPtr _
  ) as Integer

   Declare Function m01fsc Lib "CLW3225DA_nag.dll" ( _
    ByVal keyPTR As IntPtr, _
    <[In]()> ByVal vec As IntPtr(), _
    ByVal n As Integer, _
    ByVal stride As IntPtr, _
    ByVal compare As m01fsc_compare_DELEGATE, _
    ByVal order As Nag_SortOrder, _
    ByVal final As Nag_SearchMatch, _
    ByRef matchPTR As IntPtr, _
    ByRef fail As NagError _
   ) as Integer


   Declare Function nag_search_double Lib "CLW3225DA_nag.dll" Alias "m01nac" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal rv As Double(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As Double, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function m01nac Lib "CLW3225DA_nag.dll" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal rv As Double(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As Double, _
    ByRef fail As NagError _
   ) as Integer


   Declare Function nag_search_int Lib "CLW3225DA_nag.dll" Alias "m01nbc" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal iv As Integer(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As Integer, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function m01nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal iv As Integer(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As Integer, _
    ByRef fail As NagError _
   ) as Integer


   Declare Function nag_search_char Lib "CLW3225DA_nag.dll" Alias "m01ncc" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal ch As IntPtr(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As String, _
    ByRef fail As NagError _
   ) as Integer

   Declare Function m01ncc Lib "CLW3225DA_nag.dll" ( _
    ByVal validate As Nag_Boolean, _
    <[In]()> ByVal ch As IntPtr(), _
    ByVal m1 As Integer, _
    ByVal m2 As Integer, _
    ByVal item As String, _
    ByRef fail As NagError _
   ) as Integer


   Declare Sub nag_make_indices Lib "CLW3225DA_nag.dll" Alias "m01zac" ( _
    ByRef ranks As Integer(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub m01zac Lib "CLW3225DA_nag.dll" ( _
    ByRef ranks As Integer(), _
    ByVal n As Integer, _
    ByRef fail As NagError _
   )


' chapter s

   Declare Function nag_shifted_log Lib "CLW3225DA_nag.dll" Alias "s01bac" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s01bac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_tanh Lib "CLW3225DA_nag.dll" Alias "s10aac" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s10aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_sinh Lib "CLW3225DA_nag.dll" Alias "s10abc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s10abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_cosh Lib "CLW3225DA_nag.dll" Alias "s10acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s10acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_arctanh Lib "CLW3225DA_nag.dll" Alias "s11aac" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s11aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_arcsinh Lib "CLW3225DA_nag.dll" Alias "s11abc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s11abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_arccosh Lib "CLW3225DA_nag.dll" Alias "s11acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s11acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_exp_integral Lib "CLW3225DA_nag.dll" Alias "s13aac" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s13aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_cos_integral Lib "CLW3225DA_nag.dll" Alias "s13acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s13acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_sin_integral Lib "CLW3225DA_nag.dll" Alias "s13adc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s13adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_gamma Lib "CLW3225DA_nag.dll" Alias "s14aac" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_log_gamma Lib "CLW3225DA_nag.dll" Alias "s14abc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_polygamma_fun Lib "CLW3225DA_nag.dll" Alias "s14acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_polygamma_deriv Lib "CLW3225DA_nag.dll" Alias "s14adc" ( _
    ByVal x As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal ans As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s14adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal n As Integer, _
    ByVal m As Integer, _
    <Out()> ByVal ans As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_real_polygamma Lib "CLW3225DA_nag.dll" Alias "s14aec" ( _
    ByVal x As Double, _
    ByVal k As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14aec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal k As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_complex_polygamma Lib "CLW3225DA_nag.dll" Alias "s14afc" ( _
    ByVal z As Complex, _
    ByVal k As Integer, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function s14afc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal k As Integer, _
    ByRef fail As NagError _
   ) as Complex


   Declare Function nag_complex_log_gamma Lib "CLW3225DA_nag.dll" Alias "s14agc" ( _
    ByVal z As Complex, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function s14agc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByRef fail As NagError _
   ) as Complex


   Declare Function nag_scaled_log_gamma Lib "CLW3225DA_nag.dll" Alias "s14ahc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14ahc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_incomplete_gamma Lib "CLW3225DA_nag.dll" Alias "s14bac" ( _
    ByVal a As Double, _
    ByVal x As Double, _
    ByVal tol As Double, _
    ByRef p As Double, _
    ByRef q As Double, _
    ByRef fail As NagError _
   )

   Declare Sub s14bac Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal x As Double, _
    ByVal tol As Double, _
    ByRef p As Double, _
    ByRef q As Double, _
    ByRef fail As NagError _
   )


   Declare Function nag_log_beta Lib "CLW3225DA_nag.dll" Alias "s14cbc" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s14cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_incomplete_beta Lib "CLW3225DA_nag.dll" Alias "s14ccc" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal x As Double, _
    ByRef w As Double, _
    ByRef w1 As Double, _
    ByRef fail As NagError _
   )

   Declare Sub s14ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal x As Double, _
    ByRef w As Double, _
    ByRef w1 As Double, _
    ByRef fail As NagError _
   )


   Declare Function nag_cumul_normal Lib "CLW3225DA_nag.dll" Alias "s15abc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s15abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_cumul_normal_complem Lib "CLW3225DA_nag.dll" Alias "s15acc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s15acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_erfc Lib "CLW3225DA_nag.dll" Alias "s15adc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s15adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_erf Lib "CLW3225DA_nag.dll" Alias "s15aec" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s15aec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_dawson Lib "CLW3225DA_nag.dll" Alias "s15afc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s15afc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_erfcx Lib "CLW3225DA_nag.dll" Alias "s15agc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s15agc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_complex_erfc Lib "CLW3225DA_nag.dll" Alias "s15ddc" ( _
    ByVal z As Complex, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function s15ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByRef fail As NagError _
   ) as Complex


   Declare Function nag_bessel_y0 Lib "CLW3225DA_nag.dll" Alias "s17acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_y1 Lib "CLW3225DA_nag.dll" Alias "s17adc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_j0 Lib "CLW3225DA_nag.dll" Alias "s17aec" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17aec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_j1 Lib "CLW3225DA_nag.dll" Alias "s17afc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17afc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_airy_ai Lib "CLW3225DA_nag.dll" Alias "s17agc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17agc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_airy_bi Lib "CLW3225DA_nag.dll" Alias "s17ahc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17ahc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_airy_ai_deriv Lib "CLW3225DA_nag.dll" Alias "s17ajc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17ajc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_airy_bi_deriv Lib "CLW3225DA_nag.dll" Alias "s17akc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s17akc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_bessel_zeros Lib "CLW3225DA_nag.dll" Alias "s17alc" ( _
    ByVal a As Double, _
    ByVal n As Integer, _
    ByVal mode As Integer, _
    ByVal rel As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s17alc Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal n As Integer, _
    ByVal mode As Integer, _
    ByVal rel As Double, _
    <Out()> ByVal x As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_y0_vector Lib "CLW3225DA_nag.dll" Alias "s17aqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_y1_vector Lib "CLW3225DA_nag.dll" Alias "s17arc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17arc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_j0_vector Lib "CLW3225DA_nag.dll" Alias "s17asc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17asc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_j1_vector Lib "CLW3225DA_nag.dll" Alias "s17atc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17atc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_airy_ai_vector Lib "CLW3225DA_nag.dll" Alias "s17auc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17auc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_airy_bi_vector Lib "CLW3225DA_nag.dll" Alias "s17avc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17avc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_airy_ai_deriv_vector Lib "CLW3225DA_nag.dll" Alias "s17awc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17awc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_airy_bi_deriv_vector Lib "CLW3225DA_nag.dll" Alias "s17axc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s17axc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_bessel_y Lib "CLW3225DA_nag.dll" Alias "s17dcc" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s17dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_bessel_j Lib "CLW3225DA_nag.dll" Alias "s17dec" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s17dec Lib "CLW3225DA_nag.dll" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_airy_ai Lib "CLW3225DA_nag.dll" Alias "s17dgc" ( _
    ByVal deriv As Nag_FunType, _
    ByVal z As Complex, _
    ByVal scal As Nag_ScaleResType, _
    ByRef ai As Complex, _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s17dgc Lib "CLW3225DA_nag.dll" ( _
    ByVal deriv As Nag_FunType, _
    ByVal z As Complex, _
    ByVal scal As Nag_ScaleResType, _
    ByRef ai As Complex, _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_airy_bi Lib "CLW3225DA_nag.dll" Alias "s17dhc" ( _
    ByVal deriv As Nag_FunType, _
    ByVal z As Complex, _
    ByVal scal As Nag_ScaleResType, _
    ByRef bi As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub s17dhc Lib "CLW3225DA_nag.dll" ( _
    ByVal deriv As Nag_FunType, _
    ByVal z As Complex, _
    ByVal scal As Nag_ScaleResType, _
    ByRef bi As Complex, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_hankel Lib "CLW3225DA_nag.dll" Alias "s17dlc" ( _
    ByVal m As Integer, _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s17dlc Lib "CLW3225DA_nag.dll" ( _
    ByVal m As Integer, _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_bessel_k0 Lib "CLW3225DA_nag.dll" Alias "s18acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_k1 Lib "CLW3225DA_nag.dll" Alias "s18adc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_i0 Lib "CLW3225DA_nag.dll" Alias "s18aec" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18aec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_i1 Lib "CLW3225DA_nag.dll" Alias "s18afc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18afc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_bessel_k0_vector Lib "CLW3225DA_nag.dll" Alias "s18aqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_k1_vector Lib "CLW3225DA_nag.dll" Alias "s18arc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18arc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_i0_vector Lib "CLW3225DA_nag.dll" Alias "s18asc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18asc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_i1_vector Lib "CLW3225DA_nag.dll" Alias "s18atc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18atc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Function nag_bessel_k0_scaled Lib "CLW3225DA_nag.dll" Alias "s18ccc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_k1_scaled Lib "CLW3225DA_nag.dll" Alias "s18cdc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_i0_scaled Lib "CLW3225DA_nag.dll" Alias "s18cec" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s18cec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_bessel_i1_scaled Lib "CLW3225DA_nag.dll" Alias "s18cfc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s18cfc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Sub nag_bessel_k0_scaled_vector Lib "CLW3225DA_nag.dll" Alias "s18cqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18cqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_k1_scaled_vector Lib "CLW3225DA_nag.dll" Alias "s18crc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s18crc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_i0_scaled_vector Lib "CLW3225DA_nag.dll" Alias "s18csc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s18csc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_i1_scaled_vector Lib "CLW3225DA_nag.dll" Alias "s18ctc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s18ctc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_bessel_k Lib "CLW3225DA_nag.dll" Alias "s18dcc" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s18dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_bessel_i Lib "CLW3225DA_nag.dll" Alias "s18dec" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s18dec Lib "CLW3225DA_nag.dll" ( _
    ByVal fnu As Double, _
    ByVal z As Complex, _
    ByVal n As Integer, _
    ByVal scal As Nag_ScaleResType, _
    <Out()> ByVal cy As Complex(), _
    ByRef nz As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_bessel_i_nu_scaled Lib "CLW3225DA_nag.dll" Alias "s18ecc" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18ecc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_k_nu_scaled Lib "CLW3225DA_nag.dll" Alias "s18edc" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18edc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_i_nu Lib "CLW3225DA_nag.dll" Alias "s18eec" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18eec Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_bessel_k_nu Lib "CLW3225DA_nag.dll" Alias "s18efc" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s18efc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal nu As Integer, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_bessel_k_alpha Lib "CLW3225DA_nag.dll" Alias "s18egc" ( _
    ByVal x As Double, _
    ByVal ia As Integer, _
    ByVal ja As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s18egc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal ia As Integer, _
    ByVal ja As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_k_alpha_scaled Lib "CLW3225DA_nag.dll" Alias "s18ehc" ( _
    ByVal x As Double, _
    ByVal ia As Integer, _
    ByVal ja As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s18ehc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal ia As Integer, _
    ByVal ja As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_i_alpha Lib "CLW3225DA_nag.dll" Alias "s18ejc" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub s18ejc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bessel_j_alpha Lib "CLW3225DA_nag.dll" Alias "s18ekc" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub s18ekc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_complex_bessel_j_seq Lib "CLW3225DA_nag.dll" Alias "s18gkc" ( _
    ByVal z As Complex, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )

   Declare Sub s18gkc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal a As Double, _
    ByVal nl As Integer, _
    <Out()> ByVal b As Complex(), _
    ByRef fail As NagError _
   )


   Declare Function nag_kelvin_ber Lib "CLW3225DA_nag.dll" Alias "s19aac" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s19aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_kelvin_bei Lib "CLW3225DA_nag.dll" Alias "s19abc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s19abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_kelvin_ker Lib "CLW3225DA_nag.dll" Alias "s19acc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s19acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_kelvin_kei Lib "CLW3225DA_nag.dll" Alias "s19adc" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s19adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_kelvin_ber_vector Lib "CLW3225DA_nag.dll" Alias "s19anc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s19anc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_kelvin_bei_vector Lib "CLW3225DA_nag.dll" Alias "s19apc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s19apc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_kelvin_ker_vector Lib "CLW3225DA_nag.dll" Alias "s19aqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s19aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_kelvin_kei_vector Lib "CLW3225DA_nag.dll" Alias "s19arc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )

   Declare Sub s19arc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    <Out()> ByVal ivalid As Integer(), _
    ByRef fail As NagError _
   )


   Declare Function nag_fresnel_s Lib "CLW3225DA_nag.dll" Alias "s20acc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s20acc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Function nag_fresnel_c Lib "CLW3225DA_nag.dll" Alias "s20adc" ( _
    ByVal x As Double _
   ) as Double

   Declare Function s20adc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Double


   Declare Sub nag_fresnel_s_vector Lib "CLW3225DA_nag.dll" Alias "s20aqc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s20aqc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_fresnel_c_vector Lib "CLW3225DA_nag.dll" Alias "s20arc" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s20arc Lib "CLW3225DA_nag.dll" ( _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    <Out()> ByVal f As Double(), _
    ByRef fail As NagError _
   )


   Declare Function nag_elliptic_integral_rc Lib "CLW3225DA_nag.dll" Alias "s21bac" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_rf Lib "CLW3225DA_nag.dll" Alias "s21bbc" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_rd Lib "CLW3225DA_nag.dll" Alias "s21bcc" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_rj Lib "CLW3225DA_nag.dll" Alias "s21bdc" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByVal r As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bdc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double, _
    ByVal y As Double, _
    ByVal z As Double, _
    ByVal r As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_F Lib "CLW3225DA_nag.dll" Alias "s21bec" ( _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bec Lib "CLW3225DA_nag.dll" ( _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_E Lib "CLW3225DA_nag.dll" Alias "s21bfc" ( _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_pi Lib "CLW3225DA_nag.dll" Alias "s21bgc" ( _
    ByVal dn As Double, _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bgc Lib "CLW3225DA_nag.dll" ( _
    ByVal dn As Double, _
    ByVal phi As Double, _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_complete_K Lib "CLW3225DA_nag.dll" Alias "s21bhc" ( _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bhc Lib "CLW3225DA_nag.dll" ( _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_elliptic_integral_complete_E Lib "CLW3225DA_nag.dll" Alias "s21bjc" ( _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21bjc Lib "CLW3225DA_nag.dll" ( _
    ByVal dm As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_real_jacobian_elliptic Lib "CLW3225DA_nag.dll" Alias "s21cac" ( _
    ByVal u As Double, _
    ByVal m As Double, _
    ByRef sn As Double, _
    ByRef cn As Double, _
    ByRef dn As Double, _
    ByRef fail As NagError _
   )

   Declare Sub s21cac Lib "CLW3225DA_nag.dll" ( _
    ByVal u As Double, _
    ByVal m As Double, _
    ByRef sn As Double, _
    ByRef cn As Double, _
    ByRef dn As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_jacobian_elliptic Lib "CLW3225DA_nag.dll" Alias "s21cbc" ( _
    ByVal z As Complex, _
    ByVal ak2 As Double, _
    ByRef sn As Complex, _
    ByRef cn As Complex, _
    ByRef dn As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub s21cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal ak2 As Double, _
    ByRef sn As Complex, _
    ByRef cn As Complex, _
    ByRef dn As Complex, _
    ByRef fail As NagError _
   )


   Declare Function nag_jacobian_theta Lib "CLW3225DA_nag.dll" Alias "s21ccc" ( _
    ByVal k As Integer, _
    ByVal x As Double, _
    ByVal q As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s21ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal k As Integer, _
    ByVal x As Double, _
    ByVal q As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Function nag_general_elliptic_integral_f Lib "CLW3225DA_nag.dll" Alias "s21dac" ( _
    ByVal z As Complex, _
    ByVal akp As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function s21dac Lib "CLW3225DA_nag.dll" ( _
    ByVal z As Complex, _
    ByVal akp As Double, _
    ByVal a As Double, _
    ByVal b As Double, _
    ByRef fail As NagError _
   ) as Complex


   Declare Sub nag_legendre_p Lib "CLW3225DA_nag.dll" Alias "s22aac" ( _
    ByVal mode As Integer, _
    ByVal x As Double, _
    ByVal m As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s22aac Lib "CLW3225DA_nag.dll" ( _
    ByVal mode As Integer, _
    ByVal x As Double, _
    ByVal m As Integer, _
    ByVal nl As Integer, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_specfun_1f1_real Lib "CLW3225DA_nag.dll" Alias "s22bac" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal x As Double, _
    ByRef m As Double, _
    ByRef fail As NagError _
   )

   Declare Sub s22bac Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal x As Double, _
    ByRef m As Double, _
    ByRef fail As NagError _
   )


   Declare Sub nag_specfun_1f1_real_scaled Lib "CLW3225DA_nag.dll" Alias "s22bbc" ( _
    ByVal ani As Double, _
    ByVal adr As Double, _
    ByVal bni As Double, _
    ByVal bdr As Double, _
    ByVal x As Double, _
    ByRef frm As Double, _
    ByRef scm As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s22bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal ani As Double, _
    ByVal adr As Double, _
    ByVal bni As Double, _
    ByVal bdr As Double, _
    ByVal x As Double, _
    ByRef frm As Double, _
    ByRef scm As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_specfun_2f1_real Lib "CLW3225DA_nag.dll" Alias "s22bec" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double

   Declare Function s22bec Lib "CLW3225DA_nag.dll" ( _
    ByVal a As Double, _
    ByVal b As Double, _
    ByVal c As Double, _
    ByVal x As Double, _
    ByRef fail As NagError _
   ) as Double


   Declare Sub nag_specfun_2f1_real_scaled Lib "CLW3225DA_nag.dll" Alias "s22bfc" ( _
    ByVal ani As Double, _
    ByVal adr As Double, _
    ByVal bni As Double, _
    ByVal bdr As Double, _
    ByVal cni As Double, _
    ByVal cdr As Double, _
    ByVal x As Double, _
    ByRef frf As Double, _
    ByRef scf As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub s22bfc Lib "CLW3225DA_nag.dll" ( _
    ByVal ani As Double, _
    ByVal adr As Double, _
    ByVal bni As Double, _
    ByVal bdr As Double, _
    ByVal cni As Double, _
    ByVal cdr As Double, _
    ByVal x As Double, _
    ByRef frf As Double, _
    ByRef scf As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_bsm_price Lib "CLW3225DA_nag.dll" Alias "s30aac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30aac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_bsm_greeks Lib "CLW3225DA_nag.dll" Alias "s30abc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30abc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_lookback_fls_price Lib "CLW3225DA_nag.dll" Alias "s30bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal sm As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30bac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal sm As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_lookback_fls_greeks Lib "CLW3225DA_nag.dll" Alias "s30bbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal sm As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal sm As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_binary_con_price Lib "CLW3225DA_nag.dll" Alias "s30cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    ByVal k As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30cac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    ByVal k As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_binary_con_greeks Lib "CLW3225DA_nag.dll" Alias "s30cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, ByVal k As Double, _
    <[In]()> ByVal t As Double(), ByVal sigma As Double, ByVal r As Double, _
    ByVal q As Double, <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), _
    <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal rho As Double(), <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), _
    <Out()> ByVal charm As Double(), <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), _
    <Out()> ByVal zomma As Double(), <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, ByVal k As Double, _
    <[In]()> ByVal t As Double(), ByVal sigma As Double, ByVal r As Double, _
    ByVal q As Double, <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), _
    <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal rho As Double(), <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), _
    <Out()> ByVal charm As Double(), <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), _
    <Out()> ByVal zomma As Double(), <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_binary_aon_price Lib "CLW3225DA_nag.dll" Alias "s30ccc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_binary_aon_greeks Lib "CLW3225DA_nag.dll" Alias "s30cdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal q As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_barrier_std_price Lib "CLW3225DA_nag.dll" Alias "s30fac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal typ As Nag_Barrier, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    ByVal h As Double, _
    ByVal k As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30fac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal typ As Nag_Barrier, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    ByVal h As Double, _
    ByVal k As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_jumpdiff_merton_price Lib "CLW3225DA_nag.dll" Alias "s30jac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal lambda As Double, _
    ByVal jvol As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30jac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal lambda As Double, _
    ByVal jvol As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_jumpdiff_merton_greeks Lib "CLW3225DA_nag.dll" Alias "s30jbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal lambda As Double, _
    ByVal jvol As Double, <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), _
    <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal rho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30jbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal lambda As Double, _
    ByVal jvol As Double, <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), _
    <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), _
    <Out()> ByVal rho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_heston_price Lib "CLW3225DA_nag.dll" Alias "s30nac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigmav As Double, _
    ByVal kappa As Double, _
    ByVal corr As Double, _
    ByVal var0 As Double, _
    ByVal eta As Double, _
    ByVal grisk As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30nac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigmav As Double, _
    ByVal kappa As Double, _
    ByVal corr As Double, _
    ByVal var0 As Double, _
    ByVal eta As Double, _
    ByVal grisk As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_heston_greeks Lib "CLW3225DA_nag.dll" Alias "s30nbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigmav As Double, ByVal kappa As Double, ByVal corr As Double, _
    ByVal var0 As Double, ByVal eta As Double, ByVal grisk As Double, _
    ByVal r As Double, ByVal q As Double, <Out()> ByVal p As Double(), _
    <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), _
    <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), <Out()> ByVal vanna As Double(), _
    <Out()> ByVal charm As Double(), <Out()> ByVal speed As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigmav As Double, ByVal kappa As Double, ByVal corr As Double, _
    ByVal var0 As Double, ByVal eta As Double, ByVal grisk As Double, _
    ByVal r As Double, ByVal q As Double, <Out()> ByVal p As Double(), _
    <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), <Out()> ByVal vega As Double(), _
    <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), <Out()> ByVal vanna As Double(), _
    <Out()> ByVal charm As Double(), <Out()> ByVal speed As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


   Declare Sub nag_heston_term Lib "CLW3225DA_nag.dll" Alias "s30ncc" ( _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal numts As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal fwd As Double, _
    ByVal disc As Double, _
    <[In]()> ByVal ts As Double(), _
    ByVal t As Double, _
    <[In]()> ByVal alpha As Double(), _
    <[In]()> ByVal lambda As Double(), _
    <[In]()> ByVal corr As Double(), _
    <[In]()> ByVal sigmat As Double(), _
    ByVal var0 As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30ncc Lib "CLW3225DA_nag.dll" ( _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal numts As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal fwd As Double, _
    ByVal disc As Double, _
    <[In]()> ByVal ts As Double(), _
    ByVal t As Double, _
    <[In]()> ByVal alpha As Double(), _
    <[In]()> ByVal lambda As Double(), _
    <[In]()> ByVal corr As Double(), _
    <[In]()> ByVal sigmat As Double(), _
    ByVal var0 As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_amer_bs_price Lib "CLW3225DA_nag.dll" Alias "s30qcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30qcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal q As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_asian_geom_price Lib "CLW3225DA_nag.dll" Alias "s30sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal b As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )

   Declare Sub s30sac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal x As Double(), _
    ByVal s As Double, _
    <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, _
    ByVal r As Double, _
    ByVal b As Double, _
    <Out()> ByVal p As Double(), _
    ByRef fail As NagError _
   )


   Declare Sub nag_asian_geom_greeks Lib "CLW3225DA_nag.dll" Alias "s30sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal b As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )

   Declare Sub s30sbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As Integer, ByVal n As Integer, _
    <[In]()> ByVal x As Double(), ByVal s As Double, <[In]()> ByVal t As Double(), _
    ByVal sigma As Double, ByVal r As Double, ByVal b As Double, _
    <Out()> ByVal p As Double(), <Out()> ByVal delta As Double(), <Out()> ByVal gamma As Double(), _
    <Out()> ByVal vega As Double(), <Out()> ByVal theta As Double(), <Out()> ByVal rho As Double(), _
    <Out()> ByVal crho As Double(), <Out()> ByVal vanna As Double(), <Out()> ByVal charm As Double(), _
    <Out()> ByVal speed As Double(), <Out()> ByVal colour As Double(), <Out()> ByVal zomma As Double(), _
    <Out()> ByVal vomma As Double(), ByRef fail As NagError _
   )


' chapter x01
function nag_pi() as Double
  nag_pi = 3.14159265358979323846264338328
end function 

function x01aac() as Double
  x01aac = 3.14159265358979323846264338328
end function 

function nag_euler_constant() as Double
  nag_euler_constant = 0.577215664901532860606512090082
end function 

function x01abc() as Double
  x01abc = 0.577215664901532860606512090082
end function 


' chapter x02

   Declare Function nag_max_sine_argument Lib "CLW3225DA_nag.dll" Alias "x02ahc" ( _
   ) as Double

   Declare Function x02ahc Lib "CLW3225DA_nag.dll" ( _
   ) as Double


   Declare Function nag_machine_precision Lib "CLW3225DA_nag.dll" Alias "x02ajc" ( _
   ) as Double

   Declare Function x02ajc Lib "CLW3225DA_nag.dll" ( _
   ) as Double


   Declare Function nag_real_smallest_number Lib "CLW3225DA_nag.dll" Alias "x02akc" ( _
   ) as Double

   Declare Function x02akc Lib "CLW3225DA_nag.dll" ( _
   ) as Double


   Declare Function nag_real_largest_number Lib "CLW3225DA_nag.dll" Alias "x02alc" ( _
   ) as Double

   Declare Function x02alc Lib "CLW3225DA_nag.dll" ( _
   ) as Double


   Declare Function nag_real_safe_small_number Lib "CLW3225DA_nag.dll" Alias "x02amc" ( _
   ) as Double

   Declare Function x02amc Lib "CLW3225DA_nag.dll" ( _
   ) as Double


   Declare Function nag_complex_safe_small_number Lib "CLW3225DA_nag.dll" Alias "x02anc" ( _
   ) as Double

   Declare Function x02anc Lib "CLW3225DA_nag.dll" ( _
   ) as Double

function nag_max_integer() as Integer
  nag_max_integer = 2147483647
end function 

function x02bbc() as Integer
  x02bbc = 2147483647
end function 

function nag_decimal_digits() as Integer
  nag_decimal_digits = 15
end function 

function x02bec() as Integer
  x02bec = 15
end function 

function nag_real_base() as Integer
  nag_real_base = 2
end function 

function x02bhc() as Integer
  x02bhc = 2
end function 

function nag_real_base_digits() as Integer
  nag_real_base_digits = 53
end function 

function x02bjc() as Integer
  x02bjc = 53
end function 

function nag_real_min_exponent() as Integer
  nag_real_min_exponent = (-1021)
end function 

function x02bkc() as Integer
  x02bkc = (-1021)
end function 


   Declare Function nag_real_max_exponent Lib "CLW3225DA_nag.dll" Alias "x02blc" ( _
   ) as Integer

   Declare Function x02blc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


' chapter x03

   Declare Sub x03aaw Lib "CLW3225DA_nag.dll" ( _
    ByRef oldcw As Integer _
   )


   Declare Sub x03aax Lib "CLW3225DA_nag.dll" ( _
    ByRef oldcw As Integer _
   )


' chapter x04

   Declare Sub nag_open_file Lib "CLW3225DA_nag.dll" Alias "x04acc" ( _
    ByVal filename As String, _
    ByVal mode As Integer, _
    ByRef fileid As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub x04acc Lib "CLW3225DA_nag.dll" ( _
    ByVal filename As String, _
    ByVal mode As Integer, _
    ByRef fileid As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_close_file Lib "CLW3225DA_nag.dll" Alias "x04adc" ( _
    ByVal fileid As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub x04adc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_write_line Lib "CLW3225DA_nag.dll" Alias "x04bac" ( _
    ByVal fileid As Integer, _
    ByVal line As String _
   )

   Declare Sub x04bac Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByVal line As String _
   )


   Declare Sub nag_read_line Lib "CLW3225DA_nag.dll" Alias "x04bbc" ( _
    ByVal fileid As Integer, _
    ByVal ln As String, _
    ByVal linelen As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub x04bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal fileid As Integer, _
    ByVal ln As String, _
    ByVal linelen As Integer, _
    ByRef fail As NagError _
   )


   Declare Sub nag_gen_real_mat_print Lib "CLW3225DA_nag.dll" Alias "x04cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04cac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_gen_real_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04cbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pack_real_mat_print Lib "CLW3225DA_nag.dll" Alias "x04ccc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04ccc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pack_real_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04cdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04cdc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_band_real_mat_print Lib "CLW3225DA_nag.dll" Alias "x04cec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04cec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_band_real_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04cfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04cfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Double(), _
    ByVal pda As Integer, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_gen_complx_mat_print Lib "CLW3225DA_nag.dll" Alias "x04dac" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04dac Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_gen_complx_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04dbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04dbc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pack_complx_mat_print Lib "CLW3225DA_nag.dll" Alias "x04dcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04dcc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_pack_complx_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04ddc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    <[In]()> ByVal rlabs As IntPtr(), _
    ByVal labcol As Nag_LabelType, _
    <[In]()> ByVal clabs As IntPtr(), _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04ddc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    <[In]()> ByVal rlabs As IntPtr(), _
    ByVal labcol As Nag_LabelType, _
    <[In]()> ByVal clabs As IntPtr(), _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_band_complx_mat_print Lib "CLW3225DA_nag.dll" Alias "x04dec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04dec Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Sub nag_band_complx_mat_print_comp Lib "CLW3225DA_nag.dll" Alias "x04dfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Sub x04dfc Lib "CLW3225DA_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As Integer, _
    ByVal n As Integer, _
    ByVal kl As Integer, _
    ByVal ku As Integer, _
    <[In]()> ByVal a As Complex(), _
    ByVal pda As Integer, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As Integer, _
    ByVal indent As Integer, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Function nag_enum_name_to_value Lib "CLW3225DA_nag.dll" Alias "x04nac" ( _
    ByVal enum_string As String _
   ) as Integer

   Declare Function x04nac Lib "CLW3225DA_nag.dll" ( _
    ByVal enum_string As String _
   ) as Integer


   Declare Function nag_enum_value_to_name Lib "CLW3225DA_nag.dll" Alias "x04nbc" ( _
    ByVal enum_value As Integer _
   ) as String

   Declare Function x04nbc Lib "CLW3225DA_nag.dll" ( _
    ByVal enum_value As Integer _
   ) as String


   Declare Function nag_error_name_to_code Lib "CLW3225DA_nag.dll" Alias "x04ncc" ( _
    ByVal error_name As String _
   ) as Integer

   Declare Function x04ncc Lib "CLW3225DA_nag.dll" ( _
    ByVal error_name As String _
   ) as Integer


   Declare Function nag_code_to_error_name Lib "CLW3225DA_nag.dll" Alias "x04ndc" ( _
    ByVal code As Integer _
   ) as String

   Declare Function x04ndc Lib "CLW3225DA_nag.dll" ( _
    ByVal code As Integer _
   ) as String


   Declare Function x04bcc Lib "CLW3225DA_nag.dll" ( _
    ByVal ptr As IntPtr, _
    ByVal newsize As Integer _
  ) As IntPtr
   Declare Function NAG_REALLOC Lib "CLW3225DA_nag.dll" Alias "x04bcc" ( _
    ByVal ptr As IntPtr, _
    ByVal newsize As Integer _
  ) As IntPtr

   Declare Sub x04bdc Lib "CLW3225DA_nag.dll" ( _
    ByRef ptr As IntPtr _
  )
   Declare Sub NAG_FREE Lib "CLW3225DA_nag.dll" Alias "x04bdc" ( _
    ByRef ptr As IntPtr _
  )

   Declare Function x04bjc Lib "CLW3225DA_nag.dll" ( _
    ByVal size As Integer _
  ) As IntPtr
   Declare Function NAG_ALLOC Lib "CLW3225DA_nag.dll" Alias "x04bjc" ( _
    ByVal size As Integer _
  ) As IntPtr

' chapter x06

   Declare Sub nag_omp_set_num_threads Lib "CLW3225DA_nag.dll" Alias "x06aac" ( _
    ByVal num As Integer, _
    ByRef fail As NagError _
   )

   Declare Sub x06aac Lib "CLW3225DA_nag.dll" ( _
    ByVal num As Integer, _
    ByRef fail As NagError _
   )


   Declare Function nag_omp_get_num_threads Lib "CLW3225DA_nag.dll" Alias "x06abc" ( _
   ) as Integer

   Declare Function x06abc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


   Declare Function nag_omp_get_max_threads Lib "CLW3225DA_nag.dll" Alias "x06acc" ( _
   ) as Integer

   Declare Function x06acc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


   Declare Function nag_omp_get_thread_num Lib "CLW3225DA_nag.dll" Alias "x06adc" ( _
   ) as Integer

   Declare Function x06adc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


   Declare Function nag_omp_in_parallel Lib "CLW3225DA_nag.dll" Alias "x06afc" ( _
   ) as Integer

   Declare Function x06afc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


   Declare Sub nag_omp_set_nested Lib "CLW3225DA_nag.dll" Alias "x06agc" ( _
    ByVal nesting As Integer _
   )

   Declare Sub x06agc Lib "CLW3225DA_nag.dll" ( _
    ByVal nesting As Integer _
   )


   Declare Function nag_omp_get_nested Lib "CLW3225DA_nag.dll" Alias "x06ahc" ( _
   ) as Integer

   Declare Function x06ahc Lib "CLW3225DA_nag.dll" ( _
   ) as Integer


' chapter x07

   Declare Function nag_is_finite Lib "CLW3225DA_nag.dll" Alias "x07aac" ( _
    ByVal x As Double _
   ) as Integer

   Declare Function x07aac Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Integer


   Declare Function nag_is_nan Lib "CLW3225DA_nag.dll" Alias "x07abc" ( _
    ByVal x As Double _
   ) as Integer

   Declare Function x07abc Lib "CLW3225DA_nag.dll" ( _
    ByVal x As Double _
   ) as Integer


   Declare Sub nag_create_infinity Lib "CLW3225DA_nag.dll" Alias "x07bac" ( _
    ByVal isign As Integer, _
    ByRef x As Double _
   )

   Declare Sub x07bac Lib "CLW3225DA_nag.dll" ( _
    ByVal isign As Integer, _
    ByRef x As Double _
   )


   Declare Sub nag_create_nan Lib "CLW3225DA_nag.dll" Alias "x07bbc" ( _
    ByVal quiet As Integer, _
    ByRef x As Double _
   )

   Declare Sub x07bbc Lib "CLW3225DA_nag.dll" ( _
    ByVal quiet As Integer, _
    ByRef x As Double _
   )


   Declare Sub nag_get_ieee_exception_mode Lib "CLW3225DA_nag.dll" Alias "x07cac" ( _
    <Out()> ByVal exceptionmode As Integer() _
   )

   Declare Sub x07cac Lib "CLW3225DA_nag.dll" ( _
    <Out()> ByVal exceptionmode As Integer() _
   )


   Declare Sub nag_set_ieee_exception_mode Lib "CLW3225DA_nag.dll" Alias "x07cbc" ( _
    <[In]()> ByVal exceptionmode As Integer() _
   )

   Declare Sub x07cbc Lib "CLW3225DA_nag.dll" ( _
    <[In]()> ByVal exceptionmode As Integer() _
   )

End Module
